# Get the XML from IANA:
# https://www.iana.org/assignments/service-names-port-numbers/service-names-port-numbers.xml
# Then extract ports:
# $ xmlstarlet sel -t -m "//*[local-name()='record']" \
#    -v "concat(*[local-name()='protocol'], ',', *[local-name()='number'], ',', *[local-name()='description'])" \
#    -n service-names-port-numbers.xml | grep -E '(udp|tcp),[0-9]+' | sed 's/"/\\"/g'

port_map_tcp = {
    "0": "Reserved",
    "1": "TCP Port Service Multiplexer",
    "2": "Management Utility",
    "3": "Compression Process",
    "4": "Unassigned",
    "5": "Remote Job Entry",
    "6": "Unassigned",
    "7": "Echo",
    "8": "Unassigned",
    "9": "Discard",
    "10": "Unassigned",
    "11": "Active Users",
    "12": "Unassigned",
    "13": "Daytime",
    "14": "Unassigned",
    "15": "Unassigned [was netstat]",
    "16": "Unassigned",
    "17": "Quote of the Day",
    "18": "Message Send Protocol (historic)",
    "19": "Character Generator",
    "20": "File Transfer [Default Data]",
    "21": "File Transfer Protocol [Control]",
    "22": "The Secure Shell (SSH) Protocol",
    "23": "Telnet",
    "24": "any private mail system",
    "25": "Simple Mail Transfer",
    "26": "Unassigned",
    "27": "NSW User System FE",
    "28": "Unassigned",
    "29": "MSG ICP",
    "30": "Unassigned",
    "31": "MSG Authentication",
    "32": "Unassigned",
    "33": "Display Support Protocol",
    "34": "Unassigned",
    "35": "any private printer server",
    "36": "Unassigned",
    "37": "Time",
    "38": "Route Access Protocol",
    "39": "Resource Location Protocol",
    "40": "Unassigned",
    "41": "Graphics",
    "42": "Host Name Server",
    "42": "Host Name Server",
    "43": "Who Is",
    "44": "MPM FLAGS Protocol",
    "45": "Message Processing Module [recv]",
    "46": "MPM [default send]",
    "47": "Reserved",
    "48": "Digital Audit Daemon",
    "49": "Login Host Protocol (TACACS)",
    "50": "Remote Mail Checking Protocol",
    "52": "XNS Time Protocol",
    "53": "Domain Name Server",
    "54": "XNS Clearinghouse",
    "55": "ISI Graphics Language",
    "56": "XNS Authentication",
    "57": "any private terminal access",
    "58": "XNS Mail",
    "59": "any private file service",
    "60": "Unassigned",
    "61": "Reserved",
    "62": "ACA Services",
    "63": "whois++",
    "64": "Communications Integrator (CI)",
    "65": "TACACS-Database Service",
    "66": "Oracle SQL*NET",
    "67": "Bootstrap Protocol Server",
    "68": "Bootstrap Protocol Client",
    "69": "Trivial File Transfer",
    "70": "Gopher",
    "71": "Remote Job Service",
    "72": "Remote Job Service",
    "73": "Remote Job Service",
    "74": "Remote Job Service",
    "75": "any private dial out service",
    "76": "Distributed External Object Store",
    "77": "any private RJE service",
    "78": "vettcp",
    "79": "Finger",
    "80": "World Wide Web HTTP",
    "80": "World Wide Web HTTP",
    "82": "XFER Utility",
    "83": "MIT ML Device",
    "84": "Common Trace Facility",
    "85": "MIT ML Device",
    "86": "Micro Focus Cobol",
    "87": "any private terminal link",
    "88": "Kerberos",
    "89": "SU/MIT Telnet Gateway",
    "90": "DNSIX Securit Attribute Token Map",
    "91": "MIT Dover Spooler",
    "92": "Network Printing Protocol",
    "93": "Device Control Protocol",
    "94": "Tivoli Object Dispatcher",
    "95": "SUPDUP",
    "96": "DIXIE Protocol Specification",
    "97": "Swift Remote Virtural File Protocol",
    "98": "TAC News",
    "99": "Metagram Relay",
    "101": "NIC Host Name Server",
    "102": "ISO-TSAP Class 0",
    "103": "Genesis Point-to-Point Trans Net",
    "104": "ACR-NEMA Digital Imag. &amp; Comm. 300",
    "105": "CCSO name server protocol",
    "106": "3COM-TSMUX",
    "107": "Remote Telnet Service",
    "108": "SNA Gateway Access Server",
    "109": "Post Office Protocol - Version 2",
    "110": "Post Office Protocol - Version 3",
    "111": "SUN Remote Procedure Call",
    "112": "McIDAS Data Transmission Protocol",
    "113": "Authentication Service",
    "115": "Simple File Transfer Protocol",
    "116": "ANSA REX Notify",
    "117": "UUCP Path Service",
    "118": "SQL Services",
    "119": "Network News Transfer Protocol",
    "120": "CFDPTKT",
    "121": "Encore Expedited Remote Pro.Call",
    "122": "SMAKYNET",
    "123": "Network Time Protocol",
    "124": "ANSA REX Trader",
    "125": "Locus PC-Interface Net Map Ser",
    "126": "NXEdit",
    "127": "Locus PC-Interface Conn Server",
    "128": "GSS X License Verification",
    "129": "Password Generator Protocol",
    "130": "cisco FNATIVE",
    "131": "cisco TNATIVE",
    "132": "cisco SYSMAINT",
    "133": "Statistics Service",
    "134": "INGRES-NET Service",
    "135": "DCE endpoint resolution",
    "136": "PROFILE Naming System",
    "137": "NETBIOS Name Service",
    "138": "NETBIOS Datagram Service",
    "139": "NETBIOS Session Service",
    "140": "EMFIS Data Service",
    "141": "EMFIS Control Service",
    "142": "Britton-Lee IDM",
    "143": "Internet Message Access Protocol",
    "144": "Universal Management Architecture",
    "145": "UAAC Protocol",
    "146": "ISO-IP0",
    "147": "ISO-IP",
    "148": "Jargon",
    "149": "AED 512 Emulation Service",
    "150": "SQL-NET",
    "151": "HEMS",
    "152": "Background File Transfer Program",
    "153": "SGMP",
    "154": "NETSC",
    "155": "NETSC",
    "156": "SQL Service",
    "157": "KNET/VM Command/Message Protocol",
    "158": "PCMail Server",
    "159": "NSS-Routing",
    "160": "SGMP-TRAPS",
    "161": "SNMP",
    "162": "SNMPTRAP",
    "163": "CMIP/TCP Manager",
    "164": "CMIP/TCP Agent",
    "165": "Xerox",
    "166": "Sirius Systems",
    "167": "NAMP",
    "168": "RSVD",
    "169": "SEND",
    "170": "Network PostScript",
    "171": "Network Innovations Multiplex",
    "172": "Network Innovations CL/1",
    "172": "Network Innovations CL/1",
    "173": "Xyplex",
    "174": "MAILQ",
    "175": "VMNET",
    "176": "GENRAD-MUX",
    "177": "X Display Manager Control Protocol",
    "178": "NextStep Window Server",
    "179": "Border Gateway Protocol",
    "180": "Intergraph",
    "181": "Unify",
    "182": "Unisys Audit SITP",
    "183": "OCBinder",
    "184": "OCServer",
    "185": "Remote-KIS",
    "186": "KIS Protocol",
    "187": "Application Communication Interface",
    "188": "Plus Five's MUMPS",
    "189": "Queued File Transport",
    "190": "Gateway Access Control Protocol",
    "191": "Prospero Directory Service",
    "192": "OSU Network Monitoring System",
    "193": "Spider Remote Monitoring Protocol",
    "194": "Internet Relay Chat Protocol",
    "195": "DNSIX Network Level Module Audit",
    "196": "DNSIX Session Mgt Module Audit Redir",
    "197": "Directory Location Service",
    "198": "Directory Location Service Monitor",
    "199": "SMUX",
    "200": "IBM System Resource Controller",
    "201": "AppleTalk Routing Maintenance",
    "202": "AppleTalk Name Binding",
    "203": "AppleTalk Unused",
    "204": "AppleTalk Echo",
    "205": "AppleTalk Unused",
    "206": "AppleTalk Zone Information",
    "207": "AppleTalk Unused",
    "208": "AppleTalk Unused",
    "209": "The Quick Mail Transfer Protocol",
    "210": "ANSI Z39.50",
    "210": "ANSI Z39.50",
    "211": "Texas Instruments 914C/G Terminal",
    "211": "Texas Instruments 914C/G Terminal",
    "212": "ATEXSSTR",
    "213": "IPX",
    "214": "VM PWSCS",
    "215": "Insignia Solutions",
    "216": "Computer Associates Int'l License Server",
    "217": "dBASE Unix",
    "218": "Netix Message Posting Protocol",
    "219": "Unisys ARPs",
    "220": "Interactive Mail Access Protocol v3",
    "221": "Berkeley rlogind with SPX auth",
    "222": "Berkeley rshd with SPX auth",
    "223": "Certificate Distribution Center",
    "224": "masqdialer",
    "242": "Direct",
    "243": "Survey Measurement",
    "244": "inbusiness",
    "245": "LINK",
    "246": "Display Systems Protocol",
    "247": "SUBNTBCST_TFTP",
    "247": "SUBNTBCST_TFTP",
    "248": "bhfhs",
    "256": "RAP",
    "257": "Secure Electronic Transaction",
    "259": "Efficient Short Remote Operations",
    "260": "Openport",
    "261": "IIOP Name Service over TLS/SSL",
    "262": "Arcisdms",
    "263": "HDAP",
    "264": "BGMP",
    "265": "X-Bone CTL",
    "266": "SCSI on ST",
    "267": "Tobit David Service Layer",
    "268": "Tobit David Replica",
    "269": "MANET Protocols",
    "270": "Reserved",
    "271": "IETF Network Endpoint Assessment (NEA) Posture Transport Protocol over TLS (PT-TLS)",
    "280": "http-mgmt",
    "281": "Personal Link",
    "282": "Cable Port A/X",
    "283": "rescap",
    "284": "corerjd",
    "286": "FXP Communication",
    "287": "K-BLOCK",
    "308": "Novastor Backup",
    "309": "EntrustTime",
    "310": "bhmds",
    "311": "AppleShare IP WebAdmin",
    "312": "VSLMP",
    "313": "Magenta Logic",
    "314": "Opalis Robot",
    "315": "DPSI",
    "316": "decAuth",
    "317": "Zannet",
    "318": "PKIX TimeStamp",
    "319": "PTP Event",
    "320": "PTP General",
    "321": "PIP",
    "322": "RTSPS",
    "323": "Resource PKI to Router Protocol",
    "324": "Resource PKI to Router Protocol over TLS",
    "333": "Texar Security Port",
    "344": "Prospero Data Access Protocol",
    "345": "Perf Analysis Workbench",
    "346": "Zebra server",
    "347": "Fatmen Server",
    "348": "Cabletron Management Protocol",
    "349": "mftp",
    "350": "MATIP Type A",
    "351": "MATIP Type B",
    "352": "DTAG",
    "353": "NDSAUTH",
    "354": "bh611",
    "355": "DATEX-ASN",
    "356": "Cloanto Net 1",
    "357": "bhevent",
    "358": "Shrinkwrap",
    "359": "Reserved",
    "360": "scoi2odialog",
    "361": "Semantix",
    "362": "SRS Send",
    "363": "RSVP Tunnel",
    "363": "RSVP Tunnel",
    "364": "Aurora CMGR",
    "365": "DTK",
    "366": "ODMR",
    "367": "MortgageWare",
    "368": "QbikGDP",
    "369": "rpc2portmap",
    "370": "codaauth2",
    "371": "Clearcase",
    "372": "ListProcessor",
    "373": "Legent Corporation",
    "374": "Legent Corporation",
    "375": "Hassle",
    "376": "Amiga Envoy Network Inquiry Protocol",
    "377": "NEC Corporation",
    "378": "NEC Corporation",
    "379": "TIA/EIA/IS-99 modem client",
    "380": "TIA/EIA/IS-99 modem server",
    "381": "hp performance data collector",
    "382": "hp performance data managed node",
    "383": "hp performance data alarm manager",
    "384": "A Remote Network Server System",
    "385": "IBM Application",
    "386": "ASA Message Router Object Def.",
    "387": "Appletalk Update-Based Routing Pro.",
    "388": "Unidata LDM",
    "389": "Lightweight Directory Access Protocol",
    "390": "UIS",
    "391": "SynOptics SNMP Relay Port",
    "392": "SynOptics Port Broker Port",
    "393": "Meta5",
    "394": "EMBL Nucleic Data Transfer",
    "395": "NetScout Control Protocol",
    "396": "Novell Netware over IP",
    "397": "Multi Protocol Trans. Net.",
    "398": "Kryptolan",
    "399": "ISO Transport Class 2 Non-Control over TCP",
    "400": "Oracle Secure Backup",
    "401": "Uninterruptible Power Supply",
    "402": "Genie Protocol",
    "403": "decap",
    "404": "nced",
    "405": "ncld",
    "406": "Interactive Mail Support Protocol",
    "407": "Timbuktu",
    "408": "Prospero Resource Manager Sys. Man.",
    "409": "Prospero Resource Manager Node Man.",
    "410": "DECLadebug Remote Debug Protocol",
    "411": "Remote MT Protocol",
    "412": "Trap Convention Port",
    "413": "Storage Management Services Protocol",
    "414": "InfoSeek",
    "415": "BNet",
    "416": "Silverplatter",
    "417": "Onmux",
    "418": "Hyper-G",
    "419": "Ariel 1",
    "420": "SMPTE",
    "421": "Ariel 2",
    "422": "Ariel 3",
    "423": "IBM Operations Planning and Control Start",
    "424": "IBM Operations Planning and Control Track",
    "425": "ICAD",
    "426": "smartsdp",
    "427": "Server Location",
    "428": "OCS_CMU",
    "428": "OCS_CMU",
    "429": "OCS_AMU",
    "429": "OCS_AMU",
    "430": "UTMPSD",
    "431": "UTMPCD",
    "432": "IASD",
    "433": "NNTP for transit servers (NNSP)",
    "434": "MobileIP-Agent",
    "435": "MobilIP-MN",
    "436": "DNA-CML",
    "437": "comscm",
    "438": "dsfgw",
    "439": "dasp",
    "440": "sgcp",
    "441": "decvms-sysmgt",
    "442": "cvc_hostd",
    "442": "cvc_hostd",
    "443": "http protocol over TLS/SSL",
    "444": "Simple Network Paging Protocol",
    "445": "Microsoft-DS",
    "446": "DDM-Remote Relational Database Access",
    "447": "DDM-Distributed File Management",
    "448": "DDM-Remote DB Access Using Secure Sockets",
    "449": "AS Server Mapper",
    "450": "Computer Supported Telecomunication Applications",
    "451": "Cray Network Semaphore server",
    "452": "Cray SFS config server",
    "453": "CreativeServer",
    "454": "ContentServer",
    "455": "CreativePartnr",
    "456": "macon-tcp",
    "457": "scohelp",
    "458": "apple quick time",
    "459": "ampr-rcmd",
    "460": "skronk",
    "461": "DataRampSrv",
    "462": "DataRampSrvSec",
    "463": "alpes",
    "464": "kpasswd",
    "465": "Message Submission over TLS protocol",
    "466": "digital-vrc",
    "467": "mylex-mapd",
    "468": "proturis",
    "469": "Radio Control Protocol",
    "470": "scx-proxy",
    "471": "Mondex",
    "472": "ljk-login",
    "473": "hybrid-pop",
    "474": "tn-tl-w1",
    "475": "tcpnethaspsrv",
    "476": "tn-tl-fd1",
    "477": "ss7ns",
    "478": "spsc",
    "479": "iafserver",
    "480": "iafdbase",
    "481": "Ph service",
    "482": "bgs-nsi",
    "483": "ulpnet",
    "484": "Integra Software Management Environment",
    "485": "Air Soft Power Burst",
    "486": "avian",
    "487": "saft Simple Asynchronous File Transfer",
    "488": "gss-http",
    "489": "nest-protocol",
    "490": "micom-pfs",
    "491": "go-login",
    "492": "Transport Independent Convergence for FNA",
    "493": "Transport Independent Convergence for FNA",
    "494": "POV-Ray",
    "495": "intecourier",
    "496": "PIM-RP-DISC",
    "497": "Retrospect backup and restore service",
    "498": "siam",
    "499": "ISO ILL Protocol",
    "500": "isakmp",
    "501": "STMF",
    "502": "Modbus Application Protocol",
    "503": "Intrinsa",
    "504": "citadel",
    "505": "mailbox-lm",
    "506": "ohimsrv",
    "507": "crs",
    "508": "xvttp",
    "509": "snare",
    "510": "FirstClass Protocol",
    "511": "PassGo",
    "512": "remote process execution; authentication performed using passwords and UNIX login names",
    "513": 'remote login a la telnet; automatic authentication performed based on priviledged port numbers and distributed data bases which identify "authentication domains"',
    "514": "cmd like exec, but automatic authentication is performed as for login server",
    "515": "spooler",
    "516": "videotex",
    "517": "like tenex link, but across machine - unfortunately, doesn't use link protocol (this is actually just a rendezvous port from which a tcp connection is established)",
    "518": "",
    "519": "unixtime",
    "520": "extended file name server",
    "521": "ripng",
    "522": "ULP",
    "523": "IBM-DB2",
    "524": "NCP",
    "525": "timeserver",
    "526": "newdate",
    "527": "Stock IXChange",
    "528": "Customer IXChange",
    "529": "IRC-SERV",
    "530": "rpc",
    "531": "chat",
    "532": "readnews",
    "533": "for emergency broadcasts",
    "534": "windream Admin",
    "535": "iiop",
    "536": "opalis-rdv",
    "537": "Networked Media Streaming Protocol",
    "538": "gdomap",
    "539": "Apertus Technologies Load Determination",
    "540": "uucpd",
    "541": "uucp-rlogin",
    "542": "commerce",
    "543": "",
    "544": "krcmd",
    "545": "appleqtcsrvr",
    "546": "DHCPv6 Client",
    "547": "DHCPv6 Server",
    "548": "AFP over TCP",
    "549": "IDFP",
    "550": "new-who",
    "551": "cybercash",
    "552": "DeviceShare",
    "553": "pirp",
    "554": "Real Time Streaming Protocol (RTSP)",
    "555": "",
    "556": "rfs server",
    "557": "openvms-sysipc",
    "558": "SDNSKMP",
    "559": "TEEDTAP",
    "560": "rmonitord",
    "561": "",
    "562": "chcmd",
    "563": "nntp protocol over TLS/SSL (was snntp)",
    "564": "plan 9 file service",
    "565": "whoami",
    "566": "streettalk",
    "567": "banyan-rpc",
    "568": "microsoft shuttle",
    "569": "microsoft rome",
    "570": "demon",
    "571": "udemon",
    "572": "sonar",
    "573": "banyan-vip",
    "574": "FTP Software Agent System",
    "575": "VEMMI",
    "576": "ipcd",
    "577": "vnas",
    "578": "ipdd",
    "579": "decbsrv",
    "580": "SNTP HEARTBEAT",
    "581": "Bundle Discovery Protocol",
    "582": "SCC Security",
    "583": "Philips Video-Conferencing",
    "584": "Key Server",
    "586": "Password Change",
    "587": "Message Submission",
    "588": "CAL",
    "589": "EyeLink",
    "590": "TNS CML",
    "591": "FileMaker, Inc. - HTTP Alternate (see Port 80)",
    "592": "Eudora Set",
    "593": "HTTP RPC Ep Map",
    "594": "TPIP",
    "595": "CAB Protocol",
    "596": "SMSD",
    "597": "PTC Name Service",
    "598": "SCO Web Server Manager 3",
    "599": "Aeolon Core Protocol",
    "600": "Sun IPC server",
    "601": "Reliable Syslog Service",
    "602": "XML-RPC over BEEP",
    "603": "IDXP",
    "604": "TUNNEL",
    "605": "SOAP over BEEP",
    "606": "Cray Unified Resource Manager",
    "607": "nqs",
    "608": "Sender-Initiated/Unsolicited File Transfer",
    "609": "npmp-trap",
    "610": "npmp-local",
    "611": "npmp-gui",
    "612": "HMMP Indication",
    "613": "HMMP Operation",
    "614": "SSLshell",
    "615": "Internet Configuration Manager",
    "616": "SCO System Administration Server",
    "617": "SCO Desktop Administration Server",
    "618": "DEI-ICDA",
    "619": "Compaq EVM",
    "620": "SCO WebServer Manager",
    "621": "ESCP",
    "622": "Collaborator",
    "623": "DMTF out-of-band web services management protocol",
    "624": "Crypto Admin",
    "625": "DEC DLM",
    "625": "DEC DLM",
    "626": "ASIA",
    "627": "PassGo Tivoli",
    "628": "QMQP",
    "629": "3Com AMP3",
    "630": "RDA",
    "631": "IPP (Internet Printing Protocol)",
    "632": "bmpp",
    "633": "Service Status update (Sterling Software)",
    "634": "ginad",
    "635": "RLZ DBase",
    "636": "ldap protocol over TLS/SSL (was sldap)",
    "637": "lanserver",
    "638": "mcns-sec",
    "639": "MSDP",
    "640": "entrust-sps",
    "641": "repcmd",
    "642": "ESRO-EMSDP V1.3",
    "643": "SANity",
    "644": "dwr",
    "645": "PSSC",
    "646": "LDP",
    "647": "DHCP Failover",
    "648": "Registry Registrar Protocol (RRP)",
    "649": "Cadview-3d - streaming 3d models over the internet",
    "650": "OBEX",
    "651": "IEEE MMS",
    "652": "HELLO_PORT",
    "653": "RepCmd",
    "654": "AODV",
    "655": "TINC",
    "656": "SPMP",
    "657": "RMC",
    "658": "TenFold",
    "660": "MacOS Server Admin",
    "661": "HAP",
    "662": "PFTP",
    "663": "PureNoise",
    "664": "DMTF out-of-band secure web services management protocol",
    "665": "Sun DR",
    "666": "doom Id Software",
    "667": "campaign contribution disclosures - SDR Technologies",
    "668": "MeComm",
    "669": "MeRegister",
    "670": "VACDSM-SWS",
    "671": "VACDSM-APP",
    "672": "VPPS-QUA",
    "673": "CIMPLEX",
    "674": "ACAP",
    "675": "DCTP",
    "676": "VPPS Via",
    "677": "Virtual Presence Protocol",
    "678": "GNU Generation Foundation NCP",
    "679": "MRM",
    "680": "entrust-aaas",
    "681": "entrust-aams",
    "682": "XFR",
    "683": "CORBA IIOP",
    "684": "CORBA IIOP SSL",
    "685": "MDC Port Mapper",
    "686": "Hardware Control Protocol Wismar",
    "687": "asipregistry",
    "688": "ApplianceWare managment protocol",
    "689": "NMAP",
    "690": "Velneo Application Transfer Protocol",
    "691": "MS Exchange Routing",
    "692": "Hyperwave-ISP",
    "693": "almanid Connection Endpoint",
    "694": "ha-cluster",
    "695": "IEEE-MMS-SSL",
    "696": "RUSHD",
    "697": "UUIDGEN",
    "698": "OLSR",
    "699": "Access Network",
    "700": "Extensible Provisioning Protocol",
    "701": "Link Management Protocol (LMP)",
    "702": "IRIS over BEEP",
    "704": "errlog copy/server daemon",
    "705": "AgentX",
    "706": "SILC",
    "707": "Borland DSJ",
    "709": "Entrust Key Management Service Handler",
    "710": "Entrust Administration Service Handler",
    "711": "Cisco TDP",
    "712": "TBRPF",
    "713": "IRIS over XPC",
    "714": "IRIS over XPCS",
    "715": "IRIS-LWZ",
    "729": "IBM NetView DM/6000 Server/Client",
    "730": "IBM NetView DM/6000 send/tcp",
    "731": "IBM NetView DM/6000 receive/tcp",
    "741": "netGW",
    "742": "Network based Rev. Cont. Sys.",
    "744": "Flexible License Manager",
    "747": "Fujitsu Device Control",
    "748": "Russell Info Sci Calendar Manager",
    "749": "kerberos administration",
    "750": "",
    "751": "",
    "752": "",
    "753": "",
    "754": "send",
    "758": "",
    "759": "",
    "760": "",
    "761": "",
    "762": "",
    "763": "",
    "764": "",
    "765": "",
    "767": "phone",
    "769": "",
    "770": "",
    "771": "",
    "772": "",
    "773": "",
    "774": "",
    "775": "",
    "776": "",
    "777": "Multiling HTTP",
    "780": "",
    "800": "",
    "800": "",
    "801": "",
    "802": "Modbus Application Protocol Secure",
    "810": "FCP",
    "828": "itm-mcell-s",
    "829": "PKIX-3 CA/RA",
    "830": "NETCONF over SSH",
    "831": "NETCONF over BEEP",
    "832": "NETCONF for SOAP over HTTPS",
    "833": "NETCONF for SOAP over BEEP",
    "847": "dhcp-failover 2",
    "848": "GDOI",
    "853": "DNS query-response protocol run over TLS",
    "854": "Dynamic Link Exchange Protocol (DLEP)",
    "860": "iSCSI",
    "861": "OWAMP-Control",
    "862": "TWAMP-Control",
    "873": "rsync",
    "886": "ICL coNETion locate server",
    "887": "ICL coNETion server info",
    "887": "ICL coNETion server info",
    "888": "AccessBuilder",
    "900": "OMG Initial Refs",
    "901": "SMPNAMERES",
    "902": "self documenting Telnet Door",
    "903": "self documenting Telnet Panic Door",
    "910": "Kerberized Internet Negotiation of Keys (KINK)",
    "911": "xact-backup",
    "912": "APEX relay-relay service",
    "913": "APEX endpoint-relay service",
    "914": "Reserved",
    "915": "Reserved",
    "953": "BIND9 remote name daemon controller",
    "989": "ftp protocol, data, over TLS/SSL",
    "990": "ftp protocol, control, over TLS/SSL",
    "991": "Netnews Administration System",
    "992": "telnet protocol over TLS/SSL",
    "993": "IMAP over TLS protocol",
    "994": "Reserved",
    "995": "POP3 over TLS protocol",
    "996": "vsinet",
    "997": "",
    "998": "",
    "999": "",
    "999": "",
    "1000": "",
    "1001": "HTTP Web Push",
    "1010": "surf",
    "1021": "RFC3692-style Experiment 1",
    "1022": "RFC3692-style Experiment 2",
    "1023": "Reserved",
    "1024": "Reserved",
    "1025": "network blackjack",
    "1026": "Calendar Access Protocol",
    "1027": "Reserved",
    "1029": "Solid Mux Server",
    "1033": "local netinfo port",
    "1034": "ActiveSync Notifications",
    "1035": "MX-XR RPC",
    "1036": "Nebula Secure Segment Transfer Protocol",
    "1037": "AMS",
    "1038": "Message Tracking Query Protocol",
    "1039": "Streamlined Blackhole",
    "1040": "Netarx Netcare",
    "1041": "AK2 Product",
    "1042": "Subnet Roaming",
    "1043": "BOINC Client Control",
    "1044": "Dev Consortium Utility",
    "1045": "Fingerprint Image Transfer Protocol",
    "1046": "WebFilter Remote Monitor",
    "1047": "Sun's NEO Object Request Broker",
    "1048": "Sun's NEO Object Request Broker",
    "1049": "Tobit David Postman VPMN",
    "1050": "CORBA Management Agent",
    "1051": "Optima VNET",
    "1052": "Dynamic DNS Tools",
    "1053": "Remote Assistant (RA)",
    "1054": "BRVREAD",
    "1055": "ANSYS - License Manager",
    "1056": "VFO",
    "1057": "STARTRON",
    "1058": "nim",
    "1059": "nimreg",
    "1060": "POLESTAR",
    "1061": "KIOSK",
    "1062": "Veracity",
    "1063": "KyoceraNetDev",
    "1064": "JSTEL",
    "1065": "SYSCOMLAN",
    "1066": "FPO-FNS",
    "1067": "Installation Bootstrap Proto. Serv.",
    "1067": "Installation Bootstrap Proto. Serv.",
    "1068": "Installation Bootstrap Proto. Cli.",
    "1068": "Installation Bootstrap Proto. Cli.",
    "1069": "COGNEX-INSIGHT",
    "1070": "GMRUpdateSERV",
    "1071": "BSQUARE-VOIP",
    "1072": "CARDAX",
    "1073": "Bridge Control",
    "1074": "Warmspot Management Protocol",
    "1075": "RDRMSHC",
    "1076": "DAB STI-C",
    "1077": "IMGames",
    "1078": "Avocent Proxy Protocol",
    "1079": "ASPROVATalk",
    "1080": "Socks",
    "1081": "PVUNIWIEN",
    "1082": "AMT-ESD-PROT",
    "1083": "Anasoft License Manager",
    "1084": "Anasoft License Manager",
    "1085": "Web Objects",
    "1086": "CPL Scrambler Logging",
    "1087": "CPL Scrambler Internal",
    "1088": "CPL Scrambler Alarm Log",
    "1089": "FF Annunciation",
    "1090": "FF Fieldbus Message Specification",
    "1091": "FF System Management",
    "1092": "Open Business Reporting Protocol",
    "1093": "PROOFD",
    "1094": "ROOTD",
    "1095": "NICELink",
    "1096": "Common Name Resolution Protocol",
    "1097": "Sun Cluster Manager",
    "1098": "RMI Activation",
    "1099": "RMI Registry",
    "1100": "MCTP",
    "1101": "PT2-DISCOVER",
    "1102": "ADOBE SERVER 1",
    "1103": "ADOBE SERVER 2",
    "1104": "XRL",
    "1105": "FTRANHC",
    "1106": "ISOIPSIGPORT-1",
    "1107": "ISOIPSIGPORT-2",
    "1108": "ratio-adp",
    "1110": "Start web admin server",
    "1111": "LM Social Server",
    "1112": "Intelligent Communication Protocol",
    "1113": "Licklider Transmission Protocol",
    "1114": "Mini SQL",
    "1115": "ARDUS Transfer",
    "1116": "ARDUS Control",
    "1117": "ARDUS Multicast Transfer",
    "1118": "SACRED",
    "1119": "Battle.net Chat/Game Protocol",
    "1120": "Battle.net File Transfer Protocol",
    "1121": "Datalode RMPP",
    "1122": "availant-mgr",
    "1123": "Murray",
    "1124": "HP VMM Control",
    "1125": "HP VMM Agent",
    "1126": "HP VMM Agent",
    "1127": "KWDB Remote Communication",
    "1128": "SAPHostControl over SOAP/HTTP",
    "1129": "SAPHostControl over SOAP/HTTPS",
    "1130": "CAC App Service Protocol",
    "1131": "CAC App Service Protocol Encripted",
    "1132": "KVM-via-IP Management Service",
    "1133": "Data Flow Network",
    "1134": "MicroAPL APLX",
    "1135": "OmniVision Communication Service",
    "1136": "HHB Gateway Control",
    "1137": "TRIM Workgroup Service",
    "1138": "encrypted admin requests",
    "1138": "encrypted admin requests",
    "1139": "Enterprise Virtual Manager",
    "1140": "AutoNOC Network Operations Protocol",
    "1141": "User Message Service",
    "1142": "User Discovery Service",
    "1143": "Infomatryx Exchange",
    "1144": "Fusion Script",
    "1145": "X9 iCue Show Control",
    "1146": "audit transfer",
    "1147": "CAPIoverLAN",
    "1148": "Elfiq Replication Service",
    "1149": "BlueView Sonar Service",
    "1150": "Blaze File Server",
    "1151": "Unizensus Login Server",
    "1152": "Winpopup LAN Messenger",
    "1153": "ANSI C12.22 Port",
    "1154": "Community Service",
    "1155": "Network File Access",
    "1156": "iasControl OMS",
    "1157": "Oracle iASControl",
    "1158": "dbControl OMS",
    "1159": "Oracle OMS",
    "1160": "DB Lite Mult-User Server",
    "1161": "Health Polling",
    "1162": "Health Trap",
    "1163": "SmartDialer Data Protocol",
    "1164": "QSM Proxy Service",
    "1165": "QSM GUI Service",
    "1166": "QSM RemoteExec",
    "1167": "Cisco IP SLAs Control Protocol",
    "1168": "VChat Conference Service",
    "1169": "TRIPWIRE",
    "1170": "AT+C License Manager",
    "1171": "AT+C FmiApplicationServer",
    "1172": "DNA Protocol",
    "1173": "D-Cinema Request-Response",
    "1174": "FlashNet Remote Admin",
    "1175": "Dossier Server",
    "1176": "Indigo Home Server",
    "1177": "DKMessenger Protocol",
    "1178": "SGI Storage Manager",
    "1179": "Backup To Neighbor",
    "1180": "Millicent Client Proxy",
    "1181": "3Com Net Management",
    "1182": "AcceleNet Control",
    "1183": "LL Surfup HTTP",
    "1184": "LL Surfup HTTPS",
    "1185": "Catchpole port",
    "1186": "MySQL Cluster Manager",
    "1187": "Alias Service",
    "1188": "HP Web Admin",
    "1189": "Unet Connection",
    "1190": "CommLinx GPS / AVL System",
    "1191": "General Parallel File System",
    "1192": "caids sensors channel",
    "1193": "Five Across Server",
    "1194": "OpenVPN",
    "1195": "RSF-1 clustering",
    "1196": "Network Magic",
    "1197": "Carrius Remote Access",
    "1198": "cajo reference discovery",
    "1199": "DMIDI",
    "1200": "SCOL",
    "1201": "Nucleus Sand Database Server",
    "1202": "caiccipc",
    "1203": "License Validation",
    "1204": "Log Request Listener",
    "1205": "Accord-MGC",
    "1206": "Anthony Data",
    "1207": "MetaSage",
    "1208": "SEAGULL AIS",
    "1209": "IPCD3",
    "1210": "EOSS",
    "1211": "Groove DPP",
    "1212": "lupa",
    "1213": "Medtronic/Physio-Control LIFENET",
    "1214": "KAZAA",
    "1215": "scanSTAT 1.0",
    "1216": "ETEBAC 5",
    "1217": "HPSS NonDCE Gateway",
    "1218": "AeroFlight-ADs",
    "1219": "AeroFlight-Ret",
    "1220": "QT SERVER ADMIN",
    "1221": "SweetWARE Apps",
    "1222": "SNI R&amp;D network",
    "1223": "TrulyGlobal Protocol",
    "1224": "VPNz",
    "1225": "SLINKYSEARCH",
    "1226": "STGXFWS",
    "1227": "DNS2Go",
    "1228": "FLORENCE",
    "1229": "ZENworks Tiered Electronic Distribution",
    "1230": "Periscope",
    "1231": "menandmice-lpm",
    "1232": "Remote systems monitoring",
    "1233": "Universal App Server",
    "1234": "Infoseek Search Agent",
    "1235": "mosaicsyssvc1",
    "1236": "bvcontrol",
    "1237": "tsdos390",
    "1238": "hacl-qs",
    "1239": "NMSD",
    "1240": "Instantia",
    "1241": "nessus",
    "1242": "NMAS over IP",
    "1243": "SerialGateway",
    "1244": "isbconference1",
    "1245": "isbconference2",
    "1246": "payrouter",
    "1247": "VisionPyramid",
    "1248": "hermes",
    "1249": "Mesa Vista Co",
    "1250": "swldy-sias",
    "1251": "servergraph",
    "1252": "bspne-pcc",
    "1253": "q55-pcc",
    "1254": "de-noc",
    "1255": "de-cache-query",
    "1256": "de-server",
    "1257": "Shockwave 2",
    "1258": "Open Network Library",
    "1259": "Open Network Library Voice",
    "1260": "ibm-ssd",
    "1261": "mpshrsv",
    "1262": "QNTS-ORB",
    "1263": "dka",
    "1264": "PRAT",
    "1265": "DSSIAPI",
    "1266": "DELLPWRAPPKS",
    "1267": "eTrust Policy Compliance",
    "1268": "PROPEL-MSGSYS",
    "1269": "WATiLaPP",
    "1270": "Microsoft Operations Manager",
    "1271": "eXcW",
    "1272": "CSPMLockMgr",
    "1273": "EMC-Gateway",
    "1274": "t1distproc",
    "1275": "ivcollector",
    "1276": "Reserved",
    "1277": "mqs",
    "1278": "Dell Web Admin 1",
    "1279": "Dell Web Admin 2",
    "1280": "Pictrography",
    "1281": "healthd",
    "1282": "Emperion",
    "1283": "Product Information",
    "1284": "IEE-QFX",
    "1285": "neoiface",
    "1286": "netuitive",
    "1287": "RouteMatch Com",
    "1288": "NavBuddy",
    "1289": "JWalkServer",
    "1290": "WinJaServer",
    "1291": "SEAGULLLMS",
    "1292": "dsdn",
    "1293": "PKT-KRB-IPSec",
    "1294": "CMMdriver",
    "1295": "End-by-Hop Transmission Protocol",
    "1296": "dproxy",
    "1297": "sdproxy",
    "1298": "lpcp",
    "1299": "hp-sci",
    "1300": "H.323 Secure Call Control Signalling",
    "1301": "Reserved",
    "1302": "Reserved",
    "1303": "sftsrv",
    "1304": "Boomerang",
    "1305": "pe-mike",
    "1306": "RE-Conn-Proto",
    "1307": "Pacmand",
    "1308": "Optical Domain Service Interconnect (ODSI)",
    "1309": "JTAG server",
    "1310": "Husky",
    "1311": "RxMon",
    "1312": "STI Envision",
    "1313": "BMC_PATROLDB",
    "1313": "BMC_PATROLDB",
    "1314": "Photoscript Distributed Printing System",
    "1315": "E.L.S., Event Listener Service",
    "1316": "Exbit-ESCP",
    "1317": "vrts-ipcserver",
    "1318": "krb5gatekeeper",
    "1319": "AMX-ICSP",
    "1320": "AMX-AXBNET",
    "1321": "PIP",
    "1322": "Novation",
    "1323": "brcd",
    "1324": "delta-mcp",
    "1325": "DX-Instrument",
    "1326": "WIMSIC",
    "1327": "Ultrex",
    "1328": "EWALL",
    "1329": "netdb-export",
    "1330": "StreetPerfect",
    "1331": "intersan",
    "1332": "PCIA RXP-B",
    "1333": "Password Policy",
    "1334": "writesrv",
    "1335": "Digital Notary Protocol",
    "1336": "Instant Service Chat",
    "1337": "menandmice DNS",
    "1338": "WMC-log-svr",
    "1339": "kjtsiteserver",
    "1340": "NAAP",
    "1341": "QuBES",
    "1342": "ESBroker",
    "1343": "re101",
    "1344": "ICAP",
    "1345": "VPJP",
    "1346": "Alta Analytics License Manager",
    "1347": "multi media conferencing",
    "1348": "multi media conferencing",
    "1349": "Registration Network Protocol",
    "1350": "Registration Network Protocol",
    "1351": "Digital Tool Works (MIT)",
    "1352": "Lotus Note",
    "1353": "Relief Consulting",
    "1354": "Five Across XSIP Network",
    "1355": "Intuitive Edge",
    "1356": "CuillaMartin Company",
    "1357": "Electronic PegBoard",
    "1358": "CONNLCLI",
    "1359": "FTSRV",
    "1360": "MIMER",
    "1361": "LinX",
    "1362": "TimeFlies",
    "1363": "Network DataMover Requester",
    "1364": "Network DataMover Server",
    "1365": "Network Software Associates",
    "1366": "Novell NetWare Comm Service Platform",
    "1367": "DCS",
    "1368": "ScreenCast",
    "1369": "GlobalView to Unix Shell",
    "1370": "Unix Shell to GlobalView",
    "1371": "Fujitsu Config Protocol",
    "1372": "Fujitsu Config Protocol",
    "1373": "Chromagrafx",
    "1374": "EPI Software Systems",
    "1375": "Bytex",
    "1376": "IBM Person to Person Software",
    "1377": "Cichlid License Manager",
    "1378": "Elan License Manager",
    "1379": "Integrity Solutions",
    "1380": "Telesis Network License Manager",
    "1381": "Apple Network License Manager",
    "1382": "udt_os",
    "1382": "udt_os",
    "1383": "GW Hannaway Network License Manager",
    "1384": "Objective Solutions License Manager",
    "1385": "Atex Publishing License Manager",
    "1385": "Atex Publishing License Manager",
    "1386": "CheckSum License Manager",
    "1387": "Computer Aided Design Software Inc LM",
    "1388": "Objective Solutions DataBase Cache",
    "1389": "Document Manager",
    "1390": "Storage Controller",
    "1391": "Storage Access Server",
    "1392": "Print Manager",
    "1393": "Network Log Server",
    "1394": "Network Log Client",
    "1395": "PC Workstation Manager software",
    "1396": "DVL Active Mail",
    "1397": "Audio Active Mail",
    "1398": "Video Active Mail",
    "1399": "Cadkey License Manager",
    "1400": "Cadkey Tablet Daemon",
    "1401": "Goldleaf License Manager",
    "1402": "Prospero Resource Manager",
    "1403": "Prospero Resource Manager",
    "1404": "Infinite Graphics License Manager",
    "1405": "IBM Remote Execution Starter",
    "1406": "NetLabs License Manager",
    "1407": "TIBET Data Server",
    "1408": "Sophia License Manager",
    "1409": "Here License Manager",
    "1410": "HiQ License Manager",
    "1411": "AudioFile",
    "1412": "InnoSys",
    "1413": "Innosys-ACL",
    "1414": "IBM MQSeries",
    "1415": "DBStar",
    "1416": "Novell LU6.2",
    "1416": "Novell LU6.2",
    "1417": "Timbuktu Service 1 Port",
    "1418": "Timbuktu Service 2 Port",
    "1419": "Timbuktu Service 3 Port",
    "1420": "Timbuktu Service 4 Port",
    "1421": "Gandalf License Manager",
    "1422": "Autodesk License Manager",
    "1423": "Essbase Arbor Software",
    "1424": "Hybrid Encryption Protocol",
    "1425": "Zion Software License Manager",
    "1426": "Satellite-data Acquisition System 1",
    "1427": "mloadd monitoring tool",
    "1428": "Informatik License Manager",
    "1429": "Hypercom NMS",
    "1430": "Hypercom TPDU",
    "1431": "Reverse Gossip Transport",
    "1432": "Blueberry Software License Manager",
    "1433": "Microsoft-SQL-Server",
    "1434": "Microsoft-SQL-Monitor",
    "1435": "IBM CICS",
    "1436": "Satellite-data Acquisition System 2",
    "1437": "Tabula",
    "1438": "Eicon Security Agent/Server",
    "1439": "Eicon X25/SNA Gateway",
    "1440": "Eicon Service Location Protocol",
    "1441": "Cadis License Management",
    "1442": "Cadis License Management",
    "1443": "Integrated Engineering Software",
    "1444": "Marcam  License Management",
    "1445": "Proxima License Manager",
    "1446": "Optical Research Associates License Manager",
    "1447": "Applied Parallel Research LM",
    "1448": "OpenConnect License Manager",
    "1449": "PEport",
    "1450": "Tandem Distributed Workbench Facility",
    "1451": "IBM Information Management",
    "1452": "GTE Government Systems License Man",
    "1453": "Genie License Manager",
    "1454": "interHDL License Manager",
    "1454": "interHDL License Manager",
    "1455": "ESL License Manager",
    "1456": "DCA",
    "1457": "Valisys License Manager",
    "1458": "Nichols Research Corp.",
    "1459": "Proshare Notebook Application",
    "1460": "Proshare Notebook Application",
    "1461": "IBM Wireless LAN",
    "1461": "IBM Wireless LAN",
    "1462": "World License Manager",
    "1463": "Nucleus",
    "1464": "MSL License Manager",
    "1464": "MSL License Manager",
    "1465": "Pipes Platform",
    "1466": "Ocean Software License Manager",
    "1467": "CSDMBASE",
    "1468": "CSDM",
    "1469": "Active Analysis Limited License Manager",
    "1470": "Universal Analytics",
    "1471": "csdmbase",
    "1472": "csdm",
    "1473": "OpenMath",
    "1474": "Telefinder",
    "1475": "Taligent License Manager",
    "1476": "clvm-cfg",
    "1477": "ms-sna-server",
    "1478": "ms-sna-base",
    "1479": "dberegister",
    "1480": "PacerForum",
    "1481": "AIRS",
    "1482": "Miteksys License Manager",
    "1483": "AFS License Manager",
    "1484": "Confluent License Manager",
    "1485": "LANSource",
    "1486": "nms_topo_serv",
    "1486": "nms_topo_serv",
    "1487": "LocalInfoSrvr",
    "1488": "DocStor",
    "1489": "dmdocbroker",
    "1490": "insitu-conf",
    "1492": "stone-design-1",
    "1493": "netmap_lm",
    "1493": "netmap_lm",
    "1494": "ica",
    "1495": "cvc",
    "1496": "liberty-lm",
    "1497": "rfx-lm",
    "1498": "Sybase SQL Any",
    "1499": "Federico Heinz Consultora",
    "1500": "VLSI License Manager",
    "1501": "Satellite-data Acquisition System 3",
    "1502": "Shiva",
    "1503": "Databeam",
    "1504": "EVB Software Engineering License Manager",
    "1505": "Funk Software, Inc.",
    "1506": "Universal Time daemon (utcd)",
    "1507": "symplex",
    "1508": "diagmond",
    "1509": "Robcad, Ltd. License Manager",
    "1510": "Midland Valley Exploration Ltd. Lic. Man.",
    "1511": "3l-l1",
    "1512": "Microsoft's Windows Internet Name Service",
    "1513": "Fujitsu Systems Business of America, Inc",
    "1514": "Fujitsu Systems Business of America, Inc",
    "1515": "ifor-protocol",
    "1516": "Virtual Places Audio data",
    "1517": "Virtual Places Audio control",
    "1518": "Virtual Places Video data",
    "1519": "Virtual Places Video control",
    "1520": "atm zip office",
    "1521": "nCube License Manager",
    "1522": "Ricardo North America License Manager",
    "1523": "cichild",
    "1524": "ingres",
    "1525": "oracle",
    "1526": "Prospero Data Access Prot non-priv",
    "1527": "oracle",
    "1528": "Not Only a Routeing Protocol",
    "1529": "oracle",
    "1530": "rap-service",
    "1531": "rap-listen",
    "1532": "miroconnect",
    "1533": "Virtual Places Software",
    "1534": "micromuse-lm",
    "1535": "ampr-info",
    "1536": "ampr-inter",
    "1537": "isi-lm",
    "1538": "3ds-lm",
    "1539": "Intellistor License Manager",
    "1540": "rds",
    "1541": "rds2",
    "1542": "gridgen-elmd",
    "1543": "simba-cs",
    "1544": "aspeclmd",
    "1545": "vistium-share",
    "1546": "abbaccuray",
    "1547": "laplink",
    "1548": "Axon License Manager",
    "1549": "Shiva Hose",
    "1550": "Image Storage license manager 3M Company",
    "1551": "HECMTL-DB",
    "1552": "pciarray",
    "1553": "sna-cs",
    "1554": "CACI Products Company License Manager",
    "1555": "livelan",
    "1556": "VERITAS Private Branch Exchange",
    "1556": "VERITAS Private Branch Exchange",
    "1557": "ArborText License Manager",
    "1558": "xingmpeg",
    "1559": "web2host",
    "1560": "ASCI-RemoteSHADOW",
    "1561": "facilityview",
    "1562": "pconnectmgr",
    "1563": "Cadabra License Manager",
    "1564": "Pay-Per-View",
    "1565": "WinDD",
    "1566": "CORELVIDEO",
    "1567": "jlicelmd",
    "1568": "tsspmap",
    "1569": "ets",
    "1570": "orbixd",
    "1571": "Oracle Remote Data Base",
    "1572": "Chipcom License Manager",
    "1573": "itscomm-ns",
    "1574": "mvel-lm",
    "1575": "oraclenames",
    "1576": "Moldflow License Manager",
    "1577": "hypercube-lm",
    "1578": "Jacobus License Manager",
    "1579": "ioc-sea-lm",
    "1580": "tn-tl-r1",
    "1581": "MIL-2045-47001",
    "1582": "MSIMS",
    "1583": "simbaexpress",
    "1584": "tn-tl-fd2",
    "1585": "intv",
    "1586": "ibm-abtact",
    "1587": "pra_elmd",
    "1587": "pra_elmd",
    "1588": "triquest-lm",
    "1589": "VQP",
    "1590": "gemini-lm",
    "1591": "ncpm-pm",
    "1592": "commonspace",
    "1593": "mainsoft-lm",
    "1594": "sixtrak",
    "1595": "radio",
    "1596": "radio-sm",
    "1597": "orbplus-iiop",
    "1598": "picknfs",
    "1599": "simbaservices",
    "1600": "issd",
    "1601": "aas",
    "1602": "inspect",
    "1603": "pickodbc",
    "1604": "icabrowser",
    "1605": "Salutation Manager (Salutation Protocol)",
    "1606": "Salutation Manager (SLM-API)",
    "1607": "stt",
    "1608": "Smart Corp. License Manager",
    "1609": "isysg-lm",
    "1610": "taurus-wh",
    "1611": "Inter Library Loan",
    "1612": "NetBill Transaction Server",
    "1613": "NetBill Key Repository",
    "1614": "NetBill Credential Server",
    "1615": "NetBill Authorization Server",
    "1616": "NetBill Product Server",
    "1617": "Nimrod Inter-Agent Communication",
    "1618": "skytelnet",
    "1619": "xs-openstorage",
    "1620": "faxportwinport",
    "1621": "softdataphone",
    "1622": "ontime",
    "1623": "jaleosnd",
    "1624": "udp-sr-port",
    "1625": "svs-omagent",
    "1626": "Shockwave",
    "1627": "T.128 Gateway",
    "1628": "LonTalk normal",
    "1629": "LonTalk urgent",
    "1630": "Oracle Net8 Cman",
    "1631": "Visit view",
    "1632": "PAMMRATC",
    "1633": "PAMMRPC",
    "1634": "Log On America Probe",
    "1635": "EDB Server 1",
    "1636": "ISP shared public data control",
    "1637": "ISP shared local data control",
    "1638": "ISP shared management control",
    "1639": "cert-initiator",
    "1640": "cert-responder",
    "1641": "InVision",
    "1642": "isis-am",
    "1643": "isis-ambc",
    "1644": "Satellite-data Acquisition System 4",
    "1645": "SightLine",
    "1646": "sa-msg-port",
    "1647": "rsap",
    "1648": "concurrent-lm",
    "1649": "kermit",
    "1650": "nkdn",
    "1651": "shiva_confsrvr",
    "1651": "shiva_confsrvr",
    "1652": "xnmp",
    "1653": "alphatech-lm",
    "1654": "stargatealerts",
    "1655": "dec-mbadmin",
    "1656": "dec-mbadmin-h",
    "1657": "fujitsu-mmpdc",
    "1658": "sixnetudr",
    "1659": "Silicon Grail License Manager",
    "1660": "skip-mc-gikreq",
    "1661": "netview-aix-1",
    "1662": "netview-aix-2",
    "1663": "netview-aix-3",
    "1664": "netview-aix-4",
    "1665": "netview-aix-5",
    "1666": "netview-aix-6",
    "1667": "netview-aix-7",
    "1668": "netview-aix-8",
    "1669": "netview-aix-9",
    "1670": "netview-aix-10",
    "1671": "netview-aix-11",
    "1672": "netview-aix-12",
    "1673": "Intel Proshare Multicast",
    "1674": "Intel Proshare Multicast",
    "1675": "Pacific Data Products",
    "1676": "netcomm1",
    "1677": "groupwise",
    "1678": "prolink",
    "1679": "darcorp-lm",
    "1680": "microcom-sbp",
    "1681": "sd-elmd",
    "1682": "lanyon-lantern",
    "1683": "ncpm-hip",
    "1684": "SnareSecure",
    "1685": "n2nremote",
    "1686": "cvmon",
    "1687": "nsjtp-ctrl",
    "1688": "nsjtp-data",
    "1689": "firefox",
    "1690": "ng-umds",
    "1691": "empire-empuma",
    "1692": "sstsys-lm",
    "1693": "rrirtr",
    "1694": "rrimwm",
    "1695": "rrilwm",
    "1696": "rrifmm",
    "1697": "rrisat",
    "1698": "RSVP-ENCAPSULATION-1",
    "1699": "RSVP-ENCAPSULATION-2",
    "1700": "mps-raft",
    "1701": "l2f",
    "1702": "deskshare",
    "1703": "hb-engine",
    "1704": "bcs-broker",
    "1705": "slingshot",
    "1706": "jetform",
    "1707": "vdmplay",
    "1708": "gat-lmd",
    "1709": "centra",
    "1710": "impera",
    "1711": "pptconference",
    "1712": "resource monitoring service",
    "1713": "ConferenceTalk",
    "1714": "sesi-lm",
    "1715": "houdini-lm",
    "1716": "xmsg",
    "1717": "fj-hdnet",
    "1718": "H.323 Multicast Gatekeeper Discover",
    "1719": "H.323 Unicast Gatekeeper Signaling",
    "1720": "H.323 Call Control Signalling",
    "1721": "caicci",
    "1722": "HKS License Manager",
    "1723": "pptp",
    "1724": "csbphonemaster",
    "1725": "iden-ralp",
    "1726": "IBERIAGAMES",
    "1727": "winddx",
    "1728": "TELINDUS",
    "1729": "CityNL License Management",
    "1730": "roketz",
    "1731": "MSICCP",
    "1732": "proxim",
    "1733": "SIMS - SIIPAT Protocol for Alarm Transmission",
    "1734": "Camber Corporation License Management",
    "1735": "PrivateChat",
    "1736": "street-stream",
    "1737": "ultimad",
    "1738": "GameGen1",
    "1739": "webaccess",
    "1740": "encore",
    "1741": "cisco-net-mgmt",
    "1742": "3Com-nsd",
    "1743": "Cinema Graphics License Manager",
    "1744": "ncpm-ft",
    "1745": "remote-winsock",
    "1746": "ftrapid-1",
    "1747": "ftrapid-2",
    "1748": "oracle-em1",
    "1749": "aspen-services",
    "1750": "Simple Socket Library's PortMaster",
    "1751": "SwiftNet",
    "1752": "Leap of Faith Research License Manager",
    "1753": "Predatar Comms Service",
    "1754": "oracle-em2",
    "1755": "ms-streaming",
    "1756": "capfast-lmd",
    "1757": "cnhrp",
    "1758": "tftp-mcast",
    "1759": "SPSS License Manager",
    "1760": "www-ldap-gw",
    "1761": "cft-0",
    "1762": "cft-1",
    "1763": "cft-2",
    "1764": "cft-3",
    "1765": "cft-4",
    "1766": "cft-5",
    "1767": "cft-6",
    "1768": "cft-7",
    "1769": "bmc-net-adm",
    "1770": "bmc-net-svc",
    "1771": "vaultbase",
    "1772": "EssWeb Gateway",
    "1773": "KMSControl",
    "1774": "global-dtserv",
    "1775": "data interchange between visual processing containers",
    "1776": "Federal Emergency Management Information System",
    "1777": "powerguardian",
    "1778": "prodigy-internet",
    "1779": "pharmasoft",
    "1780": "dpkeyserv",
    "1781": "answersoft-lm",
    "1782": "hp-hcip",
    "1784": "Finle License Manager",
    "1785": "Wind River Systems License Manager",
    "1786": "funk-logger",
    "1787": "funk-license",
    "1788": "psmond",
    "1789": "hello",
    "1790": "Narrative Media Streaming Protocol",
    "1791": "EA1",
    "1792": "ibm-dt-2",
    "1793": "rsc-robot",
    "1794": "cera-bcm",
    "1795": "dpi-proxy",
    "1796": "Vocaltec Server Administration",
    "1797": "UMA",
    "1798": "Event Transfer Protocol",
    "1799": "NETRISK",
    "1800": "ANSYS-License manager",
    "1801": "Microsoft Message Que",
    "1802": "ConComp1",
    "1803": "HP-HCIP-GWY",
    "1804": "ENL",
    "1805": "ENL-Name",
    "1806": "Musiconline",
    "1807": "Fujitsu Hot Standby Protocol",
    "1808": "Oracle-VP2",
    "1809": "Oracle-VP1",
    "1810": "Jerand License Manager",
    "1811": "Scientia-SDB",
    "1812": "RADIUS",
    "1813": "RADIUS Accounting",
    "1814": "TDP Suite",
    "1815": "MMPFT",
    "1816": "HARP",
    "1817": "RKB-OSCS",
    "1818": "Enhanced Trivial File Transfer Protocol",
    "1819": "Plato License Manager",
    "1820": "mcagent",
    "1821": "donnyworld",
    "1822": "es-elmd",
    "1823": "Unisys Natural Language License Manager",
    "1824": "metrics-pas",
    "1825": "DirecPC Video",
    "1826": "ARDT",
    "1827": "ASI",
    "1828": "itm-mcell-u",
    "1829": "Optika eMedia",
    "1830": "Oracle Net8 CMan Admin",
    "1831": "Myrtle",
    "1832": "ThoughtTreasure",
    "1833": "udpradio",
    "1834": "ARDUS Unicast",
    "1835": "ARDUS Multicast",
    "1836": "ste-smsc",
    "1837": "csoft1",
    "1838": "TALNET",
    "1839": "netopia-vo1",
    "1840": "netopia-vo2",
    "1841": "netopia-vo3",
    "1842": "netopia-vo4",
    "1843": "netopia-vo5",
    "1844": "DirecPC-DLL",
    "1845": "altalink",
    "1846": "Tunstall PNC",
    "1847": "SLP Notification",
    "1848": "fjdocdist",
    "1849": "ALPHA-SMS",
    "1850": "GSI",
    "1851": "ctcd",
    "1852": "Virtual Time",
    "1853": "VIDS-AVTP",
    "1854": "Buddy Draw",
    "1855": "Fiorano RtrSvc",
    "1856": "Fiorano MsgSvc",
    "1857": "DataCaptor",
    "1858": "PrivateArk",
    "1859": "Gamma Fetcher Server",
    "1860": "SunSCALAR Services",
    "1861": "LeCroy VICP",
    "1862": "MySQL Cluster Manager Agent",
    "1863": "MSNP",
    "1864": "Paradym 31 Port",
    "1865": "ENTP",
    "1866": "swrmi",
    "1867": "UDRIVE",
    "1868": "VizibleBrowser",
    "1869": "TransAct",
    "1870": "SunSCALAR DNS Service",
    "1871": "Cano Central 0",
    "1872": "Cano Central 1",
    "1873": "Fjmpjps",
    "1874": "Fjswapsnp",
    "1875": "westell stats",
    "1876": "ewcappsrv",
    "1877": "hp-webqosdb",
    "1878": "drmsmc",
    "1879": "NettGain NMS",
    "1880": "Gilat VSAT Control",
    "1881": "IBM WebSphere MQ Everyplace",
    "1882": "CA eTrust Common Services",
    "1883": "Message Queuing Telemetry Transport Protocol",
    "1884": "Internet Distance Map Svc",
    "1885": "Veritas Trap Server",
    "1886": "Leonardo over IP",
    "1887": "FileX Listening Port",
    "1888": "NC Config Port",
    "1889": "Unify Web Adapter Service",
    "1890": "wilkenListener",
    "1891": "ChildKey Notification",
    "1892": "ChildKey Control",
    "1893": "ELAD Protocol",
    "1894": "O2Server Port",
    "1895": "unassigned",
    "1896": "b-novative license server",
    "1897": "MetaAgent",
    "1898": "Cymtec secure management",
    "1899": "MC2Studios",
    "1900": "SSDP",
    "1901": "Fujitsu ICL Terminal Emulator Program A",
    "1902": "Fujitsu ICL Terminal Emulator Program B",
    "1903": "Local Link Name Resolution",
    "1904": "Fujitsu ICL Terminal Emulator Program C",
    "1905": "Secure UP.Link Gateway Protocol",
    "1906": "TPortMapperReq",
    "1907": "IntraSTAR",
    "1908": "Dawn",
    "1909": "Global World Link",
    "1910": "UltraBac Software communications port",
    "1911": "Starlight Networks Multimedia Transport Protocol",
    "1912": "rhp-iibp",
    "1913": "armadp",
    "1914": "Elm-Momentum",
    "1915": "FACELINK",
    "1916": "Persoft Persona",
    "1917": "nOAgent",
    "1918": "IBM Tivole Directory Service - NDS",
    "1919": "IBM Tivoli Directory Service - DCH",
    "1920": "IBM Tivoli Directory Service - FERRET",
    "1921": "NoAdmin",
    "1922": "Tapestry",
    "1923": "SPICE",
    "1924": "XIIP",
    "1925": "Surrogate Discovery Port",
    "1926": "Evolution Game Server",
    "1927": "Videte CIPC Port",
    "1928": "Expnd Maui Srvr Dscovr",
    "1929": "Bandwiz System - Server",
    "1930": "Drive AppServer",
    "1931": "AMD SCHED",
    "1932": "CTT Broker",
    "1933": "IBM LM MT Agent",
    "1934": "IBM LM Appl Agent",
    "1935": "Macromedia Flash Communications Server MX",
    "1936": "JetCmeServer Server Port",
    "1937": "JetVWay Server Port",
    "1938": "JetVWay Client Port",
    "1939": "JetVision Server Port",
    "1940": "JetVision Client Port",
    "1941": "DIC-Aida",
    "1942": "Real Enterprise Service",
    "1943": "Beeyond Media",
    "1944": "close-combat",
    "1945": "dialogic-elmd",
    "1946": "tekpls",
    "1947": "SentinelSRM",
    "1948": "eye2eye",
    "1949": "ISMA Easdaq Live",
    "1950": "ISMA Easdaq Test",
    "1951": "bcs-lmserver",
    "1952": "mpnjsc",
    "1953": "Rapid Base",
    "1954": "ABR-API (diskbridge)",
    "1955": "ABR-Secure Data (diskbridge)",
    "1956": "Vertel VMF DS",
    "1957": "unix-status",
    "1958": "CA Administration Daemon",
    "1959": "SIMP Channel",
    "1960": "Merit DAC NASmanager",
    "1961": "BTS APPSERVER",
    "1962": "BIAP-MP",
    "1963": "WebMachine",
    "1964": "SOLID E ENGINE",
    "1965": "Tivoli NPM",
    "1966": "Slush",
    "1967": "SNS Quote",
    "1968": "LIPSinc",
    "1969": "LIPSinc 1",
    "1970": "NetOp Remote Control",
    "1971": "NetOp School",
    "1972": "Cache",
    "1973": "Data Link Switching Remote Access Protocol",
    "1974": "DRP",
    "1975": "TCO Flash Agent",
    "1976": "TCO Reg Agent",
    "1977": "TCO Address Book",
    "1978": "UniSQL",
    "1979": "UniSQL Java",
    "1980": "PearlDoc XACT",
    "1981": "p2pQ",
    "1982": "Evidentiary Timestamp",
    "1983": "Loophole Test Protocol",
    "1984": "BB",
    "1985": "Hot Standby Router Protocol",
    "1986": "cisco license management",
    "1987": "cisco RSRB Priority 1 port",
    "1988": "cisco RSRB Priority 2 port",
    "1989": "cisco RSRB Priority 3 port",
    "1990": "cisco STUN Priority 1 port",
    "1991": "cisco STUN Priority 2 port",
    "1992": "cisco STUN Priority 3 port",
    "1993": "cisco SNMP TCP port",
    "1994": "cisco serial tunnel port",
    "1995": "cisco perf port",
    "1996": "cisco Remote SRB port",
    "1997": "cisco Gateway Discovery Protocol",
    "1998": "cisco X.25 service (XOT)",
    "1999": "cisco identification port",
    "2000": "Cisco SCCP",
    "2001": "",
    "2002": "",
    "2003": "Brutus Server",
    "2004": "",
    "2005": "",
    "2006": "",
    "2007": "",
    "2008": "",
    "2009": "",
    "2010": "",
    "2011": "raid",
    "2012": "",
    "2013": "",
    "2014": "",
    "2015": "",
    "2016": "",
    "2017": "",
    "2018": "",
    "2019": "",
    "2020": "",
    "2021": "",
    "2022": "",
    "2023": "",
    "2024": "",
    "2025": "",
    "2026": "",
    "2027": "",
    "2028": "",
    "2029": "Hot Standby Router Protocol IPv6",
    "2030": "",
    "2031": "mobrien-chat",
    "2032": "",
    "2033": "",
    "2034": "",
    "2035": "",
    "2036": "Ethernet WS DP network",
    "2037": "APplus Application Server",
    "2038": "",
    "2039": "Prizma Monitoring Service",
    "2040": "",
    "2041": "",
    "2042": "isis",
    "2043": "isis-bcast",
    "2044": "",
    "2045": "",
    "2046": "",
    "2047": "",
    "2048": "",
    "2049": "Network File System - Sun Microsystems",
    "2050": "Avaya EMB Config Port",
    "2051": "EPNSDP",
    "2052": "clearVisn Services Port",
    "2053": "Lot105 DSuper Updates",
    "2054": "Weblogin Port",
    "2055": "Iliad-Odyssey Protocol",
    "2056": "OmniSky Port",
    "2057": "Rich Content Protocol",
    "2058": "NewWaveSearchables RMI",
    "2059": "BMC Messaging Service",
    "2060": "Telenium Daemon IF",
    "2061": "NetMount",
    "2062": "ICG SWP Port",
    "2063": "ICG Bridge Port",
    "2064": "ICG IP Relay Port",
    "2065": "Data Link Switch Read Port Number",
    "2066": "AVM USB Remote Architecture",
    "2067": "Data Link Switch Write Port Number",
    "2068": "Avocent AuthSrv Protocol",
    "2069": "HTTP Event Port",
    "2070": "AH and ESP Encapsulated in UDP packet",
    "2071": "Axon Control Protocol",
    "2072": "GlobeCast mSync",
    "2073": "DataReel Database Socket",
    "2074": "Vertel VMF SA",
    "2075": "Newlix ServerWare Engine",
    "2076": "Newlix JSPConfig",
    "2077": "Old Tivoli Storage Manager",
    "2078": "IBM Total Productivity Center Server",
    "2079": "IDWARE Router Port",
    "2080": "Autodesk NLM (FLEXlm)",
    "2081": "KME PRINTER TRAP PORT",
    "2082": "Infowave Mobility Server",
    "2083": "Secure Radius Service",
    "2084": "SunCluster Geographic",
    "2085": "ADA Control",
    "2086": "GNUnet",
    "2087": "ELI - Event Logging Integration",
    "2088": "IP Busy Lamp Field",
    "2089": "Security Encapsulation Protocol - SEP",
    "2090": "Load Report Protocol",
    "2091": "PRP",
    "2092": "Descent 3",
    "2093": "NBX CC",
    "2094": "NBX AU",
    "2095": "NBX SER",
    "2096": "NBX DIR",
    "2097": "Jet Form Preview",
    "2098": "Dialog Port",
    "2099": "H.225.0 Annex G Signalling",
    "2100": "Amiga Network Filesystem",
    "2101": "rtcm-sc104",
    "2102": "Zephyr server",
    "2103": "Zephyr serv-hm connection",
    "2104": "Zephyr hostmanager",
    "2105": "MiniPay",
    "2106": "MZAP",
    "2107": "BinTec Admin",
    "2108": "Comcam",
    "2109": "Ergolight",
    "2110": "UMSP",
    "2111": "OPNET Dynamic Sampling Agent Transaction Protocol",
    "2112": "Idonix MetaNet",
    "2113": "HSL StoRM",
    "2114": "Classical Music Meta-Data Access and Enhancement",
    "2115": "Key Distribution Manager",
    "2116": "CCOWCMR",
    "2117": "MENTACLIENT",
    "2118": "MENTASERVER",
    "2119": "GSIGATEKEEPER",
    "2120": "Quick Eagle Networks CP",
    "2121": "SCIENTIA-SSDB",
    "2122": "CauPC Remote Control",
    "2123": "GTP-Control Plane (3GPP)",
    "2124": "ELATELINK",
    "2125": "LOCKSTEP",
    "2126": "PktCable-COPS",
    "2127": "INDEX-PC-WB",
    "2128": "Net Steward Control",
    "2129": "cs-live.com",
    "2130": "XDS",
    "2131": "Avantageb2b",
    "2132": "SoleraTec End Point Map",
    "2133": "ZYMED-ZPP",
    "2134": "AVENUE",
    "2135": "Grid Resource Information Server",
    "2136": "APPWORXSRV",
    "2137": "CONNECT",
    "2138": "UNBIND-CLUSTER",
    "2139": "IAS-AUTH",
    "2140": "IAS-REG",
    "2141": "IAS-ADMIND",
    "2142": "TDM OVER IP",
    "2143": "Live Vault Job Control",
    "2144": "Live Vault Fast Object Transfer",
    "2145": "Live Vault Remote Diagnostic Console Support",
    "2146": "Live Vault Admin Event Notification",
    "2147": "Live Vault Authentication",
    "2148": "VERITAS UNIVERSAL COMMUNICATION LAYER",
    "2149": "ACPTSYS",
    "2150": "DYNAMIC3D",
    "2151": "DOCENT",
    "2152": "GTP-User Plane (3GPP)",
    "2153": "Control Protocol",
    "2154": "Standard Protocol",
    "2155": "Bridge Protocol",
    "2156": "Talari Reliable Protocol",
    "2157": "Xerox Network Document Scan Protocol",
    "2158": "TouchNetPlus Service",
    "2159": "GDB Remote Debug Port",
    "2160": "APC 2160",
    "2161": "APC 2161",
    "2162": "Navisphere",
    "2163": "Navisphere Secure",
    "2164": "Dynamic DNS Version 3",
    "2165": "X-Bone API",
    "2166": "iwserver",
    "2167": "Raw Async Serial Link",
    "2168": "easy-soft Multiplexer",
    "2169": "Backbone for Academic Information Notification (BRAIN)",
    "2170": "EyeTV Server Port",
    "2171": "MS Firewall Storage",
    "2172": "MS Firewall SecureStorage",
    "2173": "MS Firewall Replication",
    "2174": "MS Firewall Intra Array",
    "2175": "Microsoft Desktop AirSync Protocol",
    "2176": "Microsoft ActiveSync Remote API",
    "2177": "qWAVE Bandwidth Estimate",
    "2178": "Peer Services for BITS",
    "2179": "Microsoft RDP for virtual machines",
    "2180": "Millicent Vendor Gateway Server",
    "2181": "eforward",
    "2182": "CGN status",
    "2183": "Code Green configuration",
    "2184": "NVD User",
    "2185": "OnBase Distributed Disk Services",
    "2186": "Guy-Tek Automated Update Applications",
    "2187": "Sepehr System Management Control",
    "2188": "Radware Resource Pool Manager",
    "2189": "Secure Radware Resource Pool Manager",
    "2190": "TiVoConnect Beacon",
    "2191": "TvBus Messaging",
    "2192": "ASDIS software management",
    "2193": "Dr.Web Enterprise Management Service",
    "2197": "MNP data exchange",
    "2198": "OneHome Remote Access",
    "2199": "OneHome Service Port",
    "2200": "Reserved",
    "2201": "Advanced Training System Program",
    "2202": "Int. Multimedia Teleconferencing Cosortium",
    "2203": "b2 Runtime Protocol",
    "2204": "b2 License Server",
    "2205": "Java Presentation Server",
    "2206": "HP OpenCall bus",
    "2207": "HP Status and Services",
    "2208": "HP I/O Backend",
    "2209": "HP RIM for Files Portal Service",
    "2210": "NOAAPORT Broadcast Network",
    "2211": "EMWIN",
    "2212": "LeeCO POS Server Service",
    "2213": "Kali",
    "2214": "RDQ Protocol Interface",
    "2215": "IPCore.co.za GPRS",
    "2216": "VTU data service",
    "2217": "GoToDevice Device Management",
    "2218": "Bounzza IRC Proxy",
    "2219": "NetIQ NCAP Protocol",
    "2220": "NetIQ End2End",
    "2221": "EtherNet/IP over TLS",
    "2222": "EtherNet/IP I/O",
    "2222": "EtherNet/IP I/O",
    "2223": "Rockwell CSP2",
    "2224": "Easy Flexible Internet/Multiplayer Games",
    "2225": "Resource Connection Initiation Protocol",
    "2226": "Digital Instinct DRM",
    "2227": "DI Messaging Service",
    "2228": "eHome Message Server",
    "2229": "DataLens Service",
    "2230": "MetaSoft Job Queue Administration Service",
    "2231": "WiMAX ASN Control Plane Protocol",
    "2232": "IVS Video default",
    "2233": "INFOCRYPT",
    "2234": "DirectPlay",
    "2235": "Sercomm-WLink",
    "2236": "Nani",
    "2237": "Optech Port1 License Manager",
    "2238": "AVIVA SNA SERVER",
    "2239": "Image Query",
    "2240": "RECIPe",
    "2241": "IVS Daemon",
    "2242": "Folio Remote Server",
    "2243": "Magicom Protocol",
    "2244": "NMS Server",
    "2245": "HaO",
    "2246": "PacketCable MTA Addr Map",
    "2247": "Antidote Deployment Manager Service",
    "2248": "User Management Service",
    "2249": "RISO File Manager Protocol",
    "2250": "remote-collab",
    "2251": "Distributed Framework Port",
    "2252": "NJENET using SSL",
    "2253": "DTV Channel Request",
    "2254": "Seismic P.O.C. Port",
    "2255": "VRTP - ViRtue Transfer Protocol",
    "2256": "PCC MFP",
    "2257": "simple text/file transfer",
    "2258": "Rotorcraft Communications Test System",
    "2259": "BIF identifiers resolution service",
    "2260": "APC 2260",
    "2261": "CoMotion Master Server",
    "2262": "CoMotion Backup Server",
    "2263": "ECweb Configuration Service",
    "2264": "Audio Precision Apx500 API Port 1",
    "2265": "Audio Precision Apx500 API Port 2",
    "2266": "M-Files Server",
    "2267": "OntoBroker",
    "2268": "AMT",
    "2269": "MIKEY",
    "2270": "starSchool",
    "2271": "Secure Meeting Maker Scheduling",
    "2272": "Meeting Maker Scheduling",
    "2273": "MySQL Instance Manager",
    "2274": "PCTTunneller",
    "2275": "iBridge Conferencing",
    "2276": "iBridge Management",
    "2277": "Bt device control proxy",
    "2278": "Simple Stacked Sequences Database",
    "2279": "xmquery",
    "2280": "LNVPOLLER",
    "2281": "LNVCONSOLE",
    "2282": "LNVALARM",
    "2283": "LNVSTATUS",
    "2284": "LNVMAPS",
    "2285": "LNVMAILMON",
    "2286": "NAS-Metering",
    "2287": "DNA",
    "2288": "NETML",
    "2289": "Lookup dict server",
    "2290": "Sonus Logging Services",
    "2291": "EPSON Advanced Printer Share Protocol",
    "2292": "Sonus Element Management Services",
    "2293": "Network Platform Debug Manager",
    "2294": "Konshus License Manager (FLEX)",
    "2295": "Advant License Manager",
    "2296": "Theta License Manager (Rainbow)",
    "2297": "D2K DataMover 1",
    "2298": "D2K DataMover 2",
    "2299": "PC Telecommute",
    "2300": "CVMMON",
    "2301": "Compaq HTTP",
    "2302": "Bindery Support",
    "2303": "Proxy Gateway",
    "2304": "Attachmate UTS",
    "2305": "MT ScaleServer",
    "2306": "TAPPI BoxNet",
    "2307": "pehelp",
    "2308": "sdhelp",
    "2309": "SD Server",
    "2310": "SD Client",
    "2311": "Message Service",
    "2312": "WANScaler Communication Service",
    "2313": "IAPP (Inter Access Point Protocol)",
    "2314": "CR WebSystems",
    "2315": "Precise Sft.",
    "2316": "SENT License Manager",
    "2317": "Attachmate G32",
    "2318": "Cadence Control",
    "2319": "InfoLibria",
    "2320": "Siebel NS",
    "2321": "RDLAP",
    "2322": "ofsd",
    "2323": "3d-nfsd",
    "2324": "Cosmocall",
    "2325": "ANSYS Licensing Interconnect",
    "2326": "IDCP",
    "2327": "xingcsm",
    "2328": "Netrix SFTM",
    "2329": "NVD",
    "2330": "TSCCHAT",
    "2331": "AGENTVIEW",
    "2332": "RCC Host",
    "2333": "SNAPP",
    "2334": "ACE Client Auth",
    "2335": "ACE Proxy",
    "2336": "Apple UG Control",
    "2337": "ideesrv",
    "2338": "Norton Lambert",
    "2339": "3Com WebView",
    "2340": "WRS Registry",
    "2340": "WRS Registry",
    "2341": "XIO Status",
    "2342": "Seagate Manage Exec",
    "2343": "nati logos",
    "2344": "fcmsys",
    "2345": "dbm",
    "2346": "Game Connection Port",
    "2346": "Game Connection Port",
    "2347": "Game Announcement and Location",
    "2347": "Game Announcement and Location",
    "2348": "Information to query for game status",
    "2348": "Information to query for game status",
    "2349": "Diagnostics Port",
    "2349": "Diagnostics Port",
    "2350": "Pharos Booking Server",
    "2351": "psrserver",
    "2352": "pslserver",
    "2353": "pspserver",
    "2354": "psprserver",
    "2355": "psdbserver",
    "2356": "GXT License Managemant",
    "2357": "UniHub Server",
    "2358": "Futrix",
    "2359": "FlukeServer",
    "2360": "NexstorIndLtd",
    "2361": "TL1",
    "2362": "digiman",
    "2363": "Media Central NFSD",
    "2364": "OI-2000",
    "2365": "dbref",
    "2366": "qip-login",
    "2367": "Service Control",
    "2368": "OpenTable",
    "2369": "Blockchain Identifier InFrastructure P2P",
    "2370": "L3-HBMon",
    "2371": "Remote Device Access",
    "2372": "LanMessenger",
    "2373": "Remograph License Manager",
    "2374": "Hydra RPC",
    "2375": "Docker REST API (plain text)",
    "2376": "Docker REST API (ssl)",
    "2377": "RPC interface for Docker Swarm",
    "2378": "Reserved",
    "2379": "etcd client communication",
    "2380": "etcd server to server communication",
    "2381": "Compaq HTTPS",
    "2382": "Microsoft OLAP",
    "2383": "Microsoft OLAP",
    "2384": "SD-REQUEST",
    "2385": "SD-DATA",
    "2386": "Virtual Tape",
    "2387": "VSAM Redirector",
    "2388": "MYNAH AutoStart",
    "2389": "OpenView Session Mgr",
    "2390": "RSMTP",
    "2391": "3COM Net Management",
    "2392": "Tactical Auth",
    "2393": "MS OLAP 1",
    "2394": "MS OLAP 2",
    "2395": "LAN900 Remote",
    "2395": "LAN900 Remote",
    "2396": "Wusage",
    "2397": "NCL",
    "2398": "Orbiter",
    "2399": "FileMaker, Inc. - Data Access Layer",
    "2400": "OpEquus Server",
    "2401": "cvspserver",
    "2402": "TaskMaster 2000 Server",
    "2403": "TaskMaster 2000 Web",
    "2404": "IEC 60870-5-104 process control over IP",
    "2405": "TRC Netpoll",
    "2406": "JediServer",
    "2407": "Orion",
    "2408": "CloudFlare Railgun Web Acceleration Protocol",
    "2409": "SNS Protocol",
    "2410": "VRTS Registry",
    "2411": "Netwave AP Management",
    "2412": "CDN",
    "2413": "orion-rmi-reg",
    "2414": "Beeyond",
    "2415": "Codima Remote Transaction Protocol",
    "2416": "RMT Server",
    "2417": "Composit Server",
    "2418": "cas",
    "2419": "Attachmate S2S",
    "2420": "DSL Remote Management",
    "2421": "G-Talk",
    "2422": "CRMSBITS",
    "2423": "RNRP",
    "2424": "KOFAX-SVR",
    "2425": "Fujitsu App Manager",
    "2426": "VeloCloud MultiPath Protocol",
    "2427": "Media Gateway Control Protocol Gateway",
    "2428": "One Way Trip Time",
    "2429": "FT-ROLE",
    "2430": "venus",
    "2431": "venus-se",
    "2432": "codasrv",
    "2433": "codasrv-se",
    "2434": "pxc-epmap",
    "2435": "OptiLogic",
    "2436": "TOP/X",
    "2437": "UniControl",
    "2438": "MSP",
    "2439": "SybaseDBSynch",
    "2440": "Spearway Lockers",
    "2441": "Pervasive I*net Data Server",
    "2442": "Netangel",
    "2443": "PowerClient Central Storage Facility",
    "2444": "BT PP2 Sectrans",
    "2445": "DTN1",
    "2446": "bues_service",
    "2446": "bues_service",
    "2447": "OpenView NNM daemon",
    "2448": "hpppsvr",
    "2449": "RATL",
    "2450": "netadmin",
    "2451": "netchat",
    "2452": "SnifferClient",
    "2453": "madge ltd",
    "2454": "IndX-DDS",
    "2455": "WAGO-IO-SYSTEM",
    "2456": "altav-remmgt",
    "2457": "Rapido_IP",
    "2458": "griffin",
    "2459": "Community",
    "2460": "ms-theater",
    "2461": "qadmifoper",
    "2462": "qadmifevent",
    "2463": "LSI RAID Management",
    "2464": "DirecPC SI",
    "2465": "Load Balance Management",
    "2466": "Load Balance Forwarding",
    "2467": "High Criteria",
    "2468": "qip_msgd",
    "2469": "MTI-TCS-COMM",
    "2470": "taskman port",
    "2471": "SeaODBC",
    "2472": "C3",
    "2473": "Aker-cdp",
    "2474": "Vital Analysis",
    "2475": "ACE Server",
    "2476": "ACE Server Propagation",
    "2477": "SecurSight Certificate Valifation Service",
    "2478": "SecurSight Authentication Server (SSL)",
    "2479": "SecurSight Event Logging Server (SSL)",
    "2480": "Informatica PowerExchange Listener",
    "2481": "Oracle GIOP",
    "2482": "Oracle GIOP SSL",
    "2483": "Oracle TTC",
    "2484": "Oracle TTC SSL",
    "2485": "Net Objects1",
    "2486": "Net Objects2",
    "2487": "Policy Notice Service",
    "2488": "Moy Corporation",
    "2489": "TSILB",
    "2490": "qip_qdhcp",
    "2491": "Conclave CPP",
    "2492": "GROOVE",
    "2493": "Talarian MQS",
    "2494": "BMC AR",
    "2495": "Fast Remote Services",
    "2496": "DIRGIS",
    "2497": "Quad DB",
    "2498": "ODN-CasTraq",
    "2499": "UniControl",
    "2500": "Resource Tracking system server",
    "2501": "Resource Tracking system client",
    "2502": "Kentrox Protocol",
    "2503": "NMS-DPNSS",
    "2504": "WLBS",
    "2505": "PowerPlay Control",
    "2506": "jbroker",
    "2507": "spock",
    "2508": "JDataStore",
    "2509": "fjmpss",
    "2510": "fjappmgrbulk",
    "2511": "Metastorm",
    "2512": "Citrix IMA",
    "2513": "Citrix ADMIN",
    "2514": "Facsys NTP",
    "2515": "Facsys Router",
    "2516": "Main Control",
    "2517": "H.323 Annex E Call Control Signalling Transport",
    "2518": "Willy",
    "2519": "globmsgsvc",
    "2520": "Pervasive Listener",
    "2521": "Adaptec Manager",
    "2522": "WinDb",
    "2523": "Qke LLC V.3",
    "2524": "Optiwave License Management",
    "2525": "MS V-Worlds",
    "2526": "EMA License Manager",
    "2527": "IQ Server",
    "2528": "NCR CCL",
    "2528": "NCR CCL",
    "2529": "UTS FTP",
    "2530": "VR Commerce",
    "2531": "ITO-E GUI",
    "2532": "OVTOPMD",
    "2533": "SnifferServer",
    "2534": "Combox Web Access",
    "2535": "MADCAP",
    "2536": "btpp2audctr1",
    "2537": "Upgrade Protocol",
    "2538": "vnwk-prapi",
    "2539": "VSI Admin",
    "2540": "LonWorks",
    "2541": "LonWorks2",
    "2542": "uDraw(Graph)",
    "2543": "REFTEK",
    "2544": "Management Daemon Refresh",
    "2545": "sis-emt",
    "2546": "vytalvaultbrtp",
    "2547": "vytalvaultvsmp",
    "2548": "vytalvaultpipe",
    "2549": "IPASS",
    "2550": "ADS",
    "2551": "ISG UDA Server",
    "2552": "Call Logging",
    "2553": "efidiningport",
    "2554": "VCnet-Link v10",
    "2555": "Compaq WCP",
    "2556": "nicetec-nmsvc",
    "2557": "nicetec-mgmt",
    "2558": "PCLE Multi Media",
    "2559": "LSTP",
    "2560": "labrat",
    "2561": "MosaixCC",
    "2562": "Delibo",
    "2563": "CTI Redwood",
    "2564": "HP 3000 NS/VT block mode telnet",
    "2565": "Coordinator Server",
    "2566": "pcs-pcw",
    "2567": "Cisco Line Protocol",
    "2568": "SPAM TRAP",
    "2569": "Sonus Call Signal",
    "2570": "HS Port",
    "2571": "CECSVC",
    "2572": "IBP",
    "2573": "Trust Establish",
    "2574": "Blockade BPSP",
    "2575": "HL7",
    "2576": "TCL Pro Debugger",
    "2577": "Scriptics Lsrvr",
    "2578": "RVS ISDN DCP",
    "2579": "mpfoncl",
    "2580": "Tributary",
    "2581": "ARGIS TE",
    "2582": "ARGIS DS",
    "2583": "MON",
    "2584": "cyaserv",
    "2585": "NETX Server",
    "2586": "NETX Agent",
    "2587": "MASC",
    "2588": "Privilege",
    "2589": "quartus tcl",
    "2590": "idotdist",
    "2591": "Maytag Shuffle",
    "2592": "netrek",
    "2593": "MNS Mail Notice Service",
    "2594": "Data Base Server",
    "2595": "World Fusion 1",
    "2596": "World Fusion 2",
    "2597": "Homestead Glory",
    "2598": "Citrix MA Client",
    "2599": "Snap Discovery",
    "2600": "HPSTGMGR",
    "2601": "discp client",
    "2602": "discp server",
    "2603": "Service Meter",
    "2604": "NSC CCS",
    "2605": "NSC POSA",
    "2606": "Dell Netmon",
    "2607": "Dell Connection",
    "2608": "Wag Service",
    "2609": "System Monitor",
    "2610": "VersaTek",
    "2611": "LIONHEAD",
    "2612": "Qpasa Agent",
    "2613": "SMNTUBootstrap",
    "2614": "Never Offline",
    "2615": "firepower",
    "2616": "appswitch-emp",
    "2617": "Clinical Context Managers",
    "2618": "Priority E-Com",
    "2619": "bruce",
    "2620": "LPSRecommender",
    "2621": "Miles Apart Jukebox Server",
    "2622": "MetricaDBC",
    "2623": "LMDP",
    "2624": "Aria",
    "2625": "Blwnkl Port",
    "2626": "gbjd816",
    "2627": "Moshe Beeri",
    "2628": "DICT",
    "2629": "Sitara Server",
    "2630": "Sitara Management",
    "2631": "Sitara Dir",
    "2632": "IRdg Post",
    "2633": "InterIntelli",
    "2634": "PK Electronics",
    "2635": "Back Burner",
    "2636": "Solve",
    "2637": "Import Document Service",
    "2638": "Sybase Anywhere",
    "2639": "AMInet",
    "2640": "Alcorn McBride Inc protocol used for device control",
    "2641": "HDL Server",
    "2642": "Tragic",
    "2643": "GTE-SAMP",
    "2644": "Travsoft IPX Tunnel",
    "2645": "Novell IPX CMD",
    "2646": "AND License Manager",
    "2647": "SyncServer",
    "2648": "Upsnotifyprot",
    "2649": "VPSIPPORT",
    "2650": "eristwoguns",
    "2651": "EBInSite",
    "2652": "InterPathPanel",
    "2653": "Sonus",
    "2654": "Corel VNC Admin",
    "2654": "Corel VNC Admin",
    "2655": "UNIX Nt Glue",
    "2656": "Kana",
    "2657": "SNS Dispatcher",
    "2658": "SNS Admin",
    "2659": "SNS Query",
    "2660": "GC Monitor",
    "2661": "OLHOST",
    "2662": "BinTec-CAPI",
    "2663": "BinTec-TAPI",
    "2664": "Patrol for MQ GM",
    "2665": "Patrol for MQ NM",
    "2666": "extensis",
    "2667": "Alarm Clock Server",
    "2668": "Alarm Clock Client",
    "2669": "TOAD",
    "2670": "TVE Announce",
    "2671": "newlixreg",
    "2672": "nhserver",
    "2673": "First Call 42",
    "2674": "ewnn",
    "2675": "TTC ETAP",
    "2676": "SIMSLink",
    "2677": "Gadget Gate 1 Way",
    "2678": "Gadget Gate 2 Way",
    "2679": "Sync Server SSL",
    "2680": "pxc-sapxom",
    "2681": "mpnjsomb",
    "2683": "NCDLoadBalance",
    "2684": "mpnjsosv",
    "2685": "mpnjsocl",
    "2686": "mpnjsomg",
    "2687": "pq-lic-mgmt",
    "2688": "md-cf-http",
    "2689": "FastLynx",
    "2690": "HP NNM Embedded Database",
    "2691": "ITInternet ISM Server",
    "2692": "Admins LMS",
    "2693": "Unassigned",
    "2694": "pwrsevent",
    "2695": "VSPREAD",
    "2696": "Unify Admin",
    "2697": "Oce SNMP Trap Port",
    "2698": "MCK-IVPIP",
    "2699": "Csoft Plus Client",
    "2700": "tqdata",
    "2701": "SMS RCINFO",
    "2702": "SMS XFER",
    "2703": "SMS CHAT",
    "2704": "SMS REMCTRL",
    "2705": "SDS Admin",
    "2706": "NCD Mirroring",
    "2707": "EMCSYMAPIPORT",
    "2708": "Banyan-Net",
    "2709": "Supermon",
    "2710": "SSO Service",
    "2711": "SSO Control",
    "2712": "Axapta Object Communication Protocol",
    "2713": "Raven Trinity Broker Service",
    "2714": "Raven Trinity Data Mover",
    "2715": "HPSTGMGR2",
    "2716": "Inova IP Disco",
    "2717": "PN REQUESTER",
    "2718": "PN REQUESTER 2",
    "2719": "Scan &amp; Change",
    "2720": "wkars",
    "2721": "Smart Diagnose",
    "2722": "Proactive Server",
    "2723": "WatchDog NT Protocol",
    "2724": "qotps",
    "2725": "MSOLAP PTP2",
    "2726": "TAMS",
    "2727": "Media Gateway Control Protocol Call Agent",
    "2728": "SQDR",
    "2729": "TCIM Control",
    "2730": "NEC RaidPlus",
    "2731": "Fyre Messanger",
    "2732": "G5M",
    "2733": "Signet CTF",
    "2734": "CCS Software",
    "2735": "NetIQ Monitor Console",
    "2736": "RADWIZ NMS SRV",
    "2737": "SRP Feedback",
    "2738": "NDL TCP-OSI Gateway",
    "2739": "TN Timing",
    "2740": "Alarm",
    "2741": "TSB",
    "2742": "TSB2",
    "2743": "murx",
    "2744": "honyaku",
    "2745": "URBISNET",
    "2746": "CPUDPENCAP",
    "2747": "",
    "2748": "",
    "2749": "",
    "2750": "",
    "2751": "",
    "2752": "RSISYS ACCESS",
    "2753": "de-spot",
    "2754": "APOLLO CC",
    "2755": "Express Pay",
    "2756": "simplement-tie",
    "2757": "CNRP",
    "2758": "APOLLO Status",
    "2759": "APOLLO GMS",
    "2760": "Saba MS",
    "2761": "DICOM ISCL",
    "2762": "DICOM TLS",
    "2763": "Desktop DNA",
    "2764": "Data Insurance",
    "2765": "qip-audup",
    "2766": "Compaq SCP",
    "2767": "UADTC",
    "2768": "UACS",
    "2769": "eXcE",
    "2770": "Veronica",
    "2771": "Vergence CM",
    "2772": "auris",
    "2773": "RBackup Remote Backup",
    "2774": "RBackup Remote Backup",
    "2775": "SMPP",
    "2776": "Ridgeway Systems &amp; Software",
    "2777": "Ridgeway Systems &amp; Software",
    "2778": "Gwen-Sonya",
    "2779": "LBC Sync",
    "2780": "LBC Control",
    "2781": "whosells",
    "2782": "everydayrc",
    "2783": "AISES",
    "2784": "world wide web - development",
    "2785": "aic-np",
    "2786": "aic-oncrpc - Destiny MCD database",
    "2787": "piccolo - Cornerstone Software",
    "2788": "NetWare Loadable Module - Seagate Software",
    "2789": "Media Agent",
    "2790": "PLG Proxy",
    "2791": "MT Port Registrator",
    "2792": "f5-globalsite",
    "2793": "initlsmsad",
    "2795": "LiveStats",
    "2796": "ac-tech",
    "2797": "esp-encap",
    "2798": "TMESIS-UPShot",
    "2799": "ICON Discover",
    "2800": "ACC RAID",
    "2801": "IGCP",
    "2802": "Veritas TCP1",
    "2803": "btprjctrl",
    "2804": "March Networks Digital Video Recorders and Enterprise Service Manager products",
    "2805": "WTA WSP-S",
    "2806": "cspuni",
    "2807": "cspmulti",
    "2808": "J-LAN-P",
    "2809": "CORBA LOC",
    "2810": "Active Net Steward",
    "2811": "GSI FTP",
    "2812": "atmtcp",
    "2813": "llm-pass",
    "2814": "llm-csv",
    "2815": "LBC Measurement",
    "2816": "LBC Watchdog",
    "2817": "NMSig Port",
    "2818": "rmlnk",
    "2819": "FC Fault Notification",
    "2820": "UniVision",
    "2821": "VERITAS Authentication Service",
    "2822": "ka0wuc",
    "2823": "CQG Net/LAN",
    "2824": "CQG Net/LAN 1",
    "2826": "slc systemlog",
    "2827": "slc ctrlrloops",
    "2828": "ITM License Manager",
    "2829": "silkp1",
    "2830": "silkp2",
    "2831": "silkp3",
    "2832": "silkp4",
    "2833": "glishd",
    "2834": "EVTP",
    "2835": "EVTP-DATA",
    "2836": "catalyst",
    "2837": "Repliweb",
    "2838": "Starbot",
    "2839": "NMSigPort",
    "2840": "l3-exprt",
    "2841": "l3-ranger",
    "2842": "l3-hawk",
    "2843": "PDnet",
    "2844": "BPCP POLL",
    "2845": "BPCP TRAP",
    "2846": "AIMPP Hello",
    "2847": "AIMPP Port Req",
    "2848": "AMT-BLC-PORT",
    "2849": "FXP",
    "2850": "MetaConsole",
    "2851": "webemshttp",
    "2852": "bears-01",
    "2853": "ISPipes",
    "2854": "InfoMover",
    "2855": "MSRP over TCP",
    "2856": "cesdinv",
    "2857": "SimCtIP",
    "2858": "ECNP",
    "2859": "Active Memory",
    "2860": "Dialpad Voice 1",
    "2861": "Dialpad Voice 2",
    "2862": "TTG Protocol",
    "2863": "Sonar Data",
    "2864": "main 5001 cmd",
    "2865": "pit-vpn",
    "2866": "iwlistener",
    "2867": "esps-portal",
    "2868": "Norman Proprietaqry Events Protocol",
    "2869": "ICSLAP",
    "2870": "daishi",
    "2871": "MSI Select Play",
    "2872": "RADIX",
    "2873": "PubSub Realtime Telemetry Protocol",
    "2874": "DX Message Base Transport Protocol",
    "2875": "DX Message Base Transport Protocol",
    "2876": "SPS Tunnel",
    "2877": "BLUELANCE",
    "2878": "AAP",
    "2879": "ucentric-ds",
    "2880": "Synapse Transport",
    "2881": "NDSP",
    "2882": "NDTP",
    "2883": "NDNP",
    "2884": "Flash Msg",
    "2885": "TopFlow",
    "2886": "RESPONSELOGIC",
    "2887": "aironet",
    "2888": "SPCSDLOBBY",
    "2889": "RSOM",
    "2890": "CSPCLMULTI",
    "2891": "CINEGRFX-ELMD License Manager",
    "2892": "SNIFFERDATA",
    "2893": "VSECONNECTOR",
    "2894": "ABACUS-REMOTE",
    "2895": "NATUS LINK",
    "2896": "ECOVISIONG6-1",
    "2897": "Citrix RTMP",
    "2898": "APPLIANCE-CFG",
    "2899": "POWERGEMPLUS",
    "2900": "QUICKSUITE",
    "2901": "ALLSTORCNS",
    "2902": "NET ASPI",
    "2903": "SUITCASE",
    "2904": "M2UA",
    "2905": "M3UA",
    "2906": "CALLER9",
    "2907": "WEBMETHODS B2B",
    "2908": "mao",
    "2909": "Funk Dialout",
    "2910": "TDAccess",
    "2911": "Blockade",
    "2912": "Epicon",
    "2913": "Booster Ware",
    "2914": "Game Lobby",
    "2915": "TK Socket",
    "2916": "Elvin Server",
    "2916": "Elvin Server",
    "2917": "Elvin Client",
    "2917": "Elvin Client",
    "2918": "Kasten Chase Pad",
    "2919": "roboER",
    "2920": "roboEDA",
    "2921": "CESD Contents Delivery Management",
    "2922": "CESD Contents Delivery Data Transfer",
    "2923": "WTA-WSP-WTP-S",
    "2924": "PRECISE-VIP",
    "2926": "MOBILE-FILE-DL",
    "2927": "UNIMOBILECTRL",
    "2928": "REDSTONE-CPSS",
    "2929": "AMX-WEBADMIN",
    "2930": "AMX-WEBLINX",
    "2931": "Circle-X",
    "2932": "INCP",
    "2933": "4-TIER OPM GW",
    "2934": "4-TIER OPM CLI",
    "2935": "QTP",
    "2936": "OTPatch",
    "2937": "PNACONSULT-LM",
    "2938": "SM-PAS-1",
    "2939": "SM-PAS-2",
    "2940": "SM-PAS-3",
    "2941": "SM-PAS-4",
    "2942": "SM-PAS-5",
    "2943": "TTNRepository",
    "2944": "Megaco H-248",
    "2945": "H248 Binary",
    "2946": "FJSVmpor",
    "2947": "GPS Daemon request/response protocol",
    "2948": "WAP PUSH",
    "2949": "WAP PUSH SECURE",
    "2950": "ESIP",
    "2951": "OTTP",
    "2952": "MPFWSAS",
    "2953": "OVALARMSRV",
    "2954": "OVALARMSRV-CMD",
    "2955": "CSNOTIFY",
    "2956": "OVRIMOSDBMAN",
    "2957": "JAMCT5",
    "2958": "JAMCT6",
    "2959": "RMOPAGT",
    "2960": "DFOXSERVER",
    "2961": "BOLDSOFT-LM",
    "2962": "IPH-POLICY-CLI",
    "2963": "IPH-POLICY-ADM",
    "2964": "BULLANT SRAP",
    "2965": "BULLANT RAP",
    "2966": "IDP-INFOTRIEVE",
    "2967": "SSC-AGENT",
    "2968": "ENPP",
    "2969": "ESSP",
    "2970": "INDEX-NET",
    "2971": "NetClip clipboard daemon",
    "2972": "PMSM Webrctl",
    "2973": "SV Networks",
    "2974": "Signal",
    "2975": "Fujitsu Configuration Management Service",
    "2976": "CNS Server Port",
    "2977": "TTCs Enterprise Test Access Protocol - NS",
    "2978": "TTCs Enterprise Test Access Protocol - DS",
    "2979": "H.263 Video Streaming",
    "2980": "Instant Messaging Service",
    "2981": "MYLXAMPORT",
    "2982": "IWB-WHITEBOARD",
    "2983": "NETPLAN",
    "2984": "HPIDSADMIN",
    "2985": "HPIDSAGENT",
    "2986": "STONEFALLS",
    "2987": "identify",
    "2988": "HIPPA Reporting Protocol",
    "2989": "ZARKOV Intelligent Agent Communication",
    "2990": "BOSCAP",
    "2991": "WKSTN-MON",
    "2992": "Avenyo Server",
    "2993": "VERITAS VIS1",
    "2994": "VERITAS VIS2",
    "2995": "IDRS",
    "2996": "vsixml",
    "2997": "REBOL",
    "2998": "Real Secure",
    "2999": "RemoteWare Unassigned",
    "3000": "HBCI",
    "3001": "OrigoDB Server Native Interface",
    "3002": "EXLM Agent",
    "3003": "CGMS",
    "3004": "Csoft Agent",
    "3005": "Genius License Manager",
    "3006": "Instant Internet Admin",
    "3007": "Lotus Mail Tracking Agent Protocol",
    "3008": "Midnight Technologies",
    "3009": "PXC-NTFY",
    "3010": "Telerate Workstation",
    "3011": "Trusted Web",
    "3012": "Trusted Web Client",
    "3013": "Gilat Sky Surfer",
    "3014": "Broker Service",
    "3014": "Broker Service",
    "3015": "NATI DSTP",
    "3016": "Notify Server",
    "3016": "Notify Server",
    "3017": "Event Listener",
    "3017": "Event Listener",
    "3018": "Service Registry",
    "3018": "Service Registry",
    "3019": "Resource Manager",
    "3019": "Resource Manager",
    "3020": "CIFS",
    "3021": "AGRI Server",
    "3022": "CSREGAGENT",
    "3023": "magicnotes",
    "3024": "NDS_SSO",
    "3024": "NDS_SSO",
    "3025": "Arepa Raft",
    "3026": "AGRI Gateway",
    "3027": "LiebDevMgmt_C",
    "3027": "LiebDevMgmt_C",
    "3028": "LiebDevMgmt_DM",
    "3028": "LiebDevMgmt_DM",
    "3029": "LiebDevMgmt_A",
    "3029": "LiebDevMgmt_A",
    "3030": "Arepa Cas",
    "3031": "Remote AppleEvents/PPC Toolbox",
    "3032": "Redwood Chat",
    "3033": "PDB",
    "3034": "Osmosis / Helix (R) AEEA Port",
    "3035": "FJSV gssagt",
    "3036": "Hagel DUMP",
    "3037": "HP SAN Mgmt",
    "3038": "Santak UPS",
    "3039": "Cogitate, Inc.",
    "3040": "Tomato Springs",
    "3041": "di-traceware",
    "3042": "journee",
    "3043": "Broadcast Routing Protocol",
    "3044": "EndPoint Protocol",
    "3045": "ResponseNet",
    "3046": "di-ase",
    "3047": "Fast Security HL Server",
    "3048": "Sierra Net PC Trader",
    "3049": "NSWS",
    "3050": "gds_db",
    "3050": "gds_db",
    "3051": "Galaxy Server",
    "3052": "APC 3052",
    "3053": "dsom-server",
    "3054": "AMT CNF PROT",
    "3055": "Policy Server",
    "3056": "CDL Server",
    "3057": "GoAhead FldUp",
    "3058": "videobeans",
    "3059": "qsoft",
    "3060": "interserver",
    "3061": "cautcpd",
    "3062": "ncacn-ip-tcp",
    "3063": "ncadg-ip-udp",
    "3064": "Remote Port Redirector",
    "3065": "slinterbase",
    "3066": "NETATTACHSDMP",
    "3067": "FJHPJP",
    "3068": "ls3 Broadcast",
    "3069": "ls3",
    "3070": "MGXSWITCH",
    "3071": "Crossplatform replication protocol",
    "3072": "ContinuStor Monitor Port",
    "3073": "Very simple chatroom prot",
    "3074": "Xbox game port",
    "3075": "Orbix 2000 Locator",
    "3076": "Orbix 2000 Config",
    "3077": "Orbix 2000 Locator SSL",
    "3078": "Orbix 2000 Locator SSL",
    "3079": "LV Front Panel",
    "3080": "stm_pproc",
    "3080": "stm_pproc",
    "3081": "TL1-LV",
    "3082": "TL1-RAW",
    "3083": "TL1-TELNET",
    "3084": "ITM-MCCS",
    "3085": "PCIHReq",
    "3086": "JDL-DBKitchen",
    "3087": "Asoki SMA",
    "3088": "eXtensible Data Transfer Protocol",
    "3089": "ParaTek Agent Linking",
    "3090": "Senforce Session Services",
    "3091": "1Ci Server Management",
    "3093": "Jiiva RapidMQ Center",
    "3094": "Jiiva RapidMQ Registry",
    "3095": "Panasas rendezvous port",
    "3096": "Active Print Server Port",
    "3097": "Reserved",
    "3098": "Universal Message Manager",
    "3099": "CHIPSY Machine Daemon",
    "3100": "OpCon/xps",
    "3101": "HP PolicyXpert PIB Server",
    "3102": "SoftlinK Slave Mon Port",
    "3103": "Autocue SMI Protocol",
    "3104": "Autocue Logger Protocol",
    "3105": "Cardbox",
    "3106": "Cardbox HTTP",
    "3107": "Business protocol",
    "3108": "Geolocate protocol",
    "3109": "Personnel protocol",
    "3110": "simulator control port",
    "3111": "Web Synchronous Services",
    "3112": "KDE System Guard",
    "3113": "CS-Authenticate Svr Port",
    "3114": "CCM AutoDiscover",
    "3115": "MCTET Master",
    "3116": "MCTET Gateway",
    "3117": "MCTET Jserv",
    "3118": "PKAgent",
    "3119": "D2000 Kernel Port",
    "3120": "D2000 Webserver Port",
    "3121": "The pacemaker remote (pcmk-remote) service extends high availability functionality outside of the Linux cluster into remote nodes.",
    "3122": "MTI VTR Emulator port",
    "3123": "EDI Translation Protocol",
    "3124": "Beacon Port",
    "3125": "A13-AN Interface",
    "3127": "CTX Bridge Port",
    "3128": "Active API Server Port",
    "3129": "NetPort Discovery Port",
    "3130": "ICPv2",
    "3131": "Net Book Mark",
    "3132": "Microsoft Business Rule Engine Update Service",
    "3133": "Prism Deploy User Port",
    "3134": "Extensible Code Protocol",
    "3135": "PeerBook Port",
    "3136": "Grub Server Port",
    "3137": "rtnt-1 data packets",
    "3138": "rtnt-2 data packets",
    "3139": "Incognito Rendez-Vous",
    "3140": "Arilia Multiplexor",
    "3141": "VMODEM",
    "3142": "RDC WH EOS",
    "3143": "Sea View",
    "3144": "Tarantella",
    "3145": "CSI-LFAP",
    "3146": "bears-02",
    "3147": "RFIO",
    "3148": "NetMike Game Administrator",
    "3149": "NetMike Game Server",
    "3150": "NetMike Assessor Administrator",
    "3151": "NetMike Assessor",
    "3152": "FeiTian Port",
    "3153": "S8Cargo Client Port",
    "3154": "ON RMI Registry",
    "3155": "JpegMpeg Port",
    "3156": "Indura Collector",
    "3157": "LSA Communicator",
    "3158": "SmashTV Protocol",
    "3159": "NavegaWeb Tarification",
    "3160": "TIP Application Server",
    "3161": "DOC1 License Manager",
    "3162": "SFLM",
    "3163": "RES-SAP",
    "3164": "IMPRS",
    "3165": "Newgenpay Engine Service",
    "3166": "Quest Spotlight Out-Of-Process Collector",
    "3167": "Now Contact Public Server",
    "3168": "Now Up-to-Date Public Server",
    "3169": "SERVERVIEW-AS",
    "3170": "SERVERVIEW-ASN",
    "3171": "SERVERVIEW-GF",
    "3172": "SERVERVIEW-RM",
    "3173": "SERVERVIEW-ICC",
    "3174": "ARMI Server",
    "3175": "T1_E1_Over_IP",
    "3176": "ARS Master",
    "3177": "Phonex Protocol",
    "3178": "Radiance UltraEdge Port",
    "3179": "H2GF W.2m Handover prot.",
    "3180": "Millicent Broker Server",
    "3181": "BMC Patrol Agent",
    "3182": "BMC Patrol Rendezvous",
    "3183": "COPS/TLS",
    "3184": "ApogeeX Port",
    "3185": "SuSE Meta PPPD",
    "3186": "IIW Monitor User Port",
    "3187": "Open Design Listen Port",
    "3188": "Broadcom Port",
    "3189": "Pinnacle Sys InfEx Port",
    "3190": "ConServR Proxy",
    "3191": "ConServR SSL Proxy",
    "3192": "FireMon Revision Control",
    "3193": "SpanDataPort",
    "3194": "Rockstorm MAG protocol",
    "3195": "Network Control Unit",
    "3196": "Network Control Unit",
    "3197": "Embrace Device Protocol Server",
    "3198": "Embrace Device Protocol Client",
    "3199": "DMOD WorkSpace",
    "3200": "Press-sense Tick Port",
    "3201": "CPQ-TaskSmart",
    "3202": "IntraIntra",
    "3203": "Network Watcher Monitor",
    "3204": "Network Watcher DB Access",
    "3205": "iSNS Server Port",
    "3206": "IronMail POP Proxy",
    "3207": "Veritas Authentication Port",
    "3208": "PFU PR Callback",
    "3209": "HP OpenView Network Path Engine Server",
    "3210": "Flamenco Networks Proxy",
    "3211": "Avocent Secure Management",
    "3212": "Survey Instrument",
    "3213": "NEON 24X7 Mission Control",
    "3214": "JMQ Daemon Port 1",
    "3215": "JMQ Daemon Port 2",
    "3216": "Ferrari electronic FOAM",
    "3217": "Unified IP &amp; Telecom Environment",
    "3218": "EMC SmartPackets",
    "3219": "WMS Messenger",
    "3220": "XML NM over SSL",
    "3221": "XML NM over TCP",
    "3222": "Gateway Load Balancing Pr",
    "3223": "DIGIVOTE (R) Vote-Server",
    "3224": "AES Discovery Port",
    "3225": "FCIP",
    "3226": "ISI Industry Software IRP",
    "3227": "DiamondWave NMS Server",
    "3228": "DiamondWave MSG Server",
    "3229": "Global CD Port",
    "3230": "Software Distributor Port",
    "3231": "VidiGo communication (previous was: Delta Solutions Direct)",
    "3232": "MDT port",
    "3233": "WhiskerControl main port",
    "3234": "Alchemy Server",
    "3235": "MDAP port",
    "3236": "appareNet Test Server",
    "3237": "appareNet Test Packet Sequencer",
    "3238": "appareNet Analysis Server",
    "3239": "appareNet User Interface",
    "3240": "Trio Motion Control Port",
    "3241": "SysOrb Monitoring Server",
    "3242": "Session Description ID",
    "3243": "Timelot Port",
    "3244": "OneSAF",
    "3245": "VIEO Fabric Executive",
    "3246": "DVT SYSTEM PORT",
    "3247": "DVT DATA LINK",
    "3248": "PROCOS LM",
    "3249": "State Sync Protocol",
    "3250": "HMS hicp port",
    "3251": "Sys Scanner",
    "3252": "DHE port",
    "3253": "PDA Data",
    "3254": "PDA System",
    "3255": "Semaphore Connection Port",
    "3256": "Compaq RPM Agent Port",
    "3257": "Compaq RPM Server Port",
    "3258": "Ivecon Server Port",
    "3259": "Epson Network Common Devi",
    "3260": "iSCSI port",
    "3261": "winShadow",
    "3262": "NECP",
    "3263": "E-Color Enterprise Imager",
    "3264": "cc:mail/lotus",
    "3265": "Altav Tunnel",
    "3266": "NS CFG Server",
    "3267": "IBM Dial Out",
    "3268": "Microsoft Global Catalog",
    "3269": "Microsoft Global Catalog with LDAP/SSL",
    "3270": "Verismart",
    "3271": "CSoft Prev Port",
    "3272": "Fujitsu User Manager",
    "3273": "Simple Extensible Multiplexed Protocol",
    "3274": "Ordinox Server",
    "3275": "SAMD",
    "3276": "Maxim ASICs",
    "3277": "AWG Proxy",
    "3278": "LKCM Server",
    "3279": "admind",
    "3280": "VS Server",
    "3281": "SYSOPT",
    "3282": "Datusorb",
    "3283": "Net Assistant",
    "3284": "4Talk",
    "3285": "Plato",
    "3286": "E-Net",
    "3287": "DIRECTVDATA",
    "3288": "COPS",
    "3289": "ENPC",
    "3290": "CAPS LOGISTICS TOOLKIT - LM",
    "3291": "S A Holditch &amp; Associates - LM",
    "3292": "Cart O Rama",
    "3293": "fg-fps",
    "3294": "fg-gip",
    "3295": "Dynamic IP Lookup",
    "3296": "Rib License Manager",
    "3297": "Cytel License Manager",
    "3298": "DeskView",
    "3299": "pdrncs",
    "3300": "Ceph monitor",
    "3301": "Tarantool in-memory computing platform",
    "3302": "MCS Fastmail",
    "3303": "OP Session Client",
    "3304": "OP Session Server",
    "3305": "ODETTE-FTP",
    "3306": "MySQL",
    "3307": "OP Session Proxy",
    "3308": "TNS Server",
    "3309": "TNS ADV",
    "3310": "Dyna Access",
    "3311": "MCNS Tel Ret",
    "3312": "Application Management Server",
    "3313": "Unify Object Broker",
    "3314": "Unify Object Host",
    "3315": "CDID",
    "3316": "AICC/CMI",
    "3317": "VSAI PORT",
    "3318": "Swith to Swith Routing Information Protocol",
    "3319": "SDT License Manager",
    "3320": "Office Link 2000",
    "3321": "VNSSTR",
    "3326": "SFTU",
    "3327": "BBARS",
    "3328": "Eaglepoint License Manager",
    "3329": "HP Device Disc",
    "3330": "MCS Calypso ICF",
    "3331": "MCS Messaging",
    "3332": "MCS Mail Server",
    "3333": "DEC Notes",
    "3334": "Direct TV Webcasting",
    "3335": "Direct TV Software Updates",
    "3336": "Direct TV Tickers",
    "3337": "Direct TV Data Catalog",
    "3338": "OMF data b",
    "3339": "OMF data l",
    "3340": "OMF data m",
    "3341": "OMF data h",
    "3342": "WebTIE",
    "3343": "MS Cluster Net",
    "3344": "BNT Manager",
    "3345": "Influence",
    "3346": "Trnsprnt Proxy",
    "3347": "Phoenix RPC",
    "3348": "Pangolin Laser",
    "3349": "Chevin Services",
    "3350": "FINDVIATV",
    "3351": "Btrieve port",
    "3352": "Scalable SQL",
    "3353": "FATPIPE",
    "3354": "SUITJD",
    "3355": "Ordinox Dbase",
    "3356": "UPNOTIFYPS",
    "3357": "Adtech Test IP",
    "3358": "Mp Sys Rmsvr",
    "3359": "WG NetForce",
    "3360": "KV Server",
    "3361": "KV Agent",
    "3362": "DJ ILM",
    "3363": "NATI Vi Server",
    "3364": "Creative Server",
    "3365": "Content Server",
    "3366": "Creative Partner",
    "3372": "TIP 2",
    "3373": "Lavenir License Manager",
    "3374": "Cluster Disc",
    "3375": "VSNM Agent",
    "3376": "CD Broker",
    "3377": "Cogsys Network License Manager",
    "3378": "WSICOPY",
    "3379": "SOCORFS",
    "3380": "SNS Channels",
    "3381": "Geneous",
    "3382": "Fujitsu Network Enhanced Antitheft function",
    "3383": "Enterprise Software Products License Manager",
    "3384": "Cluster Management Services",
    "3385": "qnxnetman",
    "3386": "GPRS Data",
    "3387": "Back Room Net",
    "3388": "CB Server",
    "3389": "MS WBT Server",
    "3390": "Distributed Service Coordinator",
    "3391": "SAVANT",
    "3392": "EFI License Management",
    "3393": "D2K Tapestry Client to Server",
    "3394": "D2K Tapestry Server to Server",
    "3395": "Dyna License Manager (Elam)",
    "3396": "Printer Agent",
    "3396": "Printer Agent",
    "3397": "Cloanto License Manager",
    "3398": "Mercantile",
    "3399": "CSMS",
    "3400": "CSMS2",
    "3401": "filecast",
    "3402": "FXa Engine Network Port",
    "3405": "Nokia Announcement ch 1",
    "3406": "Nokia Announcement ch 2",
    "3407": "LDAP admin server port",
    "3408": "BES Api Port",
    "3409": "NetworkLens Event Port",
    "3410": "NetworkLens SSL Event",
    "3411": "BioLink Authenteon server",
    "3412": "xmlBlaster",
    "3413": "SpecView Networking",
    "3414": "BroadCloud WIP Port",
    "3415": "BCI Name Service",
    "3416": "AirMobile IS Command Port",
    "3417": "ConServR file translation",
    "3418": "Remote nmap",
    "3419": "Isogon SoftAudit",
    "3420": "iFCP User Port",
    "3421": "Bull Apprise portmapper",
    "3422": "Remote USB System Port",
    "3423": "xTrade Reliable Messaging",
    "3424": "xTrade over TLS/SSL",
    "3425": "AGPS Access Port",
    "3426": "Arkivio Storage Protocol",
    "3427": "WebSphere SNMP",
    "3428": "2Wire CSS",
    "3429": "GCSP user port",
    "3430": "Scott Studios Dispatch",
    "3431": "Active License Server Port",
    "3432": "Secure Device Protocol",
    "3433": "OPNET Service Management Platform",
    "3434": "OpenCM Server",
    "3435": "Pacom Security User Port",
    "3436": "GuardControl Exchange Protocol",
    "3437": "Autocue Directory Service",
    "3438": "Spiralcraft Admin",
    "3439": "HRI Interface Port",
    "3440": "Net Steward Mgmt Console",
    "3441": "OC Connect Client",
    "3442": "OC Connect Server",
    "3443": "OpenView Network Node Manager WEB Server",
    "3444": "Denali Server",
    "3445": "Media Object Network Protocol",
    "3446": "3Com FAX RPC port",
    "3447": "DirectNet IM System",
    "3448": "Discovery and Net Config",
    "3449": "HotU Chat",
    "3450": "CAStorProxy",
    "3451": "ASAM Services",
    "3452": "SABP-Signalling Protocol",
    "3453": "PSC Update",
    "3454": "Apple Remote Access Protocol",
    "3455": "RSVP Port",
    "3456": "VAT default data",
    "3457": "VAT default control",
    "3458": "D3WinOSFI",
    "3459": "TIP Integral",
    "3460": "EDM Manger",
    "3461": "EDM Stager",
    "3462": "EDM STD Notify",
    "3463": "EDM ADM Notify",
    "3464": "EDM MGR Sync",
    "3465": "EDM MGR Cntrl",
    "3466": "WORKFLOW",
    "3467": "RCST",
    "3468": "TTCM Remote Controll",
    "3469": "Pluribus",
    "3470": "jt400",
    "3471": "jt400-ssl",
    "3472": "JAUGS N-G Remotec 1",
    "3473": "JAUGS N-G Remotec 2",
    "3474": "TSP Automation",
    "3475": "Genisar Comm Port",
    "3476": "NVIDIA Mgmt Protocol",
    "3477": "eComm link port",
    "3478": "Session Traversal Utilities for NAT (STUN) port",
    "3479": "2Wire RPC",
    "3480": "Secure Virtual Workspace",
    "3481": "CleanerLive remote ctrl",
    "3482": "Vulture Monitoring System",
    "3483": "Slim Devices Protocol",
    "3484": "GBS SnapTalk Protocol",
    "3485": "CelaTalk",
    "3486": "IFSF Heartbeat Port",
    "3487": "LISA TCP Transfer Channel",
    "3488": "FS Remote Host Server",
    "3489": "DTP/DIA",
    "3490": "Colubris Management Port",
    "3491": "SWR Port",
    "3492": "TVDUM Tray Port",
    "3493": "Network UPS Tools",
    "3494": "IBM 3494",
    "3495": "securitylayer over tcp",
    "3496": "securitylayer over tls",
    "3497": "ipEther232Port",
    "3498": "DASHPAS user port",
    "3499": "SccIP Media",
    "3500": "RTMP Port",
    "3501": "iSoft-P2P",
    "3502": "Avocent Install Discovery",
    "3503": "MPLS LSP-echo Port",
    "3504": "IronStorm game server",
    "3505": "CCM communications port",
    "3506": "APC 3506",
    "3507": "Nesh Broker Port",
    "3508": "Interaction Web",
    "3509": "Virtual Token SSL Port",
    "3510": "XSS Port",
    "3511": "WebMail/2",
    "3512": "Aztec Distribution Port",
    "3513": "Adaptec Remote Protocol",
    "3514": "MUST Peer to Peer",
    "3515": "MUST Backplane",
    "3516": "Smartcard Port",
    "3517": "IEEE 802.11 WLANs WG IAPP",
    "3518": "Artifact Message Server",
    "3519": "Netvion Messenger Port",
    "3520": "Netvion Galileo Log Port",
    "3521": "Telequip Labs MC3SS",
    "3522": "DO over NSSocketPort",
    "3523": "Odeum Serverlink",
    "3524": "ECM Server port",
    "3525": "EIS Server port",
    "3526": "starQuiz Port",
    "3527": "VERITAS Backup Exec Server",
    "3528": "JBoss IIOP",
    "3529": "JBoss IIOP/SSL",
    "3530": "Grid Friendly",
    "3531": "Joltid",
    "3532": "Raven Remote Management Control",
    "3533": "Raven Remote Management Data",
    "3534": "URL Daemon Port",
    "3535": "MS-LA",
    "3536": "SNAC",
    "3537": "Remote NI-VISA port",
    "3538": "IBM Directory Server",
    "3539": "IBM Directory Server SSL",
    "3540": "PNRP User Port",
    "3541": "VoiSpeed Port",
    "3542": "HA cluster monitor",
    "3543": "qftest Lookup Port",
    "3544": "Teredo Port",
    "3545": "CAMAC equipment",
    "3547": "Symantec SIM",
    "3548": "Interworld",
    "3549": "Tellumat MDR NMS",
    "3550": "Secure SMPP",
    "3551": "Apcupsd Information Port",
    "3552": "TeamAgenda Server Port",
    "3553": "Red Box Recorder ADP",
    "3554": "Quest Notification Server",
    "3555": "Vipul's Razor",
    "3556": "Sky Transport Protocol",
    "3557": "PersonalOS Comm Port",
    "3558": "MCP user port",
    "3559": "CCTV control port",
    "3560": "INIServe port",
    "3561": "BMC-OneKey",
    "3562": "SDBProxy",
    "3563": "Watcom Debug",
    "3564": "Electromed SIM port",
    "3565": "M2PA",
    "3566": "Quest Data Hub",
    "3567": "DOF Protocol Stack",
    "3568": "DOF Secure Tunnel",
    "3569": "Meinberg Control Service",
    "3570": "MCC Web Server Port",
    "3571": "MegaRAID Server Port",
    "3572": "Registration Server Port",
    "3573": "Advantage Group UPS Suite",
    "3574": "DMAF Server",
    "3575": "Coalsere CCM Port",
    "3576": "Coalsere CMC Port",
    "3577": "Configuration Port",
    "3578": "Data Port",
    "3579": "Tarantella Load Balancing",
    "3580": "NATI-ServiceLocator",
    "3581": "Ascent Capture Licensing",
    "3582": "PEG PRESS Server",
    "3583": "CANEX Watch System",
    "3584": "U-DBase Access Protocol",
    "3585": "Emprise License Server",
    "3586": "License Server Console",
    "3587": "Peer to Peer Grouping",
    "3588": "Sentinel Server",
    "3589": "isomair",
    "3590": "WV CSP SMS Binding",
    "3591": "LOCANIS G-TRACK Server",
    "3592": "LOCANIS G-TRACK NE Port",
    "3593": "BP Model Debugger",
    "3594": "MediaSpace",
    "3595": "ShareApp",
    "3596": "Illusion Wireless MMOG",
    "3597": "A14 (AN-to-SC/MM)",
    "3598": "A15 (AN-to-AN)",
    "3599": "Quasar Accounting Server",
    "3600": "text relay-answer",
    "3601": "Visinet Gui",
    "3602": "InfiniSwitch Mgr Client",
    "3603": "Integrated Rcvr Control",
    "3604": "BMC JMX Port",
    "3605": "ComCam IO Port",
    "3606": "Splitlock Server",
    "3607": "Precise I3",
    "3608": "Trendchip control protocol",
    "3609": "CPDI PIDAS Connection Mon",
    "3610": "ECHONET",
    "3611": "Six Degrees Port",
    "3612": "Micro Focus Data Protector",
    "3613": "Alaris Device Discovery",
    "3614": "Satchwell Sigma",
    "3615": "Start Messaging Network",
    "3616": "cd3o Control Protocol",
    "3617": "ATI SHARP Logic Engine",
    "3618": "AAIR-Network 1",
    "3619": "AAIR-Network 2",
    "3620": "EPSON Projector Control Port",
    "3621": "EPSON Network Screen Port",
    "3622": "FF LAN Redundancy Port",
    "3623": "HAIPIS Dynamic Discovery",
    "3624": "Distributed Upgrade Port",
    "3625": "Volley",
    "3626": "bvControl Daemon",
    "3627": "Jam Server Port",
    "3628": "EPT Machine Interface",
    "3629": "ESC/VP.net",
    "3630": "C&amp;S Remote Database Port",
    "3631": "C&amp;S Web Services Port",
    "3632": "distributed compiler",
    "3633": "Wyrnix AIS port",
    "3634": "hNTSP Library Manager",
    "3635": "Simple Distributed Objects",
    "3636": "SerVistaITSM",
    "3637": "Customer Service Port",
    "3638": "EHP Backup Protocol",
    "3639": "Extensible Automation",
    "3640": "Netplay Port 1",
    "3641": "Netplay Port 2",
    "3642": "Juxml Replication port",
    "3643": "AudioJuggler",
    "3644": "ssowatch",
    "3645": "Cyc",
    "3646": "XSS Server Port",
    "3647": "Splitlock Gateway",
    "3648": "Fujitsu Cooperation Port",
    "3649": "Nishioka Miyuki Msg Protocol",
    "3650": "PRISMIQ VOD plug-in",
    "3651": "XRPC Registry",
    "3652": "VxCR NBU Default Port",
    "3653": "Tunnel Setup Protocol",
    "3654": "VAP RealTime Messenger",
    "3655": "ActiveBatch Exec Agent",
    "3656": "ActiveBatch Job Scheduler",
    "3657": "ImmediaNet Beacon",
    "3658": "PlayStation AMS (Secure)",
    "3659": "Apple SASL",
    "3660": "IBM Tivoli Directory Service using SSL",
    "3661": "IBM Tivoli Directory Service using SSL",
    "3662": "pserver",
    "3663": "DIRECWAY Tunnel Protocol",
    "3664": "UPS Engine Port",
    "3665": "Enterprise Engine Port",
    "3666": "IBM eServer PAP",
    "3667": "IBM Information Exchange",
    "3668": "Dell Remote Management",
    "3669": "CA SAN Switch Management",
    "3670": "SMILE TCP/UDP Interface",
    "3671": "e Field Control (EIBnet)",
    "3672": "LispWorks ORB",
    "3673": "Openview Media Vault GUI",
    "3674": "WinINSTALL IPC Port",
    "3675": "CallTrax Data Port",
    "3676": "VisualAge Pacbase server",
    "3677": "RoverLog IPC",
    "3678": "DataGuardianLT",
    "3679": "Newton Dock",
    "3680": "NPDS Tracker",
    "3681": "BTS X73 Port",
    "3682": "EMC SmartPackets-MAPI",
    "3683": "BMC EDV/EA",
    "3684": "FAXstfX",
    "3685": "DS Expert Agent",
    "3686": "Trivial Network Management",
    "3687": "simple-push",
    "3688": "simple-push Secure",
    "3689": "Digital Audio Access Protocol (iTunes)",
    "3690": "Subversion",
    "3691": "Magaya Network Port",
    "3692": "Brimstone IntelSync",
    "3693": "Emergency Automatic Structure Lockdown System",
    "3695": "BMC Data Collection",
    "3696": "Telnet Com Port Control",
    "3697": "NavisWorks License System",
    "3698": "SAGECTLPANEL",
    "3699": "Internet Call Waiting",
    "3700": "LRS NetPage",
    "3701": "NetCelera",
    "3702": "Web Service Discovery",
    "3703": "Adobe Server 3",
    "3704": "Adobe Server 4",
    "3705": "Adobe Server 5",
    "3706": "Real-Time Event Port",
    "3707": "Real-Time Event Secure Port",
    "3708": "Sun App Svr - Naming",
    "3709": "CA-IDMS Server",
    "3710": "PortGate Authentication",
    "3711": "EBD Server 2",
    "3712": "Sentinel Enterprise",
    "3713": "TFTP over TLS",
    "3714": "DELOS Direct Messaging",
    "3715": "Anoto Rendezvous Port",
    "3716": "WV CSP SMS CIR Channel",
    "3717": "WV CSP UDP/IP CIR Channel",
    "3718": "OPUS Server Port",
    "3719": "iTel Server Port",
    "3720": "UF Astro. Instr. Services",
    "3721": "Xsync",
    "3722": "Xserve RAID",
    "3723": "Sychron Service Daemon",
    "3724": "World of Warcraft",
    "3725": "Netia NA-ER Port",
    "3726": "Xyratex Array Manager",
    "3727": "Ericsson Mobile Data Unit",
    "3728": "Ericsson Web on Air",
    "3729": "Fireking Audit Port",
    "3730": "Client Control",
    "3731": "Service Manager",
    "3732": "Mobile Wnn",
    "3733": "Multipuesto Msg Port",
    "3734": "Synel Data Collection Port",
    "3735": "Password Distribution",
    "3736": "RealSpace RMI",
    "3737": "XPanel Daemon",
    "3738": "versaTalk Server Port",
    "3739": "Launchbird LicenseManager",
    "3740": "Heartbeat Protocol",
    "3741": "WysDM Agent",
    "3742": "CST - Configuration &amp; Service Tracker",
    "3743": "IP Control Systems Ltd.",
    "3744": "SASG",
    "3745": "GWRTC Call Port",
    "3746": "LXPRO.COM LinkTest",
    "3747": "LXPRO.COM LinkTest SSL",
    "3748": "webData",
    "3749": "CimTrak",
    "3750": "CBOS/IP ncapsalation port",
    "3751": "CommLinx GPRS Cube",
    "3752": "Vigil-IP RemoteAgent",
    "3753": "NattyServer Port",
    "3754": "TimesTen Broker Port",
    "3755": "SAS Remote Help Server",
    "3756": "Canon CAPT Port",
    "3757": "GRF Server Port",
    "3758": "apw RMI registry",
    "3759": "Exapt License Manager",
    "3760": "adTempus Client",
    "3761": "gsakmp port",
    "3762": "GBS SnapMail Protocol",
    "3763": "XO Wave Control Port",
    "3764": "MNI Protected Routing",
    "3765": "Remote Traceroute",
    "3766": "SSL e-watch sitewatch server",
    "3767": "ListMGR Port",
    "3768": "rblcheckd server daemon",
    "3769": "HAIPE Network Keying",
    "3770": "Cinderella Collaboration",
    "3771": "RTP Paging Port",
    "3772": "Chantry Tunnel Protocol",
    "3773": "ctdhercules",
    "3774": "ZICOM",
    "3775": "ISPM Manager Port",
    "3776": "Device Provisioning Port",
    "3777": "Jibe EdgeBurst",
    "3778": "Cutler-Hammer IT Port",
    "3779": "Cognima Replication",
    "3780": "Nuzzler Network Protocol",
    "3781": "ABCvoice server port",
    "3782": "Secure ISO TP0 port",
    "3783": "Impact Mgr./PEM Gateway",
    "3784": "BFD Control Protocol",
    "3785": "BFD Echo Protocol",
    "3786": "VSW Upstrigger port",
    "3787": "Fintrx",
    "3788": "SPACEWAY Routing port",
    "3789": "RemoteDeploy Administration Port [July 2003]",
    "3790": "QuickBooks RDS",
    "3791": "TV NetworkVideo Data port",
    "3792": "e-Watch Corporation SiteWatch",
    "3793": "DataCore Software",
    "3794": "JAUS Robots",
    "3795": "myBLAST Mekentosj port",
    "3796": "Spaceway Dialer",
    "3797": "idps",
    "3798": "Minilock",
    "3799": "RADIUS Dynamic Authorization",
    "3800": "Print Services Interface",
    "3801": "ibm manager service",
    "3802": "VHD",
    "3803": "SoniqSync",
    "3804": "Harman IQNet Port",
    "3805": "ThorGuard Server Port",
    "3806": "Remote System Manager",
    "3807": "SpuGNA Communication Port",
    "3808": "Sun App Svr-IIOPClntAuth",
    "3809": "Java Desktop System Configuration Agent",
    "3810": "WLAN AS server",
    "3811": "AMP",
    "3812": "netO WOL Server",
    "3813": "Rhapsody Interface Protocol",
    "3814": "netO DCS",
    "3815": "LANsurveyor XML",
    "3816": "Sun Local Patch Server",
    "3817": "Yosemite Tech Tapeware",
    "3818": "Crinis Heartbeat",
    "3819": "EPL Sequ Layer Protocol",
    "3820": "Siemens AuD SCP",
    "3821": "ATSC PMCP Standard",
    "3822": "Compute Pool Discovery",
    "3823": "Compute Pool Conduit",
    "3824": "Compute Pool Policy",
    "3825": "Antera FlowFusion Process Simulation",
    "3826": "WarMUX game server",
    "3827": "Netadmin Systems MPI service",
    "3828": "Netadmin Systems Event Handler",
    "3829": "Netadmin Systems Event Handler External",
    "3830": "Cerner System Management Agent",
    "3831": "Docsvault Application Service",
    "3832": "xxNETserver",
    "3833": "AIPN LS Authentication",
    "3834": "Spectar Data Stream Service",
    "3835": "Spectar Database Rights Service",
    "3836": "MARKEM NEXTGEN DCP",
    "3837": "MARKEM Auto-Discovery",
    "3838": "Scito Object Server",
    "3839": "AMX Resource Management Suite",
    "3840": "www.FlirtMitMir.de",
    "3841": "ShipRush Database Server",
    "3842": "NHCI status port",
    "3843": "Quest Common Agent",
    "3844": "RNM",
    "3845": "V-ONE Single Port Proxy",
    "3846": "Astare Network PCP",
    "3847": "MS Firewall Control",
    "3848": "IT Environmental Monitor",
    "3849": "SPACEWAY DNS Preload",
    "3850": "QTMS Bootstrap Protocol",
    "3851": "SpectraTalk Port",
    "3852": "SSE App Configuration",
    "3853": "SONY scanning protocol",
    "3854": "Stryker Comm Port",
    "3855": "OpenTRAC",
    "3856": "INFORMER",
    "3857": "Trap Port",
    "3858": "Trap Port MOM",
    "3859": "Navini Port",
    "3860": "Server/Application State Protocol (SASP)",
    "3861": "winShadow Host Discovery",
    "3862": "GIGA-POCKET",
    "3863": "asap tcp port",
    "3864": "asap/tls tcp port",
    "3865": "xpl automation protocol",
    "3866": "Sun SDViz DZDAEMON Port",
    "3867": "Sun SDViz DZOGLSERVER Port",
    "3868": "DIAMETER",
    "3869": "hp OVSAM MgmtServer Disco",
    "3870": "hp OVSAM HostAgent Disco",
    "3871": "Avocent DS Authorization",
    "3872": "OEM Agent",
    "3873": "fagordnc",
    "3874": "SixXS Configuration",
    "3875": "PNBSCADA",
    "3876": "DirectoryLockdown Agent",
    "3876": "DirectoryLockdown Agent",
    "3877": "XMPCR Interface Port",
    "3878": "FotoG CAD interface",
    "3879": "appss license manager",
    "3880": "IGRS",
    "3881": "Data Acquisition and Control",
    "3882": "DTS Service Port",
    "3883": "VR Peripheral Network",
    "3884": "SofTrack Metering",
    "3885": "TopFlow SSL",
    "3886": "NEI management port",
    "3887": "Ciphire Data Transport",
    "3888": "Ciphire Services",
    "3889": "D and V Tester Control Port",
    "3890": "Niche Data Server Connect",
    "3891": "Oracle RTC-PM port",
    "3892": "PCC-image-port",
    "3893": "CGI StarAPI Server",
    "3894": "SyAM Agent Port",
    "3895": "SyAm SMC Service Port",
    "3896": "Simple Distributed Objects over TLS",
    "3897": "Simple Distributed Objects over SSH",
    "3898": "IAS, Inc. SmartEye NET Internet Protocol",
    "3899": "ITV Port",
    "3900": "Unidata UDT OS",
    "3900": "Unidata UDT OS",
    "3901": "NIM Service Handler",
    "3902": "NIMsh Auxiliary Port",
    "3903": "CharsetMGR",
    "3904": "Arnet Omnilink Port",
    "3905": "Mailbox Update (MUPDATE) protocol",
    "3906": "TopoVista elevation data",
    "3907": "Imoguia Port",
    "3908": "HP Procurve NetManagement",
    "3909": "SurfControl CPA",
    "3910": "Printer Request Port",
    "3911": "Printer Status Port",
    "3912": "Global Maintech Stars",
    "3913": "ListCREATOR Port",
    "3914": "ListCREATOR Port 2",
    "3915": "Auto-Graphics Cataloging",
    "3916": "WysDM Controller",
    "3917": "AFT multiplex port",
    "3918": "PacketCableMultimediaCOPS",
    "3919": "HyperIP",
    "3920": "Exasoft IP Port",
    "3921": "Herodotus Net",
    "3922": "Soronti Update Port",
    "3923": "Symbian Service Broker",
    "3924": "MPL_GPRS_PORT",
    "3925": "Zoran Media Port",
    "3926": "WINPort",
    "3927": "ScsTsr",
    "3928": "PXE NetBoot Manager",
    "3929": "AMS Port",
    "3930": "Syam Web Server Port",
    "3931": "MSR Plugin Port",
    "3932": "Dynamic Site System",
    "3933": "PL/B App Server User Port",
    "3934": "PL/B File Manager Port",
    "3935": "SDP Port Mapper Protocol",
    "3936": "Mailprox",
    "3937": "DVB Service Discovery",
    "3938": "Oracle dbControl Agent po",
    "3938": "Oracle dbControl Agent po",
    "3939": "Anti-virus Application Management Port",
    "3940": "XeCP Node Service",
    "3941": "Home Portal Web Server",
    "3942": "satellite distribution",
    "3943": "TetraNode Ip Gateway",
    "3944": "S-Ops Management",
    "3945": "EMCADS Server Port",
    "3946": "BackupEDGE Server",
    "3947": "Connect and Control Protocol for Consumer, Commercial, and Industrial Electronic Devices",
    "3948": "Anton Paar Device Administration Protocol",
    "3949": "Dynamic Routing Information Protocol",
    "3950": "Name Munging",
    "3951": "PWG IPP Facsimile",
    "3952": "I3 Session Manager",
    "3953": "Eydeas XMLink Connect",
    "3954": "AD Replication RPC",
    "3955": "p2pCommunity",
    "3956": "GigE Vision Control",
    "3957": "MQEnterprise Broker",
    "3958": "MQEnterprise Agent",
    "3959": "Tree Hopper Networking",
    "3960": "Bess Peer Assessment",
    "3961": "ProAxess Server",
    "3962": "SBI Agent Protocol",
    "3963": "Teran Hybrid Routing Protocol",
    "3964": "SASG GPRS",
    "3965": "Avanti IP to NCPE API",
    "3966": "BuildForge Lock Manager",
    "3967": "PPS Message Service",
    "3968": "iAnywhere DBNS",
    "3969": "Landmark Messages",
    "3970": "LANrev Agent",
    "3971": "LANrev Server",
    "3972": "ict-control Protocol",
    "3973": "ConnectShip Progistics",
    "3974": "Remote Applicant Tracking Service",
    "3975": "Air Shot",
    "3976": "Server Automation Agent",
    "3977": "Opsware Manager",
    "3978": "Secured Configuration Server",
    "3979": "Smith Micro Wide Area Network Service",
    "3980": "Reserved",
    "3981": "Starfish System Admin",
    "3982": "ESRI Image Server",
    "3983": "ESRI Image Service",
    "3984": "MAPPER network node manager",
    "3985": "MAPPER TCP/IP server",
    "3986": "MAPPER workstation server",
    "3986": "MAPPER workstation server",
    "3987": "Centerline",
    "3988": "DCS Configuration Port",
    "3989": "BindView-Query Engine",
    "3990": "BindView-IS",
    "3991": "BindView-SMCServer",
    "3992": "BindView-DirectoryServer",
    "3993": "BindView-Agent",
    "3995": "ISS Management Svcs SSL",
    "3996": "abcsoftware-01",
    "3997": "aes_db",
    "3998": "Distributed Nagios Executor Service",
    "3999": "Norman distributes scanning service",
    "4000": "Terabase",
    "4001": "NewOak",
    "4002": "pxc-spvr-ft",
    "4003": "pxc-splr-ft",
    "4004": "pxc-roid",
    "4005": "pxc-pin",
    "4006": "pxc-spvr",
    "4007": "pxc-splr",
    "4008": "NetCheque accounting",
    "4009": "Chimera HWM",
    "4010": "Samsung Unidex",
    "4011": "Alternate Service Boot",
    "4012": "PDA Gate",
    "4013": "ACL Manager",
    "4014": "TAICLOCK",
    "4015": "Talarian Mcast",
    "4016": "Talarian Mcast",
    "4017": "Talarian Mcast",
    "4018": "Talarian Mcast",
    "4019": "Talarian Mcast",
    "4020": "TRAP Port",
    "4021": "Nexus Portal",
    "4022": "DNOX",
    "4023": "ESNM Zoning Port",
    "4024": "TNP1 User Port",
    "4025": "Partition Image Port",
    "4026": "Graphical Debug Server",
    "4027": "bitxpress",
    "4028": "DTServer Port",
    "4029": "IP Q signaling protocol",
    "4030": "Accell/JSP Daemon Port",
    "4031": "UUCP over SSL",
    "4032": "VERITAS Authorization Service",
    "4033": "SANavigator Peer Port",
    "4034": "Ubiquinox Daemon",
    "4035": "WAP Push OTA-HTTP port",
    "4036": "WAP Push OTA-HTTP secure",
    "4037": "RaveHD network control",
    "4038": "Fazzt Point-To-Point",
    "4039": "Fazzt Administration",
    "4040": "Yo.net main service",
    "4041": "Rocketeer-Houston",
    "4042": "LDXP",
    "4043": "Neighbour Identity Resolution",
    "4044": "Location Tracking Protocol",
    "4045": "Network Paging Protocol",
    "4046": "Accounting Protocol",
    "4047": "Context Transfer Protocol",
    "4049": "Wide Area File Services",
    "4050": "Wide Area File Services",
    "4051": "Cisco Peer to Peer Distribution Protocol",
    "4052": "VoiceConnect Interact",
    "4053": "CosmoCall Universe Communications Port 1",
    "4054": "CosmoCall Universe Communications Port 2",
    "4055": "CosmoCall Universe Communications Port 3",
    "4056": "Location Message Service",
    "4057": "Servigistics WFM server",
    "4058": "Kingfisher protocol",
    "4059": "DLMS/COSEM",
    "4060": "DSMETER Inter-Agent Transfer Channel",
    "4060": "DSMETER Inter-Agent Transfer Channel",
    "4061": "Ice Location Service (TCP)",
    "4062": "Ice Location Service (SSL)",
    "4063": "Ice Firewall Traversal Service (TCP)",
    "4064": "Ice Firewall Traversal Service (SSL)",
    "4065": "Avanti Common Data",
    "4065": "Avanti Common Data",
    "4066": "Performance Measurement and Analysis",
    "4067": "Information Distribution Protocol",
    "4068": "IP Fleet Broadcast",
    "4069": "Minger Email Address Validation Service",
    "4070": "Trivial IP Encryption (TrIPE)",
    "4071": "Automatically Incremental Backup",
    "4072": "Zieto Socket Communications",
    "4073": "Interactive Remote Application Pairing Protocol",
    "4074": "Cequint City ID UI trigger",
    "4075": "ISC Alarm Message Service",
    "4076": "Seraph DCS",
    "4077": "Reserved",
    "4078": "Coordinated Security Service Protocol",
    "4079": "SANtools Diagnostic Server",
    "4080": "Lorica inside facing",
    "4081": "Lorica inside facing (SSL)",
    "4082": "Lorica outside facing",
    "4083": "Lorica outside facing (SSL)",
    "4084": "Reserved",
    "4085": "EZNews Newsroom Message Service",
    "4086": "Reserved",
    "4087": "APplus Service",
    "4088": "Noah Printing Service Protocol",
    "4089": "OpenCORE Remote Control Service",
    "4090": "OMA BCAST Service Guide",
    "4091": "EminentWare Installer",
    "4092": "EminentWare DGS",
    "4093": "Pvx Plus CS Host",
    "4094": "sysrq daemon",
    "4095": "xtgui information service",
    "4096": "BRE (Bridge Relay Element)",
    "4097": "Patrol View",
    "4098": "drmsfsd",
    "4099": "DPCP",
    "4100": "IGo Incognito Data Port",
    "4101": "Braille protocol",
    "4102": "Braille protocol",
    "4103": "Braille protocol",
    "4104": "Braille protocol",
    "4105": "Shofar",
    "4106": "Synchronite",
    "4107": "JDL Accounting LAN Service",
    "4108": "ACCEL",
    "4109": "Instantiated Zero-control Messaging",
    "4110": "G2 RFID Tag Telemetry Data",
    "4111": "Xgrid",
    "4112": "Apple VPN Server Reporting Protocol",
    "4113": "AIPN LS Registration",
    "4114": "JomaMQMonitor",
    "4115": "CDS Transfer Agent",
    "4116": "smartcard-TLS",
    "4117": "Hillr Connection Manager",
    "4118": "Netadmin Systems NETscript service",
    "4119": "Assuria Log Manager",
    "4120": "MiniRem Remote Telemetry and Control",
    "4121": "e-Builder Application Communication",
    "4122": "Fiber Patrol Alarm Service",
    "4123": "Z-Wave Protocol",
    "4124": "Rohill TetraNode Ip Gateway v2",
    "4125": "Opsview Envoy",
    "4126": "Data Domain Replication Service",
    "4127": "NetUniKeyServer",
    "4128": "NuFW decision delegation protocol",
    "4129": "NuFW authentication protocol",
    "4130": "FRONET message protocol",
    "4131": "Global Maintech Stars",
    "4132": "NUTS Daemon",
    "4132": "NUTS Daemon",
    "4133": "NUTS Bootp Server",
    "4133": "NUTS Bootp Server",
    "4134": "NIFTY-Serve HMI protocol",
    "4135": "Classic Line Database Server Attach",
    "4136": "Classic Line Database Server Request",
    "4137": "Classic Line Database Server Remote",
    "4138": "nettest",
    "4139": "Imperfect Networks Server",
    "4140": "Cedros Fraud Detection System",
    "4140": "Cedros Fraud Detection System",
    "4141": "Workflow Server",
    "4142": "Document Server",
    "4143": "Document Replication",
    "4145": "VVR Control",
    "4146": "TGCConnect Beacon",
    "4147": "Multum Service Manager",
    "4148": "HHB Handheld Client",
    "4149": "A10 GSLB Service",
    "4150": "PowerAlert Network Shutdown Agent",
    "4151": "Men &amp; Mice Remote Control",
    "4151": "Men &amp; Mice Remote Control",
    "4152": "iDigTech Multiplex",
    "4152": "iDigTech Multiplex",
    "4153": "MBL Remote Battery Monitoring",
    "4154": "atlinks device discovery",
    "4155": "Bazaar version control system",
    "4156": "STAT Results",
    "4157": "STAT Scanner Control",
    "4158": "STAT Command Center",
    "4159": "Network Security Service",
    "4160": "Jini Discovery",
    "4161": "OMS Contact",
    "4162": "OMS Topology",
    "4163": "Silver Peak Peer Protocol",
    "4164": "Silver Peak Communication Protocol",
    "4165": "ArcLink over Ethernet",
    "4166": "Joost Peer to Peer Protocol",
    "4167": "DeskDirect Global Network",
    "4168": "PrintSoft License Server",
    "4169": "Automation Drive Interface Transport",
    "4170": "SMPTE Content Synchonization Protocol",
    "4171": "Maxlogic Supervisor Communication",
    "4172": "PC over IP",
    "4173": "Reserved",
    "4174": "StorMagic Cluster Services",
    "4175": "Brocade Cluster Communication Protocol",
    "4176": "Translattice Cluster IPC Proxy",
    "4177": "Wello P2P pubsub service",
    "4178": "StorMan",
    "4179": "Maxum Services",
    "4180": "HTTPX",
    "4181": "MacBak",
    "4182": "Production Company Pro TCP Service",
    "4183": "CyborgNet communications protocol",
    "4184": "UNIVERSE SUITE MESSAGE SERVICE",
    "4184": "UNIVERSE SUITE MESSAGE SERVICE",
    "4185": "Woven Control Plane Protocol",
    "4186": "Box Backup Store Service",
    "4187": "Cascade Proxy",
    "4187": "Cascade Proxy",
    "4188": "Vatata Peer to Peer Protocol",
    "4189": "Path Computation Element Communication Protocol",
    "4190": "ManageSieve Protocol",
    "4191": "Reserved",
    "4192": "Azeti Agent Service",
    "4193": "PxPlus remote file srvr",
    "4194": "Security Protocol and Data Model",
    "4195": "AWS protocol for cloud remoting solution",
    "4197": "Harman HControl Protocol",
    "4199": "EIMS ADMIN",
    "4300": "Corel CCam",
    "4301": "Diagnostic Data",
    "4302": "Diagnostic Data Control",
    "4303": "Simple Railroad Command Protocol",
    "4304": "One-Wire Filesystem Server",
    "4305": "better approach to mobile ad-hoc networking",
    "4306": "Hellgate London",
    "4307": "TrueConf Videoconference Service",
    "4308": "CompX-LockView",
    "4309": "Exsequi Appliance Discovery",
    "4310": "Mir-RT exchange service",
    "4311": "P6R Secure Server Management Console",
    "4312": "Parascale Membership Manager",
    "4313": "PERRLA User Services",
    "4314": "ChoiceView Agent",
    "4316": "ChoiceView Client",
    "4317": "OpenTelemetry Protocol",
    "4319": "Fox SkyTale encrypted communication",
    "4320": "FDT Remote Categorization Protocol",
    "4321": "Remote Who Is",
    "4322": "TRIM Event Service",
    "4323": "TRIM ICE Service",
    "4325": "Cadcorp GeognoSIS Administrator",
    "4326": "Cadcorp GeognoSIS",
    "4327": "Jaxer Web Protocol",
    "4328": "Jaxer Manager Command Protocol",
    "4329": "PubliQare Distributed Environment Synchronisation Engine",
    "4330": "DEY Storage Administration REST API",
    "4331": "ktickets REST API for event management and ticketing systems (embedded POS devices)",
    "4332": "Getty Images FOCUS service",
    "4333": "ArrowHead Service Protocol (AHSP)",
    "4334": "NETCONF Call Home (SSH)",
    "4335": "NETCONF Call Home (TLS)",
    "4336": "RESTCONF Call Home (TLS)",
    "4340": "Gaia Connector Protocol",
    "4341": "Reserved",
    "4342": "Reserved",
    "4343": "UNICALL",
    "4344": "VinaInstall",
    "4345": "Macro 4 Network AS",
    "4346": "ELAN LM",
    "4347": "LAN Surveyor",
    "4348": "ITOSE",
    "4349": "File System Port Map",
    "4350": "Net Device",
    "4351": "PLCY Net Services",
    "4352": "Projector Link",
    "4353": "F5 iQuery",
    "4354": "QSNet Transmitter",
    "4355": "QSNet Workstation",
    "4356": "QSNet Assistant",
    "4357": "QSNet Conductor",
    "4358": "QSNet Nucleus",
    "4359": "OMA BCAST Long-Term Key Messages",
    "4360": "Matrix VNet Communication Protocol",
    "4360": "Matrix VNet Communication Protocol",
    "4361": "Reserved",
    "4362": "Reserved",
    "4366": "Reserved",
    "4368": "WeatherBrief Direct",
    "4369": "Erlang Port Mapper Daemon",
    "4370": "ELPRO V2 Protocol Tunnel",
    "4370": "ELPRO V2 Protocol Tunnel",
    "4371": "LAN2CAN Control",
    "4372": "LAN2CAN Data",
    "4373": "Remote Authenticated Command Service",
    "4374": "PSI Push-to-Talk Protocol",
    "4375": "Toltec EasyShare",
    "4376": "BioAPI Interworking",
    "4377": "Cambridge Pixel SPx Server",
    "4378": "Cambridge Pixel SPx Display",
    "4379": "CTDB",
    "4389": "Xandros Community Management Service",
    "4390": "Physical Access Control",
    "4391": "American Printware IMServer Protocol",
    "4392": "American Printware RXServer Protocol",
    "4393": "American Printware RXSpooler Protocol",
    "4394": "Reserved",
    "4395": "OmniVision communication for Virtual environments",
    "4396": "Fly Object Space",
    "4400": "ASIGRA Services",
    "4401": "ASIGRA Televaulting DS-System Service",
    "4402": "ASIGRA Televaulting DS-Client Service",
    "4403": "ASIGRA Televaulting DS-Client Monitoring/Management",
    "4404": "ASIGRA Televaulting DS-System Monitoring/Management",
    "4405": "ASIGRA Televaulting Message Level Restore service",
    "4406": "ASIGRA Televaulting DS-Sleeper Service",
    "4407": "Network Access Control Agent",
    "4408": "SLS Technology Control Centre",
    "4409": "Net-Cabinet comunication",
    "4410": "RIB iTWO Application Server",
    "4411": "Found Messaging Protocol",
    "4412": "Reserved",
    "4413": "AVI Systems NMS",
    "4414": "Updog Monitoring and Status Framework",
    "4415": "Brocade Virtual Router Request",
    "4416": "PJJ Media Player",
    "4417": "Workflow Director Communication",
    "4418": "Reserved",
    "4419": "Colnod Binary Protocol",
    "4420": "NVM Express over Fabrics storage access",
    "4421": "Multi-Platform Remote Management for Cloud Infrastructure",
    "4422": "TSEP Installation Service Protocol",
    "4423": "thingkit secure mesh",
    "4425": "NetROCKEY6 SMART Plus Service",
    "4426": "SMARTS Beacon Port",
    "4427": "Drizzle database server",
    "4428": "OMV-Investigation Server-Client",
    "4429": "OMV Investigation Agent-Server",
    "4430": "REAL SQL Server",
    "4431": "adWISE Pipe",
    "4432": "L-ACOUSTICS management",
    "4433": "Versile Object Protocol",
    "4441": "Reserved",
    "4442": "Saris",
    "4443": "Pharos",
    "4444": "KRB524",
    "4445": "UPNOTIFYP",
    "4446": "N1-FWP",
    "4447": "N1-RMGMT",
    "4448": "ASC Licence Manager",
    "4449": "PrivateWire",
    "4450": "Common ASCII Messaging Protocol",
    "4451": "CTI System Msg",
    "4452": "CTI Program Load",
    "4453": "NSS Alert Manager",
    "4454": "NSS Agent Manager",
    "4455": "PR Chat User",
    "4456": "PR Chat Server",
    "4457": "PR Register",
    "4458": "Matrix Configuration Protocol",
    "4460": "Network Time Security Key Establishment",
    "4484": "hpssmgmt service",
    "4485": "Assyst Data Repository Service",
    "4486": "Integrated Client Message Service",
    "4487": "Protocol for Remote Execution over TCP",
    "4488": "Apple Wide Area Connectivity Service ICE Bootstrap",
    "4500": "IPsec NAT-Traversal",
    "4534": "Reserved",
    "4535": "Event Heap Server",
    "4536": "Event Heap Server SSL",
    "4537": "WSS Security Service",
    "4538": "Software Data Exchange Gateway",
    "4545": "WorldScores",
    "4546": "SF License Manager (Sentinel)",
    "4547": "Lanner License Manager",
    "4548": "Synchromesh",
    "4549": "Aegate PMR Service",
    "4550": "Perman I Interbase Server",
    "4551": "MIH Services",
    "4552": "Men and Mice Monitoring",
    "4553": "ICS host services",
    "4554": "MS FRS Replication",
    "4555": "RSIP Port",
    "4556": "DTN Bundle TCP CL Protocol",
    "4557": "Reserved",
    "4558": "Reserved",
    "4559": "HylaFAX",
    "4563": "Amahi Anywhere",
    "4566": "Kids Watch Time Control Service",
    "4567": "TRAM",
    "4568": "BMC Reporting",
    "4569": "Inter-Asterisk eXchange",
    "4570": "Service to distribute and update within a site deployment information for Oracle Communications Suite",
    "4573": "A port for communication between a server and client for a custom backup system",
    "4590": "RID over HTTP/TLS",
    "4591": "HRPD L3T (AT-AN)",
    "4592": "Reserved",
    "4593": "IPT (ANRI-ANRI)",
    "4594": "IAS-Session (ANRI-ANRI)",
    "4595": "IAS-Paging (ANRI-ANRI)",
    "4596": "IAS-Neighbor (ANRI-ANRI)",
    "4597": "A21 (AN-1xBS)",
    "4598": "A16 (AN-AN)",
    "4599": "A17 (AN-AN)",
    "4600": "Piranha1",
    "4601": "Piranha2",
    "4602": "EAX MTS Server",
    "4603": "Men &amp; Mice Upgrade Agent",
    "4604": "Identity Registration Protocol",
    "4605": "Direct End to End Secure Chat Protocol",
    "4606": "Secure ID to IP registration and lookup",
    "4621": "Reserved",
    "4646": "Distributed Denial-of-Service Open Threat Signaling (DOTS) ",
    "4658": "PlayStation2 App Port",
    "4659": "PlayStation2 Lobby Port",
    "4660": "smaclmgr",
    "4661": "Kar2ouche Peer location service",
    "4662": "OrbitNet Message Service",
    "4663": "Note It! Message Service",
    "4664": "Rimage Messaging Server",
    "4665": "Container Client Message Service",
    "4666": "E-Port Message Service",
    "4667": "MMA Comm Services",
    "4668": "MMA EDS Service",
    "4669": "E-Port Data Service",
    "4670": "Light packets transfer protocol",
    "4671": "Bull RSF action server",
    "4672": "remote file access server",
    "4673": "CXWS Operations",
    "4674": "AppIQ Agent Management",
    "4675": "BIAP Device Status",
    "4676": "BIAP Generic Alert",
    "4677": "Business Continuity Servi",
    "4678": "boundary traversal",
    "4679": "MGE UPS Supervision",
    "4680": "MGE UPS Management",
    "4681": "Parliant Telephony System",
    "4682": "finisar",
    "4683": "Spike Clipboard Service",
    "4684": "RFID Reader Protocol 1.0",
    "4685": "Autopac Protocol",
    "4686": "Manina Service Protocol",
    "4687": "Network Scanner Tool FTP",
    "4688": "Mobile P2P Service",
    "4689": "Altova DatabaseCentral",
    "4690": "Prelude IDS message proto",
    "4691": "monotone Netsync Protocol",
    "4692": "Conspiracy messaging",
    "4700": "NetXMS Agent",
    "4701": "NetXMS Management",
    "4702": "NetXMS Server Synchronization",
    "4703": "Network Performance Quality Evaluation System Test Service",
    "4704": "Assuria Insider",
    "4711": "Trinity Trust Network Node Communication",
    "4725": "TruckStar Service",
    "4726": "Reserved",
    "4727": "F-Link Client Information Service",
    "4728": "CA Port Multiplexer",
    "4729": "Reserved",
    "4730": "Gearman Job Queue System",
    "4731": "Remote Capture Protocol",
    "4732": "Reserved",
    "4733": "RES Orchestration Catalog Services",
    "4737": "IPDR/SP",
    "4738": "SoleraTec Locator",
    "4739": "IP Flow Info Export",
    "4740": "ipfix protocol over TLS",
    "4741": "Luminizer Manager",
    "4742": "SICCT",
    "4743": "openhpi HPI service",
    "4744": "Internet File Synchronization Protocol",
    "4745": "Funambol Mobile Push",
    "4746": "Reserved",
    "4747": "Reserved",
    "4749": "Profile for Mac",
    "4750": "Simple Service Auto Discovery",
    "4751": "Simple Policy Control Protocol",
    "4752": "Simple Network Audio Protocol",
    "4753": "Simple Invocation of Methods Over Network (SIMON)",
    "4754": "Reserved",
    "4755": "Reserved",
    "4756": "Reticle Decision Center",
    "4774": "Converge RPC",
    "4784": "BFD Multihop Control",
    "4785": "Reserved",
    "4786": "Smart Install Service",
    "4787": "Service Insertion Architecture (SIA) Control-Plane",
    "4788": "eXtensible Messaging Client Protocol",
    "4789": "Reserved",
    "4790": "Reserved",
    "4791": "Reserved",
    "4792": "IP Routable Unified Bus",
    "4800": "Icona Instant Messenging System",
    "4801": "Icona Web Embedded Chat",
    "4802": "Icona License System Server",
    "4803": "Notateit Messaging",
    "4804": "Reserved",
    "4827": "HTCP",
    "4837": "Varadero-0",
    "4838": "Varadero-1",
    "4839": "Varadero-2",
    "4840": "OPC UA Connection Protocol",
    "4841": "QUOSA Virtual Library Service",
    "4842": "nCode ICE-flow Library AppServer",
    "4843": "OPC UA TCP Protocol over TLS/SSL",
    "4844": "nCode ICE-flow Library LogServer",
    "4845": "WordCruncher Remote Library Service",
    "4846": "Contamac ICM Service",
    "4846": "Contamac ICM Service",
    "4847": "Web Fresh Communication",
    "4848": "App Server - Admin HTTP",
    "4849": "App Server - Admin HTTPS",
    "4850": "Sun App Server - NA",
    "4851": "Apache Derby Replication",
    "4867": "Unify Debugger",
    "4868": "Photon Relay",
    "4869": "Photon Relay Debug",
    "4870": "Citcom Tracking Service",
    "4871": "Wired",
    "4876": "Tritium CAN Bus Bridge Service",
    "4877": "Lighting Management Control System",
    "4878": "Reserved",
    "4879": "WSDL Event Receiver",
    "4880": "IVI High-Speed LAN Instrument Protocol",
    "4881": "Reserved",
    "4882": "Reserved",
    "4883": "Meier-Phelps License Server",
    "4884": "HiveStor Distributed File System",
    "4885": "ABBS",
    "4888": "xcap code analysis portal public user access",
    "4889": "xcap code analysis portal cluster control and administration",
    "4894": "LysKOM Protocol A",
    "4899": "RAdmin Port",
    "4900": "HFSQL Client/Server Database Engine",
    "4901": "FileLocator Remote Search Agent",
    "4901": "FileLocator Remote Search Agent",
    "4902": "magicCONROL RF and Data Interface",
    "4912": "Technicolor LUT Access Protocol",
    "4913": "LUTher Control Protocol",
    "4914": "Bones Remote Control",
    "4915": "Fibics Remote Control Service",
    "4936": "Reserved",
    "4937": "Reserved",
    "4940": "Equitrac Office",
    "4941": "Equitrac Office",
    "4942": "Equitrac Office",
    "4949": "Munin Graphing Framework",
    "4950": "Sybase Server Monitor",
    "4951": "PWG WIMS",
    "4952": "SAG Directory Server",
    "4953": "Synchronization Arbiter",
    "4969": "CCSS QMessageMonitor",
    "4970": "CCSS QSystemMonitor",
    "4971": "BackUp and Restore Program",
    "4980": "Reserved",
    "4984": "WebYast",
    "4985": "GER HC Standard",
    "4986": "Model Railway Interface Program",
    "4987": "SMAR Ethernet Port 1",
    "4988": "SMAR Ethernet Port 2",
    "4989": "Parallel for GAUSS (tm)",
    "4990": "BusySync Calendar Synch. Protocol",
    "4991": "VITA Radio Transport",
    "4999": "HFSQL Client/Server Database Engine Manager",
    "5000": "",
    "5001": "",
    "5002": "radio free ethernet",
    "5003": "FileMaker, Inc. - Proprietary transport",
    "5004": "RTP media data",
    "5005": "RTP control protocol",
    "5006": "wsm server",
    "5007": "wsm server ssl",
    "5008": "Synapsis EDGE",
    "5009": "Microsoft Windows Filesystem",
    "5010": "TelepathStart",
    "5011": "TelepathAttack",
    "5012": "NetOnTap Service",
    "5013": "FileMaker, Inc. - Proprietary transport",
    "5014": "Reserved",
    "5015": "FileMaker, Inc. - Web publishing",
    "5020": "zenginkyo-1",
    "5021": "zenginkyo-2",
    "5022": "mice server",
    "5023": "Htuil Server for PLD2",
    "5024": "SCPI-TELNET",
    "5025": "SCPI-RAW",
    "5026": "Storix I/O daemon (data)",
    "5027": "Storix I/O daemon (stat)",
    "5028": "Quiqum Virtual Relais",
    "5029": "Infobright Database Server",
    "5030": "Reserved",
    "5031": "Reserved",
    "5032": "SignaCert Enterprise Trust Server Agent",
    "5033": "Janstor Secure Data",
    "5034": "Janstor Status",
    "5042": "asnaacceler8db",
    "5043": "ShopWorX Administration",
    "5044": "LXI Event Service",
    "5045": "Open Settlement Protocol",
    "5046": "Reserved",
    "5047": "Reserved",
    "5048": "Texai Message Service",
    "5049": "iVocalize Web Conference",
    "5050": "multimedia conference control tool",
    "5051": "ITA Agent",
    "5052": "ITA Manager",
    "5053": "RLM License Server",
    "5054": "RLM administrative interface",
    "5055": "UNOT",
    "5056": "Intecom Pointspan 1",
    "5057": "Intecom Pointspan 2",
    "5058": "Reserved",
    "5059": "SIP Directory Services",
    "5060": "SIP",
    "5061": "SIP-TLS",
    "5062": "Localisation access",
    "5063": "centrify secure RPC",
    "5064": "Channel Access 1",
    "5065": "Channel Access 2",
    "5066": "STANAG-5066-SUBNET-INTF",
    "5067": "Authentx Service",
    "5068": "Bitforest Data Service",
    "5069": "I/Net 2000-NPR",
    "5070": "VersaTrans Server Agent Service",
    "5071": "PowerSchool",
    "5072": "Anything In Anything",
    "5073": "Advantage Group Port Mgr",
    "5074": "ALES Query",
    "5075": "Experimental Physics and Industrial Control System",
    "5078": "Reserved",
    "5079": "Reserved",
    "5080": "OnScreen Data Collection Service",
    "5081": "SDL - Ent Trans Server",
    "5082": "Qpur Communication Protocol",
    "5083": "Qpur File Protocol",
    "5084": "EPCglobal Low-Level Reader Protocol",
    "5085": "EPCglobal Encrypted LLRP",
    "5086": "Aprigo Collection Service",
    "5087": "BIOTIC - Binary Internet of Things Interoperable Communication",
    "5092": "Reserved",
    "5093": "Sentinel LM",
    "5094": "HART-IP",
    "5099": "SentLM Srv2Srv",
    "5100": "Socalia service mux",
    "5101": "Talarian_TCP",
    "5102": "Oracle OMS non-secure",
    "5103": "Actifio C2C",
    "5104": "Reserved",
    "5105": "Reserved",
    "5106": "Actifio UDS Agent",
    "5107": "Disk to Disk replication between Actifio Clusters",
    "5111": "TAEP AS service",
    "5112": "PeerMe Msg Cmd Service",
    "5114": "Enterprise Vault Services",
    "5115": "Symantec Autobuild Service",
    "5116": "Reserved",
    "5117": "GradeCam Image Processing",
    "5120": "Barracuda Backup Protocol",
    "5133": "Policy Commander",
    "5134": "PP ActivationServer",
    "5135": "ERP-Scale",
    "5136": "Reserved",
    "5137": "MyCTS server port",
    "5145": "RMONITOR SECURE",
    "5145": "RMONITOR SECURE",
    "5146": "Social Alarm Service",
    "5150": "Ascend Tunnel Management Protocol",
    "5151": "ESRI SDE Instance",
    "5151": "ESRI SDE Instance",
    "5152": "ESRI SDE Instance Discovery",
    "5153": "Reserved",
    "5154": "BZFlag game server",
    "5155": "Oracle asControl Agent",
    "5156": "Russian Online Game",
    "5157": "Mediat Remote Object Exchange",
    "5161": "SNMP over SSH Transport Model",
    "5162": "SNMP Notification over SSH Transport Model",
    "5163": "Shadow Backup",
    "5164": "Virtual Protocol Adapter",
    "5165": "ife_1corp",
    "5165": "ife_1corp",
    "5166": "WinPCS Service Connection",
    "5167": "SCTE104 Connection",
    "5168": "SCTE30 Connection",
    "5172": "PC over IP Endpoint Management",
    "5190": "America-Online",
    "5191": "AmericaOnline1",
    "5192": "AmericaOnline2",
    "5193": "AmericaOnline3",
    "5194": "CipherPoint Config Service",
    "5195": "The protocol is used by a license server and client programs to control use of program licenses that float to networked machines",
    "5196": 'The protocol is used by two programs that exchange "table" data used in the AMPL modeling language',
    "5197": "Tunstall Lone worker device interface",
    "5200": "TARGUS GetData",
    "5201": "TARGUS GetData 1",
    "5202": "TARGUS GetData 2",
    "5203": "TARGUS GetData 3",
    "5209": "Nomad Device Video Transfer",
    "5215": "NOTEZA Data Safety Service",
    "5221": "3eTI Extensible Management Protocol for OAMP",
    "5222": "XMPP Client Connection",
    "5223": "HP Virtual Machine Group Management",
    "5224": "HP Virtual Machine Console Operations",
    "5225": "HP Server",
    "5226": "HP Status",
    "5227": "HP System Performance Metric Service",
    "5228": "HP Virtual Room Service",
    "5229": "Netflow/IPFIX/sFlow Collector and Forwarder Management",
    "5230": "JaxMP RealFlow application and protocol data",
    "5231": "Remote Control of Scan Software for Cruse Scanners",
    "5232": "Cruse Scanning System Service",
    "5233": "Etinnae Network File Service",
    "5234": "EEnet communications",
    "5235": "Galaxy Network Service",
    "5236": "",
    "5237": "m-net discovery",
    "5242": "ATTUne API",
    "5243": "xyClient Status API and rendevous point",
    "5245": "DownTools Control Protocol",
    "5246": "Reserved",
    "5247": "Reserved",
    "5248": "CA Access Control Web Service",
    "5249": "CA AC Lang Service",
    "5250": "soaGateway",
    "5251": "CA eTrust VM Service",
    "5252": "Movaz SSC",
    "5253": "Kohler Power Device Protocol",
    "5254": "LogCabin storage service",
    "5264": "3Com Network Jack Port 1",
    "5265": "3Com Network Jack Port 2",
    "5269": "XMPP Server Connection",
    "5270": "Cartographer XMP",
    "5271": "StageSoft CueLink messaging",
    "5272": "PK",
    "5280": "Bidirectional-streams Over Synchronous HTTP (BOSH)",
    "5281": "Undo License Manager",
    "5282": "Marimba Transmitter Port",
    "5298": "XMPP Link-Local Messaging",
    "5299": "NLG Data Service",
    "5300": "HA cluster heartbeat",
    "5301": "HA cluster general services",
    "5302": "HA cluster configuration",
    "5303": "HA cluster probing",
    "5304": "HA Cluster Commands",
    "5305": "HA Cluster Test",
    "5306": "Sun MC Group",
    "5307": "SCO AIP",
    "5308": "CFengine",
    "5309": "J Printer",
    "5310": "Outlaws",
    "5312": "Permabit Client-Server",
    "5313": "Real-time &amp; Reliable Data",
    "5314": "opalis-rbt-ipc",
    "5315": "HA Cluster UDP Polling",
    "5316": "HPBladeSystem Monitor Service",
    "5317": "HP Device Monitor Service",
    "5318": "PKIX Certificate Management using CMS (CMC)",
    "5320": "Webservices-based Zn interface of BSF",
    "5321": "Webservices-based Zn interface of BSF over SSL",
    "5343": "Sculptor Database Server",
    "5344": "xkoto DRCP",
    "5349": "Session Traversal Utilities for NAT (STUN) port",
    "5350": "Reserved",
    "5351": "Reserved",
    "5352": "DNS Long-Lived Queries",
    "5353": "Multicast DNS",
    "5354": "Multicast DNS Responder IPC",
    "5355": "LLMNR",
    "5356": "Microsoft Small Business",
    "5357": "Web Services for Devices",
    "5358": "WS for Devices Secured",
    "5359": "Microsoft Alerter",
    "5360": "Protocol for Windows SideShow",
    "5361": "Secure Protocol for Windows SideShow",
    "5362": "Microsoft Windows Server WSD2 Service",
    "5363": "Windows Network Projection",
    "5364": "Reserved",
    "5397": "StressTester(tm) Injector",
    "5398": "Elektron Administration",
    "5399": "SecurityChase",
    "5400": "Excerpt Search",
    "5401": "Excerpt Search Secure",
    "5402": "OmniCast MFTP",
    "5403": "HPOMS-CI-LSTN",
    "5404": "HPOMS-DPS-LSTN",
    "5405": "NetSupport",
    "5406": "Systemics Sox",
    "5407": "Foresyte-Clear",
    "5408": "Foresyte-Sec",
    "5409": "Salient Data Server",
    "5410": "Salient User Manager",
    "5411": "ActNet",
    "5412": "Continuus",
    "5413": "WWIOTALK",
    "5414": "StatusD",
    "5415": "NS Server",
    "5416": "SNS Gateway",
    "5417": "SNS Agent",
    "5418": "MCNTP",
    "5419": "DJ-ICE",
    "5420": "Cylink-C",
    "5421": "Net Support 2",
    "5422": "Salient MUX",
    "5423": "VIRTUALUSER",
    "5424": "Beyond Remote",
    "5425": "Beyond Remote Command Channel",
    "5426": "DEVBASIC",
    "5427": "SCO-PEER-TTA",
    "5428": "TELACONSOLE",
    "5429": "Billing and Accounting System Exchange",
    "5430": "RADEC CORP",
    "5431": "PARK AGENT",
    "5432": "PostgreSQL Database",
    "5433": "Pyrrho DBMS",
    "5434": "SGI Array Services Daemon",
    "5435": "SCEANICS situation and action notification",
    "5436": "Reserved",
    "5437": "Reserved",
    "5443": "Pearson HTTPS",
    "5445": "Server Message Block over Remote Direct Memory Access",
    "5450": "TiePie engineering data acquisition",
    "5453": "SureBox",
    "5454": "APC 5454",
    "5455": "APC 5455",
    "5456": "APC 5456",
    "5461": "SILKMETER",
    "5462": "TTL Publisher",
    "5463": "TTL Price Proxy",
    "5464": "Quail Networks Object Broker",
    "5465": "NETOPS-BROKER",
    "5470": "The Apsolab company's data collection protocol (native api)",
    "5471": "The Apsolab company's secure data collection protocol (native api)",
    "5472": "The Apsolab company's dynamic tag protocol",
    "5473": "The Apsolab company's secure dynamic tag protocol",
    "5474": "Reserved",
    "5475": "The Apsolab company's data retrieval protocol",
    "5500": "fcp-addr-srvr1",
    "5501": "fcp-addr-srvr2",
    "5502": "fcp-srvr-inst1",
    "5503": "fcp-srvr-inst2",
    "5504": "fcp-cics-gw1",
    "5505": "Checkout Database",
    "5506": "Amcom Mobile Connect",
    "5507": "PowerSysLab Electrical Management",
    "5540": "Matter Operational Discovery and Communi",
    "5543": "QF-Test License Server",
    "5550": "Model Railway control using the CBUS message protocol",
    "5553": "SGI Eventmond Port",
    "5554": "SGI ESP HTTP",
    "5555": "Personal Agent",
    "5556": "Freeciv gameplay",
    "5557": "Sandlab FARENET",
    "5565": "Data Protector BURA",
    "5566": "Westec Connect",
    "5567": "DOF Protocol Stack Multicast/Secure Transport",
    "5568": "Session Data Transport Multicast",
    "5569": "PLASA E1.33, Remote Device Management (RDM) controller status notifications",
    "5573": "SAS Domain Management Messaging Protocol",
    "5574": "SAS IO Forwarding",
    "5575": "Oracle Access Protocol",
    "5579": "FleetDisplay Tracking Service",
    "5580": "T-Mobile SMS Protocol Message 0",
    "5581": "T-Mobile SMS Protocol Message 1",
    "5582": "T-Mobile SMS Protocol Message 3",
    "5583": "T-Mobile SMS Protocol Message 2",
    "5584": "BeInSync-Web",
    "5585": "BeInSync-sync",
    "5586": "Planning to send mobile terminated SMS to the specific port so that the SMS is not visible to the client",
    "5597": "inin secure messaging",
    "5598": "MCT Market Data Feed",
    "5599": "Enterprise Security Remote Install",
    "5600": "Enterprise Security Manager",
    "5601": "Enterprise Security Agent",
    "5602": "A1-MSC",
    "5603": "A1-BS",
    "5604": "A3-SDUNode",
    "5605": "A4-SDUNode",
    "5618": "Fiscal Registering Protocol",
    "5627": "Node Initiated Network Association Forma",
    "5628": "HTrust API",
    "5629": "Symantec Storage Foundation for Database",
    "5630": "PreciseCommunication",
    "5631": "pcANYWHEREdata",
    "5632": "pcANYWHEREstat",
    "5633": "BE Operations Request Listener",
    "5634": "SF Message Service",
    "5635": "SFM Authentication Subsystem",
    "5636": "SFMdb - SFM DB server",
    "5637": "Symantec CSSC",
    "5638": "Symantec Fingerprint Lookup and Container Reference Service",
    "5639": "Symantec Integrity Checking Service",
    "5646": "Ventureforth Mobile",
    "5666": "Nagios Remote Plugin Executor",
    "5670": "ZeroMQ file publish-subscribe protocol",
    "5671": "amqp protocol over TLS/SSL",
    "5672": "AMQP",
    "5673": "JACL Message Server",
    "5674": "HyperSCSI Port",
    "5675": "V5UA application port",
    "5676": "RA Administration",
    "5677": "Quest Central DB2 Launchr",
    "5678": "Remote Replication Agent Connection",
    "5679": "Direct Cable Connect Manager",
    "5680": "Auriga Router Service",
    "5681": "Net-coneX Control Protocol",
    "5682": "Reserved",
    "5683": "Constrained Application Protocol (CoAP)",
    "5684": "Constrained Application Protocol (CoAP)",
    "5687": "Reserved",
    "5688": "GGZ Gaming Zone",
    "5689": "QM video network management protocol",
    "5693": "Robert Bosch Data Transfer",
    "5696": "Key Management Interoperability Protocol",
    "5700": "Dell SupportAssist data center management",
    "5705": "StorageOS REST API",
    "5713": "proshare conf audio",
    "5714": "proshare conf video",
    "5715": "proshare conf data",
    "5716": "proshare conf request",
    "5717": "proshare conf notify",
    "5718": "DPM Communication Server",
    "5719": "DPM Agent Coordinator",
    "5720": "MS-Licensing",
    "5721": "Desktop Passthru Service",
    "5722": "Microsoft DFS Replication Service",
    "5723": "Operations Manager - Health Service",
    "5724": "Operations Manager - SDK Service",
    "5725": "Microsoft Identity Lifecycle Manager",
    "5726": "Microsoft Lifecycle Manager Secure Token Service",
    "5727": "ASG Event Notification Framework",
    "5728": "Dist. I/O Comm. Service Data and Control",
    "5729": "Openmail User Agent Layer",
    "5730": "Steltor's calendar access",
    "5741": "IDA Discover Port 1",
    "5742": "IDA Discover Port 2",
    "5743": "Watchdoc NetPOD Protocol",
    "5744": "Watchdoc Server",
    "5745": "fcopy-server",
    "5746": "fcopys-server",
    "5747": "Wildbits Tunatic",
    "5748": "Wildbits Tunalyzer",
    "5750": "Bladelogic Agent Service",
    "5755": "OpenMail Desk Gateway server",
    "5757": "OpenMail X.500 Directory Server",
    "5766": "OpenMail NewMail Server",
    "5767": "OpenMail Suer Agent Layer (Secure)",
    "5768": "OpenMail CMTS Server",
    "5769": "x509solutions Internal CA",
    "5770": "x509solutions Secure Data",
    "5771": "NetAgent",
    "5777": "Control commands and responses",
    "5780": "Visual Tag System RPC",
    "5781": "3PAR Event Reporting Service",
    "5782": "3PAR Management Service",
    "5783": "3PAR Management Service with SSL",
    "5784": "Reserved",
    "5785": "3PAR Inform Remote Copy",
    "5786": "Reserved",
    "5787": "Reserved",
    "5793": "XtreamX Supervised Peer message",
    "5794": "Reserved",
    "5798": "Proprietary Website deployment service",
    "5813": "ICMPD",
    "5814": "Support Automation",
    "5820": "AutoPass licensing",
    "5841": "Z-firm ShipRush interface for web access and bidirectional data",
    "5842": "Reversion Backup/Restore",
    "5859": "WHEREHOO",
    "5863": "PlanetPress Suite Messeng",
    "5868": "Diameter over TLS/TCP",
    "5883": "Javascript Unit Test Environment",
    "5900": "Remote Framebuffer",
    "5903": "Flight &amp; Flow Info for Collaborative Env",
    "5904": "Air-Ground SWIM",
    "5905": "Adv Surface Mvmnt and Guidance Cont Sys",
    "5906": "Remotely Piloted Vehicle C&amp;C",
    "5907": "Distress and Safety Data App",
    "5908": "IPS Management Application",
    "5909": "Air-ground media advisory",
    "5910": "Air Traffic Services applications using ATN",
    "5911": "Air Traffic Services applications using ACARS",
    "5912": "Aeronautical Information Service/Meteorological applications using ACARS",
    "5913": "Airline operational communications applications using ACARS",
    "5963": "Indy Application Server",
    "5968": "mppolicy-v5",
    "5969": "mppolicy-mgr",
    "5984": "CouchDB",
    "5985": "WBEM WS-Management HTTP",
    "5986": "WBEM WS-Management HTTP over TLS/SSL",
    "5987": "WBEM RMI",
    "5988": "WBEM CIM-XML (HTTP)",
    "5989": "WBEM CIM-XML (HTTPS)",
    "5990": "WBEM Export HTTPS",
    "5991": "NUXSL",
    "5992": "Consul InSight Security",
    "5993": "DMTF WBEM CIM REST",
    "5994": "RMS Agent Listening Service",
    "5999": "CVSup",
    "6000": "X Window System",
    "6064": "NDL-AHP-SVC",
    "6065": "WinPharaoh",
    "6066": "EWCTSP",
    "6068": "GSMP/ANCP",
    "6069": "TRIP",
    "6070": "Messageasap",
    "6071": "SSDTP",
    "6072": "DIAGNOSE-PROC",
    "6073": "DirectPlay8",
    "6074": "Microsoft Max",
    "6075": "Microsoft DPM Access Control Manager",
    "6076": "Microsoft DPM WCF Certificates",
    "6077": "iConstruct Server",
    "6080": "Reserved",
    "6081": "Reserved",
    "6082": "Reserved",
    "6083": "Reserved",
    "6084": "Peer to Peer Infrastructure Configuration",
    "6085": "konspire2b p2p network",
    "6086": "PDTP P2P",
    "6087": "Local Download Sharing Service",
    "6088": "SuperDog License Manager",
    "6099": "RAXA Management",
    "6100": "SynchroNet-db",
    "6101": "SynchroNet-rtc",
    "6102": "SynchroNet-upd",
    "6103": "RETS",
    "6104": "DBDB",
    "6105": "Prima Server",
    "6106": "MPS Server",
    "6107": "ETC Control",
    "6108": "Sercomm-SCAdmin",
    "6109": "GLOBECAST-ID",
    "6110": "HP SoftBench CM",
    "6111": "HP SoftBench Sub-Process Control",
    "6112": "Desk-Top Sub-Process Control Daemon",
    "6113": "Daylite Server",
    "6114": "WRspice IPC Service",
    "6115": "Xic IPC Service",
    "6116": "XicTools License Manager Service",
    "6117": "Daylite Touch Sync",
    "6118": "Reserved",
    "6121": "SPDY for a faster web",
    "6122": "Backup Express Web Server",
    "6123": "Backup Express",
    "6124": "Phlexible Network Backup Service",
    "6130": "The DameWare Mobile Gateway Service",
    "6133": "New Boundary Tech WOL",
    "6140": "Pulsonix Network License Service",
    "6141": "Meta Corporation License Manager",
    "6142": "Aspen Technology License Manager",
    "6143": "Watershed License Manager",
    "6144": "StatSci License Manager - 1",
    "6145": "StatSci License Manager - 2",
    "6146": "Lone Wolf Systems License Manager",
    "6147": "Montage License Manager",
    "6148": "Ricardo North America License Manager",
    "6149": "tal-pod",
    "6159": "EFB Application Control Interface",
    "6160": "Emerson Extensible Control and Management Protocol",
    "6161": "PATROL Internet Srv Mgr",
    "6162": "PATROL Collector",
    "6163": "Precision Scribe Cnx Port",
    "6200": "LM-X License Manager by X-Formation",
    "6201": "Reserved",
    "6209": "QMTP over TLS",
    "6222": "Radmind Access Protocol",
    "6241": "JEOL Network Services Data Transport Protocol 1",
    "6242": "JEOL Network Services Data Transport Protocol 2",
    "6243": "JEOL Network Services Data Transport Protocol 3",
    "6244": "JEOL Network Services Data Transport Protocol 4",
    "6251": "TL1 Raw Over SSL/TLS",
    "6252": "TL1 over SSH",
    "6253": "CRIP",
    "6267": "GridLAB-D User Interface",
    "6268": "Grid Authentication",
    "6269": "Grid Authentication Alt",
    "6300": "BMC GRX",
    "6301": "BMC CONTROL-D LDAP SERVER",
    "6301": "BMC CONTROL-D LDAP SERVER",
    "6306": "Unified Fabric Management Protocol",
    "6315": "Sensor Control Unit Protocol",
    "6316": "Ethernet Sensor Communications Protocol",
    "6317": "Navtech Radar Sensor Data Command",
    "6320": "Double-Take Replication Service",
    "6321": "Empress Software Connectivity Server 1",
    "6322": "Empress Software Connectivity Server 2",
    "6324": "HR Device Network Configuration Service",
    "6325": "Double-Take Management Service",
    "6326": "Double-Take Virtual Recovery Assistant",
    "6343": "sFlow traffic monitoring",
    "6344": "Argus-Spectr security and fire-prevention systems service",
    "6346": "gnutella-svc",
    "6347": "gnutella-rtr",
    "6350": "App Discovery and Access Protocol",
    "6355": "PMCS applications",
    "6360": "MetaEdit+ Multi-User",
    "6363": "Reserved",
    "6370": "MetaEdit+ Server Administration",
    "6379": "An advanced key-value cache and store",
    "6382": "Metatude Dialogue Server",
    "6389": "clariion-evr01",
    "6390": "MetaEdit+ WebService API",
    "6417": "Faxcom Message Service",
    "6418": "SYserver remote commands",
    "6419": "Simple VDR Protocol",
    "6420": "NIM_VDRShell",
    "6421": "NIM_WAN",
    "6432": "PgBouncer",
    "6440": "heliosd daemon",
    "6442": "Transitory Application Request Protocol",
    "6443": "Service Registry Default HTTPS Domain",
    "6444": "Grid Engine Qmaster Service",
    "6444": "Grid Engine Qmaster Service",
    "6445": "Grid Engine Execution Service",
    "6445": "Grid Engine Execution Service",
    "6446": "MySQL Proxy",
    "6455": "SKIP Certificate Receive",
    "6456": "SKIP Certificate Send",
    "6464": "Port assignment for medical device communication in ",
    "6471": "LVision License Manager",
    "6480": "Service Registry Default HTTP Domain",
    "6481": "Service Tags",
    "6482": "Logical Domains Management Interface",
    "6483": "SunVTS RMI",
    "6484": "Service Registry Default JMS Domain",
    "6485": "Service Registry Default IIOP Domain",
    "6486": "Service Registry Default IIOPS Domain",
    "6487": "Service Registry Default IIOPAuth Domain",
    "6488": "Service Registry Default JMX Domain",
    "6489": "Service Registry Default Admin Domain",
    "6500": "BoKS Master",
    "6501": "BoKS Servc",
    "6501": "BoKS Servc",
    "6502": "BoKS Servm",
    "6502": "BoKS Servm",
    "6503": "BoKS Clntd",
    "6503": "BoKS Clntd",
    "6505": "BoKS Admin Private Port",
    "6505": "BoKS Admin Private Port",
    "6506": "BoKS Admin Public Port",
    "6506": "BoKS Admin Public Port",
    "6507": "BoKS Dir Server, Private Port",
    "6507": "BoKS Dir Server, Private Port",
    "6508": "BoKS Dir Server, Public Port",
    "6508": "BoKS Dir Server, Public Port",
    "6509": "MGCS-MFP Port",
    "6510": "MCER Port",
    "6511": "Reserved",
    "6513": "NETCONF over TLS",
    "6514": "Syslog over TLS",
    "6515": "Elipse RPC Protocol",
    "6543": "lds_distrib",
    "6544": "LDS Dump Service",
    "6547": "APC 6547",
    "6548": "APC 6548",
    "6549": "APC 6549",
    "6550": "fg-sysupdate",
    "6551": "Software Update Manager",
    "6556": "Checkmk Monitoring Agent",
    "6558": "",
    "6566": "SANE Control Port",
    "6568": "CanIt Storage Manager",
    "6568": "CanIt Storage Manager",
    "6579": "Affiliate",
    "6580": "Parsec Masterserver",
    "6581": "Parsec Peer-to-Peer",
    "6582": "Parsec Gameserver",
    "6583": "JOA Jewel Suite",
    "6600": "Microsoft Hyper-V Live Migration",
    "6601": "Microsoft Threat Management Gateway SSTP",
    "6602": "Windows WSS Communication Framework",
    "6619": "ODETTE-FTP over TLS/SSL",
    "6620": "Kerberos V5 FTP Data",
    "6621": "Kerberos V5 FTP Control",
    "6622": "Multicast FTP",
    "6623": "Kerberos V5 Telnet",
    "6624": "DataScaler database",
    "6625": "DataScaler control",
    "6626": "WAGO Service and Update",
    "6627": "Allied Electronics NeXGen",
    "6628": "AFE Stock Channel M/C",
    "6629": "Secondary, (non ANDI) multi-protocol multi-function interface to",
    "6632": "eGenix mxODBC Connect",
    "6633": "Reserved",
    "6634": "Reserved",
    "6635": "Reserved",
    "6636": "Reserved",
    "6640": "Open vSwitch Database protocol",
    "6653": "OpenFlow",
    "6655": "PC SOFT - Software factory UI/manager",
    "6656": "Emergency Message Control Service",
    "6657": "Reserved",
    "6665": "IRCU",
    "6670": "Vocaltec Global Online Directory",
    "6671": "P4P Portal Service",
    "6672": "vision_server",
    "6672": "vision_server",
    "6673": "vision_elmd",
    "6673": "vision_elmd",
    "6678": "Viscount Freedom Bridge Protocol",
    "6679": "Osorno Automation",
    "6687": "CleverView for cTrace Message Service",
    "6688": "CleverView for TCP/IP Message Service",
    "6689": "Tofino Security Appliance",
    "6690": "CLEVERDetect Message Service",
    "6696": "Reserved",
    "6697": "Internet Relay Chat via TLS/SSL",
    "6699": "Reserved",
    "6701": "KTI/ICAD Nameserver",
    "6702": "e-Design network",
    "6703": "e-Design web",
    "6704": "Reserved",
    "6705": "Reserved",
    "6706": "Reserved",
    "6714": "Internet Backplane Protocol",
    "6715": "Fibotrader Communications",
    "6716": "Princity Agent",
    "6767": "BMC PERFORM AGENT",
    "6768": "BMC PERFORM MGRD",
    "6769": "ADInstruments GxP Server",
    "6770": "PolyServe http",
    "6771": "PolyServe https",
    "6777": "netTsunami Tracker",
    "6778": "netTsunami p2p storage system",
    "6784": "Reserved",
    "6785": "DGPF Individual Exchange",
    "6786": "Sun Java Web Console JMX",
    "6787": "Sun Web Console Admin",
    "6788": "SMC-HTTP",
    "6789": "GSS-API for the Oracle Remote Administration Daemon",
    "6790": "HNMP",
    "6791": "Halcyon Network Manager",
    "6801": "ACNET Control System Protocol",
    "6817": "PenTBox Secure IM Protocol",
    "6831": "ambit-lm",
    "6841": "Netmo Default",
    "6842": "Netmo HTTP",
    "6850": "ICCRUSHMORE",
    "6868": "Acctopus Command Channel",
    "6888": "MUSE",
    "6900": "R*TIME Viewer Data Interface",
    "6901": "Novell Jetstream messaging protocol",
    "6924": "Ping with RX/TX latency/loss split",
    "6935": "EthoScan Service",
    "6936": "XenSource Management Service",
    "6946": "Biometrics Server",
    "6951": "OTLP",
    "6961": "JMACT3",
    "6962": "jmevt2",
    "6963": "swismgr1",
    "6964": "swismgr2",
    "6965": "swistrap",
    "6966": "swispol",
    "6969": "acmsoda",
    "6970": "Conductor test coordination protocol",
    "6980": "Reserved",
    "6997": "Mobility XE Protocol",
    "6998": "IATP-highPri",
    "6999": "IATP-normalPri",
    "7000": "file server itself",
    "7001": "callbacks to cache managers",
    "7002": "users &amp; groups database",
    "7003": "volume location database",
    "7004": "AFS/Kerberos authentication service",
    "7005": "volume managment server",
    "7006": "error interpretation service",
    "7007": "basic overseer process",
    "7008": "server-to-server updater",
    "7009": "remote cache manager service",
    "7010": "onlinet uninterruptable power supplies",
    "7011": "Talon Discovery Port",
    "7012": "Talon Engine",
    "7013": "Microtalon Discovery",
    "7014": "Microtalon Communications",
    "7015": "Talon Webserver",
    "7016": "SPG Controls Carrier",
    "7017": "GeneRic Autonomic Signaling Protocol",
    "7018": "FISA Service",
    "7019": "doceri drawing service control",
    "7020": "DP Serve",
    "7021": "DP Serve Admin",
    "7022": "CT Discovery Protocol",
    "7023": "Comtech T2 NMCS",
    "7024": "Vormetric service",
    "7025": "Vormetric Service II",
    "7026": "Loreji Webhosting Panel",
    "7030": "ObjectPlanet probe",
    "7031": "IPOSPLANET retailing multi devices protocol",
    "7040": "Reserved",
    "7070": "ARCP",
    "7071": "IWGADTS Aircraft Housekeeping Message",
    "7072": "iba Device Configuration Protocol",
    "7073": "MarTalk protocol",
    "7080": "EmpowerID Communication",
    "7088": "Reserved",
    "7095": "Reserved",
    "7099": "lazy-ptop",
    "7100": "X Font Service",
    "7101": "Embedded Light Control Network",
    "7107": "Reserved",
    "7117": "Encrypted chat and file transfer service",
    "7121": "Virtual Prototypes License Manager",
    "7123": "End-to-end TLS Relay Control Connection",
    "7128": "intelligent data manager",
    "7129": "Catalog Content Search",
    "7161": "CA BSM Comm",
    "7162": "CA Storage Manager",
    "7163": "CA Connection Broker",
    "7164": "File System Repository Agent",
    "7165": "Document WCF Server",
    "7166": "Aruba eDiscovery Server",
    "7167": "CA SRM Agent",
    "7168": "cncKadServer DB &amp; Inventory Services",
    "7169": "Consequor Consulting Process Integration Bridge",
    "7170": "Adaptive Name/Service Resolution",
    "7171": "Discovery and Retention Mgt Production",
    "7172": "Port used for MetalBend programmable interface",
    "7173": "zSecure Server",
    "7174": "Clutild",
    "7181": "Reserved",
    "7200": "FODMS FLIP",
    "7201": "DLIP",
    "7202": "Inter-Channel Termination Protocol (ICTP) for multi-wavelength PON",
    "7215": "Communication ports for PaperStream Server services",
    "7216": "PaperStream Capture Professional",
    "7227": "Registry A &amp; M Protocol",
    "7228": "Citrix Universal Printing Port",
    "7229": "Citrix UPP Gateway",
    "7234": "Traffic forwarding for Okta cloud infra",
    "7235": "Reserved",
    "7236": "Wi-Fi Alliance Wi-Fi Display Protocol",
    "7237": "PADS (Public Area Display System) Server",
    "7244": "FrontRow Calypso Human Interface Control Protocol",
    "7262": "Calypso Network Access Protocol",
    "7272": "WatchMe Monitoring 7272",
    "7273": "OMA Roaming Location",
    "7274": "OMA Roaming Location SEC",
    "7275": "OMA UserPlane Location",
    "7276": "OMA Internal Location Protocol",
    "7277": "OMA Internal Location Secure Protocol",
    "7278": "OMA Dynamic Content Delivery over CBS",
    "7279": "Citrix Licensing",
    "7280": "ITACTIONSERVER 1",
    "7281": "ITACTIONSERVER 2",
    "7282": "eventACTION/ussACTION (MZCA) server",
    "7283": "General Statistics Rendezvous Protocol",
    "7365": "LifeKeeper Communications",
    "7391": "mind-file system server",
    "7392": "mrss-rendezvous server",
    "7393": "nFoldMan Remote Publish",
    "7394": "File system export of backup images",
    "7395": "winqedit",
    "7397": "Hexarc Command Language",
    "7400": "RTPS Discovery",
    "7401": "RTPS Data-Distribution User-Traffic",
    "7402": "RTPS Data-Distribution Meta-Traffic",
    "7410": "Ionix Network Monitor",
    "7411": "Streaming of measurement data",
    "7420": "Reserved",
    "7421": "Matisse Port Monitor",
    "7426": "OpenView DM Postmaster Manager",
    "7427": "OpenView DM Event Agent Manager",
    "7428": "OpenView DM Log Agent Manager",
    "7429": "OpenView DM rqt communication",
    "7430": "OpenView DM xmpv7 api pipe",
    "7431": "OpenView DM ovc/xmpv3 api pipe",
    "7437": "Faximum",
    "7443": "Oracle Application Server HTTPS",
    "7471": "Stateless Transport Tunneling Protocol",
    "7473": "Rise: The Vieneo Province",
    "7474": "Neo4j Graph Database",
    "7478": "IT Asset Management",
    "7491": "telops-lmd",
    "7500": "Silhouette User",
    "7501": "HP OpenView Bus Daemon",
    "7508": "Automation Device Configuration Protocol",
    "7509": "ACPLT - process automation service",
    "7510": "HP OpenView Application Server",
    "7511": "pafec-lm",
    "7542": "Saratoga Transfer Protocol",
    "7543": "atul server",
    "7544": "FlowAnalyzer DisplayServer",
    "7545": "FlowAnalyzer UtilityServer",
    "7546": "Cisco Fabric service",
    "7547": "Broadband Forum CWMP",
    "7548": "Threat Information Distribution Protocol",
    "7549": "Network Layer Signaling Transport Layer",
    "7550": "Reserved",
    "7551": "ControlONE Console signaling",
    "7560": "Sniffer Command Protocol",
    "7563": "Control Framework",
    "7566": "VSI Omega",
    "7569": "Dell EqualLogic Host Group Management",
    "7570": "Aries Kfinder",
    "7574": "Oracle Coherence Cluster Service",
    "7588": "Sun License Manager",
    "7606": "MIPI Alliance Debug",
    "7624": "Instrument Neutral Distributed Interface",
    "7626": "SImple Middlebox COnfiguration (SIMCO) Server",
    "7627": "SOAP Service Port",
    "7628": "Primary Agent Work Notification",
    "7629": "OpenXDAS Wire Protocol",
    "7630": "HA Web Konsole",
    "7631": "TESLA System Messaging",
    "7633": "PMDF Management",
    "7648": "bonjour-cuseeme",
    "7663": "Proprietary immutable distributed data storage",
    "7672": "iMQ STOMP Server",
    "7673": "iMQ STOMP Server over SSL",
    "7674": "iMQ SSL tunnel",
    "7675": "iMQ Tunnel",
    "7676": "iMQ Broker Rendezvous",
    "7677": "Sun App Server - HTTPS",
    "7680": "Microsoft Delivery Optimization Peer-to-Peer",
    "7683": "Cleondris DMT",
    "7687": "Bolt database connection",
    "7689": "Collaber Network Service",
    "7690": "Service-Oriented Vehicle Diagnostics",
    "7697": "KLIO communications",
    "7700": "EM7 Secure Communications",
    "7701": "Reserved",
    "7707": "EM7 Dynamic Updates",
    "7708": "scientia.net",
    "7720": "MedImage Portal",
    "7724": "Novell Snap-in Deep Freeze Control",
    "7725": "Nitrogen Service",
    "7726": "FreezeX Console Service",
    "7727": "Trident Systems Data",
    "7728": "Open-Source Virtual Reality",
    "7734": "Smith Protocol over IP",
    "7738": "HP Enterprise Discovery Agent",
    "7741": "ScriptView Network",
    "7742": "Mugginsoft Script Server Service",
    "7743": "Sakura Script Transfer Protocol",
    "7744": "RAQMON PDU",
    "7747": "Put/Run/Get Protocol",
    "7775": "A File System using TLS over a wide area network",
    "7777": "cbt",
    "7778": "Interwise",
    "7779": "VSTAT",
    "7781": "accu-lmgr",
    "7784": "Reserved",
    "7786": "MINIVEND",
    "7787": "Popup Reminders Receive",
    "7789": "Office Tools Pro Receive",
    "7794": "Q3ADE Cluster Service",
    "7797": "Propel Connector port",
    "7798": "Propel Encoder port",
    "7799": "Alternate BSDP Service",
    "7800": "Apple Software Restore",
    "7801": "Secure Server Protocol - client",
    "7802": "Reserved",
    "7810": "Riverbed WAN Optimization Protocol",
    "7845": "APC 7845",
    "7846": "APC 7846",
    "7847": "A product key authentication protocol made by CSO",
    "7869": "MobileAnalyzer&amp; MobileMonitor",
    "7870": "Riverbed Steelhead Mobile Service",
    "7871": "Mobile Device Management",
    "7872": "Reserved",
    "7878": "Opswise Message Service",
    "7880": "Pearson",
    "7887": "Universal Broker",
    "7900": "Multicast Event",
    "7901": "TNOS Service Protocol",
    "7902": "TNOS shell Protocol",
    "7903": "TNOS Secure DiaguardProtocol",
    "7913": "QuickObjects secure port",
    "7932": "Tier 2 Data Resource Manager",
    "7933": "Tier 2 Business Rules Manager",
    "7962": "Encrypted, extendable, general-purpose synchronization protocol",
    "7967": "Supercell",
    "7979": "Micromuse-ncps",
    "7980": "Quest Vista",
    "7981": "Spotlight on SQL Server Desktop Collect",
    "7982": "Spotlight on SQL Server Desktop Agent",
    "7997": "PUSH Notification Service",
    "7998": "Reserved",
    "7999": "iRDMI2",
    "8000": "iRDMI",
    "8001": "VCOM Tunnel",
    "8002": "Teradata ORDBMS",
    "8003": "Mulberry Connect Reporting Service",
    "8004": "Opensource Evolv Enterprise Platform P2P Network Node Connection Protocol",
    "8005": "MXI Generation II for z/OS",
    "8006": "World Programming analytics",
    "8007": "I/O oriented cluster computing software",
    "8008": "HTTP Alternate",
    "8009": "NVMe over Fabrics Discovery Service",
    "8015": "Configuration Cloud Service",
    "8016": "Beckhoff Automation Device Specification",
    "8017": "Reserved",
    "8019": "QB DB Dynamic Port",
    "8020": "Intuit Entitlement Service and Discovery",
    "8021": "Intuit Entitlement Client",
    "8022": "oa-system",
    "8023": "ARCATrust vault API",
    "8025": "CA Audit Distribution Agent",
    "8026": "CA Audit Distribution Server",
    "8027": "peer tracker and data relay service",
    "8032": "ProEd",
    "8033": "MindPrint",
    "8034": ".vantronix Management",
    "8040": "Ampify Messaging Protocol",
    "8041": "Xcorpeon ASIC Carrier Ethernet Transport",
    "8042": "FireScope Agent",
    "8043": "FireScope Server",
    "8044": "FireScope Management Interface",
    "8051": "Rocrail Client Service",
    "8052": "Senomix Timesheets Server",
    "8053": "Senomix Timesheets Client [1 year assignment]",
    "8054": "Senomix Timesheets Server [1 year assignment]",
    "8055": "Senomix Timesheets Server [1 year assignment]",
    "8056": "Senomix Timesheets Server [1 year assignment]",
    "8057": "Senomix Timesheets Client [1 year assignment]",
    "8058": "Senomix Timesheets Client [1 year assignment]",
    "8059": "Senomix Timesheets Client [1 year assignment]",
    "8060": "Reserved",
    "8061": "Nikatron Device Protocol",
    "8066": "Toad BI Application Server",
    "8067": "Infinidat async replication",
    "8070": "Oracle Unified Communication Suite's Indexed Search Converter",
    "8074": "Gadu-Gadu",
    "8077": "Reserved",
    "8080": "HTTP Alternate (see port 80)",
    "8081": "Sun Proxy Admin Service",
    "8082": "Utilistor (Client)",
    "8083": "Utilistor (Server)",
    "8084": "Snarl Network Protocol over HTTP",
    "8086": "Distributed SCADA Networking Rendezvous Port",
    "8087": "Simplify Media SPP Protocol",
    "8088": "Radan HTTP",
    "8090": "Vehicle to station messaging",
    "8091": "Jam Link Framework",
    "8097": "SAC Port Id",
    "8100": "Xprint Server",
    "8101": "Logical Domains Migration",
    "8102": "Oracle Kernel zones migration server",
    "8111": "Reserved",
    "8115": "MTL8000 Matrix",
    "8116": "Check Point Clustering",
    "8117": "Purity replication clustering and remote management",
    "8118": "Privoxy HTTP proxy",
    "8121": "Apollo Data Port",
    "8122": "Apollo Admin Port",
    "8128": "PayCash Online Protocol",
    "8129": "PayCash Wallet-Browser",
    "8130": "INDIGO-VRMI",
    "8131": "INDIGO-VBCP",
    "8132": "dbabble",
    "8140": "The Puppet master service",
    "8148": "i-SDD file transfer",
    "8149": "Reserved",
    "8153": "QuantaStor Management Interface",
    "8160": "Patrol",
    "8161": "Patrol SNMP",
    "8162": "LPAR2RRD client server communication",
    "8181": "Intermapper network management system",
    "8182": "VMware Fault Domain Manager",
    "8183": "ProRemote",
    "8184": "Remote iTach Connection",
    "8190": "Generic control plane for RPHY",
    "8191": "Limner Pressure",
    "8192": "SpyTech Phone Service",
    "8194": "Bloomberg data API",
    "8195": "Bloomberg feed",
    "8199": "VVR DATA",
    "8200": "TRIVNET",
    "8201": "TRIVNET",
    "8202": "Reserved",
    "8204": "LM Perfworks",
    "8205": "LM Instmgr",
    "8206": "LM Dta",
    "8207": "LM SServer",
    "8208": "LM Webwatcher",
    "8211": "Reserved",
    "8230": "RexecJ Server",
    "8231": "Reserved",
    "8232": "Reserved",
    "8243": "Synapse Non Blocking HTTPS",
    "8266": "Reserved",
    "8270": "Robot Framework Remote Library Interface",
    "8276": "Microsoft Connected Cache",
    "8280": "Synapse Non Blocking HTTP",
    "8282": "Libelle EnterpriseBus",
    "8292": "Bloomberg professional",
    "8293": "Hiperscan Identification Service",
    "8294": "Bloomberg intelligent client",
    "8300": "Transport Management Interface",
    "8301": "Amberon PPC/PPS",
    "8313": "Hub Open Network",
    "8320": "Thin(ium) Network Protocol",
    "8321": "Thin(ium) Network Protocol",
    "8322": "Garmin Marine",
    "8351": "Server Find",
    "8376": "Cruise ENUM",
    "8377": "Cruise SWROUTE",
    "8378": "Cruise CONFIG",
    "8379": "Cruise DIAGS",
    "8380": "Cruise UPDATE",
    "8383": "M2m Services",
    "8384": "Reserved",
    "8400": "cvd",
    "8401": "sabarsd",
    "8402": "abarsd",
    "8403": "admind",
    "8404": "SuperVault Cloud",
    "8405": "SuperVault Backup",
    "8415": "Delphix Session Protocol",
    "8416": "eSpeech Session Protocol",
    "8417": "eSpeech RTP Protocol",
    "8423": "Aristech text-to-speech server",
    "8432": "PostgreSQL Backup",
    "8433": "Reserved",
    "8442": "CyBro A-bus Protocol",
    "8443": "PCsync HTTPS",
    "8444": "PCsync HTTP",
    "8445": "Port for copy peer sync feature",
    "8448": "Matrix Federation Protocol",
    "8450": "npmp",
    "8457": "Nexenta Management GUI",
    "8470": "Cisco Address Validation Protocol",
    "8471": "PIM over Reliable Transport",
    "8472": "Overlay Transport Virtualization (OTV)",
    "8473": "Virtual Point to Point",
    "8474": "AquaMinds NoteShare",
    "8500": "Flight Message Transfer Protocol",
    "8501": "CYTEL Message Transfer Management",
    "8502": "FTN Message Transfer Protocol",
    "8503": "Reserved",
    "8554": "RTSP Alternate (see port 554)",
    "8555": "SYMAX D-FENCE",
    "8567": "DOF Tunneling Protocol",
    "8600": "Surveillance Data",
    "8609": "Reserved",
    "8610": "Canon MFNP Service",
    "8611": "Canon BJNP Port 1",
    "8612": "Canon BJNP Port 2",
    "8613": "Canon BJNP Port 3",
    "8614": "Canon BJNP Port 4",
    "8615": "Imink Service Control",
    "8665": "Monetra",
    "8666": "Monetra Administrative Access",
    "8668": "Spartan management",
    "8675": "Motorola Solutions Customer Programming Software for Radio Management",
    "8686": "Sun App Server - JMX/RMI",
    "8688": "OpenRemote Controller HTTP/REST",
    "8699": "VNYX Primary Port",
    "8710": "gRPC for SEMI Standards implementations",
    "8711": "Nuance Voice Control",
    "8732": "Reserved",
    "8733": "iBus",
    "8750": "DEY Storage Key Negotiation",
    "8763": "MC-APPSERVER",
    "8764": "OPENQUEUE",
    "8765": "Ultraseek HTTP",
    "8766": "Agilent Connectivity Service",
    "8767": "Online mobile multiplayer game",
    "8768": "Sandpolis Server",
    "8769": "Okta MultiPlatform Access Mgmt for Cloud Svcs",
    "8770": "Digital Photo Access Protocol (iPhoto)",
    "8778": "Stonebranch Universal Enterprise Controller",
    "8786": "Message Client",
    "8787": "Message Server",
    "8793": "Accedian Performance Measurement",
    "8800": "Sun Web Server Admin Service",
    "8804": "truecm",
    "8805": "Reserved",
    "8807": "Reserved",
    "8808": "Reserved",
    "8809": "Reserved",
    "8873": "dxspider linking protocol",
    "8880": "CDDBP",
    "8881": "Galaxy4D Online Game Engine",
    "8883": "Secure MQTT",
    "8888": "NewsEDGE server TCP (TCP 1)",
    "8889": "Desktop Data TCP 1",
    "8890": "Desktop Data TCP 2",
    "8891": "Desktop Data TCP 3: NESS application",
    "8892": "Desktop Data TCP 4: FARM product",
    "8893": "Desktop Data TCP 5: NewsEDGE/Web application",
    "8894": "Desktop Data TCP 6: COAL application",
    "8899": "ospf-lite",
    "8900": "JMB-CDS 1",
    "8901": "JMB-CDS 2",
    "8908": "WFA Device Provisioning Protocol",
    "8910": "manyone-http",
    "8911": "manyone-xml",
    "8912": "Windows Client Backup",
    "8913": "Dragonfly System Service",
    "8937": "Transaction Warehouse Data Service",
    "8953": "unbound dns nameserver control",
    "8954": "Cumulus Admin Port",
    "8980": "Network of Devices Provider",
    "8981": "Reserved",
    "8989": "Sun Web Server SSL Admin Service",
    "8990": "webmail HTTP service",
    "8991": "webmail HTTPS service",
    "8997": "Oracle Messaging Server Event Notification Service",
    "8998": "Canto RoboFlow Control",
    "8999": "Brodos Crypto Trade Protocol",
    "9000": "CSlistener",
    "9001": "ETL Service Manager",
    "9002": "DynamID authentication",
    "9005": "Golem Inter-System RPC",
    "9007": "Reserved",
    "9008": "Open Grid Services Server",
    "9009": "Pichat Server",
    "9010": "Secure Data Replicator Protocol",
    "9011": "Reserved",
    "9020": "TAMBORA",
    "9021": "Pangolin Identification",
    "9022": "PrivateArk Remote Agent",
    "9023": "Secure Web Access - 1",
    "9024": "Secure Web Access - 2",
    "9025": "Secure Web Access - 3",
    "9026": "Secure Web Access - 4",
    "9050": "Versiera Agent Listener",
    "9051": "Fusion-io Central Manager Service",
    "9060": "CardWeb request-response I/O exchange",
    "9080": "Groove GLRPC",
    "9081": "Reserved",
    "9083": "EMC PowerPath Mgmt Service",
    "9084": "IBM AURORA Performance Visualizer",
    "9085": "IBM Remote System Console",
    "9086": "Vesa Net2Display",
    "9087": "Classic Data Server",
    "9088": "IBM Informix SQL Interface",
    "9089": "IBM Informix SQL Interface - Encrypted",
    "9090": "WebSM",
    "9091": "xmltec-xmlmail",
    "9092": "Xml-Ipc Server Reg",
    "9093": "Copycat database replication service",
    "9100": "PDL Data Streaming Port",
    "9101": "Bacula Director",
    "9102": "Bacula File Daemon",
    "9103": "Bacula Storage Daemon",
    "9104": "PeerWire",
    "9105": "Xadmin Control Service",
    "9106": "Astergate Control Service",
    "9107": "AstergateFax Control Service",
    "9111": "Multiple Purpose, Distributed Message Bus",
    "9119": "MXit Instant Messaging",
    "9122": "Global Relay compliant mobile instant messaging protocol",
    "9123": "Global Relay compliant instant messaging protocol",
    "9131": "Dynamic Device Discovery",
    "9160": "apani1",
    "9161": "apani2",
    "9162": "apani3",
    "9163": "apani4",
    "9164": "apani5",
    "9191": "Sun AppSvr JPDA",
    "9200": "WAP connectionless session service",
    "9201": "WAP session service",
    "9202": "WAP secure connectionless session service",
    "9203": "WAP secure session service",
    "9204": "WAP vCard",
    "9205": "WAP vCal",
    "9206": "WAP vCard Secure",
    "9207": "WAP vCal Secure",
    "9208": "rjcdb vCard",
    "9209": "ALMobile System Service",
    "9210": "OMA Mobile Location Protocol",
    "9211": "OMA Mobile Location Protocol Secure",
    "9212": "Server View dbms access",
    "9213": "ServerStart RemoteControl",
    "9214": "IPDC ESG BootstrapService",
    "9215": "Integrated Setup and Install Service",
    "9216": "Aionex Communication Management Engine",
    "9217": "FSC Communication Port",
    "9222": "QSC Team Coherence",
    "9255": "Manager On Network",
    "9277": "Reserved",
    "9278": "Pegasus GPS Platform",
    "9279": "Pegaus GPS System Control Interface",
    "9280": "Predicted GPS",
    "9281": "SofaWare transport port 1",
    "9282": "SofaWare transport port 2",
    "9283": "CallWaveIAM",
    "9284": "VERITAS Information Serve",
    "9285": "N2H2 Filter Service Port",
    "9286": "Reserved",
    "9287": "Cumulus",
    "9292": "ArmTech Daemon",
    "9293": "StorView Client",
    "9294": "ARMCenter http Service",
    "9295": "ARMCenter https Service",
    "9300": "Virtual Racing Service",
    "9306": "Sphinx search server (MySQL listener)",
    "9310": "SAP Message Server",
    "9312": "Sphinx search server",
    "9318": "PKIX TimeStamp over TLS",
    "9321": "guibase",
    "9339": "gRPC Network Mgmt/Operations Interface",
    "9340": "gRPC Routing Information Base Interface",
    "9343": "MpIdcMgr",
    "9344": "Mphlpdmc",
    "9345": "Rancher Agent",
    "9346": "C Tech Licensing",
    "9374": "fjdmimgr",
    "9380": "Brivs! Open Extensible Protocol",
    "9387": "D2D Configuration Service",
    "9388": "D2D Data Transfer Service",
    "9389": "Active Directory Web Services",
    "9390": "OpenVAS Transfer Protocol",
    "9396": "fjinvmgr",
    "9397": "MpIdcAgt",
    "9400": "Samsung Twain for Network Server",
    "9401": "Samsung Twain for Network Client",
    "9402": "Samsung PC2FAX for Network Server",
    "9418": "git pack transfer service",
    "9443": "WSO2 Tungsten HTTPS",
    "9444": "WSO2 ESB Administration Console HTTPS",
    "9445": "MindArray Systems Console Agent",
    "9450": "Sentinel Keys Server",
    "9500": "ismserver",
    "9522": "Reserved",
    "9535": "Management Suite Remote Control",
    "9536": "Surveillance buffering function",
    "9555": "Trispen Secure Remote Access",
    "9559": "P4Runtime gRPC Service",
    "9592": "LANDesk Gateway",
    "9593": "LANDesk Management Agent (cba8)",
    "9594": "Message System",
    "9595": "Ping Discovery Service",
    "9596": "Mercury Discovery",
    "9597": "PD Administration",
    "9598": "Very Simple Ctrl Protocol",
    "9599": "Robix",
    "9600": "MICROMUSE-NCPW",
    "9612": "StreamComm User Directory",
    "9614": "iADT Protocol over TLS",
    "9616": "eRunbook Agent",
    "9616": "eRunbook Agent",
    "9617": "eRunbook Server",
    "9617": "eRunbook Server",
    "9618": "Condor Collector Service",
    "9628": "ODBC Pathway Service",
    "9629": "UniPort SSO Controller",
    "9630": "Peovica Controller",
    "9631": "Peovica Collector",
    "9632": "Reserved",
    "9640": "ProQueSys Flows Service",
    "9666": "Zoom Control Panel Game Server Management",
    "9667": "Cross-platform Music Multiplexing System",
    "9668": "tec5 Spectral Device Control Protocol",
    "9694": "T-Mobile Client Wakeup Message",
    "9695": "Content Centric Networking",
    "9700": "Board M.I.T. Service",
    "9747": "L5NAS Parallel Channel",
    "9750": "Board M.I.T. Synchronous Collaboration",
    "9753": "rasadv",
    "9762": "WSO2 Tungsten HTTP",
    "9800": "WebDav Source Port",
    "9801": "Sakura Script Transfer Protocol-2",
    "9802": "WebDAV Source TLS/SSL",
    "9875": "Session Announcement v1",
    "9876": "Session Director",
    "9877": "The X.510 wrapper protocol",
    "9878": "Reserved",
    "9888": "CYBORG Systems",
    "9889": "Port for Cable network related data proxy or repeater",
    "9898": "MonkeyCom",
    "9899": "Reserved",
    "9900": "IUA",
    "9903": "Reserved",
    "9909": "domaintime",
    "9911": "SYPECom Transport Protocol",
    "9925": "XYBRID Cloud",
    "9950": "APC 9950",
    "9951": "APC 9951",
    "9952": "APC 9952",
    "9953": "9953",
    "9954": "HaloteC Instrument Network Protocol",
    "9955": "Contact Port for AllJoyn standard messaging",
    "9956": "Reserved",
    "9966": "OKI Data Network Setting Protocol",
    "9978": "XYBRID RT Server",
    "9979": "Valley Information Systems Weather station data",
    "9981": "Event sourcing database engine with a built-in programming language",
    "9987": "DSM/SCM Target Interface",
    "9988": "Software Essentials Secure HTTP server",
    "9990": "OSM Applet Server",
    "9991": "OSM Event Server",
    "9992": "OnLive-1",
    "9993": "OnLive-2",
    "9994": "OnLive-3",
    "9995": "Palace-4",
    "9996": "Palace-5",
    "9997": "Palace-6",
    "9998": "Distinct32",
    "9999": "distinct",
    "10000": "Network Data Management Protocol",
    "10001": "SCP Configuration",
    "10002": "EMC-Documentum Content Server Product",
    "10003": "EMC-Documentum Content Server Product",
    "10003": "EMC-Documentum Content Server Product",
    "10004": "EMC Replication Manager Client",
    "10005": "EMC Replication Manager Server",
    "10006": "Sync replication protocol among different NetApp platforms",
    "10007": "MVS Capacity",
    "10008": "Octopus Multiplexer",
    "10009": "Systemwalker Desktop Patrol",
    "10010": "ooRexx rxapi services",
    "10020": "Hardware configuration and maintenance",
    "10023": "Reserved",
    "10050": "Zabbix Agent",
    "10051": "Zabbix Trapper",
    "10055": "Quantapoint FLEXlm Licensing Service",
    "10080": "Amanda",
    "10081": "FAM Archive Server",
    "10100": "VERITAS ITAP DDTP",
    "10101": "eZmeeting",
    "10102": "eZproxy",
    "10103": "eZrelay",
    "10104": "Systemwalker Desktop Patrol",
    "10107": "VERITAS BCTP, server",
    "10110": "NMEA-0183 Navigational Data",
    "10111": "Reserved",
    "10113": "NetIQ Endpoint",
    "10114": "NetIQ Qcheck",
    "10115": "NetIQ Endpoint",
    "10116": "NetIQ VoIP Assessor",
    "10117": "NetIQ IQCResource Managament Svc",
    "10125": "HotLink CIMple REST API",
    "10128": "BMC-PERFORM-SERVICE DAEMON",
    "10129": "BMC General Manager Server",
    "10160": "QB Database Server",
    "10161": "SNMP-TLS",
    "10162": "SNMP-Trap-TLS",
    "10200": "Trigence AE Soap Service",
    "10201": "Remote Server Management Service",
    "10252": "Apollo Relay Port",
    "10253": "Reserved",
    "10260": "Axis WIMP Port",
    "10261": "Tile remote machine learning",
    "10288": "Blocks",
    "10321": "Reserved",
    "10439": "Reserved",
    "10443": "CirrosSP Workstation Communication",
    "10500": "Reserved",
    "10540": "MOS Media Object Metadata Port",
    "10541": "MOS Running Order Port",
    "10542": "MOS Low Priority Port",
    "10543": "MOS SOAP Default Port",
    "10544": "MOS SOAP Optional Port",
    "10548": "Apple Document Sharing Service",
    "10631": "Printopia Serve",
    "10800": "Gestor de Acaparamiento para Pocket PCs",
    "10805": "LUCIA Pareja Data Group",
    "10809": "Linux Network Block Device",
    "10810": "Reserved",
    "10860": "Helix Client/Server",
    "10880": "BVEssentials HTTP API",
    "10933": "Listen port used by the Octopus Deploy Tentacle deployment agent",
    "10990": "Auxiliary RMI Port",
    "11000": "IRISA",
    "11001": "Metasys",
    "11095": "Nest device-to-device and device-to-service application protocol",
    "11103": "OrigoDB Server Sync Interface",
    "11104": "NetApp Intercluster Management",
    "11105": "NetApp Intercluster Data",
    "11106": "SGI LK Licensing service",
    "11108": "Reserved",
    "11109": "Data migration facility Manager (DMF) is a browser based interface to DMF",
    "11110": "Data migration facility (DMF) SOAP is a web server protocol to support remote access to DMF",
    "11111": "Viral Computing Environment (VCE)",
    "11112": "DICOM",
    "11161": "sun cacao snmp access point",
    "11162": "sun cacao JMX-remoting access point",
    "11163": "sun cacao rmi registry access point",
    "11164": "sun cacao command-streaming access point",
    "11165": "sun cacao web service access point",
    "11171": "Reserved",
    "11172": "OEM cacao JMX-remoting access point",
    "11173": "Straton Runtime Programing",
    "11174": "OEM cacao rmi registry access point",
    "11175": "OEM cacao web service access point",
    "11201": "smsqp",
    "11202": "DCSL Network Backup Services",
    "11208": "WiFree Service",
    "11211": "Memory cache service",
    "11235": "numerical systems messaging",
    "11319": "IMIP",
    "11320": "IMIP Channels Port",
    "11321": "Arena Server Listen",
    "11367": "ATM UHAS",
    "11371": "OpenPGP HTTP Keyserver",
    "11430": "Reserved",
    "11489": "ASG Cypress Secure Only",
    "11600": "Tempest Protocol Port",
    "11623": "EMC XtremSW distributed config",
    "11720": "H.323 Call Control Signalling Alternate",
    "11723": "EMC XtremSW distributed cache",
    "11751": "Intrepid SSL",
    "11796": "LanSchool",
    "11876": "X2E Xoraya Multichannel protocol",
    "11877": "Reserved",
    "11967": "SysInfo Service Protocol",
    "11971": "TiBS Service",
    "12000": "IBM Enterprise Extender SNA XID Exchange",
    "12001": "IBM Enterprise Extender SNA COS Network Priority",
    "12002": "IBM Enterprise Extender SNA COS High Priority",
    "12003": "IBM Enterprise Extender SNA COS Medium Priority",
    "12004": "IBM Enterprise Extender SNA COS Low Priority",
    "12005": "DBISAM Database Server - Regular",
    "12006": "DBISAM Database Server - Admin",
    "12007": "Accuracer Database System Server",
    "12008": "Accuracer Database System Admin",
    "12009": "Reserved",
    "12010": "ElevateDB Server",
    "12012": "Vipera Messaging Service",
    "12013": "Vipera Messaging Service over SSL Communication",
    "12109": "RETS over SSL",
    "12121": "NuPaper Session Service",
    "12168": "CA Web Access Service",
    "12172": "HiveP",
    "12300": "LinoGrid Engine",
    "12302": "Remote Administration Daemon (RAD) is a system service that offers secure, remote, programmatic access to Solaris system configuration and run-time state",
    "12321": "Warehouse Monitoring Syst SSS",
    "12322": "Warehouse Monitoring Syst",
    "12345": "Italk Chat System",
    "12546": "Carbonite Server Replication Control",
    "12753": "tsaf port",
    "12865": "control port for the netperf benchmark",
    "13160": "I-ZIPQD",
    "13216": "Black Crow Software application logging",
    "13217": "R&amp;S Proxy Installation Assistant Service",
    "13218": "EMC Virtual CAS Service",
    "13223": "PowWow Client",
    "13224": "PowWow Server",
    "13400": "DoIP Data",
    "13720": "BPRD Protocol (VERITAS NetBackup)",
    "13721": "BPDBM Protocol (VERITAS NetBackup)",
    "13722": "BP Java MSVC Protocol",
    "13724": "Veritas Network Utility",
    "13782": "VERITAS NetBackup",
    "13783": "VOPIED Protocol",
    "13785": "NetBackup Database",
    "13786": "Veritas-nomdb",
    "13818": "DSMCC Config",
    "13819": "DSMCC Session Messages",
    "13820": "DSMCC Pass-Thru Messages",
    "13821": "DSMCC Download Protocol",
    "13822": "DSMCC Channel Change Protocol",
    "13823": "Blackmagic Design Streaming Server",
    "13832": "Certificate Management and Issuing",
    "13894": "Ultimate Control communication protocol",
    "13929": "D-TA SYSTEMS",
    "13930": "MedEvolve Port Requester",
    "14000": "SCOTTY High-Speed Filetransfer",
    "14001": "SUA",
    "14002": "Reserved",
    "14033": "sage Best! Config Server 1",
    "14034": "sage Best! Config Server 2",
    "14141": "VCS Application",
    "14142": "IceWall Cert Protocol",
    "14143": "IceWall Cert Protocol over TLS",
    "14145": "GCM Application",
    "14149": "Veritas Traffic Director",
    "14150": "Veritas Cluster Server Command Server",
    "14154": "Veritas Application Director",
    "14250": "Fencing Server",
    "14414": "CA eTrust Web Update Service",
    "14500": "xpra network protocol",
    "14936": "hde-lcesrvr-1",
    "14937": "hde-lcesrvr-2",
    "15000": "Hypack Data Aquisition",
    "15002": "Open Network Environment TLS",
    "15118": "Reserved",
    "15345": "XPilot Contact Port",
    "15363": "3Link Negotiation",
    "15555": "Cisco Stateful NAT",
    "15660": "Backup Express Restore Server",
    "15740": "Picture Transfer Protocol",
    "15998": "Reserved",
    "15999": "ProGrammar Enterprise",
    "16000": "Administration Server Access",
    "16001": "Administration Server Connector",
    "16002": "GoodSync Mediation Service",
    "16003": "Reserved",
    "16020": "Filemaker Java Web Publishing Core",
    "16021": "Filemaker Java Web Publishing Core Binary",
    "16161": "Solaris SEA Port",
    "16162": "Solaris Audit - secure remote audit log",
    "16309": "etb4j",
    "16310": "Policy Distribute, Update Notification",
    "16311": "Policy definition and update management",
    "16360": "Network Serial Extension Ports One",
    "16361": "Network Serial Extension Ports Two",
    "16367": "Network Serial Extension Ports Three",
    "16368": "Network Serial Extension Ports Four",
    "16384": "Connected Corp",
    "16385": "Reliable Datagram Sockets",
    "16619": "X509 Objects Management Service",
    "16665": "Reliable multipath data transport for high latencies",
    "16666": "Reserved",
    "16789": "This server provides callable services to mainframe External Security Managers from any TCP/IP platform",
    "16900": "Newbay Mobile Client Update Service",
    "16950": "Simple Generic Client Interface Protocol",
    "16991": "INTEL-RCI-MP",
    "16992": "Intel(R) AMT SOAP/HTTP",
    "16993": "Intel(R) AMT SOAP/HTTPS",
    "16994": "Intel(R) AMT Redirection/TCP",
    "16995": "Intel(R) AMT Redirection/TLS",
    "17007": "",
    "17010": "Plan 9 cpu port",
    "17184": "Vestas Data Layer Protocol",
    "17185": "Sounds Virtual",
    "17219": "Chipper",
    "17220": "IEEE 1722 Transport Protocol for Time Sensitive Applications",
    "17221": "IEEE 1722.1 AVB Discovery, Enumeration, Connection management, and Control",
    "17222": "Reserved",
    "17223": "ISA100 GCI is a service utilizing a common interface between an ISA100 Wireless gateway and a client application",
    "17224": "Reserved",
    "17225": "Train Realtime Data Protocol (TRDP) Message Data",
    "17234": "Integrius Secure Tunnel Protocol",
    "17235": "SSH Tectia Manager",
    "17500": "Dropbox LanSync Protocol",
    "17555": "Ailith management of routers",
    "17729": "Eclipse Aviation",
    "17754": "Encap. ZigBee Packets",
    "17755": "ZigBee IP Transport Service",
    "17756": "ZigBee IP Transport Secure Service",
    "17777": "SolarWinds Orion",
    "18000": "Beckman Instruments, Inc.",
    "18104": "RAD PDF Service",
    "18136": "z/OS Resource Access Control Facility",
    "18181": "OPSEC CVP",
    "18182": "OPSEC UFP",
    "18183": "OPSEC SAM",
    "18184": "OPSEC LEA",
    "18185": "OPSEC OMI",
    "18186": "Occupational Health SC",
    "18187": "OPSEC ELA",
    "18241": "Check Point RTM",
    "18242": "Checkpoint router monitoring",
    "18243": "Checkpoint router state backup",
    "18262": "GV NetConfig Service",
    "18463": "AC Cluster",
    "18516": "Reserved",
    "18634": "Reliable Datagram Service",
    "18635": "Reliable Datagram Service over IP",
    "18668": "Manufacturing Execution Systems Mesh Communication",
    "18769": "IQue Protocol",
    "18881": "Infotos",
    "18888": "APCNECMP",
    "19000": "iGrid Server",
    "19007": "Scintilla protocol for device services",
    "19020": "J-Link TCP/IP Protocol",
    "19191": "OPSEC UAA",
    "19194": "UserAuthority SecureAgent",
    "19220": "Client Connection Management and Data Exchange Service",
    "19283": "Key Server for SASSAFRAS",
    "19315": "Key Shadow for SASSAFRAS",
    "19398": "mtrgtrans",
    "19410": "hp-sco",
    "19411": "hp-sca",
    "19412": "HP-SESSMON",
    "19539": "FXUPTP",
    "19540": "SXUPTP",
    "19541": "JCP Client",
    "19788": "Reserved",
    "19790": "FairCom Database",
    "19998": "IEC 60870-5-104 process control - secure",
    "19999": "Distributed Network Protocol - Secure",
    "20000": "DNP",
    "20001": "MicroSAN",
    "20002": "Commtact HTTP",
    "20003": "Commtact HTTPS",
    "20005": "OpenWebNet protocol for electric network",
    "20012": "Reserved",
    "20013": "Samsung Interdevice Interaction",
    "20014": "OpenDeploy Listener",
    "20034": "NetBurner ID Port",
    "20034": "NetBurner ID Port",
    "20046": "TMOP HL7 Message Transfer Service",
    "20048": "NFS mount protocol",
    "20049": "Network File System (NFS) over RDMA",
    "20057": "AvesTerra Hypergraph Transfer Protocol (HGTP)",
    "20167": "TOLfab Data Change",
    "20202": "IPD Tunneling Port",
    "20222": "iPulse-ICS",
    "20480": "emWave Message Service",
    "20670": "Track",
    "20810": "CRTech NLM",
    "20999": "At Hand MMP",
    "21000": "IRTrans Control",
    "21010": "Notezilla.Lan Server",
    "21212": "Distributed artificial intelligence",
    "21213": "Cohesity backup agents",
    "21221": "Services for Air Server",
    "21553": "Raima RDM TFS",
    "21554": "MineScape Design File Server",
    "21590": "VoFR Gateway",
    "21800": "TVNC Pro Multiplexing",
    "21801": "Safe AutoLogon",
    "21845": "webphone",
    "21846": "NetSpeak Corp. Directory Services",
    "21847": "NetSpeak Corp. Connection Services",
    "21848": "NetSpeak Corp. Automatic Call Distribution",
    "21849": "NetSpeak Corp. Credit Processing System",
    "22000": "SNAPenetIO",
    "22001": "OptoControl",
    "22002": "Opto Host Port 2",
    "22003": "Opto Host Port 3",
    "22004": "Opto Host Port 4",
    "22005": "Opto Host Port 5",
    "22125": "dCache Access Protocol",
    "22128": "GSI dCache Access Protocol",
    "22222": "EasyEngine is CLI tool to manage WordPress Sites on Nginx server",
    "22273": "wnn6",
    "22305": "CompactIS Tunnel",
    "22333": "ShowCockpit Networking",
    "22335": "Initium Labs Security and Automation Control",
    "22343": "CompactIS Secure Tunnel",
    "22347": "WibuKey Standard WkLan",
    "22350": "CodeMeter Standard",
    "22351": "TPC/IP requests of copy protection software to a server",
    "22537": "CaldSoft Backup server file transfer",
    "22555": "Vocaltec Web Conference",
    "22763": "Talika Main Server",
    "22800": "Telerate Information Platform LAN",
    "22951": "Telerate Information Platform WAN",
    "23000": "Inova LightLink Server Type 1",
    "23001": "Inova LightLink Server Type 2",
    "23002": "Inova LightLink Server Type 3",
    "23003": "Inova LightLink Server Type 4",
    "23004": "Inova LightLink Server Type 5",
    "23005": "Inova LightLink Server Type 6",
    "23053": "Generic Notification Transport Protocol",
    "23272": "Reserved",
    "23294": "5AFE SDN Directory",
    "23333": "Emulex HBAnyware Remote Management",
    "23400": "Novar Data",
    "23401": "Novar Alarm",
    "23402": "Novar Global",
    "23456": "Aequus Service",
    "23457": "Aequus Service Mgmt",
    "23546": "AreaGuard Neo - WebServer",
    "24000": "med-ltp",
    "24001": "med-fsp-rx",
    "24002": "med-fsp-tx",
    "24003": "med-supp",
    "24004": "med-ovw",
    "24005": "med-ci",
    "24006": "med-net-svc",
    "24242": "fileSphere",
    "24249": "Vista 4GL",
    "24321": "Isolv Local Directory",
    "24322": "Reserved",
    "24323": "Verimag mobile class protocol over TCP",
    "24386": "Intel RCI",
    "24386": "Intel RCI",
    "24465": "Tonido Domain Server",
    "24554": "BINKP",
    "24577": "bilobit Service",
    "24666": "Service used by SmarDTV to communicate between a CAM and a second screen application",
    "24676": "Canditv Message Service",
    "24677": "FlashFiler",
    "24678": "Turbopower Proactivate",
    "24680": "TCC User HTTP Service",
    "24754": "Citrix StorageLink Gateway",
    "24850": "Reserved",
    "24922": "Find Identification of Network Devices",
    "25000": "icl-twobase1",
    "25001": "icl-twobase2",
    "25002": "icl-twobase3",
    "25003": "icl-twobase4",
    "25004": "icl-twobase5",
    "25005": "icl-twobase6",
    "25006": "icl-twobase7",
    "25007": "icl-twobase8",
    "25008": "icl-twobase9",
    "25009": "icl-twobase10",
    "25100": "IBM Db2 Client Interface - Encrypted",
    "25576": "Sauter Dongle",
    "25604": "Identifier Tracing Protocol",
    "25793": "Vocaltec Address Server",
    "25900": "TASP Network Comm",
    "25901": "NIObserver",
    "25902": "NILinkAnalyst",
    "25903": "NIProbe",
    "25954": "Reserved",
    "25955": "Reserved",
    "26000": "quake",
    "26133": "Symbolic Computation Software Composability Protocol",
    "26208": "wnn6-ds",
    "26257": "CockroachDB",
    "26260": "eZproxy",
    "26261": "eZmeeting",
    "26262": "K3 Software-Server",
    "26263": "K3 Software-Client",
    "26486": "EXOline-TCP",
    "26487": "EXOconfig",
    "26489": "EXOnet",
    "27010": "A protocol for managing license services",
    "27017": "Mongo database system",
    "27345": "ImagePump",
    "27442": "Job controller service",
    "27504": "Kopek HTTP Head Port",
    "27782": "ARS VISTA Application",
    "27876": "Astrolink Protocol",
    "27999": "TW Authentication/Key Distribution and",
    "28000": "NX License Manager",
    "28001": "PQ Service",
    "28010": "Gruber cash registry protocol",
    "28080": "thor/server - ML engine",
    "28119": "Reserved",
    "28200": "VoxelStorm game server",
    "28240": "Siemens GSM",
    "28589": "Building operating system services wide area verified exchange",
    "29000": "Siemens Licensing Server",
    "29118": "Reserved",
    "29167": "ObTools Message Protocol",
    "29168": "Reserved",
    "29999": "data exchange protocol for IEC61850 in wind power plants",
    "30000": "Secure Network Data Management Protocol",
    "30001": "Pago Services 1",
    "30002": "Pago Services 2",
    "30003": "Amicon FPSU-IP Remote Administration",
    "30004": "Reserved",
    "30100": "Remote Window Protocol",
    "30260": "Kingdoms Online (CraigAvenue)",
    "30400": "GroundStar RealTime System",
    "30832": "Reserved",
    "30999": "OpenView Service Desk Client",
    "31016": "Kollective Agent Secure Distributed Delivery Protocol",
    "31020": "Autotrac ACP 245",
    "31029": "Reserved",
    "31337": "eldim is a secure file upload proxy",
    "31400": "PACE license server",
    "31416": "XQoS network monitor",
    "31457": "TetriNET Protocol",
    "31620": "lm mon",
    "31685": "DS Expert Monitor",
    "31685": "DS Expert Monitor",
    "31765": "GameSmith Port",
    "31948": "Embedded Device Configuration Protocol TX",
    "31948": "Embedded Device Configuration Protocol TX",
    "31949": "Embedded Device Configuration Protocol RX",
    "31949": "Embedded Device Configuration Protocol RX",
    "32034": "iRacing helper service",
    "32249": "T1 Distributed Processor",
    "32400": "Plex multimedia",
    "32483": "Access Point Manager Link",
    "32635": "SecureNotebook-CLNT",
    "32636": "DMExpress",
    "32767": "FileNet BPM WS-ReliableMessaging Client",
    "32768": "Filenet TMS",
    "32769": "Filenet RPC",
    "32770": "Filenet NCH",
    "32771": "FileNET RMI",
    "32772": "FileNET Process Analyzer",
    "32773": "FileNET Component Manager",
    "32774": "FileNET Rules Engine",
    "32775": "Performance Clearinghouse",
    "32776": "FileNET BPM IOR",
    "32777": "FileNet BPM CORBA",
    "32801": "Multiple Listing Service Network",
    "32811": "Real Estate Transport Protocol",
    "32896": "Attachmate ID Manager",
    "33000": "WatchGuard Endpoint Communications",
    "33060": "MySQL Database Extended Interface",
    "33123": "Aurora (Balaena Ltd)",
    "33331": "DiamondCentral Interface",
    "33333": "Digital Gaslight Service",
    "33334": "SpeedTrace TraceAgent",
    "33434": "traceroute use",
    "33435": "Reserved",
    "33656": "SNIP Slave",
    "33890": "Adept IP protocol",
    "34249": "TurboNote Relay Server Default Port",
    "34378": "P-Net on IP local",
    "34379": "P-Net on IP remote",
    "34567": "dhanalakshmi.org EDI Service",
    "34962": "PROFInet RT Unicast",
    "34963": "PROFInet RT Multicast",
    "34964": "PROFInet Context Manager",
    "34980": "EtherCAT Port",
    "35000": "HeathView",
    "35001": "ReadyTech Viewer",
    "35002": "ReadyTech Sound Server",
    "35003": "ReadyTech DeviceMapper Server",
    "35004": "ReadyTech ClassManager",
    "35005": "ReadyTech LabTracker",
    "35006": "ReadyTech Helper Service",
    "35100": "Axiomatic discovery protocol",
    "35354": "KIT Messenger",
    "35355": "Altova License Management",
    "35356": "Gutters Note Exchange",
    "35357": "OpenStack ID Service",
    "36001": "AllPeers Network",
    "36411": "Reserved",
    "36412": "Reserved",
    "36422": "Reserved",
    "36462": "Reserved",
    "36524": "Febooti Automation Workshop",
    "36602": "Observium statistics collection agent",
    "36700": "MapX communication",
    "36865": "KastenX Pipe",
    "37472": "Reserved",
    "37475": "science + computing's Venus Administration Port",
    "37483": "Google Drive Sync",
    "37601": "Epipole File Transfer Protocol",
    "37654": "Unisys ClearPath ePortal",
    "38000": "InfoVista Server Database",
    "38001": "InfoVista Server Insertion",
    "38002": "Cresco Controller",
    "38201": "Galaxy7 Data Tunnel",
    "38202": "Fairview Message Service",
    "38203": "AppGate Policy Server",
    "38412": "Reserved",
    "38422": "Reserved",
    "38462": "Reserved",
    "38472": "Reserved",
    "38638": "Premier SQL Middleware Server",
    "38800": "Sruth is a service for the distribution of routinely-",
    "38865": "Security approval process for use of the secRMM SafeCopy program",
    "39063": "Children's hearing test/Telemedicine",
    "39681": "TurboNote Default Port",
    "40000": "SafetyNET p",
    "40023": "Reserved",
    "40404": "Simplify Printing TX",
    "40841": "CSCP",
    "40842": "CSCCREDIR",
    "40843": "CSCCFIREWALL",
    "40853": "Reserved",
    "41111": "Foursticks QoS Protocol",
    "41121": "Tentacle Server",
    "41230": "Z-Wave Protocol over SSL/TLS",
    "41794": "Crestron Control Port",
    "41795": "Crestron Terminal Port",
    "41796": "Crestron Secure Control Port",
    "41797": "Crestron Secure Terminal Port",
    "42508": "Computer Associates network discovery protocol",
    "42509": "CA discovery response",
    "42510": "CA eTrust RPC",
    "42999": "API endpoint for search application",
    "43000": "Receiver Remote Control",
    "43188": "REACHOUT",
    "43189": "NDM-AGENT-PORT",
    "43190": "IP-PROVISION",
    "43191": "Reconnoiter Agent Data Transport",
    "43210": "Shaper Automation Server Management",
    "43438": "Reserved",
    "43439": "EQ3 firmware update",
    "43440": "Cisco EnergyWise Management",
    "43441": "Cisco NetMgmt DB Ports",
    "44123": "Z-Wave Secure Tunnel",
    "44321": "PCP server (pmcd)",
    "44322": "PCP server (pmcd) proxy",
    "44323": "HTTP binding for Performance Co-Pilot client API",
    "44444": "Cognex DataMan Management Protocol",
    "44445": "Acronis Backup Gateway service port",
    "44544": "Reserved",
    "44553": "REALbasic Remote Debug",
    "44600": "Reserved",
    "44818": "EtherNet/IP messaging",
    "44818": "EtherNet/IP messaging",
    "44900": "M3DA is used for efficient machine-to-machine communications",
    "45000": "Nuance AutoStore Status Monitoring Protocol (data transfer)",
    "45001": "Nuance AutoStore Status Monitoring Protocol (secure data transfer)",
    "45002": "Redspeed Status Monitor",
    "45045": "Remote application control protocol",
    "45054": "InVision AG",
    "45514": "ASSIA CloudCheck WiFi Management System",
    "45678": "EBA PRISE",
    "45824": "Server for the DAI family of client-server products",
    "45825": "Qpuncture Data Access Service",
    "45966": "SSRServerMgr",
    "46336": "Listen port used for Inedo agent communication",
    "46998": "Connection between a desktop computer or server and a signature tablet to capture handwritten signatures",
    "46999": "MediaBox Server",
    "47000": "Message Bus",
    "47001": "Windows Remote Management Service",
    "47100": "Reserved",
    "47557": "Databeam Corporation",
    "47624": "Direct Play Server",
    "47806": "ALC Protocol",
    "47808": "Building Automation and Control Networks",
    "47809": "Reserved",
    "48000": "Nimbus Controller",
    "48001": "Nimbus Spooler",
    "48002": "Nimbus Hub",
    "48003": "Nimbus Gateway",
    "48004": "NimbusDB Connector",
    "48005": "NimbusDB Control",
    "48048": "Juliar Programming Language Protocol",
    "48049": "3GPP Cell Broadcast Service Protocol",
    "48050": "WeFi Access Network Discovery and Selection Function",
    "48128": "Image Systems Network Services",
    "48129": "Bloomberg locator",
    "48556": "com-bardac-dw",
    "48619": "iqobject",
    "48653": "Robot Raconteur transport",
    "49000": "Matahari Broker",
    "49001": "Nuance Unity Service Request Protocol",
    "49150": "InSpider System",
}

port_map_udp = {
    "0": "Reserved",
    "1": "TCP Port Service Multiplexer",
    "2": "Management Utility",
    "3": "Compression Process",
    "4": "Unassigned",
    "5": "Remote Job Entry",
    "6": "Unassigned",
    "7": "Echo",
    "8": "Unassigned",
    "9": "Discard",
    "10": "Unassigned",
    "11": "Active Users",
    "12": "Unassigned",
    "13": "Daytime",
    "14": "Unassigned",
    "15": "Unassigned",
    "16": "Unassigned",
    "17": "Quote of the Day",
    "18": "Message Send Protocol (historic)",
    "19": "Character Generator",
    "20": "File Transfer [Default Data]",
    "21": "File Transfer Protocol [Control]",
    "22": "The Secure Shell (SSH) Protocol",
    "23": "Telnet",
    "24": "any private mail system",
    "25": "Simple Mail Transfer",
    "26": "Unassigned",
    "27": "NSW User System FE",
    "28": "Unassigned",
    "29": "MSG ICP",
    "30": "Unassigned",
    "31": "MSG Authentication",
    "32": "Unassigned",
    "33": "Display Support Protocol",
    "34": "Unassigned",
    "35": "any private printer server",
    "36": "Unassigned",
    "37": "Time",
    "38": "Route Access Protocol",
    "39": "Resource Location Protocol",
    "40": "Unassigned",
    "41": "Graphics",
    "42": "Host Name Server",
    "42": "Host Name Server",
    "43": "Who Is",
    "44": "MPM FLAGS Protocol",
    "45": "Message Processing Module [recv]",
    "46": "MPM [default send]",
    "47": "Reserved",
    "48": "Digital Audit Daemon",
    "49": "Login Host Protocol (TACACS)",
    "50": "Remote Mail Checking Protocol",
    "52": "XNS Time Protocol",
    "53": "Domain Name Server",
    "54": "XNS Clearinghouse",
    "55": "ISI Graphics Language",
    "56": "XNS Authentication",
    "57": "any private terminal access",
    "58": "XNS Mail",
    "59": "any private file service",
    "60": "Unassigned",
    "61": "Reserved",
    "62": "ACA Services",
    "63": "whois++",
    "63": "whois++",
    "64": "Communications Integrator (CI)",
    "65": "TACACS-Database Service",
    "66": "Oracle SQL*NET",
    "66": "Oracle SQL*NET",
    "67": "Bootstrap Protocol Server",
    "68": "Bootstrap Protocol Client",
    "69": "Trivial File Transfer",
    "70": "Gopher",
    "71": "Remote Job Service",
    "72": "Remote Job Service",
    "73": "Remote Job Service",
    "74": "Remote Job Service",
    "75": "any private dial out service",
    "76": "Distributed External Object Store",
    "77": "any private RJE service",
    "78": "vettcp",
    "79": "Finger",
    "80": "World Wide Web HTTP",
    "80": "World Wide Web HTTP",
    "80": "World Wide Web HTTP",
    "82": "XFER Utility",
    "83": "MIT ML Device",
    "84": "Common Trace Facility",
    "85": "MIT ML Device",
    "86": "Micro Focus Cobol",
    "87": "any private terminal link",
    "88": "Kerberos",
    "89": "SU/MIT Telnet Gateway",
    "90": "DNSIX Securit Attribute Token Map",
    "91": "MIT Dover Spooler",
    "92": "Network Printing Protocol",
    "93": "Device Control Protocol",
    "94": "Tivoli Object Dispatcher",
    "95": "SUPDUP",
    "96": "DIXIE Protocol Specification",
    "97": "Swift Remote Virtural File Protocol",
    "98": "TAC News",
    "99": "Metagram Relay",
    "101": "NIC Host Name Server",
    "102": "ISO-TSAP Class 0",
    "103": "Genesis Point-to-Point Trans Net",
    "104": "ACR-NEMA Digital Imag. &amp; Comm. 300",
    "105": "CCSO name server protocol",
    "106": "3COM-TSMUX",
    "107": "Remote Telnet Service",
    "108": "SNA Gateway Access Server",
    "109": "Post Office Protocol - Version 2",
    "110": "Post Office Protocol - Version 3",
    "111": "SUN Remote Procedure Call",
    "112": "McIDAS Data Transmission Protocol",
    "113": "Authentication Service",
    "115": "Simple File Transfer Protocol",
    "116": "ANSA REX Notify",
    "117": "UUCP Path Service",
    "118": "SQL Services",
    "119": "Network News Transfer Protocol",
    "120": "CFDPTKT",
    "121": "Encore Expedited Remote Pro.Call",
    "122": "SMAKYNET",
    "123": "Network Time Protocol",
    "124": "ANSA REX Trader",
    "125": "Locus PC-Interface Net Map Ser",
    "126": "NXEdit",
    "127": "Locus PC-Interface Conn Server",
    "128": "GSS X License Verification",
    "129": "Password Generator Protocol",
    "130": "cisco FNATIVE",
    "131": "cisco TNATIVE",
    "132": "cisco SYSMAINT",
    "133": "Statistics Service",
    "134": "INGRES-NET Service",
    "135": "DCE endpoint resolution",
    "136": "PROFILE Naming System",
    "137": "NETBIOS Name Service",
    "138": "NETBIOS Datagram Service",
    "139": "NETBIOS Session Service",
    "140": "EMFIS Data Service",
    "141": "EMFIS Control Service",
    "142": "Britton-Lee IDM",
    "143": "Reserved",
    "144": "Universal Management Architecture",
    "145": "UAAC Protocol",
    "146": "ISO-IP0",
    "147": "ISO-IP",
    "148": "Jargon",
    "149": "AED 512 Emulation Service",
    "150": "SQL-NET",
    "151": "HEMS",
    "152": "Background File Transfer Program",
    "153": "SGMP",
    "154": "NETSC",
    "155": "NETSC",
    "156": "SQL Service",
    "157": "KNET/VM Command/Message Protocol",
    "158": "PCMail Server",
    "159": "NSS-Routing",
    "160": "SGMP-TRAPS",
    "161": "SNMP",
    "162": "SNMPTRAP",
    "163": "CMIP/TCP Manager",
    "164": "CMIP/TCP Agent",
    "165": "Xerox",
    "166": "Sirius Systems",
    "167": "NAMP",
    "168": "RSVD",
    "169": "SEND",
    "170": "Network PostScript",
    "171": "Network Innovations Multiplex",
    "172": "Network Innovations CL/1",
    "172": "Network Innovations CL/1",
    "173": "Xyplex",
    "174": "MAILQ",
    "175": "VMNET",
    "176": "GENRAD-MUX",
    "177": "X Display Manager Control Protocol",
    "178": "NextStep Window Server",
    "179": "Border Gateway Protocol",
    "180": "Intergraph",
    "181": "Unify",
    "182": "Unisys Audit SITP",
    "183": "OCBinder",
    "184": "OCServer",
    "185": "Remote-KIS",
    "186": "KIS Protocol",
    "187": "Application Communication Interface",
    "188": "Plus Five's MUMPS",
    "189": "Queued File Transport",
    "190": "Gateway Access Control Protocol",
    "191": "Prospero Directory Service",
    "192": "OSU Network Monitoring System",
    "193": "Spider Remote Monitoring Protocol",
    "194": "Internet Relay Chat Protocol",
    "195": "DNSIX Network Level Module Audit",
    "196": "DNSIX Session Mgt Module Audit Redir",
    "197": "Directory Location Service",
    "198": "Directory Location Service Monitor",
    "199": "SMUX",
    "200": "IBM System Resource Controller",
    "201": "AppleTalk Routing Maintenance",
    "202": "AppleTalk Name Binding",
    "203": "AppleTalk Unused",
    "204": "AppleTalk Echo",
    "205": "AppleTalk Unused",
    "206": "AppleTalk Zone Information",
    "207": "AppleTalk Unused",
    "208": "AppleTalk Unused",
    "209": "The Quick Mail Transfer Protocol",
    "210": "ANSI Z39.50",
    "210": "ANSI Z39.50",
    "211": "Texas Instruments 914C/G Terminal",
    "211": "Texas Instruments 914C/G Terminal",
    "212": "ATEXSSTR",
    "213": "IPX",
    "214": "VM PWSCS",
    "215": "Insignia Solutions",
    "216": "Computer Associates Int'l License Server",
    "217": "dBASE Unix",
    "218": "Netix Message Posting Protocol",
    "219": "Unisys ARPs",
    "220": "Interactive Mail Access Protocol v3",
    "221": "Berkeley rlogind with SPX auth",
    "222": "Berkeley rshd with SPX auth",
    "223": "Certificate Distribution Center",
    "224": "masqdialer",
    "242": "Direct",
    "243": "Survey Measurement",
    "244": "inbusiness",
    "245": "LINK",
    "246": "Display Systems Protocol",
    "247": "SUBNTBCST_TFTP",
    "247": "SUBNTBCST_TFTP",
    "248": "bhfhs",
    "256": "RAP",
    "257": "Secure Electronic Transaction",
    "259": "Efficient Short Remote Operations",
    "260": "Openport",
    "261": "IIOP Name Service over TLS/SSL",
    "262": "Arcisdms",
    "263": "HDAP",
    "264": "BGMP",
    "265": "X-Bone CTL",
    "266": "SCSI on ST",
    "267": "Tobit David Service Layer",
    "268": "Tobit David Replica",
    "269": "MANET Protocols",
    "270": "Q-mode encapsulation for GIST messages",
    "271": "Reserved",
    "280": "http-mgmt",
    "281": "Personal Link",
    "282": "Cable Port A/X",
    "283": "rescap",
    "284": "corerjd",
    "286": "FXP Communication",
    "287": "K-BLOCK",
    "308": "Novastor Backup",
    "309": "EntrustTime",
    "310": "bhmds",
    "311": "AppleShare IP WebAdmin",
    "312": "VSLMP",
    "313": "Magenta Logic",
    "314": "Opalis Robot",
    "315": "DPSI",
    "316": "decAuth",
    "317": "Zannet",
    "318": "PKIX TimeStamp",
    "319": "PTP Event",
    "320": "PTP General",
    "321": "PIP",
    "322": "RTSPS",
    "323": "Reserved",
    "324": "Reserved",
    "333": "Texar Security Port",
    "344": "Prospero Data Access Protocol",
    "345": "Perf Analysis Workbench",
    "346": "Zebra server",
    "347": "Fatmen Server",
    "348": "Cabletron Management Protocol",
    "349": "mftp",
    "350": "MATIP Type A",
    "351": "MATIP Type B",
    "352": "DTAG",
    "353": "NDSAUTH",
    "354": "bh611",
    "355": "DATEX-ASN",
    "356": "Cloanto Net 1",
    "357": "bhevent",
    "358": "Shrinkwrap",
    "359": "Reserved",
    "360": "scoi2odialog",
    "361": "Semantix",
    "362": "SRS Send",
    "363": "RSVP Tunnel",
    "363": "RSVP Tunnel",
    "364": "Aurora CMGR",
    "365": "DTK",
    "366": "ODMR",
    "367": "MortgageWare",
    "368": "QbikGDP",
    "369": "rpc2portmap",
    "370": "codaauth2",
    "371": "Clearcase",
    "372": "ListProcessor",
    "373": "Legent Corporation",
    "374": "Legent Corporation",
    "375": "Hassle",
    "376": "Amiga Envoy Network Inquiry Protocol",
    "377": "NEC Corporation",
    "378": "NEC Corporation",
    "379": "TIA/EIA/IS-99 modem client",
    "380": "TIA/EIA/IS-99 modem server",
    "381": "hp performance data collector",
    "382": "hp performance data managed node",
    "383": "hp performance data alarm manager",
    "384": "A Remote Network Server System",
    "385": "IBM Application",
    "386": "ASA Message Router Object Def.",
    "387": "Appletalk Update-Based Routing Pro.",
    "388": "Unidata LDM",
    "389": "Lightweight Directory Access Protocol",
    "390": "UIS",
    "391": "SynOptics SNMP Relay Port",
    "392": "SynOptics Port Broker Port",
    "393": "Meta5",
    "394": "EMBL Nucleic Data Transfer",
    "395": "NetScout Control Protocol",
    "396": "Novell Netware over IP",
    "397": "Multi Protocol Trans. Net.",
    "398": "Kryptolan",
    "399": "ISO Transport Class 2 Non-Control over UDP",
    "400": "Oracle Secure Backup",
    "401": "Uninterruptible Power Supply",
    "402": "Genie Protocol",
    "403": "decap",
    "404": "nced",
    "405": "ncld",
    "406": "Interactive Mail Support Protocol",
    "407": "Timbuktu",
    "408": "Prospero Resource Manager Sys. Man.",
    "409": "Prospero Resource Manager Node Man.",
    "410": "DECLadebug Remote Debug Protocol",
    "411": "Remote MT Protocol",
    "412": "Trap Convention Port",
    "413": "Storage Management Services Protocol",
    "414": "InfoSeek",
    "415": "BNet",
    "416": "Silverplatter",
    "417": "Onmux",
    "418": "Hyper-G",
    "419": "Ariel 1",
    "420": "SMPTE",
    "421": "Ariel 2",
    "422": "Ariel 3",
    "423": "IBM Operations Planning and Control Start",
    "424": "IBM Operations Planning and Control Track",
    "425": "ICAD",
    "426": "smartsdp",
    "427": "Server Location",
    "428": "OCS_CMU",
    "428": "OCS_CMU",
    "429": "OCS_AMU",
    "429": "OCS_AMU",
    "430": "UTMPSD",
    "431": "UTMPCD",
    "432": "IASD",
    "433": "NNTP for transit servers (NNSP)",
    "434": "MobileIP-Agent",
    "435": "MobilIP-MN",
    "436": "DNA-CML",
    "437": "comscm",
    "438": "dsfgw",
    "439": "dasp",
    "440": "sgcp",
    "441": "decvms-sysmgt",
    "442": "cvc_hostd",
    "442": "cvc_hostd",
    "443": "http protocol over TLS/SSL",
    "444": "Simple Network Paging Protocol",
    "445": "Microsoft-DS",
    "446": "DDM-Remote Relational Database Access",
    "447": "DDM-Distributed File Management",
    "448": "DDM-Remote DB Access Using Secure Sockets",
    "449": "AS Server Mapper",
    "450": "Computer Supported Telecomunication Applications",
    "451": "Cray Network Semaphore server",
    "452": "Cray SFS config server",
    "453": "CreativeServer",
    "454": "ContentServer",
    "455": "CreativePartnr",
    "456": "macon-udp",
    "457": "scohelp",
    "458": "apple quick time",
    "459": "ampr-rcmd",
    "460": "skronk",
    "461": "DataRampSrv",
    "462": "DataRampSrvSec",
    "463": "alpes",
    "464": "kpasswd",
    "465": "IGMP over UDP for SSM",
    "466": "digital-vrc",
    "467": "mylex-mapd",
    "468": "proturis",
    "469": "Radio Control Protocol",
    "470": "scx-proxy",
    "471": "Mondex",
    "472": "ljk-login",
    "473": "hybrid-pop",
    "474": "tn-tl-w2",
    "475": "tcpnethaspsrv",
    "476": "tn-tl-fd1",
    "477": "ss7ns",
    "478": "spsc",
    "479": "iafserver",
    "480": "iafdbase",
    "481": "Ph service",
    "482": "bgs-nsi",
    "483": "ulpnet",
    "484": "Integra Software Management Environment",
    "485": "Air Soft Power Burst",
    "486": "avian",
    "487": "saft Simple Asynchronous File Transfer",
    "488": "gss-http",
    "489": "nest-protocol",
    "490": "micom-pfs",
    "491": "go-login",
    "492": "Transport Independent Convergence for FNA",
    "493": "Transport Independent Convergence for FNA",
    "494": "POV-Ray",
    "495": "intecourier",
    "496": "PIM-RP-DISC",
    "497": "Retrospect backup and restore service",
    "498": "siam",
    "499": "ISO ILL Protocol",
    "500": "isakmp",
    "501": "STMF",
    "502": "Modbus Application Protocol",
    "503": "Intrinsa",
    "504": "citadel",
    "505": "mailbox-lm",
    "506": "ohimsrv",
    "507": "crs",
    "508": "xvttp",
    "509": "snare",
    "510": "FirstClass Protocol",
    "511": "PassGo",
    "512": "used by mail system to notify users of new mail received; currently receives messages only from processes on the same machine",
    "513": "maintains data bases showing who's logged in to machines on a local net and the load average of the machine",
    "514": "",
    "515": "spooler",
    "516": "videotex",
    "517": "like tenex link, but across machine - unfortunately, doesn't use link protocol (this is actually just a rendezvous port from which a tcp connection is established)",
    "518": "",
    "519": "unixtime",
    "520": "local routing process (on site); uses variant of Xerox NS routing information protocol - RIP",
    "521": "ripng",
    "522": "ULP",
    "523": "IBM-DB2",
    "524": "NCP",
    "525": "timeserver",
    "526": "newdate",
    "527": "Stock IXChange",
    "528": "Customer IXChange",
    "529": "IRC-SERV",
    "530": "rpc",
    "531": "chat",
    "532": "readnews",
    "533": "for emergency broadcasts",
    "534": "windream Admin",
    "535": "iiop",
    "536": "opalis-rdv",
    "537": "Networked Media Streaming Protocol",
    "538": "gdomap",
    "539": "Apertus Technologies Load Determination",
    "540": "uucpd",
    "541": "uucp-rlogin",
    "542": "commerce",
    "543": "",
    "544": "krcmd",
    "545": "appleqtcsrvr",
    "546": "DHCPv6 Client",
    "547": "DHCPv6 Server",
    "548": "AFP over TCP",
    "549": "IDFP",
    "550": "new-who",
    "551": "cybercash",
    "552": "DeviceShare",
    "553": "pirp",
    "554": "Real Time Streaming Protocol (RTSP)",
    "555": "",
    "556": "rfs server",
    "557": "openvms-sysipc",
    "558": "SDNSKMP",
    "559": "TEEDTAP",
    "560": "rmonitord",
    "561": "",
    "562": "chcmd",
    "563": "nntp protocol over TLS/SSL (was snntp)",
    "564": "plan 9 file service",
    "565": "whoami",
    "566": "streettalk",
    "567": "banyan-rpc",
    "568": "microsoft shuttle",
    "569": "microsoft rome",
    "570": "demon",
    "571": "udemon",
    "572": "sonar",
    "573": "banyan-vip",
    "574": "FTP Software Agent System",
    "575": "VEMMI",
    "576": "ipcd",
    "577": "vnas",
    "578": "ipdd",
    "579": "decbsrv",
    "580": "SNTP HEARTBEAT",
    "581": "Bundle Discovery Protocol",
    "582": "SCC Security",
    "583": "Philips Video-Conferencing",
    "584": "Key Server",
    "586": "Password Change",
    "587": "Message Submission",
    "588": "CAL",
    "589": "EyeLink",
    "590": "TNS CML",
    "591": "FileMaker, Inc. - HTTP Alternate (see Port 80)",
    "592": "Eudora Set",
    "593": "HTTP RPC Ep Map",
    "594": "TPIP",
    "595": "CAB Protocol",
    "596": "SMSD",
    "597": "PTC Name Service",
    "598": "SCO Web Server Manager 3",
    "599": "Aeolon Core Protocol",
    "600": "Sun IPC server",
    "601": "Reliable Syslog Service",
    "602": "XML-RPC over BEEP",
    "603": "IDXP",
    "604": "TUNNEL",
    "605": "SOAP over BEEP",
    "606": "Cray Unified Resource Manager",
    "607": "nqs",
    "608": "Sender-Initiated/Unsolicited File Transfer",
    "609": "npmp-trap",
    "610": "npmp-local",
    "611": "npmp-gui",
    "612": "HMMP Indication",
    "613": "HMMP Operation",
    "614": "SSLshell",
    "615": "Internet Configuration Manager",
    "616": "SCO System Administration Server",
    "617": "SCO Desktop Administration Server",
    "618": "DEI-ICDA",
    "619": "Compaq EVM",
    "620": "SCO WebServer Manager",
    "621": "ESCP",
    "622": "Collaborator",
    "623": "ASF Remote Management and Control Protocol",
    "624": "Crypto Admin",
    "625": "DEC DLM",
    "625": "DEC DLM",
    "626": "ASIA",
    "627": "PassGo Tivoli",
    "628": "QMQP",
    "629": "3Com AMP3",
    "630": "RDA",
    "631": "IPP (Internet Printing Protocol)",
    "632": "bmpp",
    "633": "Service Status update (Sterling Software)",
    "634": "ginad",
    "635": "RLZ DBase",
    "636": "ldap protocol over TLS/SSL (was sldap)",
    "637": "lanserver",
    "638": "mcns-sec",
    "639": "MSDP",
    "640": "entrust-sps",
    "641": "repcmd",
    "642": "ESRO-EMSDP V1.3",
    "643": "SANity",
    "644": "dwr",
    "645": "PSSC",
    "646": "LDP",
    "647": "DHCP Failover",
    "648": "Registry Registrar Protocol (RRP)",
    "649": "Cadview-3d - streaming 3d models over the internet",
    "650": "OBEX",
    "651": "IEEE MMS",
    "652": "HELLO_PORT",
    "653": "RepCmd",
    "654": "AODV",
    "655": "TINC",
    "656": "SPMP",
    "657": "RMC",
    "658": "TenFold",
    "660": "MacOS Server Admin",
    "661": "HAP",
    "662": "PFTP",
    "663": "PureNoise",
    "664": "ASF Secure Remote Management and Control Protocol",
    "665": "Sun DR",
    "666": "doom Id Software",
    "667": "campaign contribution disclosures - SDR Technologies",
    "668": "MeComm",
    "669": "MeRegister",
    "670": "VACDSM-SWS",
    "671": "VACDSM-APP",
    "672": "VPPS-QUA",
    "673": "CIMPLEX",
    "674": "ACAP",
    "675": "DCTP",
    "676": "VPPS Via",
    "677": "Virtual Presence Protocol",
    "678": "GNU Generation Foundation NCP",
    "679": "MRM",
    "680": "entrust-aaas",
    "681": "entrust-aams",
    "682": "XFR",
    "683": "CORBA IIOP",
    "684": "CORBA IIOP SSL",
    "685": "MDC Port Mapper",
    "686": "Hardware Control Protocol Wismar",
    "687": "asipregistry",
    "688": "ApplianceWare managment protocol",
    "689": "NMAP",
    "690": "Velneo Application Transfer Protocol",
    "691": "MS Exchange Routing",
    "692": "Hyperwave-ISP",
    "693": "almanid Connection Endpoint",
    "694": "ha-cluster",
    "695": "IEEE-MMS-SSL",
    "696": "RUSHD",
    "697": "UUIDGEN",
    "698": "OLSR",
    "699": "Access Network",
    "700": "Extensible Provisioning Protocol",
    "701": "Link Management Protocol (LMP)",
    "702": "IRIS over BEEP",
    "704": "errlog copy/server daemon",
    "705": "AgentX",
    "706": "SILC",
    "707": "Borland DSJ",
    "709": "Entrust Key Management Service Handler",
    "710": "Entrust Administration Service Handler",
    "711": "Cisco TDP",
    "712": "TBRPF",
    "713": "IRIS over XPC",
    "714": "IRIS over XPCS",
    "715": "IRIS-LWZ",
    "716": "PANA Messages",
    "729": "IBM NetView DM/6000 Server/Client",
    "730": "IBM NetView DM/6000 send/tcp",
    "731": "IBM NetView DM/6000 receive/tcp",
    "741": "netGW",
    "742": "Network based Rev. Cont. Sys.",
    "744": "Flexible License Manager",
    "747": "Fujitsu Device Control",
    "748": "Russell Info Sci Calendar Manager",
    "749": "kerberos administration",
    "750": "kerberos version iv",
    "751": "",
    "752": "",
    "753": "",
    "754": "send",
    "758": "",
    "759": "",
    "760": "",
    "761": "",
    "762": "",
    "763": "",
    "764": "",
    "765": "",
    "767": "phone",
    "769": "",
    "770": "",
    "771": "",
    "772": "",
    "773": "",
    "774": "",
    "774": "",
    "775": "",
    "775": "",
    "776": "",
    "777": "Multiling HTTP",
    "780": "",
    "800": "",
    "800": "",
    "801": "",
    "802": "Modbus Application Protocol Secure",
    "810": "FCP Datagram",
    "828": "itm-mcell-s",
    "829": "PKIX-3 CA/RA",
    "830": "NETCONF over SSH",
    "831": "NETCONF over BEEP",
    "832": "NETCONF for SOAP over HTTPS",
    "833": "NETCONF for SOAP over BEEP",
    "847": "dhcp-failover 2",
    "848": "GDOI",
    "853": "DNS query-response protocol run over DTLS or QUIC",
    "854": "Dynamic Link Exchange Protocol (DLEP)",
    "860": "iSCSI",
    "861": "OWAMP-Test",
    "862": "TWAMP-Test Receiver Port",
    "873": "rsync",
    "886": "ICL coNETion locate server",
    "887": "ICL coNETion server info",
    "887": "ICL coNETion server info",
    "888": "AccessBuilder",
    "900": "OMG Initial Refs",
    "901": "SMPNAMERES",
    "902": "self documenting Door: send 0x00 for info",
    "903": "self documenting Panic Door: send 0x00 for info",
    "910": "Kerberized Internet Negotiation of Keys (KINK)",
    "911": "xact-backup",
    "912": "APEX relay-relay service",
    "913": "APEX endpoint-relay service",
    "914": "Routing in Fat Trees Link Information Elements ",
    "915": "Routing in Fat Trees Topology Information Elements ",
    "953": "Reserved",
    "989": "ftp protocol, data, over TLS/SSL",
    "990": "ftp protocol, control, over TLS/SSL",
    "991": "Netnews Administration System",
    "992": "telnet protocol over TLS/SSL",
    "993": "Reserved",
    "994": "Reserved",
    "995": "pop3 protocol over TLS/SSL (was spop3)",
    "996": "vsinet",
    "997": "",
    "998": "",
    "999": "Applix ac",
    "1000": "",
    "1001": "Reserved",
    "1008": "Possibly used by Sun Solaris????",
    "1010": "surf",
    "1021": "RFC3692-style Experiment 1",
    "1022": "RFC3692-style Experiment 2",
    "1023": "Reserved",
    "1024": "Reserved",
    "1025": "network blackjack",
    "1026": "Calendar Access Protocol",
    "1027": "IPv6 Behind NAT44 CPEs",
    "1029": "Solid Mux Server",
    "1033": "local netinfo port",
    "1034": "ActiveSync Notifications",
    "1035": "MX-XR RPC",
    "1036": "Nebula Secure Segment Transfer Protocol",
    "1037": "AMS",
    "1038": "Message Tracking Query Protocol",
    "1039": "Streamlined Blackhole",
    "1040": "Netarx Netcare",
    "1041": "AK2 Product",
    "1042": "Subnet Roaming",
    "1043": "BOINC Client Control",
    "1044": "Dev Consortium Utility",
    "1045": "Fingerprint Image Transfer Protocol",
    "1046": "WebFilter Remote Monitor",
    "1047": "Sun's NEO Object Request Broker",
    "1048": "Sun's NEO Object Request Broker",
    "1049": "Tobit David Postman VPMN",
    "1050": "CORBA Management Agent",
    "1051": "Optima VNET",
    "1052": "Dynamic DNS Tools",
    "1053": "Remote Assistant (RA)",
    "1054": "BRVREAD",
    "1055": "ANSYS - License Manager",
    "1056": "VFO",
    "1057": "STARTRON",
    "1058": "nim",
    "1059": "nimreg",
    "1060": "POLESTAR",
    "1061": "KIOSK",
    "1062": "Veracity",
    "1063": "KyoceraNetDev",
    "1064": "JSTEL",
    "1065": "SYSCOMLAN",
    "1066": "FPO-FNS",
    "1067": "Installation Bootstrap Proto. Serv.",
    "1067": "Installation Bootstrap Proto. Serv.",
    "1068": "Installation Bootstrap Proto. Cli.",
    "1068": "Installation Bootstrap Proto. Cli.",
    "1069": "COGNEX-INSIGHT",
    "1070": "GMRUpdateSERV",
    "1071": "BSQUARE-VOIP",
    "1072": "CARDAX",
    "1073": "Bridge Control",
    "1074": "Warmspot Management Protocol",
    "1075": "RDRMSHC",
    "1076": "DAB STI-C",
    "1077": "IMGames",
    "1078": "Avocent Proxy Protocol",
    "1079": "ASPROVATalk",
    "1080": "Socks",
    "1081": "PVUNIWIEN",
    "1082": "AMT-ESD-PROT",
    "1083": "Anasoft License Manager",
    "1084": "Anasoft License Manager",
    "1085": "Web Objects",
    "1086": "CPL Scrambler Logging",
    "1087": "CPL Scrambler Internal",
    "1088": "CPL Scrambler Alarm Log",
    "1089": "FF Annunciation",
    "1090": "FF Fieldbus Message Specification",
    "1091": "FF System Management",
    "1092": "Open Business Reporting Protocol",
    "1093": "PROOFD",
    "1094": "ROOTD",
    "1095": "NICELink",
    "1096": "Common Name Resolution Protocol",
    "1097": "Sun Cluster Manager",
    "1098": "RMI Activation",
    "1099": "RMI Registry",
    "1100": "MCTP",
    "1101": "PT2-DISCOVER",
    "1102": "ADOBE SERVER 1",
    "1103": "ADOBE SERVER 2",
    "1104": "XRL",
    "1105": "FTRANHC",
    "1106": "ISOIPSIGPORT-1",
    "1107": "ISOIPSIGPORT-2",
    "1108": "ratio-adp",
    "1110": "Client status info",
    "1111": "LM Social Server",
    "1112": "Intelligent Communication Protocol",
    "1113": "Licklider Transmission Protocol",
    "1114": "Mini SQL",
    "1115": "ARDUS Transfer",
    "1116": "ARDUS Control",
    "1117": "ARDUS Multicast Transfer",
    "1118": "SACRED",
    "1119": "Battle.net Chat/Game Protocol",
    "1120": "Battle.net File Transfer Protocol",
    "1121": "Datalode RMPP",
    "1122": "availant-mgr",
    "1123": "Murray",
    "1124": "HP VMM Control",
    "1125": "HP VMM Agent",
    "1126": "HP VMM Agent",
    "1127": "KWDB Remote Communication",
    "1128": "SAPHostControl over SOAP/HTTP",
    "1129": "SAPHostControl over SOAP/HTTPS",
    "1130": "CAC App Service Protocol",
    "1131": "CAC App Service Protocol Encripted",
    "1132": "KVM-via-IP Management Service",
    "1133": "Data Flow Network",
    "1134": "MicroAPL APLX",
    "1135": "OmniVision Communication Service",
    "1136": "HHB Gateway Control",
    "1137": "TRIM Workgroup Service",
    "1138": "encrypted admin requests",
    "1138": "encrypted admin requests",
    "1139": "Enterprise Virtual Manager",
    "1140": "AutoNOC Network Operations Protocol",
    "1141": "User Message Service",
    "1142": "User Discovery Service",
    "1143": "Infomatryx Exchange",
    "1144": "Fusion Script",
    "1145": "X9 iCue Show Control",
    "1146": "audit transfer",
    "1147": "CAPIoverLAN",
    "1148": "Elfiq Replication Service",
    "1149": "BlueView Sonar Service",
    "1150": "Blaze File Server",
    "1151": "Unizensus Login Server",
    "1152": "Winpopup LAN Messenger",
    "1153": "ANSI C12.22 Port",
    "1154": "Community Service",
    "1155": "Network File Access",
    "1156": "iasControl OMS",
    "1157": "Oracle iASControl",
    "1158": "dbControl OMS",
    "1159": "Oracle OMS",
    "1160": "DB Lite Mult-User Server",
    "1161": "Health Polling",
    "1162": "Health Trap",
    "1163": "SmartDialer Data Protocol",
    "1164": "QSM Proxy Service",
    "1165": "QSM GUI Service",
    "1166": "QSM RemoteExec",
    "1167": "Cisco IP SLAs Control Protocol",
    "1168": "VChat Conference Service",
    "1169": "TRIPWIRE",
    "1170": "AT+C License Manager",
    "1171": "AT+C FmiApplicationServer",
    "1172": "DNA Protocol",
    "1173": "D-Cinema Request-Response",
    "1174": "FlashNet Remote Admin",
    "1175": "Dossier Server",
    "1176": "Indigo Home Server",
    "1177": "DKMessenger Protocol",
    "1178": "SGI Storage Manager",
    "1179": "Backup To Neighbor",
    "1180": "Millicent Client Proxy",
    "1181": "3Com Net Management",
    "1182": "AcceleNet Data",
    "1183": "LL Surfup HTTP",
    "1184": "LL Surfup HTTPS",
    "1185": "Catchpole port",
    "1186": "MySQL Cluster Manager",
    "1187": "Alias Service",
    "1188": "HP Web Admin",
    "1189": "Unet Connection",
    "1190": "CommLinx GPS / AVL System",
    "1191": "General Parallel File System",
    "1192": "caids sensors channel",
    "1193": "Five Across Server",
    "1194": "OpenVPN",
    "1195": "RSF-1 clustering",
    "1196": "Network Magic",
    "1197": "Carrius Remote Access",
    "1198": "cajo reference discovery",
    "1199": "DMIDI",
    "1200": "SCOL",
    "1201": "Nucleus Sand Database Server",
    "1202": "caiccipc",
    "1203": "License Validation",
    "1204": "Log Request Listener",
    "1205": "Accord-MGC",
    "1206": "Anthony Data",
    "1207": "MetaSage",
    "1208": "SEAGULL AIS",
    "1209": "IPCD3",
    "1210": "EOSS",
    "1211": "Groove DPP",
    "1212": "lupa",
    "1213": "Medtronic/Physio-Control LIFENET",
    "1214": "KAZAA",
    "1215": "scanSTAT 1.0",
    "1216": "ETEBAC 5",
    "1217": "HPSS NonDCE Gateway",
    "1218": "AeroFlight-ADs",
    "1219": "AeroFlight-Ret",
    "1220": "QT SERVER ADMIN",
    "1221": "SweetWARE Apps",
    "1222": "SNI R&amp;D network",
    "1223": "TrulyGlobal Protocol",
    "1224": "VPNz",
    "1225": "SLINKYSEARCH",
    "1226": "STGXFWS",
    "1227": "DNS2Go",
    "1228": "FLORENCE",
    "1229": "ZENworks Tiered Electronic Distribution",
    "1230": "Periscope",
    "1231": "menandmice-lpm",
    "1232": "Remote systems monitoring",
    "1233": "Universal App Server",
    "1234": "Infoseek Search Agent",
    "1235": "mosaicsyssvc1",
    "1236": "bvcontrol",
    "1237": "tsdos390",
    "1238": "hacl-qs",
    "1239": "NMSD",
    "1240": "Instantia",
    "1241": "nessus",
    "1242": "NMAS over IP",
    "1243": "SerialGateway",
    "1244": "isbconference1",
    "1245": "isbconference2",
    "1246": "payrouter",
    "1247": "VisionPyramid",
    "1248": "hermes",
    "1249": "Mesa Vista Co",
    "1250": "swldy-sias",
    "1251": "servergraph",
    "1252": "bspne-pcc",
    "1253": "q55-pcc",
    "1254": "de-noc",
    "1255": "de-cache-query",
    "1256": "de-server",
    "1257": "Shockwave 2",
    "1258": "Open Network Library",
    "1259": "Open Network Library Voice",
    "1260": "ibm-ssd",
    "1261": "mpshrsv",
    "1262": "QNTS-ORB",
    "1263": "dka",
    "1264": "PRAT",
    "1265": "DSSIAPI",
    "1266": "DELLPWRAPPKS",
    "1267": "eTrust Policy Compliance",
    "1268": "PROPEL-MSGSYS",
    "1269": "WATiLaPP",
    "1270": "Microsoft Operations Manager",
    "1271": "eXcW",
    "1272": "CSPMLockMgr",
    "1273": "EMC-Gateway",
    "1274": "t1distproc",
    "1275": "ivcollector",
    "1276": "Reserved",
    "1277": "mqs",
    "1278": "Dell Web Admin 1",
    "1279": "Dell Web Admin 2",
    "1280": "Pictrography",
    "1281": "healthd",
    "1282": "Emperion",
    "1283": "Product Information",
    "1284": "IEE-QFX",
    "1285": "neoiface",
    "1286": "netuitive",
    "1287": "RouteMatch Com",
    "1288": "NavBuddy",
    "1289": "JWalkServer",
    "1290": "WinJaServer",
    "1291": "SEAGULLLMS",
    "1292": "dsdn",
    "1293": "PKT-KRB-IPSec",
    "1294": "CMMdriver",
    "1295": "End-by-Hop Transmission Protocol",
    "1296": "dproxy",
    "1297": "sdproxy",
    "1298": "lpcp",
    "1299": "hp-sci",
    "1300": "H.323 Secure Call Control Signalling",
    "1301": "Reserved",
    "1302": "Reserved",
    "1303": "sftsrv",
    "1304": "Boomerang",
    "1305": "pe-mike",
    "1306": "RE-Conn-Proto",
    "1307": "Pacmand",
    "1308": "Optical Domain Service Interconnect (ODSI)",
    "1309": "JTAG server",
    "1310": "Husky",
    "1311": "RxMon",
    "1312": "STI Envision",
    "1313": "BMC_PATROLDB",
    "1313": "BMC_PATROLDB",
    "1314": "Photoscript Distributed Printing System",
    "1315": "E.L.S., Event Listener Service",
    "1316": "Exbit-ESCP",
    "1317": "vrts-ipcserver",
    "1318": "krb5gatekeeper",
    "1319": "AMX-ICSP",
    "1320": "AMX-AXBNET",
    "1321": "PIP",
    "1322": "Novation",
    "1323": "brcd",
    "1324": "delta-mcp",
    "1325": "DX-Instrument",
    "1326": "WIMSIC",
    "1327": "Ultrex",
    "1328": "EWALL",
    "1329": "netdb-export",
    "1330": "StreetPerfect",
    "1331": "intersan",
    "1332": "PCIA RXP-B",
    "1333": "Password Policy",
    "1334": "writesrv",
    "1335": "Digital Notary Protocol",
    "1336": "Instant Service Chat",
    "1337": "menandmice DNS",
    "1338": "WMC-log-svr",
    "1339": "kjtsiteserver",
    "1340": "NAAP",
    "1341": "QuBES",
    "1342": "ESBroker",
    "1343": "re101",
    "1344": "ICAP",
    "1345": "VPJP",
    "1346": "Alta Analytics License Manager",
    "1347": "multi media conferencing",
    "1348": "multi media conferencing",
    "1349": "Registration Network Protocol",
    "1350": "Registration Network Protocol",
    "1351": "Digital Tool Works (MIT)",
    "1352": "Lotus Note",
    "1353": "Relief Consulting",
    "1354": "Five Across XSIP Network",
    "1355": "Intuitive Edge",
    "1356": "CuillaMartin Company",
    "1357": "Electronic PegBoard",
    "1358": "CONNLCLI",
    "1359": "FTSRV",
    "1360": "MIMER",
    "1361": "LinX",
    "1362": "TimeFlies",
    "1363": "Network DataMover Requester",
    "1364": "Network DataMover Server",
    "1365": "Network Software Associates",
    "1366": "Novell NetWare Comm Service Platform",
    "1367": "DCS",
    "1368": "ScreenCast",
    "1369": "GlobalView to Unix Shell",
    "1370": "Unix Shell to GlobalView",
    "1371": "Fujitsu Config Protocol",
    "1372": "Fujitsu Config Protocol",
    "1373": "Chromagrafx",
    "1374": "EPI Software Systems",
    "1375": "Bytex",
    "1376": "IBM Person to Person Software",
    "1377": "Cichlid License Manager",
    "1378": "Elan License Manager",
    "1379": "Integrity Solutions",
    "1380": "Telesis Network License Manager",
    "1381": "Apple Network License Manager",
    "1382": "udt_os",
    "1382": "udt_os",
    "1383": "GW Hannaway Network License Manager",
    "1384": "Objective Solutions License Manager",
    "1385": "Atex Publishing License Manager",
    "1385": "Atex Publishing License Manager",
    "1386": "CheckSum License Manager",
    "1387": "Computer Aided Design Software Inc LM",
    "1388": "Objective Solutions DataBase Cache",
    "1389": "Document Manager",
    "1390": "Storage Controller",
    "1391": "Storage Access Server",
    "1392": "Print Manager",
    "1393": "Network Log Server",
    "1394": "Network Log Client",
    "1395": "PC Workstation Manager software",
    "1396": "DVL Active Mail",
    "1397": "Audio Active Mail",
    "1398": "Video Active Mail",
    "1399": "Cadkey License Manager",
    "1400": "Cadkey Tablet Daemon",
    "1401": "Goldleaf License Manager",
    "1402": "Prospero Resource Manager",
    "1403": "Prospero Resource Manager",
    "1404": "Infinite Graphics License Manager",
    "1405": "IBM Remote Execution Starter",
    "1406": "NetLabs License Manager",
    "1407": "Reserved",
    "1408": "Sophia License Manager",
    "1409": "Here License Manager",
    "1410": "HiQ License Manager",
    "1411": "AudioFile",
    "1412": "InnoSys",
    "1413": "Innosys-ACL",
    "1414": "IBM MQSeries",
    "1415": "DBStar",
    "1416": "Novell LU6.2",
    "1416": "Novell LU6.2",
    "1417": "Timbuktu Service 1 Port",
    "1418": "Timbuktu Service 2 Port",
    "1419": "Timbuktu Service 3 Port",
    "1420": "Timbuktu Service 4 Port",
    "1421": "Gandalf License Manager",
    "1422": "Autodesk License Manager",
    "1423": "Essbase Arbor Software",
    "1424": "Hybrid Encryption Protocol",
    "1425": "Zion Software License Manager",
    "1426": "Satellite-data Acquisition System 1",
    "1427": "mloadd monitoring tool",
    "1428": "Informatik License Manager",
    "1429": "Hypercom NMS",
    "1430": "Hypercom TPDU",
    "1431": "Reverse Gossip Transport",
    "1432": "Blueberry Software License Manager",
    "1433": "Microsoft-SQL-Server",
    "1434": "Microsoft-SQL-Monitor",
    "1435": "IBM CICS",
    "1436": "Satellite-data Acquisition System 2",
    "1437": "Tabula",
    "1438": "Eicon Security Agent/Server",
    "1439": "Eicon X25/SNA Gateway",
    "1440": "Eicon Service Location Protocol",
    "1441": "Cadis License Management",
    "1442": "Cadis License Management",
    "1443": "Integrated Engineering Software",
    "1444": "Marcam  License Management",
    "1445": "Proxima License Manager",
    "1446": "Optical Research Associates License Manager",
    "1447": "Applied Parallel Research LM",
    "1448": "OpenConnect License Manager",
    "1449": "PEport",
    "1450": "Tandem Distributed Workbench Facility",
    "1451": "IBM Information Management",
    "1452": "GTE Government Systems License Man",
    "1453": "Genie License Manager",
    "1454": "interHDL License Manager",
    "1454": "interHDL License Manager",
    "1455": "ESL License Manager",
    "1456": "DCA",
    "1457": "Valisys License Manager",
    "1458": "Nichols Research Corp.",
    "1459": "Proshare Notebook Application",
    "1460": "Proshare Notebook Application",
    "1461": "IBM Wireless LAN",
    "1461": "IBM Wireless LAN",
    "1462": "World License Manager",
    "1463": "Nucleus",
    "1464": "MSL License Manager",
    "1464": "MSL License Manager",
    "1465": "Pipes Platform",
    "1466": "Ocean Software License Manager",
    "1467": "CSDMBASE",
    "1468": "CSDM",
    "1469": "Active Analysis Limited License Manager",
    "1470": "Universal Analytics",
    "1471": "csdmbase",
    "1472": "csdm",
    "1473": "OpenMath",
    "1474": "Telefinder",
    "1475": "Taligent License Manager",
    "1476": "clvm-cfg",
    "1477": "ms-sna-server",
    "1478": "ms-sna-base",
    "1479": "dberegister",
    "1480": "PacerForum",
    "1481": "AIRS",
    "1482": "Miteksys License Manager",
    "1483": "AFS License Manager",
    "1484": "Confluent License Manager",
    "1485": "LANSource",
    "1486": "nms_topo_serv",
    "1486": "nms_topo_serv",
    "1487": "LocalInfoSrvr",
    "1488": "DocStor",
    "1489": "dmdocbroker",
    "1490": "insitu-conf",
    "1492": "stone-design-1",
    "1493": "netmap_lm",
    "1493": "netmap_lm",
    "1494": "ica",
    "1495": "cvc",
    "1496": "liberty-lm",
    "1497": "rfx-lm",
    "1498": "Sybase SQL Any",
    "1499": "Federico Heinz Consultora",
    "1500": "VLSI License Manager",
    "1501": "Satellite-data Acquisition System 3",
    "1502": "Shiva",
    "1503": "Databeam",
    "1504": "EVB Software Engineering License Manager",
    "1505": "Funk Software, Inc.",
    "1506": "Universal Time daemon (utcd)",
    "1507": "symplex",
    "1508": "diagmond",
    "1509": "Robcad, Ltd. License Manager",
    "1510": "Midland Valley Exploration Ltd. Lic. Man.",
    "1511": "3l-l1",
    "1512": "Microsoft's Windows Internet Name Service",
    "1513": "Fujitsu Systems Business of America, Inc",
    "1514": "Fujitsu Systems Business of America, Inc",
    "1515": "ifor-protocol",
    "1516": "Virtual Places Audio data",
    "1517": "Virtual Places Audio control",
    "1518": "Virtual Places Video data",
    "1519": "Virtual Places Video control",
    "1520": "atm zip office",
    "1521": "nCube License Manager",
    "1522": "Ricardo North America License Manager",
    "1523": "cichild",
    "1524": "ingres",
    "1525": "oracle",
    "1526": "Prospero Data Access Prot non-priv",
    "1527": "oracle",
    "1528": "Not Only a Routeing Protocol",
    "1529": "oracle",
    "1530": "rap-service",
    "1531": "rap-listen",
    "1532": "miroconnect",
    "1533": "Virtual Places Software",
    "1534": "micromuse-lm",
    "1535": "ampr-info",
    "1536": "ampr-inter",
    "1537": "isi-lm",
    "1538": "3ds-lm",
    "1539": "Intellistor License Manager",
    "1540": "rds",
    "1541": "rds2",
    "1542": "gridgen-elmd",
    "1543": "simba-cs",
    "1544": "aspeclmd",
    "1545": "vistium-share",
    "1546": "abbaccuray",
    "1547": "laplink",
    "1548": "Axon License Manager",
    "1549": "Shiva Sound",
    "1550": "Image Storage license manager 3M Company",
    "1551": "HECMTL-DB",
    "1552": "pciarray",
    "1553": "sna-cs",
    "1554": "CACI Products Company License Manager",
    "1555": "livelan",
    "1556": "VERITAS Private Branch Exchange",
    "1556": "VERITAS Private Branch Exchange",
    "1557": "ArborText License Manager",
    "1558": "xingmpeg",
    "1559": "web2host",
    "1560": "ASCI-RemoteSHADOW",
    "1561": "facilityview",
    "1562": "pconnectmgr",
    "1563": "Cadabra License Manager",
    "1564": "Pay-Per-View",
    "1565": "WinDD",
    "1566": "CORELVIDEO",
    "1567": "jlicelmd",
    "1568": "tsspmap",
    "1569": "ets",
    "1570": "orbixd",
    "1571": "Oracle Remote Data Base",
    "1572": "Chipcom License Manager",
    "1573": "itscomm-ns",
    "1574": "mvel-lm",
    "1575": "oraclenames",
    "1576": "Moldflow License Manager",
    "1577": "hypercube-lm",
    "1578": "Jacobus License Manager",
    "1579": "ioc-sea-lm",
    "1580": "tn-tl-r2",
    "1581": "MIL-2045-47001",
    "1582": "MSIMS",
    "1583": "simbaexpress",
    "1584": "tn-tl-fd2",
    "1585": "intv",
    "1586": "ibm-abtact",
    "1587": "pra_elmd",
    "1587": "pra_elmd",
    "1588": "triquest-lm",
    "1589": "VQP",
    "1590": "gemini-lm",
    "1591": "ncpm-pm",
    "1592": "commonspace",
    "1593": "mainsoft-lm",
    "1594": "sixtrak",
    "1595": "radio",
    "1596": "radio-bc",
    "1597": "orbplus-iiop",
    "1598": "picknfs",
    "1599": "simbaservices",
    "1600": "issd",
    "1601": "aas",
    "1602": "inspect",
    "1603": "pickodbc",
    "1604": "icabrowser",
    "1605": "Salutation Manager (Salutation Protocol)",
    "1606": "Salutation Manager (SLM-API)",
    "1607": "stt",
    "1608": "Smart Corp. License Manager",
    "1609": "isysg-lm",
    "1610": "taurus-wh",
    "1611": "Inter Library Loan",
    "1612": "NetBill Transaction Server",
    "1613": "NetBill Key Repository",
    "1614": "NetBill Credential Server",
    "1615": "NetBill Authorization Server",
    "1616": "NetBill Product Server",
    "1617": "Nimrod Inter-Agent Communication",
    "1618": "skytelnet",
    "1619": "xs-openstorage",
    "1620": "faxportwinport",
    "1621": "softdataphone",
    "1622": "ontime",
    "1623": "jaleosnd",
    "1624": "udp-sr-port",
    "1625": "svs-omagent",
    "1626": "Shockwave",
    "1627": "T.128 Gateway",
    "1628": "LonTalk normal",
    "1629": "LonTalk urgent",
    "1630": "Oracle Net8 Cman",
    "1631": "Visit view",
    "1632": "PAMMRATC",
    "1633": "PAMMRPC",
    "1634": "Log On America Probe",
    "1635": "EDB Server 1",
    "1636": "ISP shared public data control",
    "1637": "ISP shared local data control",
    "1638": "ISP shared management control",
    "1639": "cert-initiator",
    "1640": "cert-responder",
    "1641": "InVision",
    "1642": "isis-am",
    "1643": "isis-ambc",
    "1644": "Satellite-data Acquisition System 4",
    "1645": "SightLine",
    "1646": "sa-msg-port",
    "1647": "rsap",
    "1648": "concurrent-lm",
    "1649": "kermit",
    "1650": "nkd",
    "1651": "shiva_confsrvr",
    "1651": "shiva_confsrvr",
    "1652": "xnmp",
    "1653": "alphatech-lm",
    "1654": "stargatealerts",
    "1655": "dec-mbadmin",
    "1656": "dec-mbadmin-h",
    "1657": "fujitsu-mmpdc",
    "1658": "sixnetudr",
    "1659": "Silicon Grail License Manager",
    "1660": "skip-mc-gikreq",
    "1661": "netview-aix-1",
    "1662": "netview-aix-2",
    "1663": "netview-aix-3",
    "1664": "netview-aix-4",
    "1665": "netview-aix-5",
    "1666": "netview-aix-6",
    "1667": "netview-aix-7",
    "1668": "netview-aix-8",
    "1669": "netview-aix-9",
    "1670": "netview-aix-10",
    "1671": "netview-aix-11",
    "1672": "netview-aix-12",
    "1673": "Intel Proshare Multicast",
    "1674": "Intel Proshare Multicast",
    "1675": "Pacific Data Products",
    "1676": "netcomm2",
    "1677": "groupwise",
    "1678": "prolink",
    "1679": "darcorp-lm",
    "1680": "microcom-sbp",
    "1681": "sd-elmd",
    "1682": "lanyon-lantern",
    "1683": "ncpm-hip",
    "1684": "SnareSecure",
    "1685": "n2nremote",
    "1686": "cvmon",
    "1687": "nsjtp-ctrl",
    "1688": "nsjtp-data",
    "1689": "firefox",
    "1690": "ng-umds",
    "1691": "empire-empuma",
    "1692": "sstsys-lm",
    "1693": "rrirtr",
    "1694": "rrimwm",
    "1695": "rrilwm",
    "1696": "rrifmm",
    "1697": "rrisat",
    "1698": "RSVP-ENCAPSULATION-1",
    "1699": "RSVP-ENCAPSULATION-2",
    "1700": "mps-raft",
    "1701": "l2f",
    "1702": "deskshare",
    "1703": "hb-engine",
    "1704": "bcs-broker",
    "1705": "slingshot",
    "1706": "jetform",
    "1707": "vdmplay",
    "1708": "gat-lmd",
    "1709": "centra",
    "1710": "impera",
    "1711": "pptconference",
    "1712": "resource monitoring service",
    "1713": "ConferenceTalk",
    "1714": "sesi-lm",
    "1715": "houdini-lm",
    "1716": "xmsg",
    "1717": "fj-hdnet",
    "1718": "H.323 Multicast Gatekeeper Discover",
    "1719": "H.323 Unicast Gatekeeper Signaling",
    "1720": "H.323 Call Control Signalling",
    "1721": "caicci",
    "1722": "HKS License Manager",
    "1723": "pptp",
    "1724": "csbphonemaster",
    "1725": "iden-ralp",
    "1726": "IBERIAGAMES",
    "1727": "winddx",
    "1728": "TELINDUS",
    "1729": "CityNL License Management",
    "1730": "roketz",
    "1731": "MSICCP",
    "1732": "proxim",
    "1733": "SIMS - SIIPAT Protocol for Alarm Transmission",
    "1734": "Camber Corporation License Management",
    "1735": "PrivateChat",
    "1736": "street-stream",
    "1737": "ultimad",
    "1738": "GameGen1",
    "1739": "webaccess",
    "1740": "encore",
    "1741": "cisco-net-mgmt",
    "1742": "3Com-nsd",
    "1743": "Cinema Graphics License Manager",
    "1744": "ncpm-ft",
    "1745": "remote-winsock",
    "1746": "ftrapid-1",
    "1747": "ftrapid-2",
    "1748": "oracle-em1",
    "1749": "aspen-services",
    "1750": "Simple Socket Library's PortMaster",
    "1751": "SwiftNet",
    "1752": "Leap of Faith Research License Manager",
    "1753": "Reserved",
    "1754": "oracle-em2",
    "1755": "ms-streaming",
    "1756": "capfast-lmd",
    "1757": "cnhrp",
    "1758": "tftp-mcast",
    "1759": "SPSS License Manager",
    "1760": "www-ldap-gw",
    "1761": "cft-0",
    "1762": "cft-1",
    "1763": "cft-2",
    "1764": "cft-3",
    "1765": "cft-4",
    "1766": "cft-5",
    "1767": "cft-6",
    "1768": "cft-7",
    "1769": "bmc-net-adm",
    "1770": "bmc-net-svc",
    "1771": "vaultbase",
    "1772": "EssWeb Gateway",
    "1773": "KMSControl",
    "1774": "global-dtserv",
    "1775": "Reserved",
    "1776": "Federal Emergency Management Information System",
    "1777": "powerguardian",
    "1778": "prodigy-internet",
    "1779": "pharmasoft",
    "1780": "dpkeyserv",
    "1781": "answersoft-lm",
    "1782": "hp-hcip",
    "1784": "Finle License Manager",
    "1785": "Wind River Systems License Manager",
    "1786": "funk-logger",
    "1787": "funk-license",
    "1788": "psmond",
    "1789": "hello",
    "1790": "Narrative Media Streaming Protocol",
    "1791": "EA1",
    "1792": "ibm-dt-2",
    "1793": "rsc-robot",
    "1794": "cera-bcm",
    "1795": "dpi-proxy",
    "1796": "Vocaltec Server Administration",
    "1797": "UMA",
    "1798": "Event Transfer Protocol",
    "1799": "NETRISK",
    "1800": "ANSYS-License manager",
    "1801": "Microsoft Message Que",
    "1802": "ConComp1",
    "1803": "HP-HCIP-GWY",
    "1804": "ENL",
    "1805": "ENL-Name",
    "1806": "Musiconline",
    "1807": "Fujitsu Hot Standby Protocol",
    "1808": "Oracle-VP2",
    "1809": "Oracle-VP1",
    "1810": "Jerand License Manager",
    "1811": "Scientia-SDB",
    "1812": "RADIUS",
    "1813": "RADIUS Accounting",
    "1814": "TDP Suite",
    "1815": "MMPFT",
    "1816": "HARP",
    "1817": "RKB-OSCS",
    "1818": "Enhanced Trivial File Transfer Protocol",
    "1819": "Plato License Manager",
    "1820": "mcagent",
    "1821": "donnyworld",
    "1822": "es-elmd",
    "1823": "Unisys Natural Language License Manager",
    "1824": "metrics-pas",
    "1825": "DirecPC Video",
    "1826": "ARDT",
    "1827": "ASI",
    "1828": "itm-mcell-u",
    "1829": "Optika eMedia",
    "1830": "Oracle Net8 CMan Admin",
    "1831": "Myrtle",
    "1832": "ThoughtTreasure",
    "1833": "udpradio",
    "1834": "ARDUS Unicast",
    "1835": "ARDUS Multicast",
    "1836": "ste-smsc",
    "1837": "csoft1",
    "1838": "TALNET",
    "1839": "netopia-vo1",
    "1840": "netopia-vo2",
    "1841": "netopia-vo3",
    "1842": "netopia-vo4",
    "1843": "netopia-vo5",
    "1844": "DirecPC-DLL",
    "1845": "altalink",
    "1846": "Tunstall PNC",
    "1847": "SLP Notification",
    "1848": "fjdocdist",
    "1849": "ALPHA-SMS",
    "1850": "GSI",
    "1851": "ctcd",
    "1852": "Virtual Time",
    "1853": "VIDS-AVTP",
    "1854": "Buddy Draw",
    "1855": "Fiorano RtrSvc",
    "1856": "Fiorano MsgSvc",
    "1857": "DataCaptor",
    "1858": "PrivateArk",
    "1859": "Gamma Fetcher Server",
    "1860": "SunSCALAR Services",
    "1861": "LeCroy VICP",
    "1862": "MySQL Cluster Manager Agent",
    "1863": "MSNP",
    "1864": "Paradym 31 Port",
    "1865": "ENTP",
    "1866": "swrmi",
    "1867": "UDRIVE",
    "1868": "VizibleBrowser",
    "1869": "TransAct",
    "1870": "SunSCALAR DNS Service",
    "1871": "Cano Central 0",
    "1872": "Cano Central 1",
    "1873": "Fjmpjps",
    "1874": "Fjswapsnp",
    "1875": "westell stats",
    "1876": "ewcappsrv",
    "1877": "hp-webqosdb",
    "1878": "drmsmc",
    "1879": "NettGain NMS",
    "1880": "Gilat VSAT Control",
    "1881": "IBM WebSphere MQ Everyplace",
    "1882": "CA eTrust Common Services",
    "1883": "Message Queuing Telemetry Transport Protocol",
    "1884": "Internet Distance Map Svc",
    "1885": "Veritas Trap Server",
    "1886": "Leonardo over IP",
    "1887": "FileX Listening Port",
    "1888": "NC Config Port",
    "1889": "Unify Web Adapter Service",
    "1890": "wilkenListener",
    "1891": "ChildKey Notification",
    "1892": "ChildKey Control",
    "1893": "ELAD Protocol",
    "1894": "O2Server Port",
    "1895": "unassigned",
    "1896": "b-novative license server",
    "1897": "MetaAgent",
    "1898": "Cymtec secure management",
    "1899": "MC2Studios",
    "1900": "SSDP",
    "1901": "Fujitsu ICL Terminal Emulator Program A",
    "1902": "Fujitsu ICL Terminal Emulator Program B",
    "1903": "Local Link Name Resolution",
    "1904": "Fujitsu ICL Terminal Emulator Program C",
    "1905": "Secure UP.Link Gateway Protocol",
    "1906": "TPortMapperReq",
    "1907": "IntraSTAR",
    "1908": "Dawn",
    "1909": "Global World Link",
    "1910": "UltraBac Software communications port",
    "1911": "Starlight Networks Multimedia Transport Protocol",
    "1912": "rhp-iibp",
    "1913": "armadp",
    "1914": "Elm-Momentum",
    "1915": "FACELINK",
    "1916": "Persoft Persona",
    "1917": "nOAgent",
    "1918": "IBM Tivole Directory Service - NDS",
    "1919": "IBM Tivoli Directory Service - DCH",
    "1920": "IBM Tivoli Directory Service - FERRET",
    "1921": "NoAdmin",
    "1922": "Tapestry",
    "1923": "SPICE",
    "1924": "XIIP",
    "1925": "Surrogate Discovery Port",
    "1926": "Evolution Game Server",
    "1927": "Videte CIPC Port",
    "1928": "Expnd Maui Srvr Dscovr",
    "1929": "Bandwiz System - Server",
    "1930": "Drive AppServer",
    "1931": "AMD SCHED",
    "1932": "CTT Broker",
    "1933": "IBM LM MT Agent",
    "1934": "IBM LM Appl Agent",
    "1935": "Macromedia Flash Communications server MX",
    "1936": "JetCmeServer Server Port",
    "1937": "JetVWay Server Port",
    "1938": "JetVWay Client Port",
    "1939": "JetVision Server Port",
    "1940": "JetVision Client Port",
    "1941": "DIC-Aida",
    "1942": "Real Enterprise Service",
    "1943": "Beeyond Media",
    "1944": "close-combat",
    "1945": "dialogic-elmd",
    "1946": "tekpls",
    "1947": "SentinelSRM",
    "1948": "eye2eye",
    "1949": "ISMA Easdaq Live",
    "1950": "ISMA Easdaq Test",
    "1951": "bcs-lmserver",
    "1952": "mpnjsc",
    "1953": "Rapid Base",
    "1954": "ABR-API (diskbridge)",
    "1955": "ABR-Secure Data (diskbridge)",
    "1956": "Vertel VMF DS",
    "1957": "unix-status",
    "1958": "CA Administration Daemon",
    "1959": "SIMP Channel",
    "1960": "Merit DAC NASmanager",
    "1961": "BTS APPSERVER",
    "1962": "BIAP-MP",
    "1963": "WebMachine",
    "1964": "SOLID E ENGINE",
    "1965": "Tivoli NPM",
    "1966": "Slush",
    "1967": "SNS Quote",
    "1968": "LIPSinc",
    "1969": "LIPSinc 1",
    "1970": "NetOp Remote Control",
    "1971": "NetOp School",
    "1972": "Cache",
    "1973": "Data Link Switching Remote Access Protocol",
    "1974": "DRP",
    "1975": "TCO Flash Agent",
    "1976": "TCO Reg Agent",
    "1977": "TCO Address Book",
    "1978": "UniSQL",
    "1979": "UniSQL Java",
    "1980": "PearlDoc XACT",
    "1981": "p2pQ",
    "1982": "Evidentiary Timestamp",
    "1983": "Loophole Test Protocol",
    "1984": "BB",
    "1985": "Hot Standby Router Protocol",
    "1986": "cisco license management",
    "1987": "cisco RSRB Priority 1 port",
    "1988": "cisco RSRB Priority 2 port",
    "1989": "cisco RSRB Priority 3 port",
    "1990": "cisco STUN Priority 1 port",
    "1991": "cisco STUN Priority 2 port",
    "1992": "cisco STUN Priority 3 port",
    "1993": "cisco SNMP TCP port",
    "1994": "cisco serial tunnel port",
    "1995": "cisco perf port",
    "1996": "cisco Remote SRB port",
    "1997": "cisco Gateway Discovery Protocol",
    "1998": "cisco X.25 service (XOT)",
    "1999": "cisco identification port",
    "2000": "Cisco SCCp",
    "2001": "curry",
    "2002": "",
    "2003": "Brutus Server",
    "2004": "CCWS mm conf",
    "2005": "",
    "2006": "raid",
    "2007": "",
    "2008": "",
    "2009": "",
    "2010": "",
    "2010": "",
    "2011": "",
    "2012": "",
    "2013": "",
    "2014": "",
    "2015": "",
    "2016": "",
    "2017": "",
    "2018": "",
    "2019": "",
    "2020": "",
    "2021": "",
    "2022": "",
    "2023": "",
    "2024": "",
    "2025": "",
    "2026": "",
    "2027": "",
    "2028": "",
    "2029": "Hot Standby Router Protocol IPv6",
    "2030": "",
    "2031": "mobrien-chat",
    "2032": "",
    "2033": "",
    "2034": "",
    "2035": "",
    "2036": "Ethernet WS DP network",
    "2037": "APplus Application Server",
    "2038": "",
    "2039": "Prizma Monitoring Service",
    "2040": "",
    "2041": "",
    "2042": "isis",
    "2043": "isis-bcast",
    "2044": "",
    "2045": "",
    "2046": "",
    "2047": "",
    "2048": "",
    "2049": "Network File System - Sun Microsystems",
    "2050": "Avaya EMB Config Port",
    "2051": "EPNSDP",
    "2052": "clearVisn Services Port",
    "2053": "Lot105 DSuper Updates",
    "2054": "Weblogin Port",
    "2055": "Iliad-Odyssey Protocol",
    "2056": "OmniSky Port",
    "2057": "Rich Content Protocol",
    "2058": "NewWaveSearchables RMI",
    "2059": "BMC Messaging Service",
    "2060": "Telenium Daemon IF",
    "2061": "NetMount",
    "2062": "ICG SWP Port",
    "2063": "ICG Bridge Port",
    "2064": "ICG IP Relay Port",
    "2065": "Data Link Switch Read Port Number",
    "2066": "AVM USB Remote Architecture",
    "2067": "Data Link Switch Write Port Number",
    "2068": "Avocent AuthSrv Protocol",
    "2069": "HTTP Event Port",
    "2070": "AH and ESP Encapsulated in UDP packet",
    "2071": "Axon Control Protocol",
    "2072": "GlobeCast mSync",
    "2073": "DataReel Database Socket",
    "2074": "Vertel VMF SA",
    "2075": "Newlix ServerWare Engine",
    "2076": "Newlix JSPConfig",
    "2077": "Old Tivoli Storage Manager",
    "2078": "IBM Total Productivity Center Server",
    "2079": "IDWARE Router Port",
    "2080": "Autodesk NLM (FLEXlm)",
    "2081": "KME PRINTER TRAP PORT",
    "2082": "Infowave Mobility Server",
    "2083": "Secure Radius Service",
    "2084": "SunCluster Geographic",
    "2085": "ADA Control",
    "2086": "GNUnet",
    "2087": "ELI - Event Logging Integration",
    "2088": "IP Busy Lamp Field",
    "2089": "Security Encapsulation Protocol - SEP",
    "2090": "Load Report Protocol",
    "2091": "PRP",
    "2092": "Descent 3",
    "2093": "NBX CC",
    "2094": "NBX AU",
    "2095": "NBX SER",
    "2096": "NBX DIR",
    "2097": "Jet Form Preview",
    "2098": "Dialog Port",
    "2099": "H.225.0 Annex G Signalling",
    "2100": "Amiga Network Filesystem",
    "2101": "rtcm-sc104",
    "2102": "Zephyr server",
    "2103": "Zephyr serv-hm connection",
    "2104": "Zephyr hostmanager",
    "2105": "MiniPay",
    "2106": "MZAP",
    "2107": "BinTec Admin",
    "2108": "Comcam",
    "2109": "Ergolight",
    "2110": "UMSP",
    "2111": "OPNET Dynamic Sampling Agent Transaction Protocol",
    "2112": "Idonix MetaNet",
    "2113": "HSL StoRM",
    "2114": "Classical Music Meta-Data Access and Enhancement",
    "2115": "Key Distribution Manager",
    "2116": "CCOWCMR",
    "2117": "MENTACLIENT",
    "2118": "MENTASERVER",
    "2119": "GSIGATEKEEPER",
    "2120": "Quick Eagle Networks CP",
    "2121": "SCIENTIA-SSDB",
    "2122": "CauPC Remote Control",
    "2123": "GTP-Control Plane (3GPP)",
    "2124": "ELATELINK",
    "2125": "LOCKSTEP",
    "2126": "PktCable-COPS",
    "2127": "INDEX-PC-WB",
    "2128": "Net Steward Control",
    "2129": "cs-live.com",
    "2130": "XDS",
    "2131": "Avantageb2b",
    "2132": "SoleraTec End Point Map",
    "2133": "ZYMED-ZPP",
    "2134": "AVENUE",
    "2135": "Grid Resource Information Server",
    "2136": "APPWORXSRV",
    "2137": "CONNECT",
    "2138": "UNBIND-CLUSTER",
    "2139": "IAS-AUTH",
    "2140": "IAS-REG",
    "2141": "IAS-ADMIND",
    "2142": "TDM OVER IP",
    "2143": "Live Vault Job Control",
    "2144": "Live Vault Fast Object Transfer",
    "2145": "Live Vault Remote Diagnostic Console Support",
    "2146": "Live Vault Admin Event Notification",
    "2147": "Live Vault Authentication",
    "2148": "VERITAS UNIVERSAL COMMUNICATION LAYER",
    "2149": "ACPTSYS",
    "2150": "DYNAMIC3D",
    "2151": "DOCENT",
    "2152": "GTP-User Plane (3GPP)",
    "2153": "Control Protocol",
    "2154": "Standard Protocol",
    "2155": "Bridge Protocol",
    "2156": "Talari Reliable Protocol",
    "2157": "Xerox Network Document Scan Protocol",
    "2158": "TouchNetPlus Service",
    "2159": "GDB Remote Debug Port",
    "2160": "APC 2160",
    "2161": "APC 2161",
    "2162": "Navisphere",
    "2163": "Navisphere Secure",
    "2164": "Dynamic DNS Version 3",
    "2165": "X-Bone API",
    "2166": "iwserver",
    "2167": "Raw Async Serial Link",
    "2168": "easy-soft Multiplexer",
    "2169": "Backbone for Academic Information Notification (BRAIN)",
    "2170": "EyeTV Server Port",
    "2171": "MS Firewall Storage",
    "2172": "MS Firewall SecureStorage",
    "2173": "MS Firewall Replication",
    "2174": "MS Firewall Intra Array",
    "2175": "Microsoft Desktop AirSync Protocol",
    "2176": "Microsoft ActiveSync Remote API",
    "2177": "qWAVE Bandwidth Estimate",
    "2178": "Peer Services for BITS",
    "2179": "Microsoft RDP for virtual machines",
    "2180": "Millicent Vendor Gateway Server",
    "2181": "eforward",
    "2182": "CGN status",
    "2183": "Code Green configuration",
    "2184": "NVD User",
    "2185": "OnBase Distributed Disk Services",
    "2186": "Guy-Tek Automated Update Applications",
    "2187": "Sepehr System Management Data",
    "2188": "Reserved",
    "2189": "Reserved",
    "2190": "TiVoConnect Beacon",
    "2191": "TvBus Messaging",
    "2192": "ASDIS software management",
    "2193": "Dr.Web Enterprise Management Service",
    "2197": "MNP data exchange",
    "2198": "OneHome Remote Access",
    "2199": "OneHome Service Port",
    "2200": "Reserved",
    "2201": "Advanced Training System Program",
    "2202": "Int. Multimedia Teleconferencing Cosortium",
    "2203": "b2 Runtime Protocol",
    "2204": "b2 License Server",
    "2205": "Java Presentation Server",
    "2206": "HP OpenCall bus",
    "2207": "HP Status and Services",
    "2208": "HP I/O Backend",
    "2209": "HP RIM for Files Portal Service",
    "2210": "NOAAPORT Broadcast Network",
    "2211": "EMWIN",
    "2212": "LeeCO POS Server Service",
    "2213": "Kali",
    "2214": "RDQ Protocol Interface",
    "2215": "IPCore.co.za GPRS",
    "2216": "VTU data service",
    "2217": "GoToDevice Device Management",
    "2218": "Bounzza IRC Proxy",
    "2219": "NetIQ NCAP Protocol",
    "2220": "NetIQ End2End",
    "2221": "EtherNet/IP over DTLS",
    "2222": "EtherNet/IP I/O",
    "2222": "EtherNet/IP I/O",
    "2223": "Rockwell CSP2",
    "2224": "Easy Flexible Internet/Multiplayer Games",
    "2225": "Reserved",
    "2226": "Digital Instinct DRM",
    "2227": "DI Messaging Service",
    "2228": "eHome Message Server",
    "2229": "DataLens Service",
    "2230": "MetaSoft Job Queue Administration Service",
    "2231": "WiMAX ASN Control Plane Protocol",
    "2232": "IVS Video default",
    "2233": "INFOCRYPT",
    "2234": "DirectPlay",
    "2235": "Sercomm-WLink",
    "2236": "Nani",
    "2237": "Optech Port1 License Manager",
    "2238": "AVIVA SNA SERVER",
    "2239": "Image Query",
    "2240": "RECIPe",
    "2241": "IVS Daemon",
    "2242": "Folio Remote Server",
    "2243": "Magicom Protocol",
    "2244": "NMS Server",
    "2245": "HaO",
    "2246": "PacketCable MTA Addr Map",
    "2247": "Antidote Deployment Manager Service",
    "2248": "User Management Service",
    "2249": "RISO File Manager Protocol",
    "2250": "remote-collab",
    "2251": "Distributed Framework Port",
    "2252": "NJENET using SSL",
    "2253": "DTV Channel Request",
    "2254": "Seismic P.O.C. Port",
    "2255": "VRTP - ViRtue Transfer Protocol",
    "2256": "PCC MFP",
    "2257": "simple text/file transfer",
    "2258": "Rotorcraft Communications Test System",
    "2259": "BIF identifiers resolution service",
    "2260": "APC 2260",
    "2261": "CoMotion Master Server",
    "2262": "CoMotion Backup Server",
    "2263": "ECweb Configuration Service",
    "2264": "Audio Precision Apx500 API Port 1",
    "2265": "Audio Precision Apx500 API Port 2",
    "2266": "M-files Server",
    "2267": "OntoBroker",
    "2268": "AMT",
    "2269": "MIKEY",
    "2270": "starSchool",
    "2271": "Secure Meeting Maker Scheduling",
    "2272": "Meeting Maker Scheduling",
    "2273": "MySQL Instance Manager",
    "2274": "PCTTunneller",
    "2275": "iBridge Conferencing",
    "2276": "iBridge Management",
    "2277": "Bt device control proxy",
    "2278": "Simple Stacked Sequences Database",
    "2279": "xmquery",
    "2280": "LNVPOLLER",
    "2281": "LNVCONSOLE",
    "2282": "LNVALARM",
    "2283": "LNVSTATUS",
    "2284": "LNVMAPS",
    "2285": "LNVMAILMON",
    "2286": "NAS-Metering",
    "2287": "DNA",
    "2288": "NETML",
    "2289": "Lookup dict server",
    "2290": "Sonus Logging Services",
    "2291": "EPSON Advanced Printer Share Protocol",
    "2292": "Sonus Element Management Services",
    "2293": "Network Platform Debug Manager",
    "2294": "Konshus License Manager (FLEX)",
    "2295": "Advant License Manager",
    "2296": "Theta License Manager (Rainbow)",
    "2297": "D2K DataMover 1",
    "2298": "D2K DataMover 2",
    "2299": "PC Telecommute",
    "2300": "CVMMON",
    "2301": "Compaq HTTP",
    "2302": "Bindery Support",
    "2303": "Proxy Gateway",
    "2304": "Attachmate UTS",
    "2305": "MT ScaleServer",
    "2306": "TAPPI BoxNet",
    "2307": "pehelp",
    "2308": "sdhelp",
    "2309": "SD Server",
    "2310": "SD Client",
    "2311": "Message Service",
    "2312": "WANScaler Communication Service",
    "2313": "IAPP (Inter Access Point Protocol)",
    "2314": "CR WebSystems",
    "2315": "Precise Sft.",
    "2316": "SENT License Manager",
    "2317": "Attachmate G32",
    "2318": "Cadence Control",
    "2319": "InfoLibria",
    "2320": "Siebel NS",
    "2321": "RDLAP",
    "2322": "ofsd",
    "2323": "3d-nfsd",
    "2324": "Cosmocall",
    "2325": "ANSYS Licensing Interconnect",
    "2326": "IDCP",
    "2327": "xingcsm",
    "2328": "Netrix SFTM",
    "2329": "NVD",
    "2330": "TSCCHAT",
    "2331": "AGENTVIEW",
    "2332": "RCC Host",
    "2333": "SNAPP",
    "2334": "ACE Client Auth",
    "2335": "ACE Proxy",
    "2336": "Apple UG Control",
    "2337": "ideesrv",
    "2338": "Norton Lambert",
    "2339": "3Com WebView",
    "2340": "WRS Registry",
    "2340": "WRS Registry",
    "2341": "XIO Status",
    "2342": "Seagate Manage Exec",
    "2343": "nati logos",
    "2344": "fcmsys",
    "2345": "dbm",
    "2346": "Game Connection Port",
    "2346": "Game Connection Port",
    "2347": "Game Announcement and Location",
    "2347": "Game Announcement and Location",
    "2348": "Information to query for game status",
    "2348": "Information to query for game status",
    "2349": "Diagnostics Port",
    "2349": "Diagnostics Port",
    "2350": "Pharos Booking Server",
    "2351": "psrserver",
    "2352": "pslserver",
    "2353": "pspserver",
    "2354": "psprserver",
    "2355": "psdbserver",
    "2356": "GXT License Managemant",
    "2357": "UniHub Server",
    "2358": "Futrix",
    "2359": "FlukeServer",
    "2360": "NexstorIndLtd",
    "2361": "TL1",
    "2362": "digiman",
    "2363": "Media Central NFSD",
    "2364": "OI-2000",
    "2365": "dbref",
    "2366": "qip-login",
    "2367": "Service Control",
    "2368": "OpenTable",
    "2369": "Blockchain Identifier InFrastructure P2P",
    "2370": "L3-HBMon",
    "2371": "Reserved",
    "2372": "LanMessenger",
    "2373": "Reserved",
    "2374": "Reserved",
    "2375": "Reserved",
    "2377": "Reserved",
    "2378": "DALI lighting control",
    "2379": "Reserved",
    "2380": "Reserved",
    "2381": "Compaq HTTPS",
    "2382": "Microsoft OLAP",
    "2383": "Microsoft OLAP",
    "2384": "SD-CAPACITY",
    "2385": "SD-DATA",
    "2386": "Virtual Tape",
    "2387": "VSAM Redirector",
    "2388": "MYNAH AutoStart",
    "2389": "OpenView Session Mgr",
    "2390": "RSMTP",
    "2391": "3COM Net Management",
    "2392": "Tactical Auth",
    "2393": "MS OLAP 1",
    "2394": "MS OLAP 2",
    "2395": "LAN900 Remote",
    "2395": "LAN900 Remote",
    "2396": "Wusage",
    "2397": "NCL",
    "2398": "Orbiter",
    "2399": "FileMaker, Inc. - Data Access Layer",
    "2400": "OpEquus Server",
    "2401": "cvspserver",
    "2402": "TaskMaster 2000 Server",
    "2403": "TaskMaster 2000 Web",
    "2404": "IEC 60870-5-104 process control over IP",
    "2405": "TRC Netpoll",
    "2406": "JediServer",
    "2407": "Orion",
    "2408": "Reserved",
    "2409": "SNS Protocol",
    "2410": "VRTS Registry",
    "2411": "Netwave AP Management",
    "2412": "CDN",
    "2413": "orion-rmi-reg",
    "2414": "Beeyond",
    "2415": "Codima Remote Transaction Protocol",
    "2416": "RMT Server",
    "2417": "Composit Server",
    "2418": "cas",
    "2419": "Attachmate S2S",
    "2420": "DSL Remote Management",
    "2421": "G-Talk",
    "2422": "CRMSBITS",
    "2423": "RNRP",
    "2424": "KOFAX-SVR",
    "2425": "Fujitsu App Manager",
    "2426": "VeloCloud MultiPath Protocol",
    "2427": "Media Gateway Control Protocol Gateway",
    "2428": "One Way Trip Time",
    "2429": "FT-ROLE",
    "2430": "venus",
    "2431": "venus-se",
    "2432": "codasrv",
    "2433": "codasrv-se",
    "2434": "pxc-epmap",
    "2435": "OptiLogic",
    "2436": "TOP/X",
    "2437": "UniControl",
    "2438": "MSP",
    "2439": "SybaseDBSynch",
    "2440": "Spearway Lockers",
    "2441": "Pervasive I*net Data Server",
    "2442": "Netangel",
    "2443": "PowerClient Central Storage Facility",
    "2444": "BT PP2 Sectrans",
    "2445": "DTN1",
    "2446": "bues_service",
    "2446": "bues_service",
    "2447": "OpenView NNM daemon",
    "2448": "hpppsvr",
    "2449": "RATL",
    "2450": "netadmin",
    "2451": "netchat",
    "2452": "SnifferClient",
    "2453": "madge ltd",
    "2454": "IndX-DDS",
    "2455": "WAGO-IO-SYSTEM",
    "2456": "altav-remmgt",
    "2457": "Rapido_IP",
    "2458": "griffin",
    "2459": "Community",
    "2460": "ms-theater",
    "2461": "qadmifoper",
    "2462": "qadmifevent",
    "2463": "LSI RAID Management",
    "2464": "DirecPC SI",
    "2465": "Load Balance Management",
    "2466": "Load Balance Forwarding",
    "2467": "High Criteria",
    "2468": "qip_msgd",
    "2469": "MTI-TCS-COMM",
    "2470": "taskman port",
    "2471": "SeaODBC",
    "2472": "C3",
    "2473": "Aker-cdp",
    "2474": "Vital Analysis",
    "2475": "ACE Server",
    "2476": "ACE Server Propagation",
    "2477": "SecurSight Certificate Valifation Service",
    "2478": "SecurSight Authentication Server (SSL)",
    "2479": "SecurSight Event Logging Server (SSL)",
    "2480": "Informatica PowerExchange Listener",
    "2481": "Oracle GIOP",
    "2482": "Oracle GIOP SSL",
    "2483": "Oracle TTC",
    "2484": "Oracle TTC SSL",
    "2485": "Net Objects1",
    "2486": "Net Objects2",
    "2487": "Policy Notice Service",
    "2488": "Moy Corporation",
    "2489": "TSILB",
    "2490": "qip_qdhcp",
    "2491": "Conclave CPP",
    "2492": "GROOVE",
    "2493": "Talarian MQS",
    "2494": "BMC AR",
    "2495": "Fast Remote Services",
    "2496": "DIRGIS",
    "2497": "Quad DB",
    "2498": "ODN-CasTraq",
    "2499": "UniControl",
    "2500": "Resource Tracking system server",
    "2501": "Resource Tracking system client",
    "2502": "Kentrox Protocol",
    "2503": "NMS-DPNSS",
    "2504": "WLBS",
    "2505": "PowerPlay Control",
    "2506": "jbroker",
    "2507": "spock",
    "2508": "JDataStore",
    "2509": "fjmpss",
    "2510": "fjappmgrbulk",
    "2511": "Metastorm",
    "2512": "Citrix IMA",
    "2513": "Citrix ADMIN",
    "2514": "Facsys NTP",
    "2515": "Facsys Router",
    "2516": "Main Control",
    "2517": "H.323 Annex E Call Control Signalling Transport",
    "2518": "Willy",
    "2519": "globmsgsvc",
    "2520": "Pervasive Listener",
    "2521": "Adaptec Manager",
    "2522": "WinDb",
    "2523": "Qke LLC V.3",
    "2524": "Optiwave License Management",
    "2525": "MS V-Worlds",
    "2526": "EMA License Manager",
    "2527": "IQ Server",
    "2528": "NCR CCL",
    "2528": "NCR CCL",
    "2529": "UTS FTP",
    "2530": "VR Commerce",
    "2531": "ITO-E GUI",
    "2532": "OVTOPMD",
    "2533": "SnifferServer",
    "2534": "Combox Web Access",
    "2535": "MADCAP",
    "2536": "btpp2audctr1",
    "2537": "Upgrade Protocol",
    "2538": "vnwk-prapi",
    "2539": "VSI Admin",
    "2540": "LonWorks",
    "2541": "LonWorks2",
    "2542": "uDraw(Graph)",
    "2543": "REFTEK",
    "2544": "Management Daemon Refresh",
    "2545": "sis-emt",
    "2546": "vytalvaultbrtp",
    "2547": "vytalvaultvsmp",
    "2548": "vytalvaultpipe",
    "2549": "IPASS",
    "2550": "ADS",
    "2551": "ISG UDA Server",
    "2552": "Call Logging",
    "2553": "efidiningport",
    "2554": "VCnet-Link v10",
    "2555": "Compaq WCP",
    "2556": "nicetec-nmsvc",
    "2557": "nicetec-mgmt",
    "2558": "PCLE Multi Media",
    "2559": "LSTP",
    "2560": "labrat",
    "2561": "MosaixCC",
    "2562": "Delibo",
    "2563": "CTI Redwood",
    "2564": "HP 3000 NS/VT block mode telnet",
    "2565": "Coordinator Server",
    "2566": "pcs-pcw",
    "2567": "Cisco Line Protocol",
    "2568": "SPAM TRAP",
    "2569": "Sonus Call Signal",
    "2570": "HS Port",
    "2571": "CECSVC",
    "2572": "IBP",
    "2573": "Trust Establish",
    "2574": "Blockade BPSP",
    "2575": "HL7",
    "2576": "TCL Pro Debugger",
    "2577": "Scriptics Lsrvr",
    "2578": "RVS ISDN DCP",
    "2579": "mpfoncl",
    "2580": "Tributary",
    "2581": "ARGIS TE",
    "2582": "ARGIS DS",
    "2583": "MON",
    "2584": "cyaserv",
    "2585": "NETX Server",
    "2586": "NETX Agent",
    "2587": "MASC",
    "2588": "Privilege",
    "2589": "quartus tcl",
    "2590": "idotdist",
    "2591": "Maytag Shuffle",
    "2592": "netrek",
    "2593": "MNS Mail Notice Service",
    "2594": "Data Base Server",
    "2595": "World Fusion 1",
    "2596": "World Fusion 2",
    "2597": "Homestead Glory",
    "2598": "Citrix MA Client",
    "2599": "Snap Discovery",
    "2600": "HPSTGMGR",
    "2601": "discp client",
    "2602": "discp server",
    "2603": "Service Meter",
    "2604": "NSC CCS",
    "2605": "NSC POSA",
    "2606": "Dell Netmon",
    "2607": "Dell Connection",
    "2608": "Wag Service",
    "2609": "System Monitor",
    "2610": "VersaTek",
    "2611": "LIONHEAD",
    "2612": "Qpasa Agent",
    "2613": "SMNTUBootstrap",
    "2614": "Never Offline",
    "2615": "firepower",
    "2616": "appswitch-emp",
    "2617": "Clinical Context Managers",
    "2618": "Priority E-Com",
    "2619": "bruce",
    "2620": "LPSRecommender",
    "2621": "Miles Apart Jukebox Server",
    "2622": "MetricaDBC",
    "2623": "LMDP",
    "2624": "Aria",
    "2625": "Blwnkl Port",
    "2626": "gbjd816",
    "2627": "Moshe Beeri",
    "2628": "DICT",
    "2629": "Sitara Server",
    "2630": "Sitara Management",
    "2631": "Sitara Dir",
    "2632": "IRdg Post",
    "2633": "InterIntelli",
    "2634": "PK Electronics",
    "2635": "Back Burner",
    "2636": "Solve",
    "2637": "Import Document Service",
    "2638": "Sybase Anywhere",
    "2639": "AMInet",
    "2640": "Alcorn McBride Inc protocol used for device control",
    "2641": "HDL Server",
    "2642": "Tragic",
    "2643": "GTE-SAMP",
    "2644": "Travsoft IPX Tunnel",
    "2645": "Novell IPX CMD",
    "2646": "AND License Manager",
    "2647": "SyncServer",
    "2648": "Upsnotifyprot",
    "2649": "VPSIPPORT",
    "2650": "eristwoguns",
    "2651": "EBInSite",
    "2652": "InterPathPanel",
    "2653": "Sonus",
    "2654": "Corel VNC Admin",
    "2654": "Corel VNC Admin",
    "2655": "UNIX Nt Glue",
    "2656": "Kana",
    "2657": "SNS Dispatcher",
    "2658": "SNS Admin",
    "2659": "SNS Query",
    "2660": "GC Monitor",
    "2661": "OLHOST",
    "2662": "BinTec-CAPI",
    "2663": "BinTec-TAPI",
    "2664": "Patrol for MQ GM",
    "2665": "Patrol for MQ NM",
    "2666": "extensis",
    "2667": "Alarm Clock Server",
    "2668": "Alarm Clock Client",
    "2669": "TOAD",
    "2670": "TVE Announce",
    "2671": "newlixreg",
    "2672": "nhserver",
    "2673": "First Call 42",
    "2674": "ewnn",
    "2675": "TTC ETAP",
    "2676": "SIMSLink",
    "2677": "Gadget Gate 1 Way",
    "2678": "Gadget Gate 2 Way",
    "2679": "Sync Server SSL",
    "2680": "pxc-sapxom",
    "2681": "mpnjsomb",
    "2683": "NCDLoadBalance",
    "2684": "mpnjsosv",
    "2685": "mpnjsocl",
    "2686": "mpnjsomg",
    "2687": "pq-lic-mgmt",
    "2688": "md-cf-http",
    "2689": "FastLynx",
    "2690": "HP NNM Embedded Database",
    "2691": "ITInternet ISM Server",
    "2692": "Admins LMS",
    "2693": "Unassigned",
    "2694": "pwrsevent",
    "2695": "VSPREAD",
    "2696": "Unify Admin",
    "2697": "Oce SNMP Trap Port",
    "2698": "MCK-IVPIP",
    "2699": "Csoft Plus Client",
    "2700": "tqdata",
    "2701": "SMS RCINFO",
    "2702": "SMS XFER",
    "2703": "SMS CHAT",
    "2704": "SMS REMCTRL",
    "2705": "SDS Admin",
    "2706": "NCD Mirroring",
    "2707": "EMCSYMAPIPORT",
    "2708": "Banyan-Net",
    "2709": "Supermon",
    "2710": "SSO Service",
    "2711": "SSO Control",
    "2712": "Axapta Object Communication Protocol",
    "2713": "Raven Trinity Broker Service",
    "2714": "Raven Trinity Data Mover",
    "2715": "HPSTGMGR2",
    "2716": "Inova IP Disco",
    "2717": "PN REQUESTER",
    "2718": "PN REQUESTER 2",
    "2719": "Scan &amp; Change",
    "2720": "wkars",
    "2721": "Smart Diagnose",
    "2722": "Proactive Server",
    "2723": "WatchDog NT Protocol",
    "2724": "qotps",
    "2725": "MSOLAP PTP2",
    "2726": "TAMS",
    "2727": "Media Gateway Control Protocol Call Agent",
    "2728": "SQDR",
    "2729": "TCIM Control",
    "2730": "NEC RaidPlus",
    "2731": "Fyre Messanger",
    "2732": "G5M",
    "2733": "Signet CTF",
    "2734": "CCS Software",
    "2735": "NetIQ Monitor Console",
    "2736": "RADWIZ NMS SRV",
    "2737": "SRP Feedback",
    "2738": "NDL TCP-OSI Gateway",
    "2739": "TN Timing",
    "2740": "Alarm",
    "2741": "TSB",
    "2742": "TSB2",
    "2743": "murx",
    "2744": "honyaku",
    "2745": "URBISNET",
    "2746": "CPUDPENCAP",
    "2747": "",
    "2748": "",
    "2749": "",
    "2750": "",
    "2751": "",
    "2752": "RSISYS ACCESS",
    "2753": "de-spot",
    "2754": "APOLLO CC",
    "2755": "Express Pay",
    "2756": "simplement-tie",
    "2757": "CNRP",
    "2758": "APOLLO Status",
    "2759": "APOLLO GMS",
    "2760": "Saba MS",
    "2761": "DICOM ISCL",
    "2762": "DICOM TLS",
    "2763": "Desktop DNA",
    "2764": "Data Insurance",
    "2765": "qip-audup",
    "2766": "Compaq SCP",
    "2767": "UADTC",
    "2768": "UACS",
    "2769": "eXcE",
    "2770": "Veronica",
    "2771": "Vergence CM",
    "2772": "auris",
    "2773": "RBackup Remote Backup",
    "2774": "RBackup Remote Backup",
    "2775": "SMPP",
    "2776": "Ridgeway Systems &amp; Software",
    "2777": "Ridgeway Systems &amp; Software",
    "2778": "Gwen-Sonya",
    "2779": "LBC Sync",
    "2780": "LBC Control",
    "2781": "whosells",
    "2782": "everydayrc",
    "2783": "AISES",
    "2784": "world wide web - development",
    "2785": "aic-np",
    "2786": "aic-oncrpc - Destiny MCD database",
    "2787": "piccolo - Cornerstone Software",
    "2788": "NetWare Loadable Module - Seagate Software",
    "2789": "Media Agent",
    "2790": "PLG Proxy",
    "2791": "MT Port Registrator",
    "2792": "f5-globalsite",
    "2793": "initlsmsad",
    "2795": "LiveStats",
    "2796": "ac-tech",
    "2797": "esp-encap",
    "2798": "TMESIS-UPShot",
    "2799": "ICON Discover",
    "2800": "ACC RAID",
    "2801": "IGCP",
    "2802": "Veritas UDP1",
    "2803": "btprjctrl",
    "2804": "March Networks Digital Video Recorders and Enterprise Service Manager products",
    "2805": "WTA WSP-S",
    "2806": "cspuni",
    "2807": "cspmulti",
    "2808": "J-LAN-P",
    "2809": "CORBA LOC",
    "2810": "Active Net Steward",
    "2811": "GSI FTP",
    "2812": "atmtcp",
    "2813": "llm-pass",
    "2814": "llm-csv",
    "2815": "LBC Measurement",
    "2816": "LBC Watchdog",
    "2817": "NMSig Port",
    "2818": "rmlnk",
    "2819": "FC Fault Notification",
    "2820": "UniVision",
    "2821": "VERITAS Authentication Service",
    "2822": "ka0wuc",
    "2823": "CQG Net/LAN",
    "2824": "CQG Net/Lan 1",
    "2826": "slc systemlog",
    "2827": "slc ctrlrloops",
    "2828": "ITM License Manager",
    "2829": "silkp1",
    "2830": "silkp2",
    "2831": "silkp3",
    "2832": "silkp4",
    "2833": "glishd",
    "2834": "EVTP",
    "2835": "EVTP-DATA",
    "2836": "catalyst",
    "2837": "Repliweb",
    "2838": "Starbot",
    "2839": "NMSigPort",
    "2840": "l3-exprt",
    "2841": "l3-ranger",
    "2842": "l3-hawk",
    "2843": "PDnet",
    "2844": "BPCP POLL",
    "2845": "BPCP TRAP",
    "2846": "AIMPP Hello",
    "2847": "AIMPP Port Req",
    "2848": "AMT-BLC-PORT",
    "2849": "FXP",
    "2850": "MetaConsole",
    "2851": "webemshttp",
    "2852": "bears-01",
    "2853": "ISPipes",
    "2854": "InfoMover",
    "2855": "Reserved",
    "2856": "cesdinv",
    "2857": "SimCtIP",
    "2858": "ECNP",
    "2859": "Active Memory",
    "2860": "Dialpad Voice 1",
    "2861": "Dialpad Voice 2",
    "2862": "TTG Protocol",
    "2863": "Sonar Data",
    "2864": "main 5001 cmd",
    "2865": "pit-vpn",
    "2866": "iwlistener",
    "2867": "esps-portal",
    "2868": "Norman Proprietaqry Events Protocol",
    "2869": "ICSLAP",
    "2870": "daishi",
    "2871": "MSI Select Play",
    "2872": "RADIX",
    "2873": "PubSub Realtime Telemetry Protocol",
    "2874": "DX Message Base Transport Protocol",
    "2875": "DX Message Base Transport Protocol",
    "2876": "SPS Tunnel",
    "2877": "BLUELANCE",
    "2878": "AAP",
    "2879": "ucentric-ds",
    "2880": "Synapse Transport",
    "2881": "NDSP",
    "2882": "NDTP",
    "2883": "NDNP",
    "2884": "Flash Msg",
    "2885": "TopFlow",
    "2886": "RESPONSELOGIC",
    "2887": "aironet",
    "2888": "SPCSDLOBBY",
    "2889": "RSOM",
    "2890": "CSPCLMULTI",
    "2891": "CINEGRFX-ELMD License Manager",
    "2892": "SNIFFERDATA",
    "2893": "VSECONNECTOR",
    "2894": "ABACUS-REMOTE",
    "2895": "NATUS LINK",
    "2896": "ECOVISIONG6-1",
    "2897": "Citrix RTMP",
    "2898": "APPLIANCE-CFG",
    "2899": "POWERGEMPLUS",
    "2900": "QUICKSUITE",
    "2901": "ALLSTORCNS",
    "2902": "NET ASPI",
    "2903": "SUITCASE",
    "2904": "M2UA",
    "2905": "De-registered",
    "2906": "CALLER9",
    "2907": "WEBMETHODS B2B",
    "2908": "mao",
    "2909": "Funk Dialout",
    "2910": "TDAccess",
    "2911": "Blockade",
    "2912": "Epicon",
    "2913": "Booster Ware",
    "2914": "Game Lobby",
    "2915": "TK Socket",
    "2916": "Elvin Server",
    "2916": "Elvin Server",
    "2917": "Elvin Client",
    "2917": "Elvin Client",
    "2918": "Kasten Chase Pad",
    "2919": "roboER",
    "2920": "roboEDA",
    "2921": "CESD Contents Delivery Management",
    "2922": "CESD Contents Delivery Data Transfer",
    "2923": "WTA-WSP-WTP-S",
    "2924": "PRECISE-VIP",
    "2926": "MOBILE-FILE-DL",
    "2927": "UNIMOBILECTRL",
    "2928": "REDSTONE-CPSS",
    "2929": "AMX-WEBADMIN",
    "2930": "AMX-WEBLINX",
    "2931": "Circle-X",
    "2932": "INCP",
    "2933": "4-TIER OPM GW",
    "2934": "4-TIER OPM CLI",
    "2935": "QTP",
    "2936": "OTPatch",
    "2937": "PNACONSULT-LM",
    "2938": "SM-PAS-1",
    "2939": "SM-PAS-2",
    "2940": "SM-PAS-3",
    "2941": "SM-PAS-4",
    "2942": "SM-PAS-5",
    "2943": "TTNRepository",
    "2944": "Megaco H-248",
    "2945": "H248 Binary",
    "2946": "FJSVmpor",
    "2947": "GPS Daemon request/response protocol",
    "2948": "WAP PUSH",
    "2949": "WAP PUSH SECURE",
    "2950": "ESIP",
    "2951": "OTTP",
    "2952": "MPFWSAS",
    "2953": "OVALARMSRV",
    "2954": "OVALARMSRV-CMD",
    "2955": "CSNOTIFY",
    "2956": "OVRIMOSDBMAN",
    "2957": "JAMCT5",
    "2958": "JAMCT6",
    "2959": "RMOPAGT",
    "2960": "DFOXSERVER",
    "2961": "BOLDSOFT-LM",
    "2962": "IPH-POLICY-CLI",
    "2963": "IPH-POLICY-ADM",
    "2964": "BULLANT SRAP",
    "2965": "BULLANT RAP",
    "2966": "IDP-INFOTRIEVE",
    "2967": "SSC-AGENT",
    "2968": "ENPP",
    "2969": "ESSP",
    "2970": "INDEX-NET",
    "2971": "NetClip clipboard daemon",
    "2972": "PMSM Webrctl",
    "2973": "SV Networks",
    "2974": "Signal",
    "2975": "Fujitsu Configuration Management Service",
    "2976": "CNS Server Port",
    "2977": "TTCs Enterprise Test Access Protocol - NS",
    "2978": "TTCs Enterprise Test Access Protocol - DS",
    "2979": "H.263 Video Streaming",
    "2980": "Instant Messaging Service",
    "2981": "MYLXAMPORT",
    "2982": "IWB-WHITEBOARD",
    "2983": "NETPLAN",
    "2984": "HPIDSADMIN",
    "2985": "HPIDSAGENT",
    "2986": "STONEFALLS",
    "2987": "identify",
    "2988": "HIPPA Reporting Protocol",
    "2989": "ZARKOV Intelligent Agent Communication",
    "2990": "BOSCAP",
    "2991": "WKSTN-MON",
    "2992": "Avenyo Server",
    "2993": "VERITAS VIS1",
    "2994": "VERITAS VIS2",
    "2995": "IDRS",
    "2996": "vsixml",
    "2997": "REBOL",
    "2998": "Real Secure",
    "2999": "RemoteWare Unassigned",
    "3000": "HBCI",
    "3001": "Reserved",
    "3002": "EXLM Agent",
    "3003": "CGMS",
    "3004": "Csoft Agent",
    "3005": "Genius License Manager",
    "3006": "Instant Internet Admin",
    "3007": "Lotus Mail Tracking Agent Protocol",
    "3008": "Midnight Technologies",
    "3009": "PXC-NTFY",
    "3010": "Telerate Workstation",
    "3011": "Trusted Web",
    "3012": "Trusted Web Client",
    "3013": "Gilat Sky Surfer",
    "3014": "Broker Service",
    "3014": "Broker Service",
    "3015": "NATI DSTP",
    "3016": "Notify Server",
    "3016": "Notify Server",
    "3017": "Event Listener",
    "3017": "Event Listener",
    "3018": "Service Registry",
    "3018": "Service Registry",
    "3019": "Resource Manager",
    "3019": "Resource Manager",
    "3020": "CIFS",
    "3021": "AGRI Server",
    "3022": "CSREGAGENT",
    "3023": "magicnotes",
    "3024": "NDS_SSO",
    "3024": "NDS_SSO",
    "3025": "Arepa Raft",
    "3026": "AGRI Gateway",
    "3027": "LiebDevMgmt_C",
    "3027": "LiebDevMgmt_C",
    "3028": "LiebDevMgmt_DM",
    "3028": "LiebDevMgmt_DM",
    "3029": "LiebDevMgmt_A",
    "3029": "LiebDevMgmt_A",
    "3030": "Arepa Cas",
    "3031": "Remote AppleEvents/PPC Toolbox",
    "3032": "Redwood Chat",
    "3033": "PDB",
    "3034": "Osmosis / Helix (R) AEEA Port",
    "3035": "FJSV gssagt",
    "3036": "Hagel DUMP",
    "3037": "HP SAN Mgmt",
    "3038": "Santak UPS",
    "3039": "Cogitate, Inc.",
    "3040": "Tomato Springs",
    "3041": "di-traceware",
    "3042": "journee",
    "3043": "Broadcast Routing Protocol",
    "3044": "EndPoint Protocol",
    "3045": "ResponseNet",
    "3046": "di-ase",
    "3047": "Fast Security HL Server",
    "3048": "Sierra Net PC Trader",
    "3049": "NSWS",
    "3050": "gds_db",
    "3050": "gds_db",
    "3051": "Galaxy Server",
    "3052": "APC 3052",
    "3053": "dsom-server",
    "3054": "AMT CNF PROT",
    "3055": "Policy Server",
    "3056": "CDL Server",
    "3057": "GoAhead FldUp",
    "3058": "videobeans",
    "3059": "qsoft",
    "3060": "interserver",
    "3061": "cautcpd",
    "3062": "ncacn-ip-tcp",
    "3063": "ncadg-ip-udp",
    "3064": "Remote Port Redirector",
    "3065": "slinterbase",
    "3066": "NETATTACHSDMP",
    "3067": "FJHPJP",
    "3068": "ls3 Broadcast",
    "3069": "ls3",
    "3070": "MGXSWITCH",
    "3071": "Reserved",
    "3072": "ContinuStor Monitor Port",
    "3073": "Very simple chatroom prot",
    "3074": "Xbox game port",
    "3075": "Orbix 2000 Locator",
    "3076": "Orbix 2000 Config",
    "3077": "Orbix 2000 Locator SSL",
    "3078": "Orbix 2000 Locator SSL",
    "3079": "LV Front Panel",
    "3080": "stm_pproc",
    "3080": "stm_pproc",
    "3081": "TL1-LV",
    "3082": "TL1-RAW",
    "3083": "TL1-TELNET",
    "3084": "ITM-MCCS",
    "3085": "PCIHReq",
    "3086": "JDL-DBKitchen",
    "3087": "Asoki SMA",
    "3088": "eXtensible Data Transfer Protocol",
    "3089": "ParaTek Agent Linking",
    "3090": "Senforce Session Services",
    "3091": "1Ci Server Management",
    "3093": "Jiiva RapidMQ Center",
    "3094": "Jiiva RapidMQ Registry",
    "3095": "Panasas rendezvous port",
    "3096": "Active Print Server Port",
    "3097": "Reserved",
    "3098": "Universal Message Manager",
    "3099": "CHIPSY Machine Daemon",
    "3100": "OpCon/xps",
    "3101": "HP PolicyXpert PIB Server",
    "3102": "SoftlinK Slave Mon Port",
    "3103": "Autocue SMI Protocol",
    "3104": "Autocue Time Service",
    "3105": "Cardbox",
    "3106": "Cardbox HTTP",
    "3107": "Business protocol",
    "3108": "Geolocate protocol",
    "3109": "Personnel protocol",
    "3110": "simulator control port",
    "3111": "Web Synchronous Services",
    "3112": "KDE System Guard",
    "3113": "CS-Authenticate Svr Port",
    "3114": "CCM AutoDiscover",
    "3115": "MCTET Master",
    "3116": "MCTET Gateway",
    "3117": "MCTET Jserv",
    "3118": "PKAgent",
    "3119": "D2000 Kernel Port",
    "3120": "D2000 Webserver Port",
    "3121": "Reserved",
    "3122": "MTI VTR Emulator port",
    "3123": "EDI Translation Protocol",
    "3124": "Beacon Port",
    "3125": "A13-AN Interface",
    "3127": "CTX Bridge Port",
    "3128": "Active API Server Port",
    "3129": "NetPort Discovery Port",
    "3130": "ICPv2",
    "3131": "Net Book Mark",
    "3132": "Microsoft Business Rule Engine Update Service",
    "3133": "Prism Deploy User Port",
    "3134": "Extensible Code Protocol",
    "3135": "PeerBook Port",
    "3136": "Grub Server Port",
    "3137": "rtnt-1 data packets",
    "3138": "rtnt-2 data packets",
    "3139": "Incognito Rendez-Vous",
    "3140": "Arilia Multiplexor",
    "3141": "VMODEM",
    "3142": "RDC WH EOS",
    "3143": "Sea View",
    "3144": "Tarantella",
    "3145": "CSI-LFAP",
    "3146": "bears-02",
    "3147": "RFIO",
    "3148": "NetMike Game Administrator",
    "3149": "NetMike Game Server",
    "3150": "NetMike Assessor Administrator",
    "3151": "NetMike Assessor",
    "3152": "FeiTian Port",
    "3153": "S8Cargo Client Port",
    "3154": "ON RMI Registry",
    "3155": "JpegMpeg Port",
    "3156": "Indura Collector",
    "3157": "LSA Communicator",
    "3158": "SmashTV Protocol",
    "3159": "NavegaWeb Tarification",
    "3160": "TIP Application Server",
    "3161": "DOC1 License Manager",
    "3162": "SFLM",
    "3163": "RES-SAP",
    "3164": "IMPRS",
    "3165": "Newgenpay Engine Service",
    "3166": "Quest Spotlight Out-Of-Process Collector",
    "3167": "Now Contact Public Server",
    "3168": "Now Up-to-Date Public Server",
    "3169": "SERVERVIEW-AS",
    "3170": "SERVERVIEW-ASN",
    "3171": "SERVERVIEW-GF",
    "3172": "SERVERVIEW-RM",
    "3173": "SERVERVIEW-ICC",
    "3174": "ARMI Server",
    "3175": "T1_E1_Over_IP",
    "3176": "ARS Master",
    "3177": "Phonex Protocol",
    "3178": "Radiance UltraEdge Port",
    "3179": "H2GF W.2m Handover prot.",
    "3180": "Millicent Broker Server",
    "3181": "BMC Patrol Agent",
    "3182": "BMC Patrol Rendezvous",
    "3183": "COPS/TLS",
    "3184": "ApogeeX Port",
    "3185": "SuSE Meta PPPD",
    "3186": "IIW Monitor User Port",
    "3187": "Open Design Listen Port",
    "3188": "Broadcom Port",
    "3189": "Pinnacle Sys InfEx Port",
    "3190": "ConServR Proxy",
    "3191": "ConServR SSL Proxy",
    "3192": "FireMon Revision Control",
    "3193": "SpanDataPort",
    "3194": "Rockstorm MAG protocol",
    "3195": "Network Control Unit",
    "3196": "Network Control Unit",
    "3197": "Embrace Device Protocol Server",
    "3198": "Embrace Device Protocol Client",
    "3199": "DMOD WorkSpace",
    "3200": "Press-sense Tick Port",
    "3201": "CPQ-TaskSmart",
    "3202": "IntraIntra",
    "3203": "Network Watcher Monitor",
    "3204": "Network Watcher DB Access",
    "3205": "iSNS Server Port",
    "3206": "IronMail POP Proxy",
    "3207": "Veritas Authentication Port",
    "3208": "PFU PR Callback",
    "3209": "HP OpenView Network Path Engine Server",
    "3210": "Flamenco Networks Proxy",
    "3211": "Avocent Secure Management",
    "3212": "Survey Instrument",
    "3213": "NEON 24X7 Mission Control",
    "3214": "JMQ Daemon Port 1",
    "3215": "JMQ Daemon Port 2",
    "3216": "Ferrari electronic FOAM",
    "3217": "Unified IP &amp; Telecom Environment",
    "3218": "EMC SmartPackets",
    "3219": "WMS Messenger",
    "3220": "XML NM over SSL",
    "3221": "XML NM over TCP",
    "3222": "Gateway Load Balancing Pr",
    "3223": "DIGIVOTE (R) Vote-Server",
    "3224": "AES Discovery Port",
    "3225": "FCIP",
    "3226": "ISI Industry Software IRP",
    "3227": "DiamondWave NMS Server",
    "3228": "DiamondWave MSG Server",
    "3229": "Global CD Port",
    "3230": "Software Distributor Port",
    "3231": "VidiGo communication (previous was: Delta Solutions Direct)",
    "3232": "MDT port",
    "3233": "WhiskerControl main port",
    "3234": "Alchemy Server",
    "3235": "MDAP Port",
    "3236": "appareNet Test Server",
    "3237": "appareNet Test Packet Sequencer",
    "3238": "appareNet Analysis Server",
    "3239": "appareNet User Interface",
    "3240": "Trio Motion Control Port",
    "3241": "SysOrb Monitoring Server",
    "3242": "Session Description ID",
    "3243": "Timelot Port",
    "3244": "OneSAF",
    "3245": "VIEO Fabric Executive",
    "3246": "DVT SYSTEM PORT",
    "3247": "DVT DATA LINK",
    "3248": "PROCOS LM",
    "3249": "State Sync Protocol",
    "3250": "HMS hicp port",
    "3251": "Sys Scanner",
    "3252": "DHE port",
    "3253": "PDA Data",
    "3254": "PDA System",
    "3255": "Semaphore Connection Port",
    "3256": "Compaq RPM Agent Port",
    "3257": "Compaq RPM Server Port",
    "3258": "Ivecon Server Port",
    "3259": "Epson Network Common Devi",
    "3260": "iSCSI port",
    "3261": "winShadow",
    "3262": "NECP",
    "3263": "E-Color Enterprise Imager",
    "3264": "cc:mail/lotus",
    "3265": "Altav Tunnel",
    "3266": "NS CFG Server",
    "3267": "IBM Dial Out",
    "3268": "Microsoft Global Catalog",
    "3269": "Microsoft Global Catalog with LDAP/SSL",
    "3270": "Verismart",
    "3271": "CSoft Prev Port",
    "3272": "Fujitsu User Manager",
    "3273": "Simple Extensible Multiplexed Protocol",
    "3274": "Ordinox Server",
    "3275": "SAMD",
    "3276": "Maxim ASICs",
    "3277": "AWG Proxy",
    "3278": "LKCM Server",
    "3279": "admind",
    "3280": "VS Server",
    "3281": "SYSOPT",
    "3282": "Datusorb",
    "3283": "Net Assistant",
    "3284": "4Talk",
    "3285": "Plato",
    "3286": "E-Net",
    "3287": "DIRECTVDATA",
    "3288": "COPS",
    "3289": "ENPC",
    "3290": "CAPS LOGISTICS TOOLKIT - LM",
    "3291": "S A Holditch &amp; Associates - LM",
    "3292": "Cart O Rama",
    "3293": "fg-fps",
    "3294": "fg-gip",
    "3295": "Dynamic IP Lookup",
    "3296": "Rib License Manager",
    "3297": "Cytel License Manager",
    "3298": "DeskView",
    "3299": "pdrncs",
    "3300": "Reserved",
    "3301": "Tarantool in-memory computing platform",
    "3302": "MCS Fastmail",
    "3303": "OP Session Client",
    "3304": "OP Session Server",
    "3305": "ODETTE-FTP",
    "3306": "MySQL",
    "3307": "OP Session Proxy",
    "3308": "TNS Server",
    "3309": "TNS ADV",
    "3310": "Dyna Access",
    "3311": "MCNS Tel Ret",
    "3312": "Application Management Server",
    "3313": "Unify Object Broker",
    "3314": "Unify Object Host",
    "3315": "CDID",
    "3316": "AICC/CMI",
    "3317": "VSAI PORT",
    "3318": "Swith to Swith Routing Information Protocol",
    "3319": "SDT License Manager",
    "3320": "Office Link 2000",
    "3321": "VNSSTR",
    "3326": "SFTU",
    "3327": "BBARS",
    "3328": "Eaglepoint License Manager",
    "3329": "HP Device Disc",
    "3330": "MCS Calypso ICF",
    "3331": "MCS Messaging",
    "3332": "MCS Mail Server",
    "3333": "DEC Notes",
    "3334": "Direct TV Webcasting",
    "3335": "Direct TV Software Updates",
    "3336": "Direct TV Tickers",
    "3337": "Direct TV Data Catalog",
    "3338": "OMF data b",
    "3339": "OMF data l",
    "3340": "OMF data m",
    "3341": "OMF data h",
    "3342": "WebTIE",
    "3343": "MS Cluster Net",
    "3344": "BNT Manager",
    "3345": "Influence",
    "3346": "Trnsprnt Proxy",
    "3347": "Phoenix RPC",
    "3348": "Pangolin Laser",
    "3349": "Chevin Services",
    "3350": "FINDVIATV",
    "3351": "Btrieve port",
    "3352": "Scalable SQL",
    "3353": "FATPIPE",
    "3354": "SUITJD",
    "3355": "Ordinox Dbase",
    "3356": "UPNOTIFYPS",
    "3357": "Adtech Test IP",
    "3358": "Mp Sys Rmsvr",
    "3359": "WG NetForce",
    "3360": "KV Server",
    "3361": "KV Agent",
    "3362": "DJ ILM",
    "3363": "NATI Vi Server",
    "3364": "Creative Server",
    "3365": "Content Server",
    "3366": "Creative Partner",
    "3372": "TIP 2",
    "3373": "Lavenir License Manager",
    "3374": "Cluster Disc",
    "3375": "VSNM Agent",
    "3376": "CD Broker",
    "3377": "Cogsys Network License Manager",
    "3378": "WSICOPY",
    "3379": "SOCORFS",
    "3380": "SNS Channels",
    "3381": "Geneous",
    "3382": "Fujitsu Network Enhanced Antitheft function",
    "3383": "Enterprise Software Products License Manager",
    "3384": "Hardware Management",
    "3385": "qnxnetman",
    "3386": "GPRS SIG",
    "3387": "Back Room Net",
    "3388": "CB Server",
    "3389": "MS WBT Server",
    "3390": "Distributed Service Coordinator",
    "3391": "SAVANT",
    "3392": "EFI License Management",
    "3393": "D2K Tapestry Client to Server",
    "3394": "D2K Tapestry Server to Server",
    "3395": "Dyna License Manager (Elam)",
    "3396": "Printer Agent",
    "3396": "Printer Agent",
    "3397": "Cloanto License Manager",
    "3398": "Mercantile",
    "3399": "CSMS",
    "3400": "CSMS2",
    "3401": "filecast",
    "3402": "FXa Engine Network Port",
    "3405": "Nokia Announcement ch 1",
    "3406": "Nokia Announcement ch 2",
    "3407": "LDAP admin server port",
    "3408": "BES Api Port",
    "3409": "NetworkLens Event Port",
    "3410": "NetworkLens SSL Event",
    "3411": "BioLink Authenteon server",
    "3412": "xmlBlaster",
    "3413": "SpecView Networking",
    "3414": "BroadCloud WIP Port",
    "3415": "BCI Name Service",
    "3416": "AirMobile IS Command Port",
    "3417": "ConServR file translation",
    "3418": "Remote nmap",
    "3419": "ISogon SoftAudit",
    "3420": "iFCP User Port",
    "3421": "Bull Apprise portmapper",
    "3422": "Remote USB System Port",
    "3423": "xTrade Reliable Messaging",
    "3424": "xTrade over TLS/SSL",
    "3425": "AGPS Access Port",
    "3426": "Arkivio Storage Protocol",
    "3427": "WebSphere SNMP",
    "3428": "2Wire CSS",
    "3429": "GCSP user port",
    "3430": "Scott Studios Dispatch",
    "3431": "Active License Server Port",
    "3432": "Secure Device Protocol",
    "3433": "OPNET Service Management Platform",
    "3434": "OpenCM Server",
    "3435": "Pacom Security User Port",
    "3436": "GuardControl Exchange Protocol",
    "3437": "Autocue Directory Service",
    "3438": "Spiralcraft Admin",
    "3439": "HRI Interface Port",
    "3440": "Net Steward Mgmt Console",
    "3441": "OC Connect Client",
    "3442": "OC Connect Server",
    "3443": "OpenView Network Node Manager WEB Server",
    "3444": "Denali Server",
    "3445": "Media Object Network Protocol",
    "3446": "3Com FAX RPC port",
    "3447": "DirectNet IM System",
    "3448": "Discovery and Net Config",
    "3449": "HotU Chat",
    "3450": "CAStorProxy",
    "3451": "ASAM Services",
    "3452": "SABP-Signalling Protocol",
    "3453": "PSC Update",
    "3454": "Apple Remote Access Protocol",
    "3455": "RSVP Port",
    "3456": "VAT default data",
    "3457": "VAT default control",
    "3458": "D3WinOSFI",
    "3459": "TIP Integral",
    "3460": "EDM Manger",
    "3461": "EDM Stager",
    "3462": "EDM STD Notify",
    "3463": "EDM ADM Notify",
    "3464": "EDM MGR Sync",
    "3465": "EDM MGR Cntrl",
    "3466": "WORKFLOW",
    "3467": "RCST",
    "3468": "TTCM Remote Controll",
    "3469": "Pluribus",
    "3470": "jt400",
    "3471": "jt400-ssl",
    "3472": "JAUGS N-G Remotec 1",
    "3473": "JAUGS N-G Remotec 2",
    "3474": "TSP Automation",
    "3475": "Genisar Comm Port",
    "3476": "NVIDIA Mgmt Protocol",
    "3477": "eComm link port",
    "3478": "Session Traversal Utilities for NAT (STUN) port",
    "3479": "2Wire RPC",
    "3480": "Secure Virtual Workspace",
    "3481": "CleanerLive remote ctrl",
    "3482": "Vulture Monitoring System",
    "3483": "Slim Devices Protocol",
    "3484": "GBS SnapTalk Protocol",
    "3485": "CelaTalk",
    "3486": "IFSF Heartbeat Port",
    "3487": "LISA UDP Transfer Channel",
    "3488": "FS Remote Host Server",
    "3489": "DTP/DIA",
    "3490": "Colubris Management Port",
    "3491": "SWR Port",
    "3492": "TVDUM Tray Port",
    "3493": "Network UPS Tools",
    "3494": "IBM 3494",
    "3495": "securitylayer over tcp",
    "3496": "securitylayer over tls",
    "3497": "ipEther232Port",
    "3498": "DASHPAS user port",
    "3499": "SccIP Media",
    "3500": "RTMP Port",
    "3501": "iSoft-P2P",
    "3502": "Avocent Install Discovery",
    "3503": "MPLS LSP-echo Port",
    "3504": "IronStorm game server",
    "3505": "CCM communications port",
    "3506": "APC 3506",
    "3507": "Nesh Broker Port",
    "3508": "Interaction Web",
    "3509": "Virtual Token SSL Port",
    "3510": "XSS Port",
    "3511": "WebMail/2",
    "3512": "Aztec Distribution Port",
    "3513": "Adaptec Remote Protocol",
    "3514": "MUST Peer to Peer",
    "3515": "MUST Backplane",
    "3516": "Smartcard Port",
    "3517": "IEEE 802.11 WLANs WG IAPP",
    "3518": "Artifact Message Server",
    "3519": "Netvion Galileo Port",
    "3520": "Netvion Galileo Log Port",
    "3521": "Telequip Labs MC3SS",
    "3522": "DO over NSSocketPort",
    "3523": "Odeum Serverlink",
    "3524": "ECM Server port",
    "3525": "EIS Server port",
    "3526": "starQuiz Port",
    "3527": "VERITAS Backup Exec Server",
    "3528": "JBoss IIOP",
    "3529": "JBoss IIOP/SSL",
    "3530": "Grid Friendly",
    "3531": "Joltid",
    "3532": "Raven Remote Management Control",
    "3533": "Raven Remote Management Data",
    "3534": "URL Daemon Port",
    "3535": "MS-LA",
    "3536": "SNAC",
    "3537": "Remote NI-VISA port",
    "3538": "IBM Directory Server",
    "3539": "IBM Directory Server SSL",
    "3540": "PNRP User Port",
    "3541": "VoiSpeed Port",
    "3542": "HA cluster monitor",
    "3543": "qftest Lookup Port",
    "3544": "Teredo Port",
    "3545": "CAMAC equipment",
    "3547": "Symantec SIM",
    "3548": "Interworld",
    "3549": "Tellumat MDR NMS",
    "3550": "Secure SMPP",
    "3551": "Apcupsd Information Port",
    "3552": "TeamAgenda Server Port",
    "3553": "Red Box Recorder ADP",
    "3554": "Quest Notification Server",
    "3555": "Vipul's Razor",
    "3556": "Sky Transport Protocol",
    "3557": "PersonalOS Comm Port",
    "3558": "MCP user port",
    "3559": "CCTV control port",
    "3560": "INIServe port",
    "3561": "BMC-OneKey",
    "3562": "SDBProxy",
    "3563": "Watcom Debug",
    "3564": "Electromed SIM port",
    "3565": "Reserved",
    "3566": "Reserved",
    "3567": "DOF Protocol Stack",
    "3568": "DOF Secure Tunnel",
    "3569": "Meinberg Control Service",
    "3570": "MCC Web Server Port",
    "3571": "MegaRAID Server Port",
    "3572": "Registration Server Port",
    "3573": "Advantage Group UPS Suite",
    "3574": "DMAF Caster",
    "3575": "Coalsere CCM Port",
    "3576": "Coalsere CMC Port",
    "3577": "Configuration Port",
    "3578": "Data Port",
    "3579": "Tarantella Load Balancing",
    "3580": "NATI-ServiceLocator",
    "3581": "Ascent Capture Licensing",
    "3582": "PEG PRESS Server",
    "3583": "CANEX Watch System",
    "3584": "U-DBase Access Protocol",
    "3585": "Emprise License Server",
    "3586": "License Server Console",
    "3587": "Peer to Peer Grouping",
    "3588": "Sentinel Server",
    "3589": "isomair",
    "3590": "WV CSP SMS Binding",
    "3591": "LOCANIS G-TRACK Server",
    "3592": "LOCANIS G-TRACK NE Port",
    "3593": "BP Model Debugger",
    "3594": "MediaSpace",
    "3595": "ShareApp",
    "3596": "Illusion Wireless MMOG",
    "3597": "A14 (AN-to-SC/MM)",
    "3598": "A15 (AN-to-AN)",
    "3599": "Quasar Accounting Server",
    "3600": "text relay-answer",
    "3601": "Visinet Gui",
    "3602": "InfiniSwitch Mgr Client",
    "3603": "Integrated Rcvr Control",
    "3604": "BMC JMX Port",
    "3605": "ComCam IO Port",
    "3606": "Splitlock Server",
    "3607": "Precise I3",
    "3608": "Trendchip control protocol",
    "3609": "CPDI PIDAS Connection Mon",
    "3610": "ECHONET",
    "3611": "Six Degrees Port",
    "3612": "Micro Focus Data Protector",
    "3613": "Alaris Device Discovery",
    "3614": "Satchwell Sigma",
    "3615": "Start Messaging Network",
    "3616": "cd3o Control Protocol",
    "3617": "ATI SHARP Logic Engine",
    "3618": "AAIR-Network 1",
    "3619": "AAIR-Network 2",
    "3620": "EPSON Projector Control Port",
    "3621": "EPSON Network Screen Port",
    "3622": "FF LAN Redundancy Port",
    "3623": "HAIPIS Dynamic Discovery",
    "3624": "Distributed Upgrade Port",
    "3625": "Volley",
    "3626": "bvControl Daemon",
    "3627": "Jam Server Port",
    "3628": "EPT Machine Interface",
    "3629": "ESC/VP.net",
    "3630": "C&amp;S Remote Database Port",
    "3631": "C&amp;S Web Services Port",
    "3632": "distributed compiler",
    "3633": "Wyrnix AIS port",
    "3634": "hNTSP Library Manager",
    "3635": "Simple Distributed Objects",
    "3636": "SerVistaITSM",
    "3637": "Customer Service Port",
    "3638": "EHP Backup Protocol",
    "3639": "Extensible Automation",
    "3640": "Netplay Port 1",
    "3641": "Netplay Port 2",
    "3642": "Juxml Replication port",
    "3643": "AudioJuggler",
    "3644": "ssowatch",
    "3645": "Cyc",
    "3646": "XSS Server Port",
    "3647": "Splitlock Gateway",
    "3648": "Fujitsu Cooperation Port",
    "3649": "Nishioka Miyuki Msg Protocol",
    "3650": "PRISMIQ VOD plug-in",
    "3651": "XRPC Registry",
    "3652": "VxCR NBU Default Port",
    "3653": "Tunnel Setup Protocol",
    "3654": "VAP RealTime Messenger",
    "3655": "ActiveBatch Exec Agent",
    "3656": "ActiveBatch Job Scheduler",
    "3657": "ImmediaNet Beacon",
    "3658": "PlayStation AMS (Secure)",
    "3659": "Apple SASL",
    "3660": "IBM Tivoli Directory Service using SSL",
    "3661": "IBM Tivoli Directory Service using SSL",
    "3662": "pserver",
    "3663": "DIRECWAY Tunnel Protocol",
    "3664": "UPS Engine Port",
    "3665": "Enterprise Engine Port",
    "3666": "IBM EServer PAP",
    "3667": "IBM Information Exchange",
    "3668": "Dell Remote Management",
    "3669": "CA SAN Switch Management",
    "3670": "SMILE TCP/UDP Interface",
    "3671": "e Field Control (EIBnet)",
    "3672": "LispWorks ORB",
    "3673": "Openview Media Vault GUI",
    "3674": "WinINSTALL IPC Port",
    "3675": "CallTrax Data Port",
    "3676": "VisualAge Pacbase server",
    "3677": "RoverLog IPC",
    "3678": "DataGuardianLT",
    "3679": "Newton Dock",
    "3680": "NPDS Tracker",
    "3681": "BTS X73 Port",
    "3682": "EMC SmartPackets-MAPI",
    "3683": "BMC EDV/EA",
    "3684": "FAXstfX",
    "3685": "DS Expert Agent",
    "3686": "Trivial Network Management",
    "3687": "simple-push",
    "3688": "simple-push Secure",
    "3689": "Digital Audio Access Protocol (iTunes)",
    "3690": "Subversion",
    "3691": "Magaya Network Port",
    "3692": "Brimstone IntelSync",
    "3693": "Reserved",
    "3695": "BMC Data Collection",
    "3696": "Telnet Com Port Control",
    "3697": "NavisWorks License System",
    "3698": "SAGECTLPANEL",
    "3699": "Internet Call Waiting",
    "3700": "LRS NetPage",
    "3701": "NetCelera",
    "3702": "Web Service Discovery",
    "3703": "Adobe Server 3",
    "3704": "Adobe Server 4",
    "3705": "Adobe Server 5",
    "3706": "Real-Time Event Port",
    "3707": "Real-Time Event Secure Port",
    "3708": "Sun App Svr - Naming",
    "3709": "CA-IDMS Server",
    "3710": "PortGate Authentication",
    "3711": "EBD Server 2",
    "3712": "Sentinel Enterprise",
    "3713": "TFTP over TLS",
    "3714": "DELOS Direct Messaging",
    "3715": "Anoto Rendezvous Port",
    "3716": "WV CSP SMS CIR Channel",
    "3717": "WV CSP UDP/IP CIR Channel",
    "3718": "OPUS Server Port",
    "3719": "iTel Server Port",
    "3720": "UF Astro. Instr. Services",
    "3721": "Xsync",
    "3722": "Xserve RAID",
    "3723": "Sychron Service Daemon",
    "3724": "World of Warcraft",
    "3725": "Netia NA-ER Port",
    "3726": "Xyratex Array Manager",
    "3727": "Ericsson Mobile Data Unit",
    "3728": "Ericsson Web on Air",
    "3729": "Fireking Audit Port",
    "3730": "Client Control",
    "3731": "Service Manager",
    "3732": "Mobile Wnn",
    "3733": "Multipuesto Msg Port",
    "3734": "Synel Data Collection Port",
    "3735": "Password Distribution",
    "3736": "RealSpace RMI",
    "3737": "Reserved",
    "3738": "versaTalk Server Port",
    "3739": "Launchbird LicenseManager",
    "3740": "Heartbeat Protocol",
    "3741": "WysDM Agent",
    "3742": "CST - Configuration &amp; Service Tracker",
    "3743": "IP Control Systems Ltd.",
    "3744": "SASG",
    "3745": "GWRTC Call Port",
    "3746": "LXPRO.COM LinkTest",
    "3747": "LXPRO.COM LinkTest SSL",
    "3748": "webData",
    "3749": "CimTrak",
    "3750": "CBOS/IP ncapsalation port",
    "3751": "CommLinx GPRS Cube",
    "3752": "Vigil-IP RemoteAgent",
    "3753": "NattyServer Port",
    "3754": "TimesTen Broker Port",
    "3755": "SAS Remote Help Server",
    "3756": "Canon CAPT Port",
    "3757": "GRF Server Port",
    "3758": "apw RMI registry",
    "3759": "Exapt License Manager",
    "3760": "adTEmpus Client",
    "3761": "gsakmp port",
    "3762": "GBS SnapMail Protocol",
    "3763": "XO Wave Control Port",
    "3764": "MNI Protected Routing",
    "3765": "Remote Traceroute",
    "3766": "Reserved",
    "3767": "ListMGR Port",
    "3768": "rblcheckd server daemon",
    "3769": "HAIPE Network Keying",
    "3770": "Cinderella Collaboration",
    "3771": "RTP Paging Port",
    "3772": "Chantry Tunnel Protocol",
    "3773": "ctdhercules",
    "3774": "ZICOM",
    "3775": "ISPM Manager Port",
    "3776": "Device Provisioning Port",
    "3777": "Jibe EdgeBurst",
    "3778": "Cutler-Hammer IT Port",
    "3779": "Cognima Replication",
    "3780": "Nuzzler Network Protocol",
    "3781": "ABCvoice server port",
    "3782": "Secure ISO TP0 port",
    "3783": "Impact Mgr./PEM Gateway",
    "3784": "BFD Control Protocol",
    "3785": "BFD Echo Protocol",
    "3786": "VSW Upstrigger port",
    "3787": "Fintrx",
    "3788": "SPACEWAY Routing port",
    "3789": "RemoteDeploy Administration Port [July 2003]",
    "3790": "QuickBooks RDS",
    "3791": "TV NetworkVideo Data port",
    "3792": "e-Watch Corporation SiteWatch",
    "3793": "DataCore Software",
    "3794": "JAUS Robots",
    "3795": "myBLAST Mekentosj port",
    "3796": "Spaceway Dialer",
    "3797": "idps",
    "3798": "Minilock",
    "3799": "RADIUS Dynamic Authorization",
    "3800": "Print Services Interface",
    "3801": "ibm manager service",
    "3802": "VHD",
    "3803": "SoniqSync",
    "3804": "Harman IQNet Port",
    "3805": "ThorGuard Server Port",
    "3806": "Remote System Manager",
    "3807": "SpuGNA Communication Port",
    "3808": "Sun App Svr-IIOPClntAuth",
    "3809": "Java Desktop System Configuration Agent",
    "3810": "WLAN AS server",
    "3811": "AMP",
    "3812": "netO WOL Server",
    "3813": "Rhapsody Interface Protocol",
    "3814": "netO DCS",
    "3815": "LANsurveyor XML",
    "3816": "Sun Local Patch Server",
    "3817": "Yosemite Tech Tapeware",
    "3818": "Crinis Heartbeat",
    "3819": "EPL Sequ Layer Protocol",
    "3820": "Siemens AuD SCP",
    "3821": "ATSC PMCP Standard",
    "3822": "Compute Pool Discovery",
    "3823": "Compute Pool Conduit",
    "3824": "Compute Pool Policy",
    "3825": "Antera FlowFusion Process Simulation",
    "3826": "WarMUX game server",
    "3827": "Netadmin Systems MPI service",
    "3828": "Netadmin Systems Event Handler",
    "3829": "Netadmin Systems Event Handler External",
    "3830": "Cerner System Management Agent",
    "3831": "Docsvault Application Service",
    "3832": "xxNETserver",
    "3833": "AIPN LS Authentication",
    "3834": "Spectar Data Stream Service",
    "3835": "Spectar Database Rights Service",
    "3836": "MARKEM NEXTGEN DCP",
    "3837": "MARKEM Auto-Discovery",
    "3838": "Scito Object Server",
    "3839": "AMX Resource Management Suite",
    "3840": "www.FlirtMitMir.de",
    "3841": "Reserved",
    "3842": "NHCI status port",
    "3843": "Quest Common Agent",
    "3844": "RNM",
    "3845": "V-ONE Single Port Proxy",
    "3846": "Astare Network PCP",
    "3847": "MS Firewall Control",
    "3848": "IT Environmental Monitor",
    "3849": "SPACEWAY DNS Preload",
    "3850": "QTMS Bootstrap Protocol",
    "3851": "SpectraTalk Port",
    "3852": "SSE App Configuration",
    "3853": "SONY scanning protocol",
    "3854": "Stryker Comm Port",
    "3855": "OpenTRAC",
    "3856": "INFORMER",
    "3857": "Trap Port",
    "3858": "Trap Port MOM",
    "3859": "Navini Port",
    "3860": "Server/Application State Protocol (SASP)",
    "3861": "winShadow Host Discovery",
    "3862": "GIGA-POCKET",
    "3863": "asap udp port",
    "3864": "Reserved",
    "3865": "xpl automation protocol",
    "3866": "Sun SDViz DZDAEMON Port",
    "3867": "Sun SDViz DZOGLSERVER Port",
    "3868": "Reserved",
    "3869": "hp OVSAM MgmtServer Disco",
    "3870": "hp OVSAM HostAgent Disco",
    "3871": "Avocent DS Authorization",
    "3872": "OEM Agent",
    "3873": "fagordnc",
    "3874": "SixXS Configuration",
    "3875": "PNBSCADA",
    "3876": "DirectoryLockdown Agent",
    "3876": "DirectoryLockdown Agent",
    "3877": "XMPCR Interface Port",
    "3878": "FotoG CAD interface",
    "3879": "appss license manager",
    "3880": "IGRS",
    "3881": "Data Acquisition and Control",
    "3882": "DTS Service Port",
    "3883": "VR Peripheral Network",
    "3884": "SofTrack Metering",
    "3885": "TopFlow SSL",
    "3886": "NEI management port",
    "3887": "Ciphire Data Transport",
    "3888": "Ciphire Services",
    "3889": "D and V Tester Control Port",
    "3890": "Niche Data Server Connect",
    "3891": "Oracle RTC-PM port",
    "3892": "PCC-image-port",
    "3893": "CGI StarAPI Server",
    "3894": "SyAM Agent Port",
    "3895": "SyAm SMC Service Port",
    "3896": "Simple Distributed Objects over TLS",
    "3897": "Simple Distributed Objects over SSH",
    "3898": "IAS, Inc. SmartEye NET Internet Protocol",
    "3899": "ITV Port",
    "3900": "Unidata UDT OS",
    "3900": "Unidata UDT OS",
    "3901": "NIM Service Handler",
    "3902": "NIMsh Auxiliary Port",
    "3903": "CharsetMGR",
    "3904": "Arnet Omnilink Port",
    "3905": "Mailbox Update (MUPDATE) protocol",
    "3906": "TopoVista elevation data",
    "3907": "Imoguia Port",
    "3908": "HP Procurve NetManagement",
    "3909": "SurfControl CPA",
    "3910": "Printer Request Port",
    "3911": "Printer Status Port",
    "3912": "Global Maintech Stars",
    "3913": "ListCREATOR Port",
    "3914": "ListCREATOR Port 2",
    "3915": "Auto-Graphics Cataloging",
    "3916": "WysDM Controller",
    "3917": "AFT multiplex port",
    "3918": "PacketCableMultimediaCOPS",
    "3919": "HyperIP",
    "3920": "Exasoft IP Port",
    "3921": "Herodotus Net",
    "3922": "Soronti Update Port",
    "3923": "Symbian Service Broker",
    "3924": "MPL_GPRS_Port",
    "3925": "Zoran Media Port",
    "3926": "WINPort",
    "3927": "ScsTsr",
    "3928": "PXE NetBoot Manager",
    "3929": "AMS Port",
    "3930": "Syam Web Server Port",
    "3931": "MSR Plugin Port",
    "3932": "Dynamic Site System",
    "3933": "PL/B App Server User Port",
    "3934": "PL/B File Manager Port",
    "3935": "SDP Port Mapper Protocol",
    "3936": "Mailprox",
    "3937": "DVB Service Discovery",
    "3938": "Oracle dbControl Agent po",
    "3938": "Oracle dbControl Agent po",
    "3939": "Anti-virus Application Management Port",
    "3940": "XeCP Node Service",
    "3941": "Home Portal Web Server",
    "3942": "satellite distribution",
    "3943": "TetraNode Ip Gateway",
    "3944": "S-Ops Management",
    "3945": "EMCADS Server Port",
    "3946": "BackupEDGE Server",
    "3947": "Connect and Control Protocol for Consumer, Commercial, and Industrial Electronic Devices",
    "3948": "Anton Paar Device Administration Protocol",
    "3949": "Dynamic Routing Information Protocol",
    "3950": "Name Munging",
    "3951": "PWG IPP Facsimile",
    "3952": "I3 Session Manager",
    "3953": "Eydeas XMLink Connect",
    "3954": "AD Replication RPC",
    "3955": "p2pCommunity",
    "3956": "GigE Vision Control",
    "3957": "MQEnterprise Broker",
    "3958": "MQEnterprise Agent",
    "3959": "Tree Hopper Networking",
    "3960": "Bess Peer Assessment",
    "3961": "ProAxess Server",
    "3962": "SBI Agent Protocol",
    "3963": "Teran Hybrid Routing Protocol",
    "3964": "SASG GPRS",
    "3965": "Avanti IP to NCPE API",
    "3966": "BuildForge Lock Manager",
    "3967": "PPS Message Service",
    "3968": "iAnywhere DBNS",
    "3969": "Landmark Messages",
    "3970": "LANrev Agent",
    "3971": "LANrev Server",
    "3972": "ict-control Protocol",
    "3973": "ConnectShip Progistics",
    "3974": "Remote Applicant Tracking Service",
    "3975": "Air Shot",
    "3976": "Server Automation Agent",
    "3977": "Opsware Manager",
    "3978": "Secured Configuration Server",
    "3979": "Smith Micro Wide Area Network Service",
    "3980": "Reserved",
    "3981": "Starfish System Admin",
    "3982": "ESRI Image Server",
    "3983": "ESRI Image Service",
    "3984": "MAPPER network node manager",
    "3985": "MAPPER TCP/IP server",
    "3986": "MAPPER workstation server",
    "3986": "MAPPER workstation server",
    "3987": "Centerline",
    "3988": "DCS Configuration Port",
    "3989": "BindView-Query Engine",
    "3990": "BindView-IS",
    "3991": "BindView-SMCServer",
    "3992": "BindView-DirectoryServer",
    "3993": "BindView-Agent",
    "3995": "ISS Management Svcs SSL",
    "3996": "abcsoftware-01",
    "3997": "aes_db",
    "3998": "Distributed Nagios Executor Service",
    "3999": "Norman distributes scanning service",
    "4000": "Terabase",
    "4001": "NewOak",
    "4002": "pxc-spvr-ft",
    "4003": "pxc-splr-ft",
    "4004": "pxc-roid",
    "4005": "pxc-pin",
    "4006": "pxc-spvr",
    "4007": "pxc-splr",
    "4008": "NetCheque accounting",
    "4009": "Chimera HWM",
    "4010": "Samsung Unidex",
    "4011": "Alternate Service Boot",
    "4012": "PDA Gate",
    "4013": "ACL Manager",
    "4014": "TAICLOCK",
    "4015": "Talarian Mcast",
    "4016": "Talarian Mcast",
    "4017": "Talarian Mcast",
    "4018": "Talarian Mcast",
    "4019": "Talarian Mcast",
    "4020": "TRAP Port",
    "4021": "Nexus Portal",
    "4022": "DNOX",
    "4023": "ESNM Zoning Port",
    "4024": "TNP1 User Port",
    "4025": "Partition Image Port",
    "4026": "Graphical Debug Server",
    "4027": "bitxpress",
    "4028": "DTServer Port",
    "4029": "IP Q signaling protocol",
    "4030": "Accell/JSP Daemon Port",
    "4031": "UUCP over SSL",
    "4032": "VERITAS Authorization Service",
    "4033": "SANavigator Peer Port",
    "4034": "Ubiquinox Daemon",
    "4035": "WAP Push OTA-HTTP port",
    "4036": "WAP Push OTA-HTTP secure",
    "4037": "RaveHD network control",
    "4038": "Fazzt Point-To-Point",
    "4039": "Fazzt Administration",
    "4040": "Yo.net main service",
    "4041": "Rocketeer-Houston",
    "4042": "LDXP",
    "4043": "Neighbour Identity Resolution",
    "4044": "Location Tracking Protocol",
    "4045": "Network Paging Protocol",
    "4046": "Accounting Protocol",
    "4047": "Context Transfer Protocol",
    "4049": "Wide Area File Services",
    "4050": "Wide Area File Services",
    "4051": "Cisco Peer to Peer Distribution Protocol",
    "4052": "VoiceConnect Interact",
    "4053": "CosmoCall Universe Communications Port 1",
    "4054": "CosmoCall Universe Communications Port 2",
    "4055": "CosmoCall Universe Communications Port 3",
    "4056": "Location Message Service",
    "4057": "Servigistics WFM server",
    "4058": "Kingfisher protocol",
    "4059": "DLMS/COSEM",
    "4060": "DSMETER Inter-Agent Transfer Channel",
    "4060": "DSMETER Inter-Agent Transfer Channel",
    "4061": "Ice Location Service (TCP)",
    "4062": "Ice Location Service (SSL)",
    "4063": "Ice Firewall Traversal Service (TCP)",
    "4064": "Ice Firewall Traversal Service (SSL)",
    "4065": "Avanti Common Data",
    "4065": "Avanti Common Data",
    "4066": "Performance Measurement and Analysis",
    "4067": "Information Distribution Protocol",
    "4068": "IP Fleet Broadcast",
    "4069": "Minger Email Address Validation Service",
    "4070": "Trivial IP Encryption (TrIPE)",
    "4071": "Automatically Incremental Backup",
    "4072": "Zieto Socket Communications",
    "4073": "Interactive Remote Application Pairing Protocol",
    "4074": "Cequint City ID UI trigger",
    "4075": "ISC Alarm Message Service",
    "4076": "Seraph DCS",
    "4077": "Ascom IP Alarming",
    "4078": "Reserved",
    "4079": "SANtools Diagnostic Server",
    "4080": "Lorica inside facing",
    "4081": "Lorica inside facing (SSL)",
    "4082": "Lorica outside facing",
    "4083": "Lorica outside facing (SSL)",
    "4084": "Fortisphere VM Service",
    "4085": "Reserved",
    "4086": "Firewall/NAT state table synchronization",
    "4087": "Reserved",
    "4088": "Reserved",
    "4089": "OpenCORE Remote Control Service",
    "4090": "OMA BCAST Service Guide",
    "4091": "EminentWare Installer",
    "4092": "EminentWare DGS",
    "4093": "Pvx Plus CS Host",
    "4094": "sysrq daemon",
    "4095": "xtgui information service",
    "4096": "BRE (Bridge Relay Element)",
    "4097": "Patrol View",
    "4098": "drmsfsd",
    "4099": "DPCP",
    "4100": "IGo Incognito Data Port",
    "4101": "Braille protocol",
    "4102": "Braille protocol",
    "4103": "Braille protocol",
    "4104": "Braille protocol",
    "4105": "Shofar",
    "4106": "Synchronite",
    "4107": "JDL Accounting LAN Service",
    "4108": "ACCEL",
    "4109": "Instantiated Zero-control Messaging",
    "4110": "G2 RFID Tag Telemetry Data",
    "4111": "Xgrid",
    "4112": "Apple VPN Server Reporting Protocol",
    "4113": "AIPN LS Registration",
    "4114": "JomaMQMonitor",
    "4115": "CDS Transfer Agent",
    "4116": "smartcard-TLS",
    "4117": "Hillr Connection Manager",
    "4118": "Netadmin Systems NETscript service",
    "4119": "Assuria Log Manager",
    "4120": "Reserved",
    "4121": "e-Builder Application Communication",
    "4122": "Fiber Patrol Alarm Service",
    "4123": "Z-Wave Protocol",
    "4124": "Rohill TetraNode Ip Gateway v2",
    "4125": "Opsview Envoy",
    "4126": "Data Domain Replication Service",
    "4127": "NetUniKeyServer",
    "4128": "NuFW decision delegation protocol",
    "4129": "NuFW authentication protocol",
    "4130": "FRONET message protocol",
    "4131": "Global Maintech Stars",
    "4132": "NUTS Daemon",
    "4132": "NUTS Daemon",
    "4133": "NUTS Bootp Server",
    "4133": "NUTS Bootp Server",
    "4134": "NIFTY-Serve HMI protocol",
    "4135": "Classic Line Database Server Attach",
    "4136": "Classic Line Database Server Request",
    "4137": "Classic Line Database Server Remote",
    "4138": "nettest",
    "4139": "Imperfect Networks Server",
    "4140": "Cedros Fraud Detection System",
    "4140": "Cedros Fraud Detection System",
    "4141": "Workflow Server",
    "4142": "Document Server",
    "4143": "Document Replication",
    "4145": "VVR Control",
    "4146": "TGCConnect Beacon",
    "4147": "Multum Service Manager",
    "4148": "HHB Handheld Client",
    "4149": "A10 GSLB Service",
    "4150": "PowerAlert Network Shutdown Agent",
    "4151": "Men &amp; Mice Remote Control",
    "4151": "Men &amp; Mice Remote Control",
    "4152": "iDigTech Multiplex",
    "4152": "iDigTech Multiplex",
    "4153": "MBL Remote Battery Monitoring",
    "4154": "atlinks device discovery",
    "4155": "Bazaar version control system",
    "4156": "STAT Results",
    "4157": "STAT Scanner Control",
    "4158": "STAT Command Center",
    "4159": "Network Security Service",
    "4160": "Jini Discovery",
    "4161": "OMS Contact",
    "4162": "OMS Topology",
    "4163": "Silver Peak Peer Protocol",
    "4164": "Silver Peak Communication Protocol",
    "4165": "ArcLink over Ethernet",
    "4166": "Joost Peer to Peer Protocol",
    "4167": "DeskDirect Global Network",
    "4168": "PrintSoft License Server",
    "4169": "Internet ADT Discovery Protocol",
    "4170": "Reserved",
    "4171": "Reserved",
    "4172": "PC over IP",
    "4173": "MMA Device Discovery",
    "4174": "StorMagic Discovery",
    "4175": "Reserved",
    "4176": "Reserved",
    "4177": "Wello P2P pubsub service",
    "4178": "StorMan",
    "4179": "Maxum Services",
    "4180": "HTTPX",
    "4181": "MacBak",
    "4182": "Production Company Pro TCP Service",
    "4183": "CyborgNet communications protocol",
    "4184": "UNIVERSE SUITE MESSAGE SERVICE",
    "4184": "UNIVERSE SUITE MESSAGE SERVICE",
    "4185": "Woven Control Plane Protocol",
    "4186": "Reserved",
    "4187": "Reserved",
    "4188": "Vatata Peer to Peer Protocol",
    "4189": "Reserved",
    "4190": "Reserved",
    "4191": "Dual Stack MIPv6 NAT Traversal",
    "4192": "azeti blinddate",
    "4193": "Reserved",
    "4194": "Reserved",
    "4195": "AWS protocol for cloud remoting solution",
    "4197": "Harman HControl Protocol",
    "4199": "EIMS ADMIN",
    "4300": "Corel CCam",
    "4301": "Diagnostic Data",
    "4302": "Diagnostic Data Control",
    "4303": "Simple Railroad Command Protocol",
    "4304": "One-Wire Filesystem Server",
    "4305": "better approach to mobile ad-hoc networking",
    "4306": "Hellgate London",
    "4307": "TrueConf Videoconference Service",
    "4308": "CompX-LockView",
    "4309": "Exsequi Appliance Discovery",
    "4310": "Mir-RT exchange service",
    "4311": "Reserved",
    "4312": "Reserved",
    "4313": "Reserved",
    "4314": "Reserved",
    "4316": "Reserved",
    "4317": "Reserved",
    "4319": "Fox SkyTale encrypted communication",
    "4320": "FDT Remote Categorization Protocol",
    "4321": "Remote Who Is",
    "4322": "TRIM Event Service",
    "4323": "TRIM ICE Service",
    "4325": "Cadcorp GeognoSIS Administrator",
    "4326": "Cadcorp GeognoSIS",
    "4327": "Jaxer Web Protocol",
    "4328": "Jaxer Manager Command Protocol",
    "4329": "Reserved",
    "4330": "Reserved",
    "4331": "Reserved",
    "4332": "Reserved",
    "4333": "ArrowHead Service Protocol (AHSP)",
    "4334": "Reserved",
    "4335": "Reserved",
    "4336": "Reserved",
    "4340": "Gaia Connector Protocol",
    "4341": "LISP Data Packets",
    "4342": "LISP Control Packets",
    "4343": "UNICALL",
    "4344": "VinaInstall",
    "4345": "Macro 4 Network AS",
    "4346": "ELAN LM",
    "4347": "LAN Surveyor",
    "4348": "ITOSE",
    "4349": "File System Port Map",
    "4350": "Net Device",
    "4351": "PLCY Net Services",
    "4352": "Projector Link",
    "4353": "F5 iQuery",
    "4354": "QSNet Transmitter",
    "4355": "QSNet Workstation",
    "4356": "QSNet Assistant",
    "4357": "QSNet Conductor",
    "4358": "QSNet Nucleus",
    "4359": "OMA BCAST Long-Term Key Messages",
    "4360": "Reserved",
    "4361": "NavCom Discovery and Control Port",
    "4362": "AFORE vNode Discovery protocol",
    "4366": "ShadowStream System",
    "4368": "WeatherBrief Direct",
    "4369": "Erlang Port Mapper Daemon",
    "4370": "ELPRO V2 Protocol Tunnel",
    "4370": "ELPRO V2 Protocol Tunnel",
    "4371": "LAN2CAN Discovery",
    "4372": "LAN2CAN Data",
    "4373": "Remote Authenticated Command Service",
    "4374": "Reserved",
    "4375": "Toltec EasyShare",
    "4376": "BioAPI Interworking",
    "4377": "Cambridge Pixel SPx Server",
    "4378": "Cambridge Pixel SPx Display",
    "4379": "CTDB",
    "4389": "Xandros Community Management Service",
    "4390": "Physical Access Control",
    "4391": "Reserved",
    "4392": "Reserved",
    "4393": "Reserved",
    "4394": "American Printware Discovery",
    "4395": "OmniVision communication for Virtual environments",
    "4396": "Reserved",
    "4400": "ASIGRA Services",
    "4401": "ASIGRA Televaulting DS-System Service",
    "4402": "ASIGRA Televaulting DS-Client Service",
    "4403": "ASIGRA Televaulting DS-Client Monitoring/Management",
    "4404": "ASIGRA Televaulting DS-System Monitoring/Management",
    "4405": "ASIGRA Televaulting Message Level Restore service",
    "4406": "ASIGRA Televaulting DS-Sleeper Service",
    "4407": "Reserved",
    "4408": "Reserved",
    "4409": "Reserved",
    "4410": "Reserved",
    "4411": "Reserved",
    "4412": "SmallChat",
    "4413": "AVI Systems NMS",
    "4414": "Reserved",
    "4415": "Reserved",
    "4416": "PJJ Media Player discovery",
    "4417": "Reserved",
    "4418": "AXYS communication protocol",
    "4419": "Reserved",
    "4420": "NVM Express over Fabrics storage access",
    "4421": "Reserved",
    "4422": "Reserved",
    "4423": "Reserved",
    "4425": "NetROCKEY6 SMART Plus Service",
    "4426": "SMARTS Beacon Port",
    "4427": "Reserved",
    "4428": "Reserved",
    "4429": "Reserved",
    "4430": "REAL SQL Server",
    "4431": "Reserved",
    "4432": "L-ACOUSTICS management",
    "4433": "Reserved",
    "4441": "Netblox Protocol",
    "4442": "Saris",
    "4443": "Pharos",
    "4444": "KRB524",
    "4445": "UPNOTIFYP",
    "4446": "N1-FWP",
    "4447": "N1-RMGMT",
    "4448": "ASC Licence Manager",
    "4449": "PrivateWire",
    "4450": "Common ASCII Messaging Protocol",
    "4451": "CTI System Msg",
    "4452": "CTI Program Load",
    "4453": "NSS Alert Manager",
    "4454": "NSS Agent Manager",
    "4455": "PR Chat User",
    "4456": "PR Chat Server",
    "4457": "PR Register",
    "4458": "Matrix Configuration Protocol",
    "4460": "Reserved",
    "4484": "hpssmgmt service",
    "4485": "Reserved",
    "4486": "Integrated Client Message Service",
    "4487": "Reserved",
    "4488": "Apple Wide Area Connectivity Service ICE Bootstrap",
    "4500": "IPsec NAT-Traversal",
    "4534": "Armagetron Advanced Game Server",
    "4535": "Event Heap Server",
    "4536": "Event Heap Server SSL",
    "4537": "WSS Security Service",
    "4538": "Software Data Exchange Gateway",
    "4545": "WorldScores",
    "4546": "SF License Manager (Sentinel)",
    "4547": "Lanner License Manager",
    "4548": "Synchromesh",
    "4549": "Aegate PMR Service",
    "4550": "Perman I Interbase Server",
    "4551": "MIH Services",
    "4552": "Men and Mice Monitoring",
    "4553": "Reserved",
    "4554": "MS FRS Replication",
    "4555": "RSIP Port",
    "4556": "DTN Bundle UDP CL Protocol",
    "4557": "Marathon everRun Quorum Service Server",
    "4558": "Marathon everRun Quorum Service Manager",
    "4559": "HylaFAX",
    "4563": "Reserved",
    "4566": "Kids Watch Time Control Service",
    "4567": "TRAM",
    "4568": "BMC Reporting",
    "4569": "Inter-Asterisk eXchange",
    "4570": "Reserved",
    "4573": "Reserved",
    "4590": "Reserved",
    "4591": "HRPD L3T (AT-AN)",
    "4592": "HRPD-ITH (AT-AN)",
    "4593": "IPT (ANRI-ANRI)",
    "4594": "IAS-Session (ANRI-ANRI)",
    "4595": "IAS-Paging (ANRI-ANRI)",
    "4596": "IAS-Neighbor (ANRI-ANRI)",
    "4597": "A21 (AN-1xBS)",
    "4598": "A16 (AN-AN)",
    "4599": "A17 (AN-AN)",
    "4600": "Piranha1",
    "4601": "Piranha2",
    "4602": "Reserved",
    "4603": "Reserved",
    "4604": "Reserved",
    "4605": "Reserved",
    "4606": "Reserved",
    "4621": "Bidirectional single port remote radio VOIP and Control stream",
    "4646": "Distributed Denial-of-Service Open Threat Signaling (DOTS) ",
    "4658": "PlayStation2 App Port",
    "4659": "PlayStation2 Lobby Port",
    "4660": "smaclmgr",
    "4661": "Kar2ouche Peer location service",
    "4662": "OrbitNet Message Service",
    "4663": "Note It! Message Service",
    "4664": "Rimage Messaging Server",
    "4665": "Container Client Message Service",
    "4666": "E-Port Message Service",
    "4667": "MMA Comm Services",
    "4668": "MMA EDS Service",
    "4669": "E-Port Data Service",
    "4670": "Light packets transfer protocol",
    "4671": "Bull RSF action server",
    "4672": "remote file access server",
    "4673": "CXWS Operations",
    "4674": "AppIQ Agent Management",
    "4675": "BIAP Device Status",
    "4676": "BIAP Generic Alert",
    "4677": "Business Continuity Servi",
    "4678": "boundary traversal",
    "4679": "MGE UPS Supervision",
    "4680": "MGE UPS Management",
    "4681": "Parliant Telephony System",
    "4682": "finisar",
    "4683": "Spike Clipboard Service",
    "4684": "RFID Reader Protocol 1.0",
    "4685": "Autopac Protocol",
    "4686": "Manina Service Protocol",
    "4687": "Network Scanner Tool FTP",
    "4688": "Mobile P2P Service",
    "4689": "Altova DatabaseCentral",
    "4690": "Prelude IDS message proto",
    "4691": "monotone Netsync Protocol",
    "4692": "Conspiracy messaging",
    "4700": "NetXMS Agent",
    "4701": "NetXMS Management",
    "4702": "NetXMS Server Synchronization",
    "4703": "Reserved",
    "4704": "Reserved",
    "4711": "Trinity Trust Network Node Communication",
    "4725": "TruckStar Service",
    "4726": "A26 (FAP-FGW)",
    "4727": "F-Link Client Information Service Discovery",
    "4728": "CA Port Multiplexer",
    "4729": "GSM Interface Tap",
    "4730": "Gearman Job Queue System",
    "4731": "Reserved",
    "4732": "OHM server trigger",
    "4733": "Reserved",
    "4737": "IPDR/SP",
    "4738": "SoleraTec Locator",
    "4739": "IP Flow Info Export",
    "4740": "ipfix protocol over DTLS",
    "4741": "Luminizer Manager",
    "4742": "SICCT Service Discovery Protocol",
    "4743": "openhpi HPI service",
    "4744": "Internet File Synchronization Protocol",
    "4745": "Funambol Mobile Push",
    "4746": "IntelliAdmin Discovery",
    "4747": "peer-to-peer file exchange protocol",
    "4749": "Profile for Mac",
    "4750": "Simple Service Auto Discovery",
    "4751": "Simple Policy Control Protocol",
    "4752": "Simple Network Audio Protocol",
    "4753": "Simple Invocation of Methods Over Network (SIMON) Discovery",
    "4754": "GRE-in-UDP Encapsulation",
    "4755": "GRE-in-UDP Encapsulation with DTLS",
    "4756": "Reserved",
    "4774": "Reserved",
    "4784": "BFD Multihop Control",
    "4785": "Cisco Nexus Control Protocol",
    "4786": "Reserved",
    "4787": "Reserved",
    "4788": "Reserved",
    "4789": "Virtual eXtensible Local Area Network (VXLAN)",
    "4790": "Generic Protocol Extension for Virtual eXtensible Local Area Network (VXLAN)",
    "4791": "IP Routable RocE",
    "4792": "IP Routable Unified Bus",
    "4800": "Icona Instant Messenging System",
    "4801": "Icona Web Embedded Chat",
    "4802": "Icona License System Server",
    "4803": "Notateit Messaging Discovery",
    "4804": "AJA ntv4 Video System Discovery",
    "4827": "HTCP",
    "4837": "Varadero-0",
    "4838": "Varadero-1",
    "4839": "Varadero-2",
    "4840": "OPC UA Multicast Datagram Protocol",
    "4841": "QUOSA Virtual Library Service",
    "4842": "nCode ICE-flow Library AppServer",
    "4843": "OPC UA TCP Protocol over TLS/SSL",
    "4844": "nCode ICE-flow Library LogServer",
    "4845": "WordCruncher Remote Library Service",
    "4846": "Contamac ICM Service",
    "4846": "Contamac ICM Service",
    "4847": "Web Fresh Communication",
    "4848": "App Server - Admin HTTP",
    "4849": "App Server - Admin HTTPS",
    "4850": "Sun App Server - NA",
    "4851": "Apache Derby Replication",
    "4867": "Unify Debugger",
    "4868": "Photon Relay",
    "4869": "Photon Relay Debug",
    "4870": "Citcom Tracking Service",
    "4871": "Wired",
    "4876": "Tritium CAN Bus Bridge Service",
    "4877": "Lighting Management Control System",
    "4878": "Agilent Instrument Discovery",
    "4879": "Reserved",
    "4880": "Reserved",
    "4881": "SOCP Time Synchronization Protocol",
    "4882": "SOCP Control Protocol",
    "4883": "Reserved",
    "4884": "HiveStor Distributed File System",
    "4885": "ABBS",
    "4888": "Reserved",
    "4889": "Reserved",
    "4894": "LysKOM Protocol A",
    "4899": "RAdmin Port",
    "4900": "HFSQL Client/Server Database Engine",
    "4901": "Reserved",
    "4902": "Reserved",
    "4912": "Reserved",
    "4914": "Bones Remote Control",
    "4915": "Reserved",
    "4936": "Signal protocol port for autonomic networking",
    "4937": "ATSC-M/H Service Signaling Channel",
    "4940": "Equitrac Office",
    "4941": "Equitrac Office",
    "4942": "Equitrac Office",
    "4949": "Munin Graphing Framework",
    "4950": "Sybase Server Monitor",
    "4951": "PWG WIMS",
    "4952": "SAG Directory Server",
    "4953": "Reserved",
    "4969": "CCSS QMessageMonitor",
    "4970": "CCSS QSystemMonitor",
    "4971": "Reserved",
    "4980": "Citrix Virtual Path",
    "4984": "Reserved",
    "4985": "Reserved",
    "4986": "Model Railway Interface Program",
    "4987": "SMAR Ethernet Port 1",
    "4988": "SMAR Ethernet Port 2",
    "4989": "Parallel for GAUSS (tm)",
    "4990": "BusySync Calendar Synch. Protocol",
    "4991": "VITA Radio Transport",
    "4999": "HFSQL Client/Server Database Engine Manager",
    "5000": "",
    "5001": "",
    "5002": "radio free ethernet",
    "5003": "FileMaker, Inc. - Proprietary name binding",
    "5004": "RTP media data",
    "5005": "RTP control protocol",
    "5006": "wsm server",
    "5007": "wsm server ssl",
    "5008": "Synapsis EDGE",
    "5009": "Microsoft Windows Filesystem",
    "5010": "TelepathStart",
    "5011": "TelepathAttack",
    "5012": "NetOnTap Service",
    "5013": "FileMaker, Inc. - Proprietary transport",
    "5014": "Overlay Network Protocol",
    "5015": "Reserved",
    "5020": "zenginkyo-1",
    "5021": "zenginkyo-2",
    "5022": "mice server",
    "5023": "Htuil Server for PLD2",
    "5024": "SCPI-TELNET",
    "5025": "SCPI-RAW",
    "5026": "Storix I/O daemon (data)",
    "5027": "Storix I/O daemon (stat)",
    "5028": "Reserved",
    "5029": "Infobright Database Server",
    "5030": "Reserved",
    "5031": "Direct Message Protocol",
    "5032": "Reserved",
    "5033": "Reserved",
    "5034": "Reserved",
    "5042": "asnaacceler8db",
    "5043": "ShopWorX Administration",
    "5044": "LXI Event Service",
    "5045": "Reserved",
    "5046": "Vishay PM UDP Service",
    "5047": "iSCAPE Data Broadcasting",
    "5048": "Reserved",
    "5049": "iVocalize Web Conference",
    "5050": "multimedia conference control tool",
    "5051": "ITA Agent",
    "5052": "ITA Manager",
    "5053": "RLM Discovery Server",
    "5054": "Reserved",
    "5055": "UNOT",
    "5056": "Intecom Pointspan 1",
    "5057": "Intecom Pointspan 2",
    "5058": "Locus Discovery",
    "5059": "SIP Directory Services",
    "5060": "SIP",
    "5061": "SIP-TLS",
    "5062": "Localisation access",
    "5063": "Reserved",
    "5064": "Channel Access 1",
    "5065": "Channel Access 2",
    "5066": "STANAG-5066-SUBNET-INTF",
    "5067": "Authentx Service",
    "5068": "Reserved",
    "5069": "I/Net 2000-NPR",
    "5070": "VersaTrans Server Agent Service",
    "5071": "PowerSchool",
    "5072": "Anything In Anything",
    "5073": "Advantage Group Port Mgr",
    "5074": "ALES Query",
    "5075": "Reserved",
    "5078": "PixelPusher pixel data",
    "5079": "Cambridge Pixel SPx Reports",
    "5080": "OnScreen Data Collection Service",
    "5081": "SDL - Ent Trans Server",
    "5082": "Qpur Communication Protocol",
    "5083": "Qpur File Protocol",
    "5084": "EPCglobal Low-Level Reader Protocol",
    "5085": "EPCglobal Encrypted LLRP",
    "5086": "Reserved",
    "5087": "Reserved",
    "5092": "Magpie Binary",
    "5093": "Sentinel LM",
    "5094": "HART-IP",
    "5099": "SentLM Srv2Srv",
    "5100": "Socalia service mux",
    "5101": "Talarian_UDP",
    "5102": "Oracle OMS non-secure",
    "5103": "Reserved",
    "5104": "TinyMessage",
    "5105": "Hughes Association Protocol",
    "5106": "Reserved",
    "5107": "Reserved",
    "5111": "TAEP AS service",
    "5112": "PeerMe Msg Cmd Service",
    "5114": "Reserved",
    "5115": "Reserved",
    "5116": "EPSON Projecter Image Transfer",
    "5117": "Reserved",
    "5120": "Barracuda Backup Protocol",
    "5133": "Policy Commander",
    "5134": "Reserved",
    "5135": "Reserved",
    "5136": "Minotaur SA",
    "5137": "MyCTS server port",
    "5145": "RMONITOR SECURE",
    "5145": "RMONITOR SECURE",
    "5146": "Reserved",
    "5150": "Ascend Tunnel Management Protocol",
    "5151": "ESRI SDE Remote Start",
    "5151": "ESRI SDE Remote Start",
    "5152": "ESRI SDE Instance Discovery",
    "5153": "Reserved",
    "5154": "BZFlag game server",
    "5155": "Oracle asControl Agent",
    "5156": "Reserved",
    "5157": "Reserved",
    "5161": "Reserved",
    "5162": "Reserved",
    "5163": "Reserved",
    "5164": "Virtual Protocol Adapter Discovery",
    "5165": "ife_1corp",
    "5165": "ife_1corp",
    "5166": "WinPCS Service Connection",
    "5167": "SCTE104 Connection",
    "5168": "SCTE30 Connection",
    "5172": "Reserved",
    "5190": "America-Online",
    "5191": "AmericaOnline1",
    "5192": "AmericaOnline2",
    "5193": "AmericaOnline3",
    "5194": "Reserved",
    "5195": "Reserved",
    "5196": "Reserved",
    "5197": "Reserved",
    "5200": "TARGUS GetData",
    "5201": "TARGUS GetData 1",
    "5202": "TARGUS GetData 2",
    "5203": "TARGUS GetData 3",
    "5209": "Reserved",
    "5215": "Reserved",
    "5221": "Reserved",
    "5222": "Reserved",
    "5223": "HP Virtual Machine Group Management",
    "5224": "HP Virtual Machine Console Operations",
    "5225": "HP Server",
    "5226": "HP Status",
    "5227": "HP System Performance Metric Service",
    "5228": "Reserved",
    "5229": "Reserved",
    "5230": "Reserved",
    "5231": "Reserved",
    "5232": "Reserved",
    "5233": "Reserved",
    "5234": "EEnet communications",
    "5235": "Galaxy Network Service",
    "5236": "",
    "5237": "m-net discovery",
    "5242": "Reserved",
    "5243": "Reserved",
    "5245": "DownTools Discovery Protocol",
    "5246": "CAPWAP Control Protocol",
    "5247": "CAPWAP Data Protocol",
    "5248": "CA Access Control Web Service",
    "5249": "CA AC Lang Service",
    "5250": "soaGateway",
    "5251": "CA eTrust VM Service",
    "5252": "Movaz SSC",
    "5253": "Reserved",
    "5254": "Reserved",
    "5264": "3Com Network Jack Port 1",
    "5265": "3Com Network Jack Port 2",
    "5269": "Reserved",
    "5270": "Cartographer XMP",
    "5271": "StageSoft CueLink discovery",
    "5272": "PK",
    "5280": "Reserved",
    "5281": "Reserved",
    "5282": "Marimba Transmitter Port",
    "5298": "XMPP Link-Local Messaging",
    "5299": "NLG Data Service",
    "5300": "HA cluster heartbeat",
    "5301": "HA cluster general services",
    "5302": "HA cluster configuration",
    "5303": "HA cluster probing",
    "5304": "HA Cluster Commands",
    "5305": "HA Cluster Test",
    "5306": "Sun MC Group",
    "5307": "SCO AIP",
    "5308": "CFengine",
    "5309": "J Printer",
    "5310": "Outlaws",
    "5312": "Permabit Client-Server",
    "5313": "Real-time &amp; Reliable Data",
    "5314": "opalis-rbt-ipc",
    "5315": "HA Cluster UDP Polling",
    "5316": "Unassigned",
    "5317": "Reserved",
    "5318": "Reserved",
    "5320": "Reserved",
    "5321": "Reserved",
    "5343": "Sculptor Database Server",
    "5344": "xkoto DRCP",
    "5349": "STUN over DTLS",
    "5350": "Port Control Protocol Multicast",
    "5351": "Port Control Protocol",
    "5352": "DNS Long-Lived Queries",
    "5353": "Multicast DNS",
    "5354": "Multicast DNS Responder IPC",
    "5355": "LLMNR",
    "5356": "Microsoft Small Business",
    "5357": "Web Services for Devices",
    "5358": "WS for Devices Secured",
    "5359": "Microsoft Alerter",
    "5360": "Protocol for Windows SideShow",
    "5361": "Secure Protocol for Windows SideShow",
    "5362": "Microsoft Windows Server WSD2 Service",
    "5363": "Windows Network Projection",
    "5364": "Microsoft Kernel Debugger",
    "5397": "StressTester(tm) Injector",
    "5398": "Elektron Administration",
    "5399": "SecurityChase",
    "5400": "Excerpt Search",
    "5401": "Excerpt Search Secure",
    "5402": "OmniCast MFTP",
    "5403": "HPOMS-CI-LSTN",
    "5404": "HPOMS-DPS-LSTN",
    "5405": "NetSupport",
    "5406": "Systemics Sox",
    "5407": "Foresyte-Clear",
    "5408": "Foresyte-Sec",
    "5409": "Salient Data Server",
    "5410": "Salient User Manager",
    "5411": "ActNet",
    "5412": "Continuus",
    "5413": "WWIOTALK",
    "5414": "StatusD",
    "5415": "NS Server",
    "5416": "SNS Gateway",
    "5417": "SNS Agent",
    "5418": "MCNTP",
    "5419": "DJ-ICE",
    "5420": "Cylink-C",
    "5421": "Net Support 2",
    "5422": "Salient MUX",
    "5423": "VIRTUALUSER",
    "5424": "Beyond Remote",
    "5425": "Beyond Remote Command Channel",
    "5426": "DEVBASIC",
    "5427": "SCO-PEER-TTA",
    "5428": "TELACONSOLE",
    "5429": "Billing and Accounting System Exchange",
    "5430": "RADEC CORP",
    "5431": "PARK AGENT",
    "5432": "PostgreSQL Database",
    "5433": "Pyrrho DBMS",
    "5434": "SGI Array Services Daemon",
    "5435": "SCEANICS situation and action notification",
    "5436": "pmip6-cntl",
    "5437": "pmip6-data",
    "5443": "Pearson HTTPS",
    "5445": "Reserved",
    "5450": "TiePie engineering data acquisition (discovery)",
    "5453": "SureBox",
    "5454": "APC 5454",
    "5455": "APC 5455",
    "5456": "APC 5456",
    "5461": "SILKMETER",
    "5462": "TTL Publisher",
    "5463": "TTL Price Proxy",
    "5464": "Quail Networks Object Broker",
    "5465": "NETOPS-BROKER",
    "5470": "Reserved",
    "5471": "Reserved",
    "5472": "Reserved",
    "5473": "Reserved",
    "5474": "The Apsolab company's status query protocol",
    "5475": "Reserved",
    "5500": "fcp-addr-srvr1",
    "5501": "fcp-addr-srvr2",
    "5502": "fcp-srvr-inst1",
    "5503": "fcp-srvr-inst2",
    "5504": "fcp-cics-gw1",
    "5505": "Checkout Database",
    "5506": "Amcom Mobile Connect",
    "5507": "Reserved",
    "5540": "Matter Operational Discovery and Communi",
    "5543": "Reserved",
    "5550": "Reserved",
    "5553": "SGI Eventmond Port",
    "5554": "SGI ESP HTTP",
    "5555": "Personal Agent",
    "5556": "Freeciv gameplay",
    "5557": "Reserved",
    "5565": "Reserved",
    "5566": "Reserved",
    "5567": "DOF Protocol Stack Multicast/Secure Transport",
    "5568": "Session Data Transport Multicast",
    "5569": "PLASA E1.33, Remote Device Management (RDM) messages",
    "5573": "SAS Domain Management Messaging Protocol",
    "5574": "Reserved",
    "5575": "Reserved",
    "5579": "Reserved",
    "5580": "T-Mobile SMS Protocol Message 0",
    "5581": "T-Mobile SMS Protocol Message 1",
    "5582": "T-Mobile SMS Protocol Message 3",
    "5583": "T-Mobile SMS Protocol Message 2",
    "5584": "BeInSync-Web",
    "5585": "BeInSync-sync",
    "5586": "Reserved",
    "5597": "inin secure messaging",
    "5598": "MCT Market Data Feed",
    "5599": "Enterprise Security Remote Install",
    "5600": "Enterprise Security Manager",
    "5601": "Enterprise Security Agent",
    "5602": "A1-MSC",
    "5603": "A1-BS",
    "5604": "A3-SDUNode",
    "5605": "A4-SDUNode",
    "5618": "Reserved",
    "5627": "Node Initiated Network Association Forma",
    "5628": "HTrust API",
    "5629": "Symantec Storage Foundation for Database",
    "5630": "PreciseCommunication",
    "5631": "pcANYWHEREdata",
    "5632": "pcANYWHEREstat",
    "5633": "BE Operations Request Listener",
    "5634": "SF Message Service",
    "5635": "Reserved",
    "5636": "Reserved",
    "5637": "Reserved",
    "5638": "Reserved",
    "5639": "Reserved",
    "5646": "Reserved",
    "5666": "Reserved",
    "5670": "Local area discovery and messaging over ZeroMQ",
    "5671": "amqp protocol over TLS/SSL",
    "5672": "AMQP",
    "5673": "JACL Message Server",
    "5674": "HyperSCSI Port",
    "5675": "V5UA application port",
    "5676": "RA Administration",
    "5677": "Quest Central DB2 Launchr",
    "5678": "Remote Replication Agent Connection",
    "5679": "Direct Cable Connect Manager",
    "5680": "Auriga Router Service",
    "5681": "Net-coneX Control Protocol",
    "5682": "BrightCore control &amp; data transfer exchange",
    "5683": "Constrained Application Protocol",
    "5684": "DTLS-secured CoAP",
    "5687": "GOG multiplayer game protocol",
    "5688": "GGZ Gaming Zone",
    "5689": "QM video network management protocol",
    "5693": "Reserved",
    "5696": "Reserved",
    "5700": "Reserved",
    "5705": "Reserved",
    "5713": "proshare conf audio",
    "5714": "proshare conf video",
    "5715": "proshare conf data",
    "5716": "proshare conf request",
    "5717": "proshare conf notify",
    "5718": "DPM Communication Server",
    "5719": "DPM Agent Coordinator",
    "5720": "MS-Licensing",
    "5721": "Desktop Passthru Service",
    "5722": "Microsoft DFS Replication Service",
    "5723": "Operations Manager - Health Service",
    "5724": "Operations Manager - SDK Service",
    "5725": "Reserved",
    "5726": "Reserved",
    "5727": "Reserved",
    "5728": "Dist. I/O Comm. Service Group Membership",
    "5729": "Openmail User Agent Layer",
    "5730": "Steltor's calendar access",
    "5741": "IDA Discover Port 1",
    "5742": "IDA Discover Port 2",
    "5743": "Watchdoc NetPOD Protocol",
    "5744": "Watchdoc Server",
    "5745": "fcopy-server",
    "5746": "fcopys-server",
    "5747": "Wildbits Tunatic",
    "5748": "Wildbits Tunalyzer",
    "5750": "Bladelogic Agent Service",
    "5755": "OpenMail Desk Gateway server",
    "5757": "OpenMail X.500 Directory Server",
    "5766": "OpenMail NewMail Server",
    "5767": "OpenMail Suer Agent Layer (Secure)",
    "5768": "OpenMail CMTS Server",
    "5769": "x509solutions Internal CA",
    "5770": "x509solutions Secure Data",
    "5771": "NetAgent",
    "5777": "Control commands and responses",
    "5780": "Reserved",
    "5781": "3PAR Event Reporting Service",
    "5782": "3PAR Management Service",
    "5783": "3PAR Management Service with SSL",
    "5784": "Cisco Interbox Application Redundancy",
    "5785": "3PAR Inform Remote Copy",
    "5786": "redundancy notification",
    "5787": "Cisco WAAS Cluster Protocol",
    "5793": "XtreamX Supervised Peer message",
    "5794": "Simple Peered Discovery Protocol",
    "5798": "Reserved",
    "5813": "ICMPD",
    "5814": "Support Automation",
    "5820": "Reserved",
    "5841": "Reserved",
    "5842": "Reserved",
    "5859": "WHEREHOO",
    "5863": "PlanetPress Suite Messeng",
    "5868": "Reserved",
    "5900": "Remote Framebuffer",
    "5903": "Flight &amp; Flow Info for Collaborative Env",
    "5904": "Air-Ground SWIM",
    "5905": "Adv Surface Mvmnt and Guidance Cont Sys",
    "5906": "Remotely Piloted Vehicle C&amp;C",
    "5907": "Distress and Safety Data App",
    "5908": "IPS Management Application",
    "5909": "Air-ground media advisory",
    "5910": "Air Traffic Services applications using ATN",
    "5911": "Air Traffic Services applications using ACARS",
    "5912": "Aeronautical Information Service/Meteorological applications using ACARS",
    "5913": "Airline operational communications applications using ACARS",
    "5963": "Indy Application Server",
    "5968": "mppolicy-v5",
    "5969": "mppolicy-mgr",
    "5984": "CouchDB",
    "5985": "WBEM WS-Management HTTP",
    "5986": "WBEM WS-Management HTTP over TLS/SSL",
    "5987": "WBEM RMI",
    "5988": "WBEM CIM-XML (HTTP)",
    "5989": "WBEM CIM-XML (HTTPS)",
    "5990": "WBEM Export HTTPS",
    "5991": "NUXSL",
    "5992": "Consul InSight Security",
    "5993": "Reserved",
    "5994": "Reserved",
    "5999": "CVSup",
    "6000": "X Window System",
    "6064": "NDL-AHP-SVC",
    "6065": "WinPharaoh",
    "6066": "EWCTSP",
    "6068": "Reserved",
    "6069": "TRIP",
    "6070": "Messageasap",
    "6071": "SSDTP",
    "6072": "DIAGNOSE-PROC",
    "6073": "DirectPlay8",
    "6074": "Microsoft Max",
    "6075": "Reserved",
    "6076": "Reserved",
    "6077": "Reserved",
    "6080": "Generic UDP Encapsulation",
    "6081": "Generic Network Virtualization Encapsulation (Geneve)",
    "6082": "APCO Project 25 Common Air Interface - UDP encapsulation",
    "6083": "telecomsoftware miami broadcast",
    "6084": "Reserved",
    "6085": "konspire2b p2p network",
    "6086": "PDTP P2P",
    "6087": "Local Download Sharing Service",
    "6088": "SuperDog License Manager Notifier",
    "6099": "Reserved",
    "6100": "SynchroNet-db",
    "6101": "SynchroNet-rtc",
    "6102": "SynchroNet-upd",
    "6103": "RETS",
    "6104": "DBDB",
    "6105": "Prima Server",
    "6106": "MPS Server",
    "6107": "ETC Control",
    "6108": "Sercomm-SCAdmin",
    "6109": "GLOBECAST-ID",
    "6110": "HP SoftBench CM",
    "6111": "HP SoftBench Sub-Process Control",
    "6112": "Desk-Top Sub-Process Control Daemon",
    "6113": "Reserved",
    "6114": "Reserved",
    "6115": "Reserved",
    "6116": "Reserved",
    "6117": "Reserved",
    "6118": "Transparent Inter Process Communication",
    "6121": "Reserved",
    "6122": "Backup Express Web Server",
    "6123": "Backup Express",
    "6124": "Phlexible Network Backup Service",
    "6130": "Reserved",
    "6133": "New Boundary Tech WOL",
    "6140": "Pulsonix Network License Service",
    "6141": "Meta Corporation License Manager",
    "6142": "Aspen Technology License Manager",
    "6143": "Watershed License Manager",
    "6144": "StatSci License Manager - 1",
    "6145": "StatSci License Manager - 2",
    "6146": "Lone Wolf Systems License Manager",
    "6147": "Montage License Manager",
    "6148": "Ricardo North America License Manager",
    "6149": "tal-pod",
    "6159": "Reserved",
    "6160": "Emerson Extensible Control and Management Protocol Data",
    "6161": "PATROL Internet Srv Mgr",
    "6162": "PATROL Collector",
    "6163": "Precision Scribe Cnx Port",
    "6200": "LM-X License Manager by X-Formation",
    "6201": "Management of service nodes in a processing grid for thermodynamic calculations",
    "6209": "QMTP over TLS",
    "6222": "Radmind Access Protocol",
    "6241": "JEOL Network Services Dynamic Discovery Protocol 1",
    "6242": "JEOL Network Services Dynamic Discovery Protocol 2",
    "6243": "JEOL Network Services Dynamic Discovery Protocol 3",
    "6244": "JEOL Network Services Dynamic Discovery Protocol 4",
    "6251": "TL1 Raw Over SSL/TLS",
    "6252": "TL1 over SSH",
    "6253": "CRIP",
    "6267": "Reserved",
    "6268": "Grid Authentication",
    "6269": "Grid Authentication Alt",
    "6300": "BMC GRX",
    "6301": "BMC CONTROL-D LDAP SERVER",
    "6301": "BMC CONTROL-D LDAP SERVER",
    "6306": "Unified Fabric Management Protocol",
    "6315": "Sensor Control Unit Protocol Discovery Protocol",
    "6316": "Ethernet Sensor Communications Protocol",
    "6317": "Navtech Radar Sensor Data",
    "6320": "Double-Take Replication Service",
    "6321": "Empress Software Connectivity Server 1",
    "6322": "Empress Software Connectivity Server 2",
    "6324": "HR Device Network service",
    "6325": "Reserved",
    "6326": "Reserved",
    "6343": "sFlow traffic monitoring",
    "6344": "Reserved",
    "6346": "gnutella-svc",
    "6347": "gnutella-rtr",
    "6350": "App Discovery and Access Protocol",
    "6355": "PMCS applications",
    "6360": "MetaEdit+ Multi-User",
    "6363": "Named Data Networking",
    "6370": "MetaEdit+ Server Administration",
    "6379": "Reserved",
    "6382": "Metatude Dialogue Server",
    "6389": "clariion-evr01",
    "6390": "MetaEdit+ WebService API",
    "6417": "Faxcom Message Service",
    "6418": "Reserved",
    "6419": "Simple VDR Protocol Discovery",
    "6420": "NIM_VDRShell",
    "6421": "NIM_WAN",
    "6432": "Reserved",
    "6440": "Reserved",
    "6442": "Reserved",
    "6443": "Service Registry Default HTTPS Domain",
    "6444": "Grid Engine Qmaster Service",
    "6444": "Grid Engine Qmaster Service",
    "6445": "Grid Engine Execution Service",
    "6445": "Grid Engine Execution Service",
    "6446": "MySQL Proxy",
    "6455": "SKIP Certificate Receive",
    "6456": "SKIP Certificate Send",
    "6464": "Port assignment for medical device communication in ",
    "6471": "LVision License Manager",
    "6480": "Service Registry Default HTTP Domain",
    "6481": "Service Tags",
    "6482": "Logical Domains Management Interface",
    "6483": "SunVTS RMI",
    "6484": "Service Registry Default JMS Domain",
    "6485": "Service Registry Default IIOP Domain",
    "6486": "Service Registry Default IIOPS Domain",
    "6487": "Service Registry Default IIOPAuth Domain",
    "6488": "Service Registry Default JMX Domain",
    "6489": "Service Registry Default Admin Domain",
    "6500": "BoKS Master",
    "6501": "BoKS Servc",
    "6501": "BoKS Servc",
    "6502": "BoKS Servm",
    "6502": "BoKS Servm",
    "6503": "BoKS Clntd",
    "6503": "BoKS Clntd",
    "6505": "BoKS Admin Private Port",
    "6505": "BoKS Admin Private Port",
    "6506": "BoKS Admin Public Port",
    "6506": "BoKS Admin Public Port",
    "6507": "BoKS Dir Server, Private Port",
    "6507": "BoKS Dir Server, Private Port",
    "6508": "BoKS Dir Server, Public Port",
    "6508": "BoKS Dir Server, Public Port",
    "6509": "MGCS-MFP Port",
    "6510": "MCER Port",
    "6511": "Datagram Congestion Control Protocol Encapsulation for NAT Traversal",
    "6513": "Reserved",
    "6514": "syslog over DTLS",
    "6515": "Elipse RPC Protocol",
    "6543": "lds_distrib",
    "6544": "LDS Dump Service",
    "6547": "APC 6547",
    "6548": "APC 6548",
    "6549": "APC 6549",
    "6550": "fg-sysupdate",
    "6551": "Software Update Manager",
    "6556": "Reserved",
    "6558": "",
    "6566": "SANE Control Port",
    "6568": "Roaring Penguin IP Address Reputation Collection",
    "6579": "Affiliate",
    "6580": "Parsec Masterserver",
    "6581": "Parsec Peer-to-Peer",
    "6582": "Parsec Gameserver",
    "6583": "JOA Jewel Suite",
    "6600": "Reserved",
    "6601": "Reserved",
    "6602": "Reserved",
    "6619": "ODETTE-FTP over TLS/SSL",
    "6620": "Kerberos V5 FTP Data",
    "6621": "Kerberos V5 FTP Control",
    "6622": "Multicast FTP",
    "6623": "Kerberos V5 Telnet",
    "6624": "Reserved",
    "6625": "Reserved",
    "6626": "WAGO Service and Update",
    "6627": "Allied Electronics NeXGen",
    "6628": "AFE Stock Channel M/C",
    "6629": "Secondary, (non ANDI) multi-protocol multi-function interface to",
    "6632": "Reserved",
    "6633": "Cisco vPath Services Overlay",
    "6634": "MPLS Performance Measurement out-of-band response",
    "6635": "Encapsulate MPLS packets in UDP tunnels.",
    "6636": "Encapsulate MPLS packets in UDP tunnels with DTLS.",
    "6640": "Reserved",
    "6653": "OpenFlow",
    "6655": "Reserved",
    "6656": "Reserved",
    "6657": "PalCom Discovery",
    "6665": "Reserved",
    "6670": "Vocaltec Global Online Directory",
    "6671": "P4P Portal Service",
    "6672": "vision_server",
    "6672": "vision_server",
    "6673": "vision_elmd",
    "6673": "vision_elmd",
    "6678": "Viscount Freedom Bridge Discovery",
    "6679": "Osorno Automation",
    "6687": "Reserved",
    "6688": "Reserved",
    "6689": "Tofino Security Appliance",
    "6690": "Reserved",
    "6696": "Babel Routing Protocol",
    "6697": "Reserved",
    "6699": "Babel Routing Protocol over DTLS",
    "6701": "KTI/ICAD Nameserver",
    "6702": "e-Design network",
    "6703": "e-Design web",
    "6704": "Reserved",
    "6705": "Reserved",
    "6706": "Reserved",
    "6714": "Internet Backplane Protocol",
    "6715": "Fibotrader Communications",
    "6716": "Reserved",
    "6767": "BMC PERFORM AGENT",
    "6768": "BMC PERFORM MGRD",
    "6769": "ADInstruments GxP Server",
    "6770": "PolyServe http",
    "6771": "PolyServe https",
    "6777": "Reserved",
    "6778": "Reserved",
    "6784": "Bidirectional Forwarding Detection (BFD) on Link Aggregation Group (LAG) Interfaces",
    "6785": "DGPF Individual Exchange",
    "6786": "Sun Java Web Console JMX",
    "6787": "Sun Web Console Admin",
    "6788": "SMC-HTTP",
    "6789": "Reserved",
    "6790": "HNMP",
    "6791": "Halcyon Network Manager",
    "6801": "ACNET Control System Protocol",
    "6817": "Reserved",
    "6831": "ambit-lm",
    "6841": "Netmo Default",
    "6842": "Netmo HTTP",
    "6850": "ICCRUSHMORE",
    "6868": "Acctopus Status",
    "6888": "MUSE",
    "6900": "Reserved",
    "6901": "Reserved",
    "6924": "Ping with RX/TX latency/loss split",
    "6935": "EthoScan Service",
    "6936": "XenSource Management Service",
    "6946": "Biometrics Server",
    "6951": "OTLP",
    "6961": "JMACT3",
    "6962": "jmevt2",
    "6963": "swismgr1",
    "6964": "swismgr2",
    "6965": "swistrap",
    "6966": "swispol",
    "6969": "acmsoda",
    "6970": "Reserved",
    "6980": "QoS-extended OLSR protocol",
    "6997": "Mobility XE Protocol",
    "6998": "IATP-highPri",
    "6999": "IATP-normalPri",
    "7000": "file server itself",
    "7001": "callbacks to cache managers",
    "7002": "users &amp; groups database",
    "7003": "volume location database",
    "7004": "AFS/Kerberos authentication service",
    "7005": "volume managment server",
    "7006": "error interpretation service",
    "7007": "basic overseer process",
    "7008": "server-to-server updater",
    "7009": "remote cache manager service",
    "7010": "onlinet uninterruptable power supplies",
    "7011": "Talon Discovery Port",
    "7012": "Talon Engine",
    "7013": "Microtalon Discovery",
    "7014": "Microtalon Communications",
    "7015": "Talon Webserver",
    "7016": "SPG Controls Carrier",
    "7017": "GeneRic Autonomic Signaling Protocol",
    "7018": "Reserved",
    "7019": "doceri drawing service screen view",
    "7020": "DP Serve",
    "7021": "DP Serve Admin",
    "7022": "CT Discovery Protocol",
    "7023": "Comtech T2 NMCS",
    "7024": "Vormetric service",
    "7025": "Vormetric Service II",
    "7026": "Reserved",
    "7030": "ObjectPlanet probe",
    "7031": "Reserved",
    "7040": "Quest application level network service discovery",
    "7070": "ARCP",
    "7071": "IWGADTS Aircraft Housekeeping Message",
    "7072": "iba Device Configuration Protocol",
    "7073": "Reserved",
    "7080": "EmpowerID Communication",
    "7088": "Zixi live video transport protocol",
    "7095": "Java Discovery Protocol",
    "7099": "lazy-ptop",
    "7100": "X Font Service",
    "7101": "Embedded Light Control Network",
    "7107": "AES-X170",
    "7117": "Reserved",
    "7121": "Virtual Prototypes License Manager",
    "7123": "Reserved",
    "7128": "intelligent data manager",
    "7129": "Catalog Content Search",
    "7161": "CA BSM Comm",
    "7162": "CA Storage Manager",
    "7163": "CA Connection Broker",
    "7164": "File System Repository Agent",
    "7165": "Document WCF Server",
    "7166": "Aruba eDiscovery Server",
    "7167": "Reserved",
    "7168": "Reserved",
    "7169": "Consequor Consulting Process Integration Bridge",
    "7170": "Adaptive Name/Service Resolution",
    "7171": "Discovery and Retention Mgt Production",
    "7172": "Reserved",
    "7173": "Reserved",
    "7174": "Clutild",
    "7181": "Janus Guidewire Enterprise Discovery Service Bus",
    "7200": "FODMS FLIP",
    "7201": "DLIP",
    "7202": "Reserved",
    "7215": "Reserved",
    "7216": "Reserved",
    "7227": "Registry A &amp; M Protocol",
    "7228": "Reserved",
    "7229": "Reserved",
    "7234": "Reserved",
    "7235": "ASP Coordination Protocol",
    "7236": "Reserved",
    "7237": "Reserved",
    "7244": "FrontRow Calypso Human Interface Control Protocol",
    "7262": "Calypso Network Access Protocol",
    "7272": "WatchMe Monitoring 7272",
    "7273": "OMA Roaming Location",
    "7274": "OMA Roaming Location SEC",
    "7275": "OMA UserPlane Location",
    "7276": "OMA Internal Location Protocol",
    "7277": "OMA Internal Location Secure Protocol",
    "7278": "OMA Dynamic Content Delivery over CBS",
    "7279": "Citrix Licensing",
    "7280": "ITACTIONSERVER 1",
    "7281": "ITACTIONSERVER 2",
    "7282": "eventACTION/ussACTION (MZCA) alert",
    "7283": "Reserved",
    "7365": "LifeKeeper Communications",
    "7391": "mind-file system server",
    "7392": "mrss-rendezvous server",
    "7393": "nFoldMan Remote Publish",
    "7394": "File system export of backup images",
    "7395": "winqedit",
    "7397": "Hexarc Command Language",
    "7400": "RTPS Discovery",
    "7401": "RTPS Data-Distribution User-Traffic",
    "7402": "RTPS Data-Distribution Meta-Traffic",
    "7410": "Ionix Network Monitor",
    "7411": "Streaming of measurement data",
    "7420": "Multichannel real-time lighting control",
    "7421": "Matisse Port Monitor",
    "7426": "OpenView DM Postmaster Manager",
    "7427": "OpenView DM Event Agent Manager",
    "7428": "OpenView DM Log Agent Manager",
    "7429": "OpenView DM rqt communication",
    "7430": "OpenView DM xmpv7 api pipe",
    "7431": "OpenView DM ovc/xmpv3 api pipe",
    "7437": "Faximum",
    "7443": "Oracle Application Server HTTPS",
    "7471": "Reserved",
    "7473": "Rise: The Vieneo Province",
    "7474": "Reserved",
    "7478": "Reserved",
    "7491": "telops-lmd",
    "7500": "Silhouette User",
    "7501": "HP OpenView Bus Daemon",
    "7508": "Reserved",
    "7509": "Reserved",
    "7510": "HP OpenView Application Server",
    "7511": "pafec-lm",
    "7542": "Saratoga Transfer Protocol",
    "7543": "atul server",
    "7544": "FlowAnalyzer DisplayServer",
    "7545": "FlowAnalyzer UtilityServer",
    "7546": "Cisco Fabric service",
    "7547": "Broadband Forum CWMP",
    "7548": "Threat Information Distribution Protocol",
    "7549": "Network Layer Signaling Transport Layer",
    "7550": "Cloud Signaling Service",
    "7551": "Reserved",
    "7560": "Sniffer Command Protocol",
    "7563": "Reserved",
    "7566": "VSI Omega",
    "7569": "Reserved",
    "7570": "Aries Kfinder",
    "7574": "Oracle Coherence Cluster discovery service",
    "7588": "Sun License Manager",
    "7606": "MIPI Alliance Debug",
    "7624": "Instrument Neutral Distributed Interface",
    "7626": "De-registered",
    "7627": "SOAP Service Port",
    "7628": "Primary Agent Work Notification",
    "7629": "OpenXDAS Wire Protocol",
    "7630": "Reserved",
    "7631": "Reserved",
    "7633": "PMDF Management",
    "7648": "bonjour-cuseeme",
    "7663": "Proprietary immutable distributed data storage",
    "7672": "Reserved",
    "7673": "Reserved",
    "7674": "iMQ SSL tunnel",
    "7675": "iMQ Tunnel",
    "7676": "iMQ Broker Rendezvous",
    "7677": "Sun App Server - HTTPS",
    "7680": "Microsoft Delivery Optimization Peer-to-Peer",
    "7683": "Reserved",
    "7687": "Reserved",
    "7689": "Collaber Network Service",
    "7690": "Reserved",
    "7697": "KLIO communications",
    "7700": "Reserved",
    "7701": "Reserved",
    "7707": "EM7 Dynamic Updates",
    "7708": "scientia.net",
    "7720": "MedImage Portal",
    "7724": "Novell Snap-in Deep Freeze Control",
    "7725": "Nitrogen Service",
    "7726": "FreezeX Console Service",
    "7727": "Trident Systems Data",
    "7728": "Open-Source Virtual Reality",
    "7734": "Smith Protocol over IP",
    "7738": "HP Enterprise Discovery Agent",
    "7741": "ScriptView Network",
    "7742": "Reserved",
    "7743": "Sakura Script Transfer Protocol",
    "7744": "RAQMON PDU",
    "7747": "Put/Run/Get Protocol",
    "7775": "Reserved",
    "7777": "cbt",
    "7778": "Interwise",
    "7779": "VSTAT",
    "7781": "accu-lmgr",
    "7784": "Seamless Bidirectional Forwarding Detection (S-BFD)",
    "7786": "MINIVEND",
    "7787": "Popup Reminders Receive",
    "7789": "Office Tools Pro Receive",
    "7794": "Q3ADE Cluster Service",
    "7797": "Propel Connector port",
    "7798": "Propel Encoder port",
    "7799": "Alternate BSDP Service",
    "7800": "Apple Software Restore",
    "7801": "Secure Server Protocol - client",
    "7802": "Virtualized Network Services Tunnel Protocol",
    "7810": "Riverbed WAN Optimization Protocol",
    "7845": "APC 7845",
    "7846": "APC 7846",
    "7847": "Reserved",
    "7869": "Reserved",
    "7870": "Reserved",
    "7871": "Reserved",
    "7872": "TLS-based Mobile IPv6 Security",
    "7878": "Reserved",
    "7880": "Pearson",
    "7887": "Universal Broker",
    "7900": "Multicast Event",
    "7901": "TNOS Service Protocol",
    "7902": "TNOS shell Protocol",
    "7903": "TNOS Secure DiaguardProtocol",
    "7913": "QuickObjects secure port",
    "7932": "Tier 2 Data Resource Manager",
    "7933": "Tier 2 Business Rules Manager",
    "7962": "Encrypted, extendable, general-purpose synchronization protocol",
    "7967": "Supercell",
    "7979": "Micromuse-ncps",
    "7980": "Quest Vista",
    "7981": "Reserved",
    "7982": "Spotlight on SQL Server Desktop Agent Discovery",
    "7997": "Reserved",
    "7998": "USI Content Push Service",
    "7999": "iRDMI2",
    "8000": "iRDMI",
    "8001": "VCOM Tunnel",
    "8002": "Teradata ORDBMS",
    "8003": "Mulberry Connect Reporting Service",
    "8004": "Reserved",
    "8005": "MXI Generation II for z/OS",
    "8006": "World Programming analytics discovery",
    "8007": "I/O oriented cluster computing software",
    "8008": "HTTP Alternate",
    "8009": "Reserved",
    "8015": "Reserved",
    "8016": "Reserved",
    "8017": "Cisco Cloudsec Dataplane Port Number",
    "8019": "QB DB Dynamic Port",
    "8020": "Intuit Entitlement Service and Discovery",
    "8021": "Intuit Entitlement Client",
    "8022": "oa-system",
    "8023": "ARCATrust vault API",
    "8025": "CA Audit Distribution Agent",
    "8026": "CA Audit Distribution Server",
    "8027": "peer tracker and data relay service",
    "8032": "ProEd",
    "8033": "MindPrint",
    "8034": ".vantronix Management",
    "8040": "Ampify Messaging Protocol",
    "8041": "Xcorpeon ASIC Carrier Ethernet Transport",
    "8042": "Reserved",
    "8043": "Reserved",
    "8044": "Reserved",
    "8051": "Reserved",
    "8052": "Senomix Timesheets Server",
    "8053": "Senomix Timesheets Client [1 year assignment]",
    "8054": "Senomix Timesheets Server [1 year assignment]",
    "8055": "Senomix Timesheets Server [1 year assignment]",
    "8056": "Senomix Timesheets Server [1 year assignment]",
    "8057": "Senomix Timesheets Client [1 year assignment]",
    "8058": "Senomix Timesheets Client [1 year assignment]",
    "8059": "Senomix Timesheets Client [1 year assignment]",
    "8060": "Asymmetric Extended Route Optimization (AERO)",
    "8061": "Reserved",
    "8066": "Reserved",
    "8067": "Reserved",
    "8070": "Reserved",
    "8074": "Gadu-Gadu",
    "8077": "Reserved",
    "8080": "HTTP Alternate (see port 80)",
    "8081": "Sun Proxy Admin Service",
    "8082": "Utilistor (Client)",
    "8083": "Utilistor (Server)",
    "8084": "Reserved",
    "8086": "Distributed SCADA Networking Rendezvous Port",
    "8087": "Simplify Media SPP Protocol",
    "8088": "Radan HTTP",
    "8090": "Reserved",
    "8091": "Reserved",
    "8097": "SAC Port Id",
    "8100": "Xprint Server",
    "8101": "Reserved",
    "8102": "Reserved",
    "8111": "Skynetflow network services",
    "8115": "MTL8000 Matrix",
    "8116": "Check Point Clustering",
    "8117": "Reserved",
    "8118": "Privoxy HTTP proxy",
    "8121": "Apollo Data Port",
    "8122": "Apollo Admin Port",
    "8128": "PayCash Online Protocol",
    "8129": "PayCash Wallet-Browser",
    "8130": "INDIGO-VRMI",
    "8131": "INDIGO-VBCP",
    "8132": "dbabble",
    "8140": "Reserved",
    "8148": "i-SDD file transfer",
    "8149": "Edge of Reality game data",
    "8153": "Reserved",
    "8160": "Patrol",
    "8161": "Patrol SNMP",
    "8162": "Reserved",
    "8181": "Reserved",
    "8182": "VMware Fault Domain Manager",
    "8183": "Reserved",
    "8184": "Remote iTach Connection",
    "8190": "Reserved",
    "8191": "Reserved",
    "8192": "SpyTech Phone Service",
    "8194": "Bloomberg data API",
    "8195": "Bloomberg feed",
    "8199": "VVR DATA",
    "8200": "TRIVNET",
    "8201": "TRIVNET",
    "8202": "Audio+Ethernet Standard Open Protocol",
    "8204": "LM Perfworks",
    "8205": "LM Instmgr",
    "8206": "LM Dta",
    "8207": "LM SServer",
    "8208": "LM Webwatcher",
    "8211": "Aruba Networks AP management",
    "8230": "RexecJ Server",
    "8231": "HNCP",
    "8232": "HNCP over DTLS",
    "8243": "Synapse Non Blocking HTTPS",
    "8266": "ESPeasy peer-2-peer communication",
    "8270": "Reserved",
    "8276": "Microsoft Connected Cache",
    "8280": "Synapse Non Blocking HTTP",
    "8282": "Libelle EnterpriseBus discovery",
    "8292": "Bloomberg professional",
    "8293": "Reserved",
    "8294": "Bloomberg intelligent client",
    "8300": "Transport Management Interface",
    "8301": "Amberon PPC/PPS",
    "8313": "Reserved",
    "8320": "Thin(ium) Network Protocol",
    "8321": "Thin(ium) Network Protocol",
    "8322": "Garmin Marine",
    "8351": "Server Find",
    "8376": "Cruise ENUM",
    "8377": "Cruise SWROUTE",
    "8378": "Cruise CONFIG",
    "8379": "Cruise DIAGS",
    "8380": "Cruise UPDATE",
    "8383": "M2m Services",
    "8384": "Marathon Transport Protocol",
    "8400": "cvd",
    "8401": "sabarsd",
    "8402": "abarsd",
    "8403": "admind",
    "8404": "Reserved",
    "8405": "Reserved",
    "8415": "Reserved",
    "8416": "eSpeech Session Protocol",
    "8417": "eSpeech RTP Protocol",
    "8423": "Reserved",
    "8432": "Reserved",
    "8433": "Non Persistent Desktop and Application Streaming",
    "8442": "CyBro A-bus Protocol",
    "8443": "PCsync HTTPS",
    "8444": "PCsync HTTP",
    "8445": "Port for copy discovery",
    "8448": "Reserved",
    "8450": "npmp",
    "8457": "Reserved",
    "8470": "Reserved",
    "8471": "Reserved",
    "8472": "Overlay Transport Virtualization (OTV)",
    "8473": "Virtual Point to Point",
    "8474": "AquaMinds NoteShare",
    "8500": "Flight Message Transfer Protocol",
    "8501": "CYTEL Message Transfer Audio and Video",
    "8502": "Reserved",
    "8503": "MPLS LSP Self-Ping",
    "8554": "RTSP Alternate (see port 554)",
    "8555": "SYMAX D-FENCE",
    "8567": "DOF Tunneling Protocol",
    "8600": "Surveillance Data",
    "8609": "Canon Compact Printer Protocol Discovery",
    "8610": "Canon MFNP Service",
    "8611": "Canon BJNP Port 1",
    "8612": "Canon BJNP Port 2",
    "8613": "Canon BJNP Port 3",
    "8614": "Canon BJNP Port 4",
    "8615": "Reserved",
    "8665": "Reserved",
    "8666": "Reserved",
    "8668": "Reserved",
    "8675": "Motorola Solutions Customer Programming Software for Radio Management Discovery",
    "8686": "Sun App Server - JMX/RMI",
    "8688": "Reserved",
    "8699": "Reserved",
    "8710": "Reserved",
    "8711": "Reserved",
    "8732": "DASGIP Net Services",
    "8733": "iBus",
    "8750": "Reserved",
    "8763": "MC-APPSERVER",
    "8764": "OPENQUEUE",
    "8765": "Ultraseek HTTP",
    "8766": "Agilent Connectivity Service",
    "8767": "Reserved",
    "8768": "Reserved",
    "8769": "Reserved",
    "8770": "Digital Photo Access Protocol (iPhoto)",
    "8778": "Reserved",
    "8786": "Message Client",
    "8787": "Message Server",
    "8793": "Accedian Performance Measurement",
    "8800": "Sun Web Server Admin Service",
    "8804": "truecm",
    "8805": "Destination Port number for PFCP",
    "8807": "HES-CLIP Interoperability protocol",
    "8808": "STATSports Broadcast Service",
    "8809": "MCPTT Off-Network Protocol (MONP)",
    "8873": "dxspider linking protocol",
    "8880": "CDDBP",
    "8881": "Reserved",
    "8883": "Secure MQTT",
    "8888": "NewsEDGE server UDP (UDP 1)",
    "8889": "NewsEDGE server broadcast",
    "8890": "NewsEDGE client broadcast",
    "8891": "Desktop Data UDP 3: NESS application",
    "8892": "Desktop Data UDP 4: FARM product",
    "8893": "Desktop Data UDP 5: NewsEDGE/Web application",
    "8894": "Desktop Data UDP 6: COAL application",
    "8899": "ospf-lite",
    "8900": "JMB-CDS 1",
    "8901": "JMB-CDS 2",
    "8908": "Reserved",
    "8910": "manyone-http",
    "8911": "manyone-xml",
    "8912": "Windows Client Backup",
    "8913": "Dragonfly System Service",
    "8937": "Reserved",
    "8953": "Reserved",
    "8954": "Cumulus Admin Port",
    "8980": "Network of Devices Provider",
    "8981": "Network of Devices Client",
    "8989": "Sun Web Server SSL Admin Service",
    "8990": "webmail HTTP service",
    "8991": "webmail HTTPS service",
    "8997": "Reserved",
    "8998": "Reserved",
    "8999": "Brodos Crypto Trade Protocol",
    "9000": "CSlistener",
    "9001": "ETL Service Manager",
    "9002": "DynamID authentication",
    "9005": "Reserved",
    "9007": "Open Grid Services Client",
    "9008": "Reserved",
    "9009": "Pichat Server",
    "9010": "Reserved",
    "9011": "D-Star Routing digital voice+data for amateur radio",
    "9020": "TAMBORA",
    "9021": "Pangolin Identification",
    "9022": "PrivateArk Remote Agent",
    "9023": "Secure Web Access - 1",
    "9024": "Secure Web Access - 2",
    "9025": "Secure Web Access - 3",
    "9026": "Secure Web Access - 4",
    "9050": "Reserved",
    "9051": "Reserved",
    "9060": "CardWeb realtime device data",
    "9080": "Groove GLRPC",
    "9081": "Required for Adaptive Quality of Service",
    "9083": "Reserved",
    "9084": "IBM AURORA Performance Visualizer",
    "9085": "IBM Remote System Console",
    "9086": "Vesa Net2Display",
    "9087": "Classic Data Server",
    "9088": "IBM Informix SQL Interface",
    "9089": "IBM Informix SQL Interface - Encrypted",
    "9090": "WebSM",
    "9091": "xmltec-xmlmail",
    "9092": "Xml-Ipc Server Reg",
    "9093": "Reserved",
    "9100": "PDL Data Streaming Port",
    "9101": "Bacula Director",
    "9102": "Bacula File Daemon",
    "9103": "Bacula Storage Daemon",
    "9104": "PeerWire",
    "9105": "Xadmin Control Service",
    "9106": "Astergate Discovery Service",
    "9107": "Reserved",
    "9111": "Multiple Purpose, Distributed Message Bus",
    "9119": "MXit Instant Messaging",
    "9122": "Reserved",
    "9123": "Reserved",
    "9131": "Dynamic Device Discovery",
    "9160": "apani1",
    "9161": "apani2",
    "9162": "apani3",
    "9163": "apani4",
    "9164": "apani5",
    "9191": "Sun AppSvr JPDA",
    "9200": "WAP connectionless session service",
    "9201": "WAP session service",
    "9202": "WAP secure connectionless session service",
    "9203": "WAP secure session service",
    "9204": "WAP vCard",
    "9205": "WAP vCal",
    "9206": "WAP vCard Secure",
    "9207": "WAP vCal Secure",
    "9208": "rjcdb vCard",
    "9209": "ALMobile System Service",
    "9210": "OMA Mobile Location Protocol",
    "9211": "OMA Mobile Location Protocol Secure",
    "9212": "Server View dbms access",
    "9213": "ServerStart RemoteControl",
    "9214": "IPDC ESG BootstrapService",
    "9215": "Integrated Setup and Install Service",
    "9216": "Aionex Communication Management Engine",
    "9217": "FSC Communication Port",
    "9222": "QSC Team Coherence",
    "9255": "Manager On Network",
    "9277": "GPS Data transmitted from train to ground network",
    "9278": "Pegasus GPS Platform",
    "9279": "Pegaus GPS System Control Interface",
    "9280": "Predicted GPS",
    "9281": "SofaWare transport port 1",
    "9282": "SofaWare transport port 2",
    "9283": "CallWaveIAM",
    "9284": "VERITAS Information Serve",
    "9285": "N2H2 Filter Service Port",
    "9286": "n2 monitoring receiver",
    "9287": "Cumulus",
    "9292": "ArmTech Daemon",
    "9293": "StorView Client",
    "9294": "ARMCenter http Service",
    "9295": "ARMCenter https Service",
    "9300": "Virtual Racing Service",
    "9306": "Reserved",
    "9310": "Reserved",
    "9312": "Reserved",
    "9318": "PKIX TimeStamp over TLS",
    "9321": "guibase",
    "9339": "Reserved",
    "9340": "Reserved",
    "9343": "MpIdcMgr",
    "9344": "Mphlpdmc",
    "9345": "Reserved",
    "9346": "C Tech Licensing",
    "9374": "fjdmimgr",
    "9380": "Brivs! Open Extensible Protocol",
    "9387": "Reserved",
    "9388": "Reserved",
    "9389": "Reserved",
    "9390": "Reserved",
    "9396": "fjinvmgr",
    "9397": "MpIdcAgt",
    "9400": "Samsung Twain for Network Server",
    "9401": "Samsung Twain for Network Client",
    "9402": "Samsung PC2FAX for Network Server",
    "9418": "git pack transfer service",
    "9443": "WSO2 Tungsten HTTPS",
    "9444": "WSO2 ESB Administration Console HTTPS",
    "9445": "Reserved",
    "9450": "Sentinel Keys Server",
    "9500": "ismserver",
    "9522": "SMA Speedwire",
    "9535": "Management Suite Remote Control",
    "9536": "Surveillance buffering function",
    "9555": "Trispen Secure Remote Access",
    "9559": "Reserved",
    "9592": "LANDesk Gateway",
    "9593": "LANDesk Management Agent (cba8)",
    "9594": "Message System",
    "9595": "Ping Discovery Service",
    "9596": "Mercury Discovery",
    "9597": "PD Administration",
    "9598": "Very Simple Ctrl Protocol",
    "9599": "Robix",
    "9600": "MICROMUSE-NCPW",
    "9612": "StreamComm User Directory",
    "9614": "Reserved",
    "9616": "Reserved",
    "9617": "Reserved",
    "9618": "Condor Collector Service",
    "9628": "ODBC Pathway Service",
    "9629": "UniPort SSO Controller",
    "9630": "Reserved",
    "9631": "Reserved",
    "9632": "Mobile-C Communications",
    "9640": "Reserved",
    "9666": "Reserved",
    "9667": "Cross-platform Music Multiplexing System",
    "9668": "tec5 Spectral Device Control Protocol",
    "9694": "T-Mobile Client Wakeup Message",
    "9695": "Content Centric Networking",
    "9700": "Board M.I.T. Service",
    "9747": "L5NAS Parallel Channel",
    "9750": "Board M.I.T. Synchronous Collaboration",
    "9753": "rasadv",
    "9762": "WSO2 Tungsten HTTP",
    "9800": "WebDav Source Port",
    "9801": "Sakura Script Transfer Protocol-2",
    "9802": "WebDAV Source TLS/SSL",
    "9875": "Session Announcement v1",
    "9877": "Reserved",
    "9878": "The KX509 Kerberized Certificate Issuance Protocol in Use in 2012",
    "9888": "CYBORG Systems",
    "9889": "Port for Cable network related data proxy or repeater",
    "9898": "MonkeyCom",
    "9899": "SCTP TUNNELING",
    "9900": "IUA",
    "9901": "enrp server channel",
    "9903": "Multicast Ping Protocol",
    "9909": "domaintime",
    "9911": "SYPECom Transport Protocol",
    "9925": "Reserved",
    "9950": "APC 9950",
    "9951": "APC 9951",
    "9952": "APC 9952",
    "9953": "9953",
    "9954": "Reserved",
    "9955": "Contact Port for AllJoyn multiplexed constrained messaging",
    "9956": "Alljoyn Name Service",
    "9966": "OKI Data Network Setting Protocol",
    "9978": "Reserved",
    "9979": "Reserved",
    "9981": "Reserved",
    "9987": "DSM/SCM Target Interface",
    "9988": "Reserved",
    "9990": "OSM Applet Server",
    "9991": "OSM Event Server",
    "9992": "OnLive-1",
    "9993": "OnLive-2",
    "9994": "OnLive-3",
    "9995": "Palace-4",
    "9996": "Palace-5",
    "9997": "Palace-6",
    "9998": "Distinct32",
    "9999": "distinct",
    "10000": "Network Data Management Protocol",
    "10001": "SCP Configuration",
    "10002": "EMC-Documentum Content Server Product",
    "10003": "EMC-Documentum Content Server Product",
    "10003": "EMC-Documentum Content Server Product",
    "10004": "Reserved",
    "10005": "Reserved",
    "10006": "Reserved",
    "10007": "MVS Capacity",
    "10008": "Octopus Multiplexer",
    "10009": "Systemwalker Desktop Patrol",
    "10010": "Reserved",
    "10020": "Reserved",
    "10023": "Comtech EF-Data's Vipersat Management Protocol",
    "10050": "Zabbix Agent",
    "10051": "Zabbix Trapper",
    "10055": "Reserved",
    "10080": "Amanda",
    "10081": "FAM Archive Server",
    "10100": "VERITAS ITAP DDTP",
    "10101": "eZmeeting",
    "10102": "eZproxy",
    "10103": "eZrelay",
    "10104": "Systemwalker Desktop Patrol",
    "10107": "VERITAS BCTP, server",
    "10110": "NMEA-0183 Navigational Data",
    "10111": "NMEA OneNet multicast messaging",
    "10113": "NetIQ Endpoint",
    "10114": "NetIQ Qcheck",
    "10115": "NetIQ Endpoint",
    "10116": "NetIQ VoIP Assessor",
    "10117": "NetIQ IQCResource Managament Svc",
    "10125": "Reserved",
    "10128": "BMC-PERFORM-SERVICE DAEMON",
    "10129": "Reserved",
    "10160": "QB Database Server",
    "10161": "SNMP-DTLS",
    "10162": "SNMP-Trap-DTLS",
    "10200": "Trigence AE Soap Service",
    "10201": "Remote Server Control and Test Service",
    "10252": "Apollo Relay Port",
    "10253": "Relay of EAPOL frames",
    "10260": "Axis WIMP Port",
    "10261": "Reserved",
    "10288": "Blocks",
    "10321": "Reserved",
    "10439": "BalanceNG session table synchronization protocol",
    "10443": "Reserved",
    "10500": "HIP NAT-Traversal",
    "10540": "MOS Media Object Metadata Port",
    "10541": "MOS Running Order Port",
    "10542": "MOS Low Priority Port",
    "10543": "MOS SOAP Default Port",
    "10544": "MOS SOAP Optional Port",
    "10548": "Reserved",
    "10631": "Reserved",
    "10800": "Gestor de Acaparamiento para Pocket PCs",
    "10805": "LUCIA Pareja Data Group",
    "10809": "Reserved",
    "10810": "Nuance Mobile Care Discovery",
    "10860": "Helix Client/Server",
    "10880": "BVEssentials HTTP API",
    "10933": "Reserved",
    "10990": "Auxiliary RMI Port",
    "11000": "IRISA",
    "11001": "Metasys",
    "11095": "Nest device-to-device and device-to-service application protocol",
    "11103": "Reserved",
    "11104": "Reserved",
    "11105": "Reserved",
    "11106": "SGI LK Licensing service",
    "11108": "Hardware Terminals Discovery and Low-Level Communication Protocol",
    "11109": "Reserved",
    "11110": "Reserved",
    "11111": "Viral Computing Environment (VCE)",
    "11112": "DICOM",
    "11161": "sun cacao snmp access point",
    "11162": "sun cacao JMX-remoting access point",
    "11163": "sun cacao rmi registry access point",
    "11164": "sun cacao command-streaming access point",
    "11165": "sun cacao web service access point",
    "11171": "Surgical Notes Security Service Discovery (SNSS)",
    "11172": "Reserved",
    "11173": "Reserved",
    "11174": "Reserved",
    "11175": "Reserved",
    "11201": "smsqp",
    "11202": "Reserved",
    "11208": "WiFree Service",
    "11211": "Memory cache service",
    "11235": "Reserved",
    "11319": "IMIP",
    "11320": "IMIP Channels Port",
    "11321": "Arena Server Listen",
    "11367": "ATM UHAS",
    "11371": "OpenPGP HTTP Keyserver",
    "11430": "Lenbrook Service Discovery Protocol",
    "11489": "Reserved",
    "11600": "Tempest Protocol Port",
    "11623": "Reserved",
    "11720": "H.323 Call Control Signalling Alternate",
    "11723": "EMC XtremSW distributed cache",
    "11751": "Intrepid SSL",
    "11796": "Lanschool Multipoint",
    "11876": "X2E Xoraya Multichannel protocol",
    "11877": "X2E service discovery protocol",
    "11967": "SysInfo Service Protocol",
    "11971": "Reserved",
    "12000": "IBM Enterprise Extender SNA XID Exchange",
    "12001": "IBM Enterprise Extender SNA COS Network Priority",
    "12002": "IBM Enterprise Extender SNA COS High Priority",
    "12003": "IBM Enterprise Extender SNA COS Medium Priority",
    "12004": "IBM Enterprise Extender SNA COS Low Priority",
    "12005": "DBISAM Database Server - Regular",
    "12006": "DBISAM Database Server - Admin",
    "12007": "Accuracer Database System Server",
    "12008": "Accuracer Database System Admin",
    "12009": "Green Hills VPN",
    "12010": "Reserved",
    "12012": "Vipera Messaging Service",
    "12013": "Vipera Messaging Service over SSL Communication",
    "12109": "RETS over SSL",
    "12121": "NuPaper Session Service",
    "12168": "CA Web Access Service",
    "12172": "HiveP",
    "12300": "LinoGrid Engine",
    "12302": "Reserved",
    "12321": "Warehouse Monitoring Syst SSS",
    "12322": "Warehouse Monitoring Syst",
    "12345": "Italk Chat System",
    "12546": "Reserved",
    "12753": "tsaf port",
    "12865": "Reserved",
    "13160": "I-ZIPQD",
    "13216": "Black Crow Software application logging",
    "13217": "R&amp;S Proxy Installation Assistant Service",
    "13218": "EMV Virtual CAS Service Discovery",
    "13223": "PowWow Client",
    "13224": "PowWow Server",
    "13400": "DoIP Discovery",
    "13720": "BPRD Protocol (VERITAS NetBackup)",
    "13721": "BPDBM Protocol (VERITAS NetBackup)",
    "13722": "BP Java MSVC Protocol",
    "13724": "Veritas Network Utility",
    "13782": "VERITAS NetBackup",
    "13783": "VOPIED Protocol",
    "13785": "NetBackup Database",
    "13786": "Veritas-nomdb",
    "13818": "DSMCC Config",
    "13819": "DSMCC Session Messages",
    "13820": "DSMCC Pass-Thru Messages",
    "13821": "DSMCC Download Protocol",
    "13822": "DSMCC Channel Change Protocol",
    "13823": "Reserved",
    "13832": "Reserved",
    "13894": "Ultimate Control communication protocol",
    "13929": "D-TA SYSTEMS",
    "13930": "Reserved",
    "14000": "SCOTTY High-Speed Filetransfer",
    "14001": "De-Registered",
    "14002": "Discovery of a SCOTTY hardware codec board",
    "14033": "sage Best! Config Server 1",
    "14034": "sage Best! Config Server 2",
    "14141": "VCS Application",
    "14142": "IceWall Cert Protocol",
    "14143": "Reserved",
    "14145": "GCM Application",
    "14149": "Veritas Traffic Director",
    "14150": "Reserved",
    "14154": "Veritas Application Director",
    "14250": "Fencing Server",
    "14414": "CA eTrust Web Update Service",
    "14500": "Reserved",
    "14936": "hde-lcesrvr-1",
    "14937": "hde-lcesrvr-2",
    "15000": "Hypack Data Aquisition",
    "15002": "Reserved",
    "15118": "v2g Supply Equipment Communication Controller Discovery Protocol",
    "15345": "XPilot Contact Port",
    "15363": "3Link Negotiation",
    "15555": "Cisco Stateful NAT",
    "15660": "Backup Express Restore Server",
    "15740": "Picture Transfer Protocol",
    "15998": "2ping Bi-Directional Ping Service",
    "15999": "Reserved",
    "16000": "Reserved",
    "16001": "Reserved",
    "16002": "Reserved",
    "16003": "Automation and Control by REGULACE.ORG",
    "16020": "Reserved",
    "16021": "Reserved",
    "16161": "Solaris SEA Port",
    "16162": "Reserved",
    "16309": "etb4j",
    "16310": "Policy Distribute, Update Notification",
    "16311": "Policy definition and update management",
    "16360": "Network Serial Extension Ports One",
    "16361": "Network Serial Extension Ports Two",
    "16367": "Network Serial Extension Ports Three",
    "16368": "Network Serial Extension Ports Four",
    "16384": "Connected Corp",
    "16385": "Reserved",
    "16619": "Reserved",
    "16665": "Reserved",
    "16666": "Vidder Tunnel Protocol",
    "16789": "Reserved",
    "16900": "Newbay Mobile Client Update Service",
    "16950": "Simple Generic Client Interface Protocol",
    "16991": "INTEL-RCI-MP",
    "16992": "Intel(R) AMT SOAP/HTTP",
    "16993": "Intel(R) AMT SOAP/HTTPS",
    "16994": "Intel(R) AMT Redirection/TCP",
    "16995": "Intel(R) AMT Redirection/TLS",
    "17007": "",
    "17010": "Reserved",
    "17184": "Reserved",
    "17185": "Sounds Virtual",
    "17219": "Chipper",
    "17220": "IEEE 1722 Transport Protocol for Time Sensitive Applications",
    "17221": "IEEE 1722.1 AVB Discovery, Enumeration, Connection management, and Control",
    "17222": "Control Plane Synchronization Protocol (SPSP)",
    "17223": "Reserved",
    "17224": "Train Realtime Data Protocol (TRDP) Process Data",
    "17225": "Train Realtime Data Protocol (TRDP) Message Data",
    "17234": "Integrius Secure Tunnel Protocol",
    "17235": "SSH Tectia Manager",
    "17500": "Dropbox LanSync Discovery",
    "17555": "Reserved",
    "17729": "Eclipse Aviation",
    "17754": "Encap. ZigBee Packets",
    "17755": "ZigBee IP Transport Service",
    "17756": "ZigBee IP Transport Secure Service",
    "17777": "Reserved",
    "18000": "Beckman Instruments, Inc.",
    "18104": "Reserved",
    "18136": "Reserved",
    "18181": "OPSEC CVP",
    "18182": "OPSEC UFP",
    "18183": "OPSEC SAM",
    "18184": "OPSEC LEA",
    "18185": "OPSEC OMI",
    "18186": "Occupational Health Sc",
    "18187": "OPSEC ELA",
    "18241": "Check Point RTM",
    "18242": "Reserved",
    "18243": "Reserved",
    "18262": "GV NetConfig Service",
    "18463": "AC Cluster",
    "18516": "HeyThings Device communicate service",
    "18634": "Reliable Datagram Service",
    "18635": "Reliable Datagram Service over IP",
    "18668": "Manufacturing Execution Systems Mesh Communication",
    "18769": "IQue Protocol",
    "18881": "Infotos",
    "18888": "APCNECMP",
    "19000": "iGrid Server",
    "19007": "Scintilla protocol for device services",
    "19020": "Reserved",
    "19191": "OPSEC UAA",
    "19194": "UserAuthority SecureAgent",
    "19220": "Discovery for Client Connection Management and Data Exchange Service",
    "19283": "Key Server for SASSAFRAS",
    "19315": "Key Shadow for SASSAFRAS",
    "19398": "mtrgtrans",
    "19410": "hp-sco",
    "19411": "hp-sca",
    "19412": "HP-SESSMON",
    "19539": "FXUPTP",
    "19540": "SXUPTP",
    "19541": "JCP Client",
    "19788": "Mesh Link Establishment",
    "19790": "Reserved",
    "19998": "Reserved",
    "19999": "Distributed Network Protocol - Secure",
    "20000": "DNP",
    "20001": "MicroSAN",
    "20002": "Commtact HTTP",
    "20003": "Commtact HTTPS",
    "20005": "OpenWebNet protocol for electric network",
    "20012": "Samsung Interdevice Interaction discovery",
    "20013": "Reserved",
    "20014": "OpenDeploy Listener",
    "20034": "NetBurner ID Port",
    "20034": "NetBurner ID Port",
    "20046": "TMOP HL7 Message Transfer Service",
    "20048": "NFS mount protocol",
    "20049": "Network File System (NFS) over RDMA",
    "20057": "Reserved",
    "20167": "TOLfab Data Change",
    "20202": "IPD Tunneling Port",
    "20222": "iPulse-ICS",
    "20480": "emWave Message Service",
    "20670": "Track",
    "20810": "Reserved",
    "20999": "AT Hand MMP",
    "21000": "IRTrans Control",
    "21010": "Reserved",
    "21212": "Reserved",
    "21213": "Reserved",
    "21221": "Reserved",
    "21553": "Reserved",
    "21554": "MineScape Design File Server",
    "21590": "VoFR Gateway",
    "21800": "TVNC Pro Multiplexing",
    "21845": "webphone",
    "21846": "NetSpeak Corp. Directory Services",
    "21847": "NetSpeak Corp. Connection Services",
    "21848": "NetSpeak Corp. Automatic Call Distribution",
    "21849": "NetSpeak Corp. Credit Processing System",
    "22000": "SNAPenetIO",
    "22001": "OptoControl",
    "22002": "Opto Host Port 2",
    "22003": "Opto Host Port 3",
    "22004": "Opto Host Port 4",
    "22005": "Opto Host Port 5",
    "22125": "Reserved",
    "22128": "Reserved",
    "22222": "Reserved",
    "22273": "wnn6",
    "22305": "CompactIS Tunnel",
    "22333": "ShowCockpit Networking",
    "22335": "Initium Labs Security and Automation Streaming",
    "22343": "CompactIS Secure Tunnel",
    "22347": "WibuKey Standard WkLan",
    "22350": "CodeMeter Standard",
    "22351": "Reserved",
    "22537": "Reserved",
    "22555": "Vocaltec Internet Phone",
    "22763": "Talika Main Server",
    "22800": "Telerate Information Platform LAN",
    "22951": "Telerate Information Platform WAN",
    "23000": "Inova LightLink Server Type 1",
    "23001": "Inova LightLink Server Type 2",
    "23002": "Inova LightLink Server Type 3",
    "23003": "Inova LightLink Server Type 4",
    "23004": "Inova LightLink Server Type 5",
    "23005": "Inova LightLink Server Type 6",
    "23053": "Reserved",
    "23272": "S102 application",
    "23294": "5AFE SDN Directory discovery",
    "23333": "Emulex HBAnyware Remote Management",
    "23400": "Novar Data",
    "23401": "Novar Alarm",
    "23402": "Novar Global",
    "23456": "Reserved",
    "23457": "Reserved",
    "23546": "Reserved",
    "24000": "med-ltp",
    "24001": "med-fsp-rx",
    "24002": "med-fsp-tx",
    "24003": "med-supp",
    "24004": "med-ovw",
    "24005": "med-ci",
    "24006": "med-net-svc",
    "24242": "fileSphere",
    "24249": "Vista 4GL",
    "24321": "Isolv Local Directory",
    "24322": "Transport of Human Interface Device data streams",
    "24323": "Reserved",
    "24386": "Intel RCI",
    "24386": "Intel RCI",
    "24465": "Tonido Domain Server",
    "24554": "BINKP",
    "24577": "bilobit Service Update",
    "24666": "Reserved",
    "24676": "Canditv Message Service",
    "24677": "FlashFiler",
    "24678": "Turbopower Proactivate",
    "24680": "TCC User HTTP Service",
    "24754": "Reserved",
    "24850": "Device Association Discovery",
    "24922": "Find Identification of Network Devices",
    "25000": "icl-twobase1",
    "25001": "icl-twobase2",
    "25002": "icl-twobase3",
    "25003": "icl-twobase4",
    "25004": "icl-twobase5",
    "25005": "icl-twobase6",
    "25006": "icl-twobase7",
    "25007": "icl-twobase8",
    "25008": "icl-twobase9",
    "25009": "icl-twobase10",
    "25100": "Reserved",
    "25576": "Reserved",
    "25604": "Reserved",
    "25793": "Vocaltec Address Server",
    "25900": "TASP Network Comm",
    "25901": "NIObserver",
    "25902": "NILinkAnalyst",
    "25903": "NIProbe",
    "25954": "Bitfighter game server",
    "25955": "Bitfighter master server",
    "26000": "quake",
    "26133": "Symbolic Computation Software Composability Protocol",
    "26208": "wnn6-ds",
    "26257": "Reserved",
    "26260": "eZproxy",
    "26261": "eZmeeting",
    "26262": "K3 Software-Server",
    "26263": "K3 Software-Client",
    "26486": "EXOline-UDP",
    "26487": "EXOconfig",
    "26489": "EXOnet",
    "27010": "Reserved",
    "27017": "Reserved",
    "27345": "ImagePump",
    "27442": "Job controller service",
    "27504": "Kopek HTTP Head Port",
    "27782": "ARS VISTA Application",
    "27876": "Reserved",
    "27999": "Attribute Certificate Services",
    "28000": "NX License Manager",
    "28001": "Reserved",
    "28010": "Reserved",
    "28080": "Reserved",
    "28119": "A27 cdma2000 RAN Management",
    "28200": "VoxelStorm game server",
    "28240": "Siemens GSM",
    "28589": "Reserved",
    "29000": "Reserved",
    "29118": "Reserved",
    "29167": "ObTools Message Protocol",
    "29168": "Reserved",
    "29999": "Reserved",
    "30000": "Reserved",
    "30001": "Pago Services 1",
    "30002": "Pago Services 2",
    "30003": "Amicon FPSU-IP Remote Administration",
    "30004": "Amicon FPSU-IP VPN",
    "30100": "Reserved",
    "30260": "Kingdoms Online (CraigAvenue)",
    "30400": "Reserved",
    "30832": "Samsung Convergence Discovery Protocol",
    "30999": "OpenView Service Desk Client",
    "31016": "Kollective Agent Kollective Delivery Protocol",
    "31020": "Reserved",
    "31029": "YaWN - Yet Another Windows Notifier",
    "31337": "eldim is a secure file upload proxy",
    "31400": "Reserved",
    "31416": "XQoS network monitor",
    "31457": "TetriNET Protocol",
    "31620": "lm mon",
    "31685": "Reserved",
    "31765": "GameSmith Port",
    "31948": "Embedded Device Configuration Protocol TX",
    "31948": "Embedded Device Configuration Protocol TX",
    "31949": "Embedded Device Configuration Protocol RX",
    "31949": "Embedded Device Configuration Protocol RX",
    "32034": "iRacing helper service",
    "32249": "T1 Distributed Processor",
    "32400": "Reserved",
    "32483": "Access Point Manager Link",
    "32635": "SecureNotebook-CLNT",
    "32636": "DMExpress",
    "32767": "FileNet BPM WS-ReliableMessaging Client",
    "32768": "Filenet TMS",
    "32769": "Filenet RPC",
    "32770": "Filenet NCH",
    "32771": "FileNet RMI",
    "32772": "FileNET Process Analyzer",
    "32773": "FileNET Component Manager",
    "32774": "FileNET Rules Engine",
    "32775": "Performance Clearinghouse",
    "32776": "FileNET BPM IOR",
    "32777": "FileNet BPM CORBA",
    "32801": "Multiple Listing Service Network",
    "32811": "Reserved",
    "32896": "Attachmate ID Manager",
    "33000": "Reserved",
    "33060": "Reserved",
    "33123": "Aurora (Balaena Ltd)",
    "33331": "DiamondCentral Interface",
    "33333": "Reserved",
    "33334": "SpeedTrace TraceAgent Discovery",
    "33434": "traceroute use",
    "33435": "IP Multicast Traceroute",
    "33656": "SNIP Slave",
    "33890": "Reserved",
    "34249": "TurboNote Relay Server Default Port",
    "34378": "P-Net on IP local",
    "34379": "P-Net on IP remote",
    "34567": "dhanalakshmi.org EDI Service",
    "34962": "PROFInet RT Unicast",
    "34963": "PROFInet RT Multicast",
    "34964": "PROFInet Context Manager",
    "34980": "EtherCAT Port",
    "35000": "Reserved",
    "35001": "ReadyTech Viewer",
    "35002": "Reserved",
    "35003": "Reserved",
    "35004": "ReadyTech ClassManager",
    "35005": "Reserved",
    "35006": "Reserved",
    "35100": "Axiomatic discovery protocol",
    "35354": "Reserved",
    "35355": "Altova License Management Discovery",
    "35356": "Reserved",
    "35357": "Reserved",
    "36001": "AllPeers Network",
    "36411": "Wireless LAN Control plane Protocol (WLCP)",
    "36412": "Reserved",
    "36422": "Reserved",
    "36462": "Reserved",
    "36524": "Reserved",
    "36602": "Reserved",
    "36700": "Reserved",
    "36865": "KastenX Pipe",
    "37472": "Reserved",
    "37475": "science + computing's Venus Administration Port",
    "37483": "Reserved",
    "37601": "Reserved",
    "37654": "Unisys ClearPath ePortal",
    "38000": "Reserved",
    "38001": "Reserved",
    "38002": "Cresco Controller Discovery",
    "38201": "Galaxy7 Data Tunnel",
    "38202": "Fairview Message Service",
    "38203": "AppGate Policy Server",
    "38412": "Reserved",
    "38422": "Reserved",
    "38462": "Reserved",
    "38472": "Reserved",
    "38638": "Reserved",
    "38800": "Reserved",
    "38865": "Reserved",
    "39063": "Reserved",
    "39681": "TurboNote Default Port",
    "40000": "SafetyNET p",
    "40023": "K-PatentsSensorInformation",
    "40404": "Reserved",
    "40841": "CSCP",
    "40842": "CSCCREDIR",
    "40843": "CSCCFIREWALL",
    "40853": "ORTEC Service Discovery",
    "41111": "Foursticks QoS Protocol",
    "41121": "Reserved",
    "41230": "Z-Wave Protocol over DTLS",
    "41794": "Crestron Control Port",
    "41795": "Crestron Terminal Port",
    "41796": "Reserved",
    "41797": "Reserved",
    "42508": "Computer Associates network discovery protocol",
    "42509": "CA discovery response",
    "42510": "CA eTrust RPC",
    "42999": "Reserved",
    "43000": "Receiver Remote Control Discovery",
    "43188": "REACHOUT",
    "43189": "NDM-AGENT-PORT",
    "43190": "IP-PROVISION",
    "43191": "Reserved",
    "43210": "Shaper Automation Server Management Discovery",
    "43438": "HmIP LAN Routing",
    "43439": "EQ3 discovery and configuration",
    "43440": "Cisco EnergyWise Discovery and Command Flooding",
    "43441": "Cisco NetMgmt DB Ports",
    "44123": "Reserved",
    "44321": "PCP server (pmcd)",
    "44322": "PCP server (pmcd) proxy",
    "44323": "Unassigned",
    "44444": "Reserved",
    "44445": "Reserved",
    "44544": "DOMIQ Building Automation",
    "44553": "REALbasic Remote Debug",
    "44600": "AudioScience HPI",
    "44818": "EtherNet/IP messaging",
    "44818": "EtherNet/IP messaging",
    "44900": "M3DA Discovery is used for efficient machine-to-machine communications",
    "45000": "Nuance AutoStore Status Monitoring Protocol (device monitoring)",
    "45001": "Reserved",
    "45002": "Reserved",
    "45045": "Reserved",
    "45054": "InVision AG",
    "45514": "ASSIA CloudCheck WiFi Management keepalive",
    "45678": "EBA PRISE",
    "45824": "Reserved",
    "45825": "Qpuncture Data Access Service",
    "45966": "SSRServerMgr",
    "46336": "Reserved",
    "46998": "Reserved",
    "46999": "MediaBox Server",
    "47000": "Message Bus",
    "47001": "Reserved",
    "47100": "Configuration of motors connected to Industrial Ethernet",
    "47557": "Databeam Corporation",
    "47624": "Direct Play Server",
    "47806": "ALC Protocol",
    "47808": "Building Automation and Control Networks",
    "47809": "PreSonus Universal Control Network Protocol",
    "48000": "Nimbus Controller",
    "48001": "Nimbus Spooler",
    "48002": "Nimbus Hub",
    "48003": "Nimbus Gateway",
    "48004": "Reserved",
    "48005": "Reserved",
    "48048": "Reserved",
    "48049": "Reserved",
    "48050": "Reserved",
    "48128": "Image Systems Network Services",
    "48129": "Bloomberg locator",
    "48556": "com-bardac-dw",
    "48619": "iqobject",
    "48653": "Robot Raconteur transport",
    "49000": "Reserved",
    "49001": "Nuance Unity Service Discovery Protocol",
    "49150": "Reserved",
}
